/* 
SVN Revisionsinformationen
$Revision: 996 $
$Date: 2018-10-30 11:20:07 +0100 (Di, 30 Okt 2018) $  
*/ 
/******************************************************************************
 Basisview zum Auswerten der Parameter fr die weitere Verwendung,
 nicht direkt aufrufen 
*******************************************************************************/
CREATE OR REPLACE VIEW vis_vs07_BASIS AS
SELECT SYS_GUID() ID
  , d1.s07_id
  , d1.s0701_id
  , d1.s0702_id
  , d1.s07_code
  , d1.s07_bez
  , d1.s0701_code
  , d1.s0701_bez
  , d1.auswert_level
  , d1.typ
  , d1.mandant
  , d1.s50_03_sid
  , d1.fehlernr
  , CASE WHEN Fehlernr = 0 THEN wert ELSE NULL END wert 

  , CASE d1.fehlernr
      WHEN 15 THEN 'Keine Benutzerwert vorhanden.'
      WHEN 16 THEN 'Keine Mandantenwert vorhanden.'
      WHEN 17 THEN 'Fr Mandantenparameter ist ein Benutzerwert vorhanden.'
      WHEN 18 THEN 'Fr Benutzerparameter ist ein Mandantenwert vorhanden.'
      WHEN 19 THEN 'Kein Benutzer-/Mandantenparameter vorhanden.'
      WHEN 13 THEN 'Kein Wert vorhanden.'
      WHEN 14 THEN 'Kein Wert erfasst.'   
      WHEN 20 THEN 'Systemparameter ist mit Mandanten- bzw. Benutzerzuordnung erfasst.'   
      ELSE NULL
    END Fehlertext
  , d1.s07_deleted deleted
  , d1.rank
  --, BLV_SYS.GET_MANDANT mandant
  --, BLV_SYS.GET_user_sid user_sid


FROM (
      SELECT s07.id   s07_id
        , s0701.id    s0701_id
        , s0702.id    s0702_id 
        , s07.code    s07_code
        , s07.bez     s07_bez
        , s0701.code  s0701_code
        , s0701.bez   s0701_bez
        , S0701.auswert_level
        , s0701.typ
        , s0702.mandant
        , s0702.s50_03_sid
        , s0702.wert wert
        , s07.deleted s07_deleted
        , RANK() OVER (PARTITION BY s0701.id ORDER BY s0702.s50_03_sid DESC, s0702.mandant DESC NULLS LAST) rank
        , CASE 
            WHEN s0701.auswert_level LIKE 'U' AND s0702.mandant > 0 AND S0702.s50_03_sid < 0 THEN 18 --'Fr Benutzerparameter ist ein Mandantenwert vorhanden'
            WHEN s0701.auswert_level LIKE 'U' AND ( s0702.s50_03_sid IS NULL OR S0702.s50_03_sid < 0) THEN 15 --'Keine Benutzerwert vorhanden'
            WHEN s0701.auswert_level LIKE 'M' AND ( s0702.mandant IS NULL OR S0702.mandant < 0) THEN 16 --'Keine Mandantenwert vorhanden'
            WHEN s0701.auswert_level LIKE 'M' AND ( s0702.s50_03_sid > 0) THEN 17 --'Fr Mandantenparameter ist ein Benutzerwert vorhanden'
            WHEN s0701.auswert_level NOT LIKE '%S%' AND s0701.auswert_level LIKE '%U%' AND s0701.auswert_level LIKE '%M%' AND s0702.mandant = -1 AND s0702.s50_03_sid = -1 THEN 19 --'Kein Benutzer-/Mandantenparameter vorhanden.'
            WHEN S0702.id IS NULL THEN   13 --'Kein Wert vorhanden' 
            WHEN S0702.WERT IS NULL THEN 14 -- 'Kein Wert erfat'   
            WHEN s0701.auswert_level LIKE 'S' AND  ( s0702.mandant > -1 OR s0702.s50_03_sid > -1) THEN 20
            ELSE 0
          END Fehlernr
      FROM vis_s07 s07
      JOIN vis_s0701 s0701 ON s0701.s07_id = s07.id
        AND s07.deleted = 0 
        AND (s07.zb LIKE '%' || blv_sys.GET_GKZ2 || '%' OR s07.zb = '%') -- 09.11.2012
        AND s0701.deleted = 0
      LEFT JOIN vis_s0702 s0702 ON s0702.s0701_id = s0701.id 
        AND s0702.deleted = 0
        AND ( 
              (s0702.mandant = BLV_SYS.GET_MANDANT AND NVL(s0702.s50_03_sid, -1) = -1 AND (s0701.auswert_level LIKE '%M%' OR s0701.auswert_level = '%' )) OR
              (s0702.s50_03_sid = BLV_SYS.GET_USER_SID AND s0702.mandant = BLV_SYS.GET_MANDANT AND (s0701.auswert_level LIKE '%U%' OR s0701.auswert_level = '%' )) OR
              ((s0701.auswert_level LIKE '%S%' OR s0701.auswert_level = '%') AND NVL(s0702.mandant,-1) = -1 AND NVL(s0702.s50_03_sid, -1) = -1 )
            )  
      ORDER BY s0701.code
) d1
;


/******************************************************************************
 View zum Auswerten der Parameter S07 mit Filter auf den gnstigsten Wert
 
 Beispiel:
 
 SELECT wert               -- Wert des Parameters bei Fehlernr = 0
      , fehlernr
      , fehlertext        
 FROM vis_vs07
 WHERE s07_code = '0801'   -- Verfahrenscode
   AND s0701_code = '0101' -- Parametercode
******************************************************************************/
CREATE OR REPLACE VIEW VIS_VS07 AS
SELECT * 
FROM VIS_VS07_BASIS
WHERE rank = 1
;

/******************************************************************************
 View zum Auswerten der Parameter S07 mit Filter bei auf den gnstigsten Wert fr 
 reine Systemparameter sonst alle Parameter 
 ******************************************************************************/
CREATE OR REPLACE VIEW VIS_VS07$ALL AS
SELECT * 
FROM VIS_VS07_BASIS
WHERE (rank = 1 AND auswert_level = 'S' OR auswert_level <> 'S')
;

/******************************************************************************
 Basisview zum Auswerten aller Parameter fr den aktuellen Mandanten
*******************************************************************************/
CREATE OR REPLACE VIEW vis_vs07$MD AS
SELECT SYS_GUID() ID
  , d1.s07_id
  , d1.s0701_id
  , d1.s0702_id
  , s50.d0102_id
  , d010200.id d010200_id
  , d1.s07_code
  , d1.s07_bez
  , d1.s0701_code
  , d1.s0701_bez
  , d1.auswert_level
  , d1.typ
  , d1.mandant
  , d1.s50_03_sid
  , d1.fehlernr
  , CASE WHEN Fehlernr = 0 THEN wert ELSE NULL END wert 

  , CASE d1.fehlernr
      WHEN 15 THEN 'Keine Benutzerwert vorhanden.'
      WHEN 16 THEN 'Keine Mandantenwert vorhanden.'
      WHEN 17 THEN 'Fr Mandantenparameter ist ein Benutzerwert vorhanden.'
      WHEN 18 THEN 'Fr Benutzerparameter ist ein Mandantenwert vorhanden.'
      WHEN 19 THEN 'Kein Benutzer-/Mandantenparameter vorhanden.'
      WHEN 13 THEN 'Kein Wert vorhanden.'
      WHEN 14 THEN 'Kein Wert erfasst.'   
      WHEN 20 THEN 'Systemparameter ist mit Mandanten- bzw. Benutzerzuordnung erfasst.'   
      ELSE NULL
    END Fehlertext
  , d1.s07_deleted deleted
  , d1.rank

FROM (
      SELECT s07.id   s07_id
        , s0701.id    s0701_id
        , s0702.id    s0702_id 
        , s07.code    s07_code
        , s07.bez     s07_bez
        , s0701.code  s0701_code
        , s0701.bez   s0701_bez
        , S0701.auswert_level
        , s0701.typ
        , s0702.mandant
        , s0702.s50_03_sid
        , s0702.wert wert
        , s07.deleted s07_deleted       
        , RANK() OVER (PARTITION BY s0701.id ORDER BY s0702.s50_03_sid DESC, s0702.mandant DESC NULLS LAST) rank
        , CASE 
            WHEN s0701.auswert_level LIKE 'U' AND s0702.mandant > 0 AND S0702.s50_03_sid < 0 THEN 18 --'Fr Benutzerparameter ist ein Mandantenwert vorhanden'
            WHEN s0701.auswert_level LIKE 'U' AND ( s0702.s50_03_sid IS NULL OR S0702.s50_03_sid < 0) THEN 15 --'Keine Benutzerwert vorhanden'
            WHEN s0701.auswert_level LIKE 'M' AND ( s0702.mandant IS NULL OR S0702.mandant < 0) THEN 16 --'Keine Mandantenwert vorhanden'
            WHEN s0701.auswert_level LIKE 'M' AND ( s0702.s50_03_sid > 0) THEN 17 --'Fr Mandantenparameter ist ein Benutzerwert vorhanden'
            WHEN s0701.auswert_level NOT LIKE '%S%' AND s0701.auswert_level LIKE '%U%' AND s0701.auswert_level LIKE '%M%' AND s0702.mandant = -1 AND s0702.s50_03_sid = -1 THEN 19 --'Kein Benutzer-/Mandantenparameter vorhanden.'
            WHEN S0702.id IS NULL THEN   13 --'Kein Wert vorhanden' 
            WHEN S0702.WERT IS NULL THEN 14 -- 'Kein Wert erfat'   
            WHEN s0701.auswert_level LIKE 'S' AND  ( s0702.mandant > -1 OR s0702.s50_03_sid > -1) THEN 20
            ELSE 0
          END Fehlernr
      FROM vis_s07 s07
      JOIN vis_s0701 s0701 ON s0701.s07_id = s07.id
        AND s07.deleted = 0 
        AND (s07.zb LIKE '%' || blv_sys.GET_GKZ2 || '%' OR s07.zb = '%') -- 09.11.2012        
        AND s0701.deleted = 0
      LEFT JOIN vis_s0702 s0702 ON s0702.s0701_id = s0701.id 
        AND s0702.deleted = 0
        AND ( (s0702.mandant = BLV_SYS.GET_MANDANT AND s0701.auswert_level LIKE '%M%') OR
              (s0702.mandant = BLV_SYS.GET_MANDANT AND s0701.auswert_level LIKE '%U%') OR
              (s0701.auswert_level LIKE 'S') OR 
              s0701.auswert_level = '%'
            )  
      ORDER BY s0701.code
) d1
LEFT JOIN vis_s50 s50 ON s50.sid = d1.s50_03_sid 
  AND s50.deleted = 0
LEFT JOIN vis_d010200 d010200 ON d010200.d0102_id = s50.d0102_id
  AND d010200.deleted = 0
;

-- Parameter MANDANT fr Verfahren BTR auslesen
-- liefert alle zugeordenten ZB 
CREATE OR REPLACE VIEW VIS_VS0701$BTR_MANDANT AS
  SELECT s07.code s07_code, s0701.code s0701_code, d0101_1.zb 
  FROM vis_s07 s07
  JOIN vis_s0701 s0701 on s0701.s07_id = s07.id
  AND s0701.code = 'MANDANT'
  AND s0701.deleted = 0
  JOIN vis_s0702 s0702 on s0702.s0701_id = s0701.id
  AND s0702.wert = '1'
  AND s0702.deleted = 0
  JOIN vis_s50 s50 on s50.sid = s0702.mandant
  JOIN VIS_D0101 D0101_1 ON D0101_1.ID = S50.D0101_ID
  WHERE s07.code = 'BTR'
;  

