/*<TOAD_FILE_CHUNK>*/

ALTER SESSION SET PLSQL_CODE_TYPE = NATIVE;
/
ALTER SESSION SET PLSQL_OPTIMIZE_LEVEL = 3
/

/*
alter session set plsql_warnings = 'Enable:All', 'Disable:(6002, 6005, 6006)'; 
alter session set plsql_warnings = 'Disable:All'; 
*/

/*******************************************************************************
 Plausibilittsprfungen fr Betriebe/ Betreiber bezglich
 - Adressen
 - Betriebsarten
 - Registrierungen
*******************************************************************************/
CREATE OR REPLACE PACKAGE ZBR_PLAUSI AS
/* 
SVN Revisionsinformationen
$Revision: 990 $ 
*/ 
 TYPE recRegNr IS RECORD ( d010102_ID vis_d010102.id%TYPE,
                           nummer vis_d010102.nummer%TYPE,
                           gueltig_bis vis_d010102.gueltig_bis%TYPE,
                           upd_date vis_d010102.upd_date%TYPE);
                           
 TYPE tRegNr IS TABLE OF recRegNr; -- fr Registrierungen 
 vRegnr tRegNr; 
 vRegNr$3 tRegNr;
 
 TYPE recBA IS RECORD( D010101_id VIS_D010101.id%TYPE,
                     A010108_SID VIS_D010101.a010108_sid%TYPE,
                     A010108_bez VIS_A010108.bez%TYPE,
                     A010108_code vis_a010108.code%TYPE,
                     gewerbsmaessig vis_d010101.gewerbsmaessig%TYPE,
                     gueltig_von VIS_D010101.gueltig_von%TYPE,
                     gueltig_bis VIS_D010101.gueltig_bis%TYPE,
                     angemeldet vis_d010101.angemeldet%TYPE,
                     abgemeldet vis_d010101.abgemeldet%TYPE,
                     auswahl vis_a010108.auswahl%TYPE,
                     ins_date vis_d010101.ins_date%TYPE,  -- 20.09.2013 upd_date in ins_date gendert
                     upd_date vis_d010101.upd_date%TYPE  -- 15.10.2013
                     ); 

 TYPE tBA IS TABLE OF recBA; -- fr Betriebsarten 
 vBA tBA;
 
 TYPE tStatus IS RECORD (
  result NUMBER(10),
  regel VARCHAR2(10),
  Errors VARCHAR2(250),
  Warnings VARCHAR2(250) );
  
 TYPE tbStatus IS TABLE OF tStatus;

 TYPE tPlausi IS RECORD (
  result NUMBER(10),
  typ   VARCHAR2(10),
  regel VARCHAR2(10),
  Text CLOB ); -- VARCHAR2(250)
  
 TYPE tbPlausi IS TABLE OF tPlausi;
   
  vBatchMode BOOLEAN := FALSE;
  --vErstMode BOOLEAN := FALSE; -- Erstbefllung  
  vD0101IsNew  INT := 0; -- Betrieb noch nicht im Ausgangskorb - dann neu
  vLastUpd DATE;
  vErrors CLOB; -- Fehlermeldungen
  vWarnings CLOB; -- Warnungen
  vStopErrors INT;
  vResult INT; -- Rckgabewert
  vPrio INT; -- hchste Prioritt der Fehler 
  vD0101 VIS_D0101%ROWTYPE; -- Betriebssttte
  vD0101$3 VIS_D0101%ROWTYPE; -- Betreiber
  vA010145_SID_HIT VIS_A010145.SID%TYPE := 514001; -- 0102 Registriernummer (HIT) in TH
  vA010145_SID_HIT2 CONSTANT VIS_A010145.SID%TYPE := 514001; -- 0102 Registriernummer (HIT) in TH
  vBAcnt INT := 0; -- Anzahl gltige Betriebsarten
  vBAnotExport INT := 0; -- bei 1 ergabt ChkBetriebsarten dass mind. eine BA nicht exportiert werden darf 
  vDateMin CONSTANT DATE := DATE '1920-12-31'; --TO_DATE('31.12.1920', 'dd.mm.yyyy');
  vDateMax CONSTANT DATE := DATE '9999-01-01'; --TO_DATE('01.01.9999', 'dd.mm.yyyy');
  
  TYPE tBaDatum IS RECORD (
    angemeldet DATE, -- ltestes Anmeldedatum der Betriebsarten
    angem_ins_date DATE, --
    angem_BEZ vis_a010108.bez%TYPE,
    abgemeldet DATE, -- letztes Abmeldedatum der Betriebsarten
    abgem_upd_date DATE, --
    abgem_BEZ vis_a010108.bez%TYPE );
  
  vBaDatum tBaDatum;
  
  CURSOR CurZBR_AUS (pID IN vis_d0101.id%TYPE := '%') IS
    SELECT d0101.id d0101_id, d0101.d0101_id3       
    FROM VIS_D0101 d0101
    JOIN vis_d0101 d3 ON d3.id = d0101.d0101_id3
                        
    WHERE d0101.deleted = 0
      AND d0101.skz = 1
      AND d0101.id LIKE pID      
      -- HIT-Nr. fr BTS vorhanden
--      AND EXISTS( 
--        SELECT 1 
--        FROM vis_d010102 d010102 
--        WHERE d010102.deleted = 0
--          AND d010102.a010145_sid = 514001 --Registriernummer (HIT)
--          AND d010102.d0101_id = d0101.id )          

      AND d0101.ID NOT IN ( 
        SELECT d1.d0101_id 
        FROM aus_d_usecase d1 
        WHERE d1.usecase = 'ERSTBEFUELLUNG'
      )  
    ORDER BY CASE WHEN d0101.id = d0101.d0101_id3 THEN 0 ELSE 1 END; 

  --PROCEDURE SBS_AUSGANG01(pD0101_ID IN VARCHAR2, pResult OUT INT, pErrors OUT CLOB, pWarnings OUT CLOB); 
  PROCEDURE SBS_AUSGANG(pD0101_ID IN VARCHAR2, pResult OUT INT, pErrors OUT NOCOPY CLOB, pWarnings OUT NOCOPY CLOB, pPrtStatus IN INT); 
  PROCEDURE SBS_AUSGANG(pD0101_ID IN VARCHAR2); 
  PROCEDURE SBS_AUSGANG(pD0101_ID IN VARCHAR2, pGKZ2 IN VARCHAR2); 
  PROCEDURE SBS_AUSGANGBatch(pD0101_ID IN VARCHAR2, pResult OUT INT, pErrors OUT NOCOPY CLOB, pWarnings OUT NOCOPY CLOB); 
  FUNCTION ClearData RETURN NUMBER; 
  FUNCTION ReadStatus RETURN tbStatus PIPELINED;
  PROCEDURE GetS07Verfahren DETERMINISTIC;
  FUNCTION GetVerfahren RETURN VARCHAR2;
  FUNCTION Version RETURN VARCHAR2;
  FUNCTION PlausiErstbefuellung (pD0101_ID IN vis_d0101.id%TYPE := '%', pHinweise IN NUMBER := 1, pFehler IN NUMBER := 1, pEinzeln IN NUMBER := 1) RETURN tbPlausi PIPELINED;
END ZBR_PLAUSI;
/

/*

  SBS_AUSGANG : Aufruf fr manuelles Prfen
  SBS_AUSGANGBatch : Aufruf fr Prfung ber Batch
  Parameter: 
  - pD0101_ID : Betrieb
  - pResult : Rckgabe 0 Prfung in Ordnung, 1 Warnungen, 2 Fehler
  - pErrors : alle fehlermeldungen
  - pWarnings : alle Warnungen
  
  Bsp.:
  DECLARE vErr CLOB := NULL;
          vWar CLOB := NULL;
          vRes INT := -1;
          vD0101_ID VARCHAR2(32);
  BEGIN

    zbr_plausi.vGKZ2 := '05';
    select d0101.id into vD0101_ID from vis_d0101 d0101 where d0101.code = 'VIE-00300';

    ZBR_PLAUSI.SBS_AUSGANG(vD0101_ID, vRes, vErr, vWar, 0); 
    DBMS_OUTPUT.PUT_LINE('Result: ' || vRes);
    DBMS_OUTPUT.PUT_LINE('Fehler: ' || vErr);
    DBMS_OUTPUT.PUT_LINE('Warnungen: ' || vWar);
  END;

*/

/*<TOAD_FILE_CHUNK>*/
CREATE OR REPLACE PACKAGE BODY ZBR_PLAUSI AS
/* 
SVN Revisionsinformationen
$Revision: 990 $ 
*/ 
  QUELLE_IDV_NRW CONSTANT VARCHAR2(20) := 'IDV-SFDP'; 
  QUELLE_ZBR CONSTANT VARCHAR2(20) := 'ZBR';
  QUELLE_XGEWERBE CONSTANT VARCHAR2(20) := 'XGEWERBE';
  CRLF CONSTANT VARCHAR2(2) := CHR(13)||CHR(10);
  vVerfahren VARCHAR2(20);
  vPlausi tbPlausi;
-- Warnungen fortschreiben
PROCEDURE AddWarning(pText IN VARCHAR2, pPrio IN PLS_INTEGER, pRegel IN VARCHAR2) AS
BEGIN
  vWarnings := CASE WHEN vWarnings IS NULL THEN NULL ELSE vWarnings || CHR(13) END
               || pText;

  IF vResult < 1 THEN
    vResult := 1;
  END IF;
  vPlausi.EXTEND;
  vPlausi(vPlausi.LAST).text := pText;
  vPlausi(vPlausi.LAST).regel := pRegel;  
  vPlausi(vPlausi.LAST).result := 1;  
  vPlausi(vPlausi.LAST).typ := 'Hinweis';  
  
END AddWarning;
 
-- Fehler fortschreiben
-- pWarning = True: Fehler wird als Warnung geschrieben 
-- p1 = NULL: alle Fehler werden gelscht und alle folgende Fehler nicht protokolliert
--            das Fehler aufgetreten sind wird protokolliert aber ohne Fehlertext 
PROCEDURE AddError( pText IN VARCHAR2, pPrio IN PLS_INTEGER, pRegel IN VARCHAR2, pIgnor_im_Batch IN BOOLEAN := FALSE) AS
BEGIN
    vResult := 2;
    IF vStopErrors = 0 THEN 
      CASE 
      WHEN pText IS NULL THEN
        vErrors := NULL;
        if not zbr_aus_data.vErstMode then 
          vStopErrors := 1;
        end if;
      WHEN vBatchMode AND (pIgnor_im_Batch AND NOT zbr_aus_data.vErstMode) THEN NULL;
      ELSE
        vErrors := CASE WHEN vErrors IS NULL THEN NULL ELSE vErrors || CHR(13) END || pText
                   --CASE WHEN vVerfahren = QUELLE_ZBR THEN TRIM(BOTH FROM pRegel || ' ' || pError) 
                   --ELSE pError END
                   ;
        vPlausi.EXTEND;
        vPlausi(vPlausi.LAST).text := pText;
        vPlausi(vPlausi.LAST).regel := pRegel;
        vPlausi(vPlausi.LAST).result := 2;
        vPlausi(vPlausi.LAST).typ := 'Fehler';  
                           
      END CASE;
    END IF;
    IF pPrio < vPrio THEN
      vPrio := pPrio;
    END IF;

END AddError;

FUNCTION IsZirkus RETURN NUMBER AS
vRes NUMBER(1) := 0;
BEGIN

  IF vBA.Count > 0 THEN
    FOR i IN vBa.First .. vBa.Last LOOP
      IF vBA(i).A010108_code IN ('040202') THEN --Zirkus
        vRes := 1;
        EXIT;
      END IF;
    END LOOP;
  END IF;
  RETURN vRes;
END IsZirkus;

PROCEDURE GetS07Verfahren DETERMINISTIC AS
vS07_code CONSTANT vis_s07.code%TYPE := 'BTR';
vS0701_Code CONSTANT vis_s07.code%TYPE := 'VERFAHREN';
vWert vis_s0702.wert%TYPE; 
BEGIN  

  SELECT MAX(s07.wert) 
  INTO vVerfahren
  FROM vis_vs07 s07
  WHERE s07.s07_code = vS07_Code
  AND s07.s0701_code = vS0701_Code;

  IF vVerfahren IS NULL THEN
    vVerfahren := QUELLE_ZBR;
  END IF;
  --RETURN vWert;
END;

FUNCTION GetVerfahren RETURN VARCHAR2 AS
BEGIN
  RETURN vVerfahren;
END;

PROCEDURE ReadAllData(pD0101_ID IN VARCHAR2) AS
BEGIN
  
  SELECT d0101.* INTO vD0101
  FROM vis_d0101 d0101 
  WHERE d0101.id = pD0101_ID;
  
  IF vD0101.ID <> vD0101.D0101_ID3 THEN -- abweichender Betreiber
    
    SELECT d0101.* INTO vD0101$3
    FROM vis_d0101 d0101 
    WHERE d0101.id = vD0101.D0101_ID3;
  
  ELSE    
    vD0101$3 := vD0101;
  END IF;
  
  -- bez_art des Betreibers ber Rechtsform aktualisieren, bez_art wird in Zukunft wegfallen
  SELECT CASE WHEN a1.feld1 = '0' THEN 'N' ELSE 'F' END 
  INTO vD0101$3.bez_art
  FROM vis_a0101 a1
  WHERE a1.sid = vD0101$3.a0101_03_sid;
  
  IF vVerfahren = QUELLE_IDV_NRW THEN
    -- todo 
    SELECT d010101.id, A010108.SID, a010108.bez, a010108.code, D010101.GEWERBSMAESSIG, 
      D010101.GUELTIG_VON, D010101.GUELTIG_BIS, 
      d010101.angemeldet, d010101.abgemeldet, 
      A010108.AUSWAHL AUSWAHL, 
      d010101.ins_date, d010101.upd_date
      BULK COLLECT INTO vBA 
      FROM vis_d010101 d010101 
      JOIN vis_a010108 a010108 ON a010108.sid = d010101.a010108_sid
       AND d010101.deleted = 0
       AND d010101.aktiv = 1
       AND d010101.d0101_id = pD0101_ID
       AND a010108.skz in (1,2,3,5)
       AND (a010108.fb LIKE '%H%' OR
            a010108.fb LIKE '%U%' OR 
            a010108.fb LIKE '%D%' OR 
            a010108.fb LIKE '%P%' OR 
            a010108.fb LIKE '%T%' OR 
            a010108.fb LIKE '%A%' OR 
            a010108.fb LIKE '%F%' OR 
            a010108.fb LIKE '%W%' OR 
            a010108.fb LIKE '%R%' OR 
            a010108.fb LIKE '%N%' OR 
            a010108.fb LIKE '%L%' )

      AND ( a010108.skz = 2 OR -- alle LM-Betriebsarten, auer in Thringen
            -- nur Betriebsarten, die im Zuordnungskatalog enthalten sind 
            -- 29.08.2013 
            EXISTS ( SELECT 1 
                         FROM vis_va0089_hit_betriebstyp_05 ax
                         WHERE a010108.sid = ax.sid
                           AND ax.tv_pos IN( d010101.gewerbsmaessig, 2)
                    )                   
           ) ;         
   
  ELSE  -- TH

    SELECT d010101.id, ax.A010108_SID, ax.a010108_bez, ax.a010108_code, D010101.GEWERBSMAESSIG, 
    D010101.GUELTIG_VON, D010101.GUELTIG_BIS, 
    d010101.angemeldet, d010101.abgemeldet, 
    ax.auswahl,
    d010101.ins_date, d010101.upd_date
    BULK COLLECT INTO vBA
    FROM vis_d010101 d010101
    JOIN vis_va0089_zbr_betriebstyp ax ON d010101.a010108_sid = ax.a010108_sid
    WHERE D010101.D0101_ID = pD0101_ID
      AND d010101.deleted = 0
      AND d010101.aktiv = 1 

    ORDER BY ax.a010108_bez;   

  
  END IF;
  
  -- ltestes Anmeldedatum und neuestes Abmeldedatum der BA ermitteln
  vBaDatum := NULL;
  --vBA_angemeldet := NULL;
  --vBA_abgemeldet := NULL;
  --vBA_angem_ins_date := NULL;
  --vBA_abgem_upd_date := NULL;
  
  IF vBA.COUNT > 0 THEN

    FOR i IN 1 .. vBA.LAST LOOP
      
      IF vBaDatum.angemeldet IS NULL THEN
        vBaDatum.angemeldet := vBA(i).angemeldet;  -- 1. Anmeldedatum <> NULL
        vBaDatum.angem_ins_date := vBA(i).ins_date;
        vBaDatum.angem_bez := vBa(i).a010108_bez;
      ELSIF vBaDatum.angemeldet > vBA(i).angemeldet THEN   
        vBaDatum.angemeldet := vBA(i).angemeldet;  -- lteste Anmeldedatum       
        vBaDatum.angem_ins_date := vBA(i).ins_date;
        vBaDatum.angem_bez := vBa(i).a010108_bez;
      END IF;
     
     -- letzte Abmeldedatum, wenn NULL das gibt es noch angemeldete BA's
      IF vBA(i).abgemeldet IS NULL OR vBaDatum.abgem_upd_date IS NULL THEN
        vBaDatum.abgemeldet := vBA(i).abgemeldet; -- Abmeldedatum = NULL, angemeldete BA vorh.
        vBaDatum.abgem_upd_date := vBA(i).upd_date;
        vBaDatum.abgem_bez := vBa(i).a010108_bez;
   
      ELSIF vBaDatum.abgemeldet < vBA(i).abgemeldet THEN
        vBaDatum.abgemeldet := vBA(i).abgemeldet;  -- neuestes Abmeldedatum
        vBaDatum.abgem_upd_date := vBA(i).upd_date;
        vBaDatum.abgem_bez := vBa(i).a010108_bez;
      END IF;
    END LOOP;

  END IF;
  
  -- 13.07.2012 in der Zukunft angemeldetet gelten als gltige Reg.-Nr.
  SELECT d010102.id, d010102.nummer, /*NVL(d010102.gueltig_bis, vDateMax)*/ 
         D010102.F$GUELTIG_BIS gueltig_bis, d010102.upd_date
  BULK COLLECT INTO vRegNr
  FROM vis_vd010102$01 d010102
  WHERE D010102.D0101_ID = pD0101_ID
    AND d010102.deleted = 0
    AND d010102.nummer IS NOT NULL -- 02.06.2015
    --31.08.2012 AND f$gueltig_bis > SYSDATE
    AND d010102.A010145_SID = vA010145_SID_HIT;  
 
  IF vD0101.ID <> vD0101.D0101_ID3 THEN -- abweichender Betreiber
    SELECT d010102.id, d010102.nummer, /*NVL(d010102.gueltig_bis, vDateMax)*/
          D010102.F$GUELTIG_BIS gueltig_bis, d010102.upd_date
    BULK COLLECT INTO vRegNr$3
    FROM vis_vd010102$01 d010102
    WHERE D010102.D0101_ID = vD0101.D0101_ID3
      AND d010102.deleted = 0
      AND d010102.nummer IS NOT NULL  -- 02.06.2015
      --31.08.2012 AND f$gueltig_bis > SYSDATE
      AND d010102.A010145_SID = vA010145_SID_HIT;    
  ELSE
    vRegNr$3 := NULL;
  END IF;
   
  IF vD0101IsNew = 5 THEN -- Export als Dublette - wie bei Neu verarbeiten
    vD0101IsNew := 1;
  ELSE

    SELECT CASE WHEN COUNT(*) > 0 THEN 0 ELSE 1 END INTO vD0101IsNew
    FROM aus_d_protokoll prt
    WHERE prt.d0101_id = pD0101_ID
     AND prt.deleted > -2;
  END IF;
  
  IF vD0101IsNew = 0 THEN -- Letzte Lastmodified ermitteln
    SELECT MAX(lastmodified) INTO vLastUpd
    FROM aus_d_protokoll prt
    WHERE prt.d0101_id = pD0101_id 
      AND PRT.DELETED > -2;
  ELSE
    vLastUpd := NULL;
  END IF;

END ReadAllData;

FUNCTION GetTage( pD1 IN DATE, pD2 IN DATE) RETURN VARCHAR2 AS
vTage PLS_INTEGER;
BEGIN
  vTage := TRUNC(pD1) - TRUNC(pD2);
  RETURN vTage || CASE WHEN vTage = 1 THEN ' Tag' ELSE ' Tage' END; 
END GetTage;

FUNCTION chkPERS_ID(pD0101 IN vis_d0101%ROWTYPE) RETURN NUMBER AS

CURSOR c1 ( pD0101_ID IN VARCHAR2) IS
  SELECT DISTINCT
    CASE fkt.typ
    WHEN 'INH' THEN 'Der Betreiber hat keine PERS_ID.'
    WHEN 'HV'  THEN 'Der Hauptansprechpartner hat keine PERS_ID.'
    ELSE 'Der TYP ' || fkt.typ || ' hat keine PERS_ID.'
    END fehler
  FROM aus_d_funktion fkt 
  JOIN (
    SELECT dx.d_bts_id
    FROM (
      SELECT prt.d_bts_id, prt.ins_date
      FROM aus_d_protokoll prt
      WHERE prt.d0101_id = pD0101_ID
      ORDER BY prt.ins_date DESC
    ) dx WHERE ROWNUM = 1  
  ) d0 on fkt.d_bts_id = d0.d_bts_id
  join aus_d_person prs on prs.id = fkt.d_pers_id
  and prs.pers_id = '0';
  
TYPE t1 IS TABLE OF c1%ROWTYPE; 
v1 t1;
vRes PLS_INTEGER := 0;  
BEGIN

  OPEN c1 ( pD0101.ID );
  FETCH c1 BULK COLLECT INTO v1;
  CLOSE c1;
  
  IF v1.COUNT > 0 THEN
    FOR i IN v1.FIRST .. v1.LAST LOOP
      AddError( pText => v1(i).fehler, pPrio => 1, pRegel => NULL);
    END LOOP;
    
  ELSE
    vRes := 1;
  END IF;
  RETURN vRes;
END chkPERS_ID;

-- FM-Ttigkeits-Kodierungen
PROCEDURE ChkFM_KOD (pD0101 IN vis_d0101%ROWTYPE) AS 
  vFM_KOD VARCHAR2(100) := NULL;
  vFM_KOD_AB VARCHAR2(20);
  vID VARCHAR2(32);
BEGIN
    
  --15610001    FM-Ttigkeit(en)  FM_KOD
  --17975001    FM-Ttigkeit(en) gltig ab  FM_KOD_AB
  --17976001    Angaben zu den FM-Ttigkeiten gem. Kodierkatalog  FM_KOD_ANG
  --17977001    FM-Ttigkeit(en) an HIT  FM_KOD_AN_HIT
  --19596001    FM-Ttigkeit(en) detailliert  FM_KOD_D
   
  FOR c1 IN (
    SELECT d010110.id, a01080201.fieldcode, d010110.wert   
    FROM vis_a010802 a010802
    JOIN vis_d010110 d010110 ON d010110.d0101_id = pD0101.id   
      AND d010110.deleted = 0
      AND d010110.a010802_sid = a010802.sid
      AND d010110.wert IS NOT NULL      
    JOIN vis_a01080201 a01080201 ON d010110.a01080201_sid = a01080201.sid
      AND a01080201.a010802_sid = a010802.sid
      AND a01080201.fieldcode IN( 'FM_KOD', 'FM_KOD_AB')
      AND a01080201.deleted = 0
      AND a010802.code = '1210'
      AND a010802.deleted = 0      
  ) LOOP
    IF c1.fieldcode = 'FM_KOD' THEN
      vFM_KOD := c1.wert;
      vID := c1.id;
    ELSIF c1.fieldcode = 'FM_KOD_AB' THEN
      vFM_KOD_AB := c1.wert;
    END IF;          
  END LOOP;

  IF vFM_KOD IS NOT NULL AND vFM_KOD_AB IS NULL THEN
    AddError(pText => 'Zu der Futtermittel-Kodierung ' || vFM_KOD || ' fehlt "Gltig ab".', pPrio => 1, pRegel => '06.06'); 
  END IF;  
END ChkFM_KOD;
    
-- berprfung der Zulassungen die als BA exportiert werden
-- todo 57553090: 08.04.2015
PROCEDURE ChkNZR(pD0101 IN vis_d0101%ROWTYPE) AS
  
  CURSOR c1_TH (pID IN vis_d0101.id%TYPE) IS
  SELECT d010102.a010145_bez bez, d010102.gueltig_von, d010102.gueltig_bis
  , TO_CHAR(d010102.gueltig_von, 'dd.mm.yyyy') g1 , TO_CHAR(d010102.gueltig_bis, 'dd.mm.yyyy') g2
  FROM vis_vd010102$01 d010102
  WHERE d010102.d0101_id = pID
    AND d010102.a010145_sid IN ( 1459001, 1330001, 1331001, 1135001, 1136001 );
  --sid       code      skz del bez
  --514001    0102      10  0   Registriernummer (HIT)
  --1576001   010201    10  -1  Unternehmen-Ident Nr.
  --1574001   010202    10  -1  Person-Ident Nr.
  --541001    0104      10  0   TSK-Nr.
  --1606001   0103      10  0   Betreiber_ID (Betriebsregister)
  --1459001   010417    30  0   Ermchtigung zur Ausstellung von Heimtierausweisen und Entnahme von Blutpr. zur Titrierung Tollwutantik. gem. VO (EU) 576/2013
  --1330001   01042103  60  0   Zulassung Transportunternehmen nach Art. 10 Abs. 1 VO (EG) Nr. 1/2005
  --1331001   01042104  60  0   Zulassung Transportunternehmen (lange Befrderungen) nach Art. 11 Abs. 1 VO (EG) Nr. 1/2005          
  --1135001   01042101  60  0   Zulassung Transportunternehmer nach  13 ViehVerkV u. Art. 10 Abs. 1 VO (EG) 1/2005
  --1136001   01042102  60  0   Zulassung Transportunternehmer (lange Befrderungen) nach  13 ViehVerkV u. Art. 11 Abs. 1 VO (EG) 1/2005
  
  -- todo 58123090 29.06.2015
  CURSOR c1_NRW (pID IN vis_d0101.id%TYPE) IS
  SELECT d010102.a010145_bez bez, d010102.gueltig_von, d010102.gueltig_bis
  , TO_CHAR(d010102.gueltig_von, 'dd.mm.yyyy') g1 , TO_CHAR(d010102.gueltig_bis, 'dd.mm.yyyy') g2
  FROM vis_vd010102$01 d010102
  WHERE d010102.d0101_id = pID
  AND (
    (d010102.a010145_code LIKE '011103%' AND d010102.a010145_skz = 60) -- ZU10    
     OR (d010102.a010145_code LIKE '021104%' AND d010102.a010145_skz = 70)    -- FM Reg. 
  );

  TYPE t1 IS TABLE OF c1_TH%ROWTYPE;
  v1 t1;       
  vAnm VARCHAR2(10) := TO_CHAR(pD0101.anmeldung, 'dd.mm.yyyy');
  vAbm VARCHAR2(10) := TO_CHAR(pD0101.abmeldung, 'dd.mm.yyyy');
     
BEGIN

  IF vVerfahren = QUELLE_IDV_NRW THEN
    OPEN c1_NRW (pD0101.ID);
    FETCH c1_NRW BULK COLLECT INTO v1;
    CLOSE c1_NRW;
  ELSE
    OPEN c1_TH (pD0101.ID);
    FETCH c1_TH BULK COLLECT INTO v1;
    CLOSE c1_TH;
  END IF;
  
  IF v1.COUNT > 0 THEN
    FOR i IN v1.FIRST .. v1.LAST LOOP
   
      IF vVerfahren = QUELLE_IDV_NRW THEN
        IF v1(i).gueltig_von IS NULL THEN
          AddError( pText => v1(i).bez || ' hat keine Gltigkeit. Bitte erfassen Sie die Gltigkeit.', pPrio => 1, pRegel => '06.05');            
        END IF; 
        
      ELSE
        CASE
        WHEN v1(i).gueltig_von IS NULL THEN
          AddError( pText => v1(i).bez || ' - Gltig von fehlt.', pPrio => 1, pRegel => '06.01');    
        WHEN v1(i).gueltig_von < pD0101.anmeldung THEN
          AddError( pText => v1(i).bez || ' - Gltig von ' || v1(i).g1 || 
            ' liegt vor der Anmeldung ' || vAnm || ' der Betriebssttte.', pPrio => 1, pRegel => '06.02');    

        WHEN v1(i).gueltig_bis > pD0101.abmeldung THEN
          AddError( pText => v1(i).bez || ' - Gltig bis ' || v1(i).g2 || 
          ' liegt nach der Abmeldung ' || vAbm || ' der Betriebssttte.', pPrio => 1, pRegel => '06.03');    
        
        WHEN v1(i).gueltig_bis IS NULL AND pD0101.abmeldung IS NOT NULL THEN
          AddError( pText => v1(i).bez || ' - Ist noch gltig und die Betriebssttte ist abgemeldet am ' || vAbm || '.', pPrio => 1, pRegel => '06.04');    
          
        ELSE NULL;
        END CASE;
      END IF;      
    END LOOP;
  END IF;
END ChkNZR;

/* berprfung der Gltigkeit des Betriebs ber die Betriebsarten
  alle BA ohne Anmeldedatum -> Betriebssttte - Anmeldedatum fehlt.
  lteste d010101.angemeldet > d010101.ins_date -> Betriebssttte - Anmeldedatum ist vordatiert n Tag(e)
  jngste d010101.abgemeldet > d010101.upd_date -> Betriebssttte - Abmeldedatum ist vordatiert n Tag(e)
  jngste d010101.abgemeldet < d010101.upd_date -> Betriebssttte - Abmeldedatum ist rckdatiert n Tag(e)
*/  
PROCEDURE ChkGueltigBA(pD0101 IN VIS_D0101%ROWTYPE) AS 
BEGIN

  -- BA ohne Anmeldung 
  -- todo 58263090 01.07.2015
  --IF vBA.Count > 0 AND vBA_angemeldet IS NULL THEN
  --  AddError(pType || ' - Anmeldedatum fehlt.', 1);    
  --END IF;
  
  IF vBA.Count = 0 AND vD0101.anmeldung IS NULL THEN
    AddError(pText => 'Betriebssttte - Anmeldedatum fehlt.', pPrio => 1, pRegel => '01.01');      
  END IF;
   
  IF vD0101IsNew = 1 AND vBaDatum.angemeldet > vBaDatum.angem_ins_date THEN
    AddWarning(pText => vBaDatum.angem_bez || ' - Anmeldedatum ist vordatiert ' || GetTage(vBaDatum.angemeldet, vBaDatum.angem_ins_date), 
               pPrio => 2, pRegel => '01.02' );
  END IF;
  
  IF vBaDatum.abgemeldet > vBaDatum.abgem_upd_date THEN
    AddWarning(pText => vBaDatum.abgem_bez || ' - Abmeldedatum ist vordatiert ' || GetTage(vBaDatum.abgemeldet, vBaDatum.abgem_upd_date), 
               pPrio => 2, pRegel => '01.03' );
  END IF; 
  
  IF vBaDatum.abgemeldet < TRUNC(vBaDatum.abgem_upd_date)   THEN
    AddWarning(pText => vBaDatum.abgem_bez || ' - Abmeldedatum ist rckdatiert '  || GetTage(vBaDatum.abgem_upd_date, vBaDatum.abgemeldet), 
               pPrio => 2, pRegel => '01.04');
  END IF;  

END ChkGueltigBA;


PROCEDURE ChkGueltig(pD0101 IN VIS_D0101%ROWTYPE, pType IN VARCHAR2 := 'Betriebssttte') AS
BEGIN

  IF pD0101.anmeldung IS NULL THEN
    AddError(pText => pType || ' - Anmeldedatum fehlt.', pPrio => 1, pRegel => '01.05');
  END IF;    
  
  IF vD0101IsNew = 1 AND pD0101.anmeldung > pD0101.upd_date THEN
    AddWarning(pText => pType || ' - Anmeldedatum ist vordatiert ' || GetTage(vD0101.anmeldung, pD0101.upd_date), 
               pPrio => 2, pRegel => '01.06' );
  END IF;
 
  --IF vGKZ2 <> vGKZ2NRW THEN
    --IF vD0101IsNew = 1 AND Not vErstMode AND pD0101.anmeldung < TRUNC(pD0101.upd_date) THEN
    --  AddWarning(pType || ' - Anmeldedatum ist rckdatiert ' || (TRUNC(pD0101.ins_date) - vD0101.anmeldung) || ' Tag(e)',2 );          
    --END IF;
  --END IF;
  
  IF pD0101.abmeldung > pD0101.upd_date THEN
    AddWarning( pText => pType || ' - Abmeldedatum ist vordatiert ' || GetTage(vD0101.abmeldung, pD0101.upd_date), 
                pPrio => 2, pRegel => '01.07' );
  END IF; 
  
  -- 15.05.2012 IF pD0101.Abmeldung BETWEEN vDateMin + 1 AND TRUNC(pD0101.upd_date)  THEN
  IF pD0101.Abmeldung BETWEEN vDateMin + 1 AND TRUNC(pD0101.upd_date) - 1  THEN
    AddWarning(pText => pType || ' - Abmeldedatum ist rckdatiert '  || GetTage(pD0101.upd_date, vD0101.abmeldung), 
               pPrio => 2, pRegel => '01.08');
  END IF;  

END ChkGueltig;

PROCEDURE ChkBezeichnung AS --(pD0101 IN VIS_D0101%ROWTYPE, pAdrType IN VARCHAR2 := 'Standortadresse') AS
  vBez1 VARCHAR2(1000);
  vBez2 VARCHAR2(1000);

  CURSOR cD0102 ( pID IN vis_d010200.d0101_id%TYPE) IS  
    SELECT D0102.NNAME
    FROM vis_d010200 d010200
    JOIN vis_d0102 d0102 ON d0102.id = d010200.d0102_id
      AND d0102.deleted = 0
      AND d010200.deleted = 0
      AND d010200.d0101_id = pID
      AND d010200.inhaber = 1;  
  
  vD0102 cD0102%ROWTYPE;

BEGIN
  -- 30.11.2013
  -- todo 57671090: Anpassung der Logik an das Schreiben in den Ausgangskorb
  CASE
  WHEN blvUtils.bea_konform(vD0101$3.daten_herkunft) = 1 THEN
    vBez1 := NVL( vD0101$3.hit_bez_1, vD0101$3.bez);    
    vBez2 := vD0101$3.hit_bez_2;        

  WHEN vD0101$3.bez_art = 'F' THEN -- Firma
    IF vD0101$3.abw_post = 1 THEN -- abweichende Post
      vBez1 := NVL(NVL( vD0101$3.hit_p_bez_1, vD0101$3.hit_bez_1), vD0101$3.p_name);    
      vBez2 := NVL(vD0101$3.hit_p_bez_2, vD0101$3.hit_bez_2);    
    ELSE 
      vBez1 := NVL( vD0101$3.hit_bez_1, vD0101$3.p_name);    
      vBez2 := vD0101$3.hit_bez_2;    
    END IF;    
     
  ELSE -- Person

    IF vD0101$3.abw_post = 1 THEN -- abweichende Post
      vBez1 := NVL( NVL( vD0101$3.hit_p_bez_1, vD0101$3.hit_bez_1), vD0101$3.bez); -- 20.05.2014 vD0101$3.bez  
      vBez2 := vD0101$3.hit_p_bez_2;    
    ELSE 
      vBez1 := NVL( vD0101$3.hit_bez_1, vD0101$3.bez);    
      vBez2 := vD0101$3.hit_bez_2;    
    END IF;  

   
  END CASE;
  
  IF vBez1 IS NULL THEN
    AddError(pText => 'Bezeichnung (1.Zeile) des Betreibers fehlt.', pPrio => 1, pRegel => '02.01');     
  ELSIF LENGTH(vBez1) > 30 AND NOT zbr_aus_data.vErstMode THEN
    --24.07.2013 AddError('Bezeichnung (1.Zeile) des Betreibers ist lnger als 30 Zeichen.', 2, vErstMode);      
    --02.06.2015 Abspreche Herr Schulze  AddWarning('Bezeichnung (1.Zeile) des Betreibers ist lnger als 30 Zeichen.', 2);
    AddError(pText => 'Bezeichnung (1.Zeile) des Betreibers ist lnger als 30 Zeichen.', pPrio => 2, pRegel => '02.02');
  END IF;
     
  IF LENGTH(vBez2) > 30 AND NOT zbr_aus_data.vErstMode THEN
    --24.07.2013 AddError('Bezeichnung (2.Zeile) des Betreibers ist lnger als 30 Zeichen.', 2, vErstMode);      
    --02.06.2015 Abspreche Herr Schulze  AddWarning('Bezeichnung (2.Zeile) des Betreibers ist lnger als 30 Zeichen.', 2);
    AddError(pText => 'Bezeichnung (2.Zeile) des Betreibers ist lnger als 30 Zeichen.', pPrio => 2, pRegel => '02.03');
  END IF;   
  
  
  -- 02.06.2015
  -- 22.06.2015 todo 58199090: Plausi auch fr NRW
  IF vD0101$3.bez_art <> 'F' THEN

    OPEN cD0102( vD0101$3.id );
    FETCH cD0102 INTO vD0102;
    IF ((cD0102%NOTFOUND OR vD0102.nname IS NULL  ) AND blvUtils.bea_konform(vD0101$3.daten_herkunft) = 1 ) OR
    ( vD0101$3.nname IS NULL AND blvUtils.bea_konform(vD0101$3.daten_herkunft) = 0 ) THEN  
      AddError(pText => 'Der Nachname des Betreibers ist nicht vorhanden.', pPrio => 1, pRegel => '02.04' );
    END IF;
    CLOSE cD0102;
     
  END IF;
  
END ChkBezeichnung;  

-- todo 48046090
PROCEDURE ChkHVName AS
  vNName VIS_D0102.NNAME%TYPE;
  vVName VIS_D0102.VNAME%TYPE;
  vFound BOOLEAN := FALSE;
    
  CURSOR c1 IS
    SELECT d0102.nname, d0102.vname
    FROM vis_d0102 d0102
    JOIN vis_d010200 d010200 ON d010200.d0102_id = d0102.id
    AND d0102.deleted = 0
    AND d010200.deleted = 0
    --AND d010200.HAUPTANSPRECHPARTNER = 1
    AND d010200.id = vD0101.d010200_id2;
  
BEGIN

  IF vD0101.d010200_id2 <> '-1' THEN 
    OPEN c1;
    FETCH c1 INTO vNNAme, vVName;
    IF c1%FOUND THEN    
      vFound := TRUE;
      CASE
      WHEN vVName IS NULL AND vNName IS NOT NULL THEN
        AddError( pText => 'Der Vorname des HV fehlt.', pPrio => 1, pRegel => '09.01.01');  
      WHEN vNName IS NULL AND vVName IS NOT NULL THEN
        AddError( pText => 'Der Nachname des HV fehlt.', pPrio => 1, pRegel => '09.01.02');
      ELSE NULL;  
      END CASE;
      
    END IF;
    CLOSE c1;
  END IF;
  
  IF vD0101.d010200_id2 = '-1' OR NOT vFound THEN
    CASE
    WHEN vD0101.vname IS NULL AND vD0101.nname IS NOT NULL THEN
      AddError( pText => 'Der Vorname des HV fehlt.', pPrio => 1, pRegel => '09.01.03');  
    WHEN vD0101.nname IS NULL AND vD0101.vname IS NOT NULL THEN
      AddError( pText => 'Der Nachname des HV fehlt.', pPrio => 1, pRegel => '09.01.04');
    ELSE NULL;  
    END CASE;
  END IF;
  
END ChkHVName;

PROCEDURE ChkStandortAdresse(pD0101 IN VIS_D0101%ROWTYPE, pAdrType IN VARCHAR2 := 'Standortadresse') AS
  bOk BOOLEAN := True;
  vCnt PLS_INTEGER;
BEGIN
  -- Standortadresse-PLZ fehlt
  IF NOT (vBAnotExport = 1 AND pAdrType = 'Standortadresse') THEN
  
    -- todo 56675090 14.04.2015: einheitliche Prfung fr alle BL
    IF pD0101.PLZ IS NULL AND pD0101.ambulant_jn IN( 0, 2) THEN
      AddError( pText => pAdrType || ' - PLZ fehlt.', pPrio => 1, pRegel => '04.02');
      bOK := False;    
    END IF;
    
    -- todo 56675090 14.04.2015: einheitliche Prfung fr alle BL
    -- Standortadresse-Ort fehlt
    IF pD0101.ORT IS NULL AND pD0101.ambulant_jn IN( 0, 2) THEN
      AddError(pText => pAdrType || ' - Ort fehlt.', pPrio => 1, pRegel => '04.02');    
      bOK := False;    
    END IF;  
      
    -- Standortadresse-Strae fehlt
    IF pD0101.STRASSE IS NULL THEN
      CASE pD0101.ambulant_jn 
      WHEN 2 THEN -- Freitext
        AddError(pText => pAdrType || ' - freitextliche Beschreibung fehlt.', pPrio => 1, pRegel => '03.04');    
        bOK := False;
      -- todo 56675090 14.04.2015: einheitliche Prfung fr alle BL
      WHEN 0 THEN  -- Standard
        AddError(pText => pAdrType || ' - Strae fehlt.', pPrio => 1, pRegel => '03.05');    
        bOK := False;    
      ELSE NULL;
      END CASE;      
    END IF;

    -- GKZ 8 nicht vorhanden
    IF LENGTH(pD0101.GKZ) >= 8 THEN
      NULL;  -- OK nichts machen
    ELSIF pD0101.ambulant_jn IN ( 0, 2 ) THEN
      -- todo 45335090: fehlende GKZ als Fehler
      --AddWarning(pAdrType || ' - GKZ 8 ist nicht vorhanden.', 1);
      AddError(pText => pAdrType || ' - GKZ 8 ist nicht vorhanden.', pPrio => 1, pRegel => '03.06');    
    END IF;
  END IF;
    
  -- Standortadresse-PLZ lnger als  8 Zeichen
  IF LENGTH(pD0101.PLZ) > 8 THEN
    AddError(pText => pAdrType || ' - PLZ ist lnger als 8 Zeichen.', pPrio => 2, pRegel => '03.07');
    bOK := False;    
  END IF;
 
  -- Standortadresse-Ort lnger als 50 Zeichen
  IF LENGTH(pD0101.ORT) > 50 THEN
    AddError(pText => pAdrType || ' - Ort ist lnger als 50 Zeichen.', pPrio => 2, pRegel => '03.08');
    bOK := False;    
  END IF;
-- 
  -- Standortadresse-Ortsteil lnger als 50 Zeichen
  IF LENGTH(pD0101.ORTSTEIL) > 50 THEN
    AddError(pText => pAdrType || ' - Ortsteil ist lnger als 50 Zeichen.', pPrio => 2, pRegel => '03.09');
    bOK := False;    
  END IF;
  
  -- Standortadresse-Strae+Hausnummer  lnger als 50 Zeichen
  IF LENGTH(pD0101.strasse || pD0101.hausnr) > 50 THEN
    AddError(pText => pAdrType || ' - Strae und Hausnummer sind lnger als 50 Zeichen.', pPrio => 2, pRegel => '03.10');
    bOK := False;    
  END IF;  

  -- nicht prfen wenn Ort mit "Standort" beginnt
  IF bOK AND LOWER(pD0101.ort) NOT LIKE 'standort%' 
  AND pAdrType = 'Standortadresse'
  AND pD0101.ambulant_jn = 0 THEN -- Prfung ber PLZ-Verzeichnis GLO_A26
  -- ambulant_jn 0 : Standard, 1 : wechselnder Standort, 2 : freitextliche Standortbeschreibung 
    SELECT COUNT(*) INTO vCnt
    FROM glo_a26 a26
    WHERE a26.plz = pD0101.plz
     AND a26.deleted = 0
     AND a26.bez = pD0101.ort
     AND NVL(a26.ortsteil, 'X') LIKE pD0101.ortsteil || '%';
    
    IF vCnt = 0 THEN
      AddWarning( pText => pAdrType || ' ist ungltig gem PLZ-Verzeichnis.', 
                  pPrio => 2, pRegel => '03.11');
      bOK := False;
    END IF;
    
  END IF;

  IF bOK AND LOWER(pD0101.ort) NOT LIKE 'standort%' 
  AND pAdrType = 'Standortadresse'
  AND pD0101.ambulant_jn = 0 THEN -- Prfung ber Straenverzeichnis GLO_A27    
  -- ambulant_jn 0 : Standard, 1 : wechselnder Standort, 2 : freitextliche Standortbeschreibung

    SELECT COUNT(*) INTO vCnt
    FROM glo_a27 a27
    WHERE a27.plz = pD0101.plz
     AND a27.deleted = 0 
     AND a27.ort = pD0101.ort
     AND a27.bez = pD0101.strasse;
     
    IF vCnt = 0 THEN
      AddWarning(pText => pAdrType || ' ist ungltig gem Straenverzeichnis.', pPrio => 2, pRegel => '03.12');
      bOK := False;
    END IF;
    
  END IF;
  
END ChkStandortAdresse;

PROCEDURE ChkPostAdresse(pD0101 IN VIS_D0101%ROWTYPE, pAdrType VARCHAR2 := 'Postadresse') AS
  bOk BOOLEAN := True;
  vCnt PLS_INTEGER;
BEGIN
  -- Postadresse-PLZ fehlt
  IF pD0101.P_PLZ IS NULL THEN
    AddError(pText => pAdrType || ' - PLZ fehlt.', pPrio => 1, pRegel => '04.01');    
    bOK := False;
  END IF;
  
  -- Postadresse-Ort fehlt
  IF pD0101.P_ORT IS NULL THEN
    AddError(pText => pAdrType || ' - Ort fehlt.', pPrio => 1, pRegel => '04.02');    
    bOK := False;
  END IF;    
  
  -- Postadresse-PLZ lnger als  8 Zeichen
  IF LENGTH(pD0101.P_PLZ) > 8  AND vVerfahren <> QUELLE_IDV_NRW  THEN
    AddError(pText => pAdrType || ' - PLZ ist lnger als 8 Zeichen.', pPrio => 2, pRegel => '04.03');
    bOK := False;
  END IF;
  
  IF LENGTH(pD0101.P_PLZ) > 5  AND vVerfahren = QUELLE_IDV_NRW THEN
    AddError(pText => pAdrType || ' - PLZ ist lnger als 5 Zeichen.', pPrio => 2, pRegel => '04.04');
    bOK := False;
  END IF;
  
 
  -- Postadresse-Ort lnger als 50 Zeichen
  IF LENGTH(pD0101.P_ORT) > 50 AND vVerfahren <> QUELLE_IDV_NRW THEN
    AddError(pText => pAdrType || ' - Ort ist lnger als 50 Zeichen.', pPrio => 2, pRegel => '04.05');
    bOK := False;
  END IF;
 
  -- Postadresse-Ortsteil lnger als 50 Zeichen
  IF LENGTH(pD0101.P_ORTSTEIL) > 50  AND vVerfahren <> QUELLE_IDV_NRW THEN
    AddError(pText => pAdrType || ' - Ortsteil ist lnger als 50 Zeichen.', pPrio => 2, pRegel => '04.06');
    bOK := False;
  END IF;

  -- GKZ 8 nicht vorhanden
--  IF pD0101.GKZ IS NULL THEN
--    AddError(pAdrType || ' GKZ 8 ist nicht vorhanden', 1);
--  END IF;
  
  -- Strae+Hausnummer  lnger als 50 Zeichen
  IF pD0101.IS_POSTFACH = 0 AND LENGTH(pD0101.p_strasse || pD0101.p_hausnr) > 50 AND vVerfahren <> QUELLE_IDV_NRW THEN
    AddError(pText => pAdrType || ' - Strae und Hausnummer sind lnger als 50 Zeichen.', pPrio => 2, pRegel => '04.07');
    bOK := False;
  END IF;  
  
  -- Postadresse-Strae fehlt
  IF pD0101.p_strasse IS NULL THEN
    IF pD0101.IS_POSTFACH = 1 THEN
      -- todo 66326090: Umstellung als Warnung   
      AddWarning(pText => pAdrType || ' - Postfachnummer fehlt.', pPrio => 1, pRegel => '04.08');
    ELSE
      AddError(pText => pAdrType || ' - Strae fehlt.', pPrio => 1, pRegel => '04.09');    
      bOK := FALSE;
    END IF;
  END IF;
    
  -- nur prfen wenn es kein Postfach ist
  IF bOK AND pD0101.IS_POSTFACH = 0 AND vVerfahren <> QUELLE_IDV_NRW THEN -- Prfung ber PLZ-Verzeichnis GLO_A26 wenn kein Postfach
    SELECT COUNT(*) INTO vCnt
    FROM glo_a26 a26
    WHERE a26.plz = pD0101.p_plz
     AND a26.deleted = 0
     AND a26.bez = pD0101.p_ort;
    
    IF vCnt = 0 THEN
      AddWarning( pText => pAdrType || ' ist ungltig gem PLZ-Verzeichnis.', pPrio => 2, pRegel => '04.10');
      bOK := False;
    END IF;
    
  END IF;

  IF bOK AND pD0101.IS_POSTFACH = 0 AND vVerfahren <> QUELLE_IDV_NRW THEN -- Prfung ber Straenverzeichnis GLO_A27 wenn kein Postfach   
    SELECT COUNT(*) INTO vCnt
    FROM glo_a27 a27
    -- todo 62830090
    WHERE a27.plz = pD0101.p_plz
     AND a27.deleted = 0
     AND a27.ort = pD0101.p_ort
     AND a27.bez = pD0101.p_strasse;
     
    IF vCnt = 0 THEN
      AddWarning( pText => pAdrType || ' ist ungltig gem Straenverzeichnis.', pPrio => 2, pRegel => '04.11');
      bOK := False;
    END IF;
    
  END IF;  
  
  IF vVerfahren = QUELLE_IDV_NRW AND pD0101.IS_POSTFACH = 0 AND pD0101.P_HAUSNR IS NULL THEN
    AddError(pText => pAdrType || ' - Hausnummer fehlt.', pPrio => 1, pRegel => '04.12');
  END IF;
  
END ChkPostAdresse;


PROCEDURE ChkBetriebsarten AS 
 vCnt PLS_INTEGER;
 vMinBA_angemeldet DATE;
 vMinBAi PLS_INTEGER := 0;
 vSYSDATE CONSTANT DATE := SYSDATE;
 
 CURSOR cBA (pID IN VARCHAR2 ) IS
 SELECT 1 f1
 FROM aus_d_betriebsart ba
 WHERE ba.ref_id = pID;

  --1330001   01042103  60  0   Zulassung Transportunternehmen nach Art. 10 Abs. 1 VO (EG) Nr. 1/2005
  --1331001   01042104  60  0   Zulassung Transportunternehmen (lange Befrderungen) nach Art. 11 Abs. 1 VO (EG) Nr. 1/2005          
  --1135001   01042101  60  0   Zulassung Transportunternehmer nach  13 ViehVerkV u. Art. 10 Abs. 1 VO (EG) 1/2005
  --1136001   01042102  60  0   Zulassung Transportunternehmer (lange Befrderungen) nach  13 ViehVerkV u. Art. 11 Abs. 1 VO (EG) 1/2005           
 CURSOR cD010102 (pID IN VARCHAR2) IS
 SELECT MIN(D010102.ID) ID, MIN(d010102.f$gueltig_von) f$gueltig_von, MAX(d010102.f$gueltig_bis) f$gueltig_bis
 FROM vis_vd010102$01 d010102
 WHERE D010102.D0101_ID = pID
   AND d010102.deleted = 0
   AND d010102.A010145_SID IN (1330001, 1331001, 1135001, 1136001);
  
  TYPE tD010102 IS TABLE OF cD010102%ROWTYPE;
  vD010102 tD010102;      
    
BEGIN

  -- Betriebssttte hat keine relevante Betriebsart
  IF vBA.COUNT = 0 AND NOT vBatchMode AND NOT ZBR_AUS_DATA.vErstMode THEN
    -- hat letzter Export BA dann Export auch ohne BA zulassen  
    SELECT COUNT(*) cnt INTO vBAcnt
    FROM aus_d_betriebsart ba     
    JOIN (  
      SELECT * 
      FROM (
        SELECT prt.d_bts_id, prt.ins_date
        FROM aus_d_protokoll prt
        WHERE prt.d0101_id = vD0101.ID
        ORDER BY prt.ins_date DESC
        ) dx 
      WHERE rownum = 1 ) d2 ON ba.d_bts_id = d2.d_bts_id
      AND ba.art <> 'HFMUN';
        
    IF vBAcnt = 0 THEN    
      AddError(pText => 'Betriebssttte hat keine relevante Betriebsart.', pPrio => 2, pRegel => '05.01', pIgnor_im_Batch => False);    
    END IF;
    RETURN;
  END IF;

  vBAcnt := 0;
  
  IF vVerfahren <> QUELLE_IDV_NRW THEN
    OPEN cD010102( vD0101.ID );
    FETCH cD010102 BULK COLLECT INTO vD010102 LIMIT 1;     
    CLOSE cD010102;  
  END IF;
  
  IF vBA.COUNT > 0 THEN 
  
    FOR i IN vBA.FIRST .. vBA.LAST LOOP
      IF vBA(i).angemeldet IS NULL THEN --OR vBA(i).angemeldet <= vDateMin
        AddError(pText => vBA(i).a010108_bez || ' Anmeldedatum fehlt.', pPrio => 1, pRegel => '05.03');
      END IF;
      
      IF vBA(i).auswahl = 0 AND (vBA(i).abgemeldet <= vDateMin OR vBA(i).abgemeldet IS NULL ) THEN
        IF vD0101IsNew = 1 AND vBatchMode THEN
          AddError(pText => vBA(i).A010108_bez || ' ist eine unspezifische Betriebsart.',pPrio =>  2, pRegel => '05.04', pIgnor_im_Batch => TRUE);
        ELSE
          AddError(pText => vBA(i).A010108_bez || ' ist eine unspezifische Betriebsart.', pPrio => 2, pRegel => '05.04');
        END IF;
      END IF;
      
  --    IF vD0101IsNew = 1 AND NOT vErstMode AND vBA(i).angemeldet > vBA(i).upd_date THEN
  --      AddWarning(vBA(i).a010108_bez || ' Anmeldedatum ist vordatiert ' || (vBA(i).angemeldet - TRUNC(vBA(i).upd_date)) || ' Tag(e)',2 );
  --    END IF;
     
  --    IF vD0101IsNew = 1 AND NOT vErstMode AND vBA(i).angemeldet < TRUNC(vBA(i).upd_date) THEN
  --      AddWarning(vBA(i).a010108_bez || ' Anmeldedatum ist rckdatiert ' || (TRUNC(vBA(i).upd_date) - vBA(i).angemeldet)  || ' Tag(e)',2 );
  --    END IF;

  --    IF vBA(i).abgemeldet > vBA(i).upd_date AND NOT vErstMode THEN
  --      AddWarning(vBA(i).a010108_bez || ' Abmeldedatum ist vordatiert ' || (vBA(i).abgemeldet - TRUNC(vBA(i).upd_date)) || ' Tag(e)',2 );
  --    END IF; 
      
  --    IF vBA(i).abgemeldet BETWEEN vDateMin AND TRUNC(vBA(i).upd_date) AND NOT vErstMode THEN
  --      AddWarning(vBA(i).a010108_bez || ' Abmeldedatum ist rckdatiert '  || (TRUNC(vBA(i).upd_date) - vD0101.abmeldung) || ' Tag(e)', 2);
  --    END IF;
      
      -- 23.01.2013
      -- angemeldete Betriebsarten zhlen, wird beim Prfen der Registriernr. verwendet
      IF NVL(vBA(i).abgemeldet, vSYSDATE) >= vSYSDATE THEN
        vBAcnt := vBAcnt + 1;
      END IF;   

      -- berprfung gewerbsmig
      IF i < vBA.LAST AND NVL(vBA(i).abgemeldet, vSYSDATE) >= vSYSDATE THEN            
        
        FOR y IN i+1 .. vBA.LAST LOOP
          IF vBA(i).d010101_ID <> vBA(y).d010101_ID THEN
            
            IF vBA(i).a010108_sid = vBA(y).a010108_sid 
            AND vBA(i).gewerbsmaessig <> vBA(y).gewerbsmaessig 
            AND NVL(vBA(y).abgemeldet, vSYSDATE) >= vSYSDATE THEN
            
              AddError( pText => vBA(i).a010108_bez || ': Es sind widersprchliche Angaben "gewerbsmig" vorhanden.', pPrio => 2, pRegel => '05.05');
            
            END IF;  
          END IF;
        END LOOP;
      END IF;
      
      -- berprfung Zirkus (27.08.2013)    
      CASE   
      WHEN vVerfahren <> QUELLE_IDV_NRW AND vBA(i).A010108_code IN ('040202') -- Zirkus
      -- todo 52820090
      AND vD0101.ambulant_jn IN( 0, 2) THEN -- 23.11.2015 auch bei freitextlich 
        -- abweichender Betreiber muss vorhanden sein
        IF vD0101.ID = vD0101$3.ID THEN
          AddError( pText => 'Zur Betriebssttte mit der Betriebsart "' || vBA(i).A010108_bez || '" muss ein abweichender Betreiber zugeordnet sein.', 
                    pPrio => 1, pRegel => '05.06', pIgnor_im_Batch => TRUE);
        ELSIF vD0101.ZB <> SUBSTR(vD0101$3.GKZ, 1,5) THEN -- nicht im gleichen ZB, Betreiber hat gleiche ZB wie Betrieb deshalb Vergleich mit GKZ5
          CASE 
          WHEN zbr_aus_data.vErstMode THEN -- 21.05.2015 Zirkus bei Erstbefllun exportieren
            NULL;  
          -- todo 59353090 27.10.2015: normale Verarbeitung im Batch  
          --WHEN vBatchMode THEN -- 20.09.2013
          --  AddError(NULL, 1);
          WHEN vD0101IsNew = 1 THEN -- bei neuem Betrieb 04.07.2014            
            -- todo 58263090 01.07.2015 AddError('Der Betreiber der Betriebssttte "' || vBA(i).A010108_bez || '" sitzt nicht im Zustndigkeitsbereich der Betriebssttte. Es wird keine Registriernummer vergeben.', 1);
            AddError(pText => 'Der Betreiber der Betriebssttte "' || vBA(i).A010108_bez || '" sitzt nicht im Zustndigkeitsbereich. Es wird keine Registriernummer vergeben.',
                     pPrio => 1, pRegel => '05.07', pIgnor_im_Batch => TRUE);
          -- todo 58195090 23.06.2015 Plausi nicht mehr notwendig, wird beim Export verarbeitet 
          --ELSE -- nderung          
            --AddError('Der Betreiber der Betriebssttte "' || vBA(i).A010108_bez || '" sitzt nicht im Zustndigkeitsbereich der Betriebssttte. Die nderung kann nicht bermittelt werden.', 1);
          ELSE NULL;
          END CASE;            
        END IF;          
      
      -- berprfung Transportunternehmen
      WHEN vVerfahren <> QUELLE_IDV_NRW AND ( vBA(i).A010108_code LIKE '020403%' OR vBA(i).A010108_code = '0406' ) THEN
        
        OPEN cBA ( vBA(i).d010101_id );
        FETCH cBA INTO vCnt;
        
        --IF vCnt = 0 THEN -- todo 52210090: nur bei neuen BA prfen (noch nicht im Ausgangskorb)
          -- berprfung Zulassungen 
          --1330001   01042103  60  0   Zulassung Transportunternehmen nach Art. 10 Abs. 1 VO (EG) Nr. 1/2005
          --1331001   01042104  60  0   Zulassung Transportunternehmen (lange Befrderungen) nach Art. 11 Abs. 1 VO (EG) Nr. 1/2005          
          --1135001   01042101  60  0   Zulassung Transportunternehmer nach  13 ViehVerkV u. Art. 10 Abs. 1 VO (EG) 1/2005
          --1136001   01042102  60  0   Zulassung Transportunternehmer (lange Befrderungen) nach  13 ViehVerkV u. Art. 11 Abs. 1 VO (EG) 1/2005
          
          /*SELECT COUNT(*) INTO vCnt        
          SELECT MIN(d010102.f$gueltig_von) f$gueltig_von, MAX(d010102.f$gueltig_bis) f$gueltig_bis
          FROM vis_vd010102$01 d010102
          WHERE D010102.D0101_ID = vD0101.ID
            AND d010102.deleted = 0
            AND d010102.A010145_SID IN (1330001, 1331001, 1135001, 1136001);
          
            --d010102.A010145_CODE IN ('01042101', '01042102', '01042103', '01042104')       
            --AND d010102.a010145_skz = 60;  
          IF vCnt = 0 THEN */
          -- todo 57298090
        CASE
        WHEN /*NOT zbr_aus_data.vErstMode AND*/ vD010102(1).ID IS NULL AND cBA%NOTFOUND 
        AND (vBA(i).abgemeldet <= vDateMin OR vBA(i).abgemeldet IS NULL ) THEN    
          AddError(pText => 'Die Betriebssttte mit der Betriebsart "' || vBA(i).A010108_BEZ || 
                   '" kann nicht bermittelt werden. Es fehlt die entsprechende Zulassung nach VO(EG)1/2005 Art. 10 bzw. 11.', pPrio => 1, pRegel => '05.09.01');

        -- todo 58146090 
        --WHEN NOT zbr_aus_data.vErstMode AND 
        --( vD010102(1).f$gueltig_von > vBA(i).gueltig_von OR vD010102(1).f$gueltig_bis < vBA(i).gueltig_bis)          
        --THEN        
        --  AddError('Die Betriebssttte mit der Betriebsart "' || vBA(i).A010108_BEZ || 
        --           '" kann nicht bermittelt werden. Es fehlt die entsprechende gltige Zulassung nach VO(EG)1/2005 Art. 10 bzw. 11.', 1);
        -- 15.09.2015   
        WHEN cBA%NOTFOUND AND -- nur bei neuer BA, BA ist auch neu bei neuem Betrieb
          NOT vBA(i).gueltig_von BETWEEN vD010102(1).f$gueltig_von AND vD010102(1).f$gueltig_bis AND
          NOT vBA(i).gueltig_bis BETWEEN vD010102(1).f$gueltig_von AND vD010102(1).f$gueltig_bis AND
          NOT vD010102(1).f$gueltig_von BETWEEN vBA(i).gueltig_von AND vBA(i).gueltig_bis AND
          NOT vD010102(1).f$gueltig_bis BETWEEN vBA(i).gueltig_von AND vBA(i).gueltig_bis 
          AND (vBA(i).abgemeldet <= vDateMin OR vBA(i).abgemeldet IS NULL ) THEN
            
          AddError(pText => 'Die Betriebssttte mit der Betriebsart "' || vBA(i).A010108_BEZ || 
                   '" kann nicht bermittelt werden. Es fehlt die entsprechende gltige Zulassung nach VO(EG)1/2005 Art. 10 bzw. 11.', pPrio => 1, pRegel => '05.09.02');
          
        -- todo 58146090 
        WHEN SYSDATE BETWEEN vBA(i).gueltig_von AND vBA(i).gueltig_bis AND -- gltige BA
        vD010102(1).ID IS NULL AND NOT zbr_aus_data.vErstMode THEN -- keine Zulassung 
            
          AddWarning( pText => 'Der Betriebssttte mit der Betriebsart "' || vBA(i).A010108_BEZ || 
                   '" fehlt die entsprechende Zulassung nach VO(EG)1/2005 Art. 10 bzw. 11.', pPrio => 1, pRegel => '05.09.03');

        -- tdo 58146090
        WHEN SYSDATE BETWEEN vBA(i).gueltig_von AND vBA(i).gueltig_bis AND -- heute gltige BA
        NOT SYSDATE BETWEEN vD010102(1).f$gueltig_von AND vD010102(1).f$gueltig_bis -- heute keine gltige Zulassung
        AND NOT zbr_aus_data.vErstMode THEN 
            
          AddWarning( pText => 'Der Betriebssttte mit der Betriebsart "' || vBA(i).A010108_BEZ || 
                   '" fehlt die entsprechende gltige Zulassung nach VO(EG)1/2005 Art. 10 bzw. 11.', pPrio => 1, pRegel => '05.09.04');
                
        ELSE NULL;
        END CASE;
        
        CLOSE cBA;      

      -- todo 52820090: berprfung Schafhaltung und Imker und Zirkus
      /* 04.05.2015 todo 56675090 WHEN vGKZ2 <> vGKZ2NRW 
      AND (vBA(i).A010108_code LIKE '0102%' OR vBA(i).A010108_code LIKE '0114%'
      OR vBA(i).A010108_code IN ('040202') ) -- Zirkus todo 52820090
      AND vD0101.ambulant_jn = 1 THEN -- wechselnder Standort 

        vBAnotExport := 1;
        IF vBatchMode THEN
          AddError(NULL, 1);  -- keine Meldung fr den Ausgangskorb
        ELSE
          AddError('Die Betriebssttte mit wechselndem Standort und der Betriebsart "' || vBA(i).A010108_BEZ || '" wird nicht bermittelt.', 1);
        END IF;      
  --      IF vD0101.id = vD0101.d0101_id3 THEN -- kein abweichender Betreiber
  --        AddError('Zur Betriebssttte mit der Betriebsart "' || vBA(i).A010108_bez || '" muss ein abweichender Betreiber zugeordnet sein.', 1);
  --          
  --      ELSIF vD0101.ZB <> vD0101$3.ZB THEN 
  --
  --        IF vBatchMode THEN
  --          AddError(NULL, 1);  -- keine Meldung fr den Ausgangskorb
  --        ELSE
  --          AddError('Die Betriebssttte mit wechselndem Standort und der Betriebsart "' || vBA(i).A010108_BEZ || '" kann nicht bermittelt werden.' ||
  --                  ' Der Betreiber hat seinen Sitz in einem anderen Zustndigkeitsbereich.', 1);
  --        END IF;
  --      END IF;  */
      ELSE NULL;      
      END CASE;  
    END LOOP; 
  END IF;
  
  IF vVerfahren <> QUELLE_IDV_NRW AND vBACnt = 0 AND vD0101IsNew = 1 THEN
    CASE 
    WHEN vBatchMode THEN
      AddError( pText => NULL, pPrio => 1, pRegel => NULL);  -- keine Meldung fr den Ausgangskorb            
    WHEN zbr_aus_data.vErstMode THEN 
      NULL; -- bei der Erstbefllung ignorieren und trotzdem exportieren
    ELSE
      AddError(pText => 'Der Betrieb hat keine gltige relevante Betriebsart und kann deshalb nicht als Neuanlage bermittelt werden.', pPrio => 1, pRegel => '05.14');
    END CASE;
  END IF;

  -- 20.09.2013 Prfung lteste Anmeldung rckdatiert
  IF vVerfahren <> QUELLE_IDV_NRW AND vD0101IsNew = 1 AND vBA.COUNT > 0 AND NOT vBatchMode THEN
    -- lteste Anmeldung finden
    vMinBA_angemeldet := vDateMax;  
    vMinBAi := 0;
    FOR i IN vBA.FIRST .. vBA.LAST LOOP    
      IF vBA(i).angemeldet < vMinBA_angemeldet THEN 
        vMinBA_angemeldet := vBA(i).angemeldet; 
        vMinBAi := i;
      END IF;
    END LOOP;
    IF vMinBAi > 0 THEN -- lteste Anmeldung gefunden
      IF vMinBA_angemeldet < TRUNC(vBA(vMinBAi).ins_date) THEN -- und rckdatiert
        AddWarning(pText => vBA(vMinBAi).a010108_bez || ' - Anmeldedatum ist rckdatiert ' || (TRUNC(vBA(vMinBAi).ins_date) -  vMinBA_angemeldet) || ' Tag(e)', pPrio => 2, pRegel => '05.15' );   
      END IF;
    END IF;
  END IF;
END ChkBetriebsarten;

-- berprfung der HIT-Registriernummer nur fr NRW
PROCEDURE ChkHIT_RegNr2(pD0101 IN VIS_D0101%ROWTYPE, pRegNr IN tRegNr ) AS 
  vCnt PLS_INTEGER := 0;
BEGIN

  -- Betrieb hat keine Registriernummer aber eine HIT-Nummer
  CASE
  WHEN vD0101IsNew = 1 AND pRegNr.COUNT = 0 THEN 

    SELECT COUNT(*) INTO vCnt
    FROM vis_d010102 d010102
    WHERE D010102.D0101_ID = pD0101.ID
      AND d010102.deleted = 0
      AND d010102.nummer IS NOT NULL
      AND d010102.A010145_SID = vA010145_SID_HIT2; 
    
    IF vCnt > 0 THEN
      AddError( pText => 'Die Betriebssttte hat bereits eine HIT-Registriernummer und kann daher nicht exportiert werden.', pPrio => 1, pRegel => '08.08');    
    END IF;

  WHEN pRegNr.COUNT > 1 THEN  -- todo 57494090
      AddError( pText => 'Die Betriebssttte hat mehr als eine IDV-Registriernummern und kann daher nicht exportiert werden.', pPrio => 1, pRegel => '08.09');        
 
 ELSE NULL;
  END CASE;
  
END ChkHIT_RegNr2;

PROCEDURE ChkHIT_Registriernummer(pD0101 IN VIS_D0101%ROWTYPE, pType IN VARCHAR2, pRegNr IN tRegNr, chkBAcnt BOOLEAN) AS 
  vCntTotal PLS_INTEGER := 0;
  vCntAktiv PLS_INTEGER := 0;
  vCntExists PLS_INTEGER := 0;
  --vBAangemeldetCnt PLS_INTEGER := 0; 
  vCntBA1 PLS_INTEGER := 0; -- Anzahl angemeldeter Equidenhaltungen
  vCntBA2 PLS_INTEGER := 0; -- Gesamtzahl angemeldeteter BA
  vNummer VIS_D010102.NUMMER%TYPE := NULL;
  vBezRegNr CONSTANT VARCHAR2(5) := CASE WHEN vVerfahren = QUELLE_IDV_NRW THEN 'IDV' ELSE 'HIT' END;
	vSYSDATE CONSTANT DATE := SYSDATE;
BEGIN
  -- Betriebssttte hat keine relevante Nummer
  CASE 
  WHEN vD0101IsNew = 0 AND pRegNr.COUNT = 0 THEN
    AddError( pText => pType || ' hat keine ' || vBezRegNr || '-Registriernummer, daher knnen nderungen noch nicht bermittelt werden (iP).', 
              pPrio => 1, pRegel => '07.01', pIgnor_im_Batch => TRUE);    
    RETURN;
  --WHEN vErstMode AND pRegNr.COUNT = 0 THEN
  --  AddError(pType || ' hat keine ' || vBezRegNr || '-Registriernummer (iP).', 1);    
  --  RETURN;  
  --WHEN vD0101IsNew = 1 AND pRegNr.COUNT > 0 THEN
  --  AddError(pType || ' hat bereits eine HIT-Nummer und darf deshalb nicht exportiert werden.', 1);    
  
  -- 14.04.2015 todo 57639090 
  WHEN vD0101IsNew = 1 AND pRegNr.COUNT > 0 AND NOT zbr_aus_data.vErstMode THEN
    AddError(pText => 'Die Betriebssttte kann nicht als Neuanmeldung bergeben werden, da bereits eine ' || vBezRegNr || '-Registriernummer vorhanden ist.', pPrio => 1, pRegel => '07.02');
    RETURN;
  ELSE NULL;
  END CASE;

  IF pRegNr.COUNT = 0 AND NOT zbr_aus_data.vErstMode THEN
    RETURN;
  END IF;
  
  IF vVerfahren <> QUELLE_IDV_NRW THEN
    IF pRegNr.COUNT > 0 THEN    
      FOR i IN pRegNr.FIRST .. pRegNr.LAST LOOP
        IF pRegNr(i).gueltig_bis > vSYSDATE THEN 
          vCntAktiv := vCntAktiv + 1;
          vNummer := pRegNr(i).nummer;
        END IF;
        vCntTotal := vCntTotal + 1;
      END LOOP; 
    END IF;
    
    IF vBA.COUNT > 0 THEN
      FOR i IN vBA.FIRST .. vBA.LAST LOOP
        IF NVL(vBA(i).abgemeldet, vDateMax) > vSYSDATE THEN -- nicht abgemeldet
          vCntBA2 := vCntBA2 + 1; -- alle BA
          IF vBA(i).a010108_code LIKE '0111%' THEN -- Equidenhaltung
            vCntBA1 := vCntBA1 + 1;  -- nur Equidenhaltungen
          END IF;
        END IF; 
      END LOOP;
    END IF;    

--AddError('zbr_aus_data.vErstMode:'||case when zbr_aus_data.vErstMode then 'Ja' else 'Nein' end, 1, '99' );
--DBMS_OUTPUT.PUT_LINE ( 'vD0101.ambulant_jn = ' || vD0101.ambulant_jn );
--DBMS_OUTPUT.PUT_LINE ( 'vD0101.zb = ' || vD0101.zb );
--DBMS_OUTPUT.PUT_LINE ( 'SUBSTR(vD0101$3.GKZ,5) = ' || SUBSTR(vD0101$3.GKZ,5) );
--DBMS_OUTPUT.PUT_LINE ( 'IsZirkus = ' || IsZirkus );
--DBMS_OUTPUT.PUT_LINE ( 'pRegNr.COUNT = ' || pRegNr.COUNT );
--DBMS_OUTPUT.PUT_LINE ( 'vBaDatum.abgemeldet = ' || vBaDatum.abgemeldet );
--DBMS_OUTPUT.PUT_LINE ( 'vBA.COUNT = ' || vBA.COUNT );
--DBMS_OUTPUT.PUT_LINE ( 'NOT ( IsZirkus = 1 AND vD0101.zb <> SUBSTR(vD0101$3.GKZ,5) = ' || case when NOT ( IsZirkus = 1 AND vD0101.zb <> SUBSTR(vD0101$3.GKZ,5) ) then 'ok' else 'false' end );
--DBMS_OUTPUT.PUT_LINE ( 'vCntBa2 = ' || vCntBa2 );
--DBMS_OUTPUT.PUT_LINE ( 'vCntAktiv = ' || vCntAktiv );
    CASE    
    WHEN zbr_aus_data.vErstMode AND vCntAktiv > 0 AND vD0101.ambulant_jn = 1 THEN
      AddError(pText => 'Die ' || vBezRegNr || '-Registriernummer muss abgemeldet oder das Kennzeichen "wechselnder Standort" gendert werden.', pPrio => 1, pRegel => '07.05.05');

    WHEN zbr_aus_data.vErstMode AND vCntAktiv > 0 AND IsZirkus = 1 AND vD0101.zb <> SUBSTR(vD0101$3.GKZ, 1, 5) THEN
      AddError(pText => 'Die Betriebssttte ist ein Zirkus mit einem Betreiber aus einem anderen Kreis. Die ' || vBezRegNr || '-Registriernummer muss abgemeldet werden.', pPrio => 1, pRegel => '07.05.06');
    
    
    WHEN zbr_aus_data.vErstMode AND vD0101.ambulant_jn <> 1 AND NOT ( IsZirkus = 1 AND vD0101.zb <> SUBSTR(vD0101$3.GKZ, 1, 5) )
    AND vBA.COUNT > 0 AND vBaDatum.abgemeldet IS NULL AND pRegNr.COUNT = 0 THEN
      AddError(pText => 'Die Betriebssttte hat keine ' || vBezRegNr || '-Registriernummer aber aktive Betriebsarten.', pPrio => 1, pRegel => '07.05.07');
  
    WHEN zbr_aus_data.vErstMode AND vCntAktiv > 0 AND vCntBa2 = 0 THEN
      AddError(pText => 'Die Betriebssttte hat eine aktive ' || vBezRegNr || '-Registriernummer aber keine aktive Betriebsart.', pPrio => 1, pRegel => '07.05.08');

    -- kein neuer Betrieb, Reg.Nr. vorh. aber keine gltige, BA vorh.
    WHEN vD0101IsNew = 0 AND vCntAktiv = 0 AND pRegNr.COUNT > 0 AND vBAcnt > 0 AND chkBAcnt THEN
      -- alles OK
      NULL;
    WHEN vCntAktiv = 0 AND vD0101IsNew = 0 AND vBAcnt > 0 THEN
      AddError(pText => pType || ' hat keine gltige HIT-Registriernummer.', pPrio => 1, pRegel => '07.03');
    WHEN vCntAktiv > 1 THEN
      AddError(pText => pType || ' hat mehrere gltige HIT-Registriernummern.', pPrio => 1, pRegel => '07.04');
    ELSE
      NULL;  
    END CASE;

  END IF;
  -- wenn nur eine aktive vorhanden ist dann weitere Prfungen
  IF vCntAktiv = 1 AND vVerfahren <> QUELLE_IDV_NRW THEN

  -- HIT-Nummer in anderen Betrieben vorhanden

    SELECT COUNT(*) INTO vCntExists
    FROM vis_vd010102 d010102
    JOIN vis_d0101 d0101 ON d0101.id = d010102.d0101_id
     --AND d010102.gueltig_bis > SYSDATE
     AND D010102.DELETED = 0
     AND d0101.deleted = 0
     AND d010102.a010145_sid = vA010145_SID_HIT
     AND d010102.nummer = vNummer
     AND d010102.d0101_id <> pD0101.id
     AND d0101.zb = pD0101.zb;
   
    IF vCntExists > 0 THEN
      AddError( pText => pType || ': Die HIT-Registriernummer ' || vNummer || ' ist noch weiteren Betriebssttten/Betreibern zugeordnet.', pPrio => 2, pRegel => '07.05.01' );    
    END IF;    
 
    -- Die HIT-Registriernummer entspricht nicht dem vorgegebenen Format: 12-stellig numerisch
    DECLARE vOK PLS_INTEGER := 1;
    BEGIN
      IF LENGTH(vNummer) <> 12 THEN
        vOK := 0;
      END IF;
      
      IF vNummer IS NULL THEN
        vOk := 0;
      END IF;
      
      IF vOK = 1 THEN
        vOK := IsNumeric(vNummer); -- liefert 0 wenn nicht numerisch sonst 1
      END IF;
      
      IF vOK = 0 THEN
        AddError(pText => pType || ' hat eine ungltige HIT-Registriernummer (Format).', pPrio => 1, pRegel => '07.05.02'); 
      END IF;
    END;
     
    CASE 
    WHEN SUBSTR(vNummer,1,2) <> SUBSTR(pD0101.ZB,1,2) THEN
      AddError(pText => pType || ' hat eine HIT-Registriernummer aus einem anderen Bundesland.', pPrio => 1, pRegel => '07.05.03');     
    WHEN SUBSTR(vNummer,1,5) <> SUBSTR(pD0101.ZB,1,5) THEN
      -- 20.09.2013 Fehlermeldung nicht bei Equidenhaltung prfen
      -- 24.05.2017 nach oben verschoben, wird jetzt immer ausgefhrt  
--      IF vBA.COUNT > 0 THEN
--        vCntBA1 := 0;
--        vCntBA2 := 0;
--        -- nur angemeldete BA als Equidenhaltung vorhanden -> kein Fehler
--          
--        FOR i IN vBA.FIRST .. vBA.LAST LOOP
--          IF NVL(vBA(i).abgemeldet, vDateMax) > vSYSDATE THEN -- nicht abgemeldet
--            vCntBA2 := vCntBA2 + 1; -- alle BA
--            IF vBA(i).a010108_code LIKE '0111%' THEN -- Equidenhaltung
--              vCntBA1 := vCntBA1 + 1;  -- nur Equidenhaltungen
--            END IF;
--          END IF; 
--        END LOOP;
--      END IF;
           
      IF vCntBA2 > vCntBA1 THEN  -- nicht nur angemeldete Equidenhaltungen vorhanden

        -- 21.05.2015 berprfung ber alle ZB des Mandanten
        SELECT COUNT(*) INTO vCntExists
        FROM vis_s5002 s5002
        JOIN glo_a25 a25 ON a25.sid = s5002.glo_a25_sid
        AND a25.deleted = 0
        AND a25.zb = SUBSTR(vNummer,1,5)
        AND s5002.s50_sid = pD0101.mandant   
        AND s5002.deleted = 0;
    
        IF vCntExists = 0 THEN
          AddError(pText => pType || ' hat eine HIT-Registriernummer aus einem anderen Zustndigkeitsbereich.', pPrio => 1, pRegel => '07.05.04');
        END IF;
      END IF;
    ELSE
      NULL;
    END CASE;
  
  END IF;
  
  -- todo 62429090 30.08.2016 entfllt 
--  IF vVerfahren <> QUELLE_IDV_NRW AND NOT zbr_aus_data.vErstMode THEN  -- 21.05.2015 NOT zbr_aus_data.vErstMode
--    -- berprfung mehrfache Zulassungen
--    FOR c1 IN (      
--      SELECT d010102.A010145_CODE, MAX(d010102.A010145_BEZ) a010145_bez
--      FROM vis_vd010102$01 d010102
--      WHERE D010102.D0101_ID = vD0101.ID
--        AND d010102.deleted = 0
--        AND d010102.A010145_CODE IN (
--          '01042101',  --Zulassung Transportunternehmer nach  13 ViehVerkV u. Art. 10 Abs. 1 VO (EG) 1/2005
--          '01042102',  --Zulassung Transportunternehmer (lange Befrderungen) nach  13 ViehVerkV u. Art. 11 Abs. 1 VO (EG) 1/2005
--          '01042103',  --Zulassung Transportunternehmen nach Art. 10 Abs. 1 VO (EG) Nr. 1/2005
--          '01042104',  --Zulassung Transportunternehmen (lange Befrderungen) nach Art. 11 Abs. 1 VO (EG) Nr. 1/2005                      
--                       -- + Heimtierpass 
--          null)           
--        AND d010102.a010145_skz = 60
--      GROUP BY d010102.A010145_CODE
--      HAVING COUNT(*) > 1
--    ) LOOP
--        AddError('Die Betriebssttte hat mehrere gleiche Zulassungen "' || c1.A010145_BEZ || 
--                 '" und kann deshalb nicht bermittelt werden.', 1);
--
--    END LOOP;  
--  END IF; 
END ChkHIT_Registriernummer;


PROCEDURE ChkTelefon (pD0101 IN VIS_D0101%ROWTYPE, pAdrType IN VARCHAR2 := 'Betrieb') AS
BEGIN
  -- Bezeichnung (1.Zeile) fehlt : D0101.P_NAME leer
  IF LENGTH(pD0101.kom_tel) > 25 THEN 
    -- 24.07.2013 AddError(pAdrType || ' Telefon beinhaltet mehr als 25 Zeichen: ' || pD0101.kom_tel , 1, vErstMode);
    AddWarning(pText => pAdrType || ' Telefon beinhaltet mehr als 25 Zeichen: ' || pD0101.kom_tel , pPrio => 1, pRegel => '08.01' );
  END IF;
  -- todo 59264090 21.10.2015
  IF LENGTH(pD0101.kom_fax) > 25 THEN 
    AddWarning(pText => pAdrType || ' Fax beinhaltet mehr als 25 Zeichen: ' || pD0101.kom_fax , pPrio => 1, pRegel => '08.02' );
  END IF;
  
    
END ChkTelefon;  


PROCEDURE ChkRechtsform(pD0101 IN VIS_D0101%ROWTYPE, pAdrType VARCHAR2 := 'Betriebssttte') AS
BEGIN
  -- Rechtsform fehlt
  IF vVerfahren <> QUELLE_IDV_NRW THEN
    IF pD0101.a0101_03_sid = -1 THEN
      AddWarning( pText => pAdrType || ' - Rechtsform fehlt.', pPrio => 1, pRegel => '08.03');    
    END IF;  
  END IF;

END ChkRechtsform;

PROCEDURE Chk_Betreiber_ID(pD0101 IN vis_d0101%ROWTYPE) AS
vA010145_SID1 vis_a010145.sid%TYPE;
vA010145_SID2 vis_a010145.sid%TYPE := NULL;
vA010145_BEZ vis_a010145.bez%TYPE;
vSYSDATE CONSTANT DATE := SYSDATE;
vCnt PLS_INTEGER;
vCntGueltig PLS_INTEGER;

  CURSOR cAK_BTR (pREF_ID IN VARCHAR2) IS
    SELECT dx.* FROM (
      SELECT prt.d_bts_id, reg.id reg_id
      FROM aus_d_person prs
      JOIN aus_d_funktion fkt on fkt.d_pers_id = prs.id
      JOIN aus_d_protokoll prt on prt.d_bts_id = fkt.d_bts_id
      LEFT JOIN aus_r_fkt_reg r1 
        JOIN aus_d_registrierung reg on reg.id = r1.d_reg_id
        AND reg.art = 'BI'
      ON r1.d_fkt_id = fkt.id
      WHERE prs.ref_id = pRef_ID
      ORDER by prt.ins_date DESC
      ) dx 
    WHERE ROWNUM = 1;  
  
  vAK_Btr cAK_BTR%ROWTYPE;



BEGIN
	IF vVerfahren = QUELLE_IDV_NRW THEN
		vA010145_SID1 := 1474008; -- IDV-Betreiber-ID
  ELSE
    vA010145_SID1 := 1606001; -- Betreiber-ID   
  END IF;
  
  -- todo 66344090 17.08.2017: Betreiber-ID ohne Gltigkeitsprfung 
  --  SELECT COUNT(*), MAX(d1.a010145_bez) INTO vCntGueltig, vA010145_bez
  --  FROM vis_vd010102$01 d1
  --  WHERE d1.d0101_id = pD0101.d0101_id3
  --  AND d1.f$gueltig_bis > vSYSDATE
  --  AND d1.a010145_sid = vA010145_sid1;
  SELECT COUNT(*), MAX(a1.bez) INTO vCntGueltig, vA010145_bez
  FROM vis_d010102 d1
  JOIN vis_a010145 a1 ON a1.sid = d1.a010145_sid
  WHERE d1.d0101_id = pD0101.d0101_id3
  AND d1.deleted = 0
  AND d1.a010145_sid = vA010145_sid1;

  CASE
  WHEN vCntGueltig > 1 THEN 
    AddError( pText => 'Betreiber der Betriebssttte hat mehr als eine ' || vA010145_bez || 
      ', daher knnen nderungen zur Betriebssttte nicht exportiert werden.', pPrio => 1, pRegel => '08.04' );

  WHEN vCntGueltig = 0 AND vVerfahren <> QUELLE_IDV_NRW AND zbr_aus_data.vErstMode THEN
    --IF pD0101.SKZ = 1 THEN  
    --  AddError( pText => 'Betreiber der Betriebssttte hat keine Registriernummer (HIT),' || 
    --    ' daher knnen nderungen zur Betriebssttte nicht exportiert werden.', pPrio => 1, pRegel => '08.05' );
    --ELSE
      AddError( pText => 'Der Betreiber der Betriebssttte hat keine Betreiber_ID.', pPrio => 1, pRegel => '08.06' );
    --END IF;

  WHEN vCntGueltig = 0 AND vVerfahren <> QUELLE_IDV_NRW THEN
      
    OPEN cAK_BTR(pD0101.d0101_id3);
    FETCH cAK_Btr INTO vAK_Btr;
            
    IF cAK_Btr%FOUND AND vAK_Btr.reg_id IS NULL THEN 
    
      AddError(pTEXT => 'Der Betreiber ist im Register noch nicht registriert. nderungen knnen deshalb noch nicht bertragen werden.', 
        pPRIO => 2, 
        pREGEL => '08.10', 
        pIGNOR_IM_BATCH => TRUE);

    END IF;    
    CLOSE cAK_BTR;
    
  ELSE NULL;
  END CASE;
  
  IF vVerfahren <> QUELLE_IDV_NRW AND pD0101.d0101_id3 = pD0101.id THEN 

    vA010145_SID1 := 1606001; -- Betreiber-ID
    vA010145_SID2 := 514001;  -- HIT-Nr.
  
    --    SELECT COUNT( DISTINCT d1.NUMMER ), MAX(d1.a010145_bez), MAX(d0101.skz)
    --    , COUNT( DISTINCT CASE WHEN d1.f$gueltig_bis > vSYSDATE THEN d1.nummer ELSE NULL END )  
    --    INTO vCnt, vA010145_bez, vD0101_SKZ, vCntGueltig
    --    FROM vis_d0101 d0101
    --    JOIN vis_vd010102$01 d1 ON d1.d0101_id = d0101.id
    --    AND d1.nummer IS NOT NULL  -- 02.06.2015
    --    --AND d1.f$gueltig_bis > vSYSDATE
    --    AND d1.a010145_sid IN( 
    --      CASE WHEN d0101.skz = 1 THEN vA010145_sid2 ELSE vA010145_SID1 END,
    --      CASE WHEN d0101.skz = 1 THEN vA010145_sid1 END )
    --    WHERE d0101.id = pD0101.d0101_id3;

    SELECT COUNT( * ) INTO vCnt
    FROM vis_vd010102$01 d1 
    JOIN vis_vd010102$01 d2 ON d2.d0101_id = pD0101.d0101_id3
    AND d1.nummer <> d2.nummer
    AND d2.a010145_sid = vA010145_SID2
    AND d1.d0101_id = pD0101.d0101_id3
    AND d1.a010145_sid = vA010145_SID1;
        
    IF vCnt > 0 THEN
      AddError(pText => 'Betreiber besitzt eine von der Registriernummer (HIT) abweichende Betreiber ID. Betreiber_ID und Registriernummer sind nicht identisch.'
             , pPrio => 1, pRegel => '08.07');
    END IF;         

  END IF;

END Chk_Betreiber_ID;

PROCEDURE ChkGkzBetreiber(pD0101 IN vis_d0101%ROWTYPE, pAdrType IN VARCHAR2) AS
BEGIN

  CASE
  WHEN LENGTH(pD0101.GKZ) >= 8 THEN
    NULL;  -- OK nichts machen
  WHEN pD0101.glo_a24_sid2 = 120 THEN -- Warnung nur bei Deutschland
    AddWarning( pText => pAdrType || ' GKZ 8 ist nicht vorhanden.', pPrio => 1, pRegel => '04.13');
  ELSE NULL;
  END CASE; 


END ChkGkzBetreiber;

PROCEDURE ChkBea AS
BEGIN

  IF BLVUTILS.BEA_KONFORM(pValue => vD0101.daten_herkunft) = 0 THEN
    AddError(pTEXT => 'Die Betriebssttte ist nicht BEA-konform.', pPRIO => 1, pREGEL => '10.01');
  END IF;
  
  IF BLVUTILS.BEA_KONFORM(pValue => vD0101$3.daten_herkunft) = 0 THEN
    AddError(pTEXT => 'Der Betreiber ist nicht BEA-konform.', pPRIO => 1, pREGEL => '10.02');
  END IF;  
END;

PROCEDURE ChkTierangaben(pD0101 IN vis_d0101%ROWTYPE) AS

  CURSOR c1 ( pD0101_ID IN VARCHAR2) IS
  SELECT DISTINCT
  LISTAGG( dx.a010108_bez || CASE WHEN dx.sum_anzahl6 >= 0 THEN ' (Anzahl '||dx.sum_anzahl6||')' END , ',') 
  WITHIN GROUP ( ORDER BY a010108_bez ) OVER ( PARTITION BY a010108_code4) listagg_bez
  FROM (
    SELECT DISTINCT SUBSTR(ax.a010108_code, 1, CASE WHEN ax.a010108_code LIKE '0120%' OR ax.a010108_code LIKE '0112%' THEN 6 ELSE 4 END ) a010108_code4
    , AX.a010108_bez a010108_bez
    , COUNT(DISTINCT d010101.id) OVER (PARTITION BY SUBSTR(ax.a010108_code, 1, CASE WHEN ax.a010108_code LIKE '0120%' OR ax.a010108_code LIKE '0112%' THEN 6 ELSE 4 END))  anz_d010101_id  
    , SUM(d0104.anzahl6) OVER ( PARTITION BY d010101.id) sum_anzahl6 
    FROM vis_d010101 d010101
    --JOIN vis_a010108 a010108 ON a010108.sid = d010101.a010108_sid
    JOIN vis_va0089_zbr_betriebstyp ax ON d010101.a010108_sid = ax.a010108_sid    
    --JOIN vis_d0101 d0101 ON d0101.id = d010101.d0101_id
    JOIN vis_d0104 d0104 ON d0104.d010101_id = d010101.id
    AND d0104.deleted = 0
    AND d0104.gueltig_bis = vDateMax -- EST-738
    AND d0104.aktiv = 1
    WHERE d010101.deleted = 0
    AND d010101.aktiv = 1
    AND d010101.abgemeldet IS NULL
    AND d010101.d0101_id = pD0101_ID
  ) dx
  WHERE dx.anz_d010101_id > 1 ;

  TYPE tC1 IS TABLE OF c1%ROWTYPE; 
  vC1 tC1;

  CURSOR c2 (pD0101_ID IN VARCHAR2) IS
  SELECT DISTINCT
  a010108_bez || ': ' || 
  LISTAGG( dx.anz_a0104_sid || 'x ' || dx.a0104_bez, ', ') 
    WITHIN GROUP( ORDER BY dx.a0104_bez) 
    OVER ( PARTITION BY dx.a010108_bez) listagg_bez
     
  FROM (
    SELECT 
      COUNT(d0104.a0104_sid) anz_a0104_sid
    , MAX(a0104.bez) a0104_bez
    , MAX(ax.a010108_bez) a010108_bez
    FROM vis_d010101 d010101
    --JOIN vis_a010108 a010108 ON a010108.sid = d010101.a010108_sid
    JOIN vis_va0089_zbr_betriebstyp ax ON d010101.a010108_sid = ax.a010108_sid
    JOIN vis_d0104 d0104 ON d0104.d010101_id = d010101.id
    AND d0104.deleted = 0
    AND d0104.aktiv = 1
    AND d0104.gueltig_bis = vDateMax -- EST-738
    JOIN vis_a0104 a0104 ON a0104.sid = d0104.a0104_sid
    WHERE d010101.deleted = 0
    AND d010101.aktiv = 1
    AND d010101.abgemeldet IS NULL
    AND d010101.d0101_id = pD0101_ID
    GROUP BY d0104.d010101_id, d0104.a0104_sid
    HAVING COUNT(d0104.a0104_sid) > 1
  ) dx;

  TYPE tC2 IS TABLE OF c2%ROWTYPE; 
  vC2 tC2;

  CURSOR c3 (pD0101_ID IN VARCHAR2) IS
  SELECT
    LISTAGG(dx.text, CRLF) WITHIN GROUP (ORDER BY dx.a0104_bez, dx.a010108_bez) text
  FROM (
    SELECT 
      a0104.bez a0104_bez
    , ax.a010108_bez a010108_bez
    --, TO_CHAR(d0104.gueltig_von, 'dd.mm.yyyy') d0104_gueltig_von
    --, TO_CHAR(d0104.gueltig_bis, 'dd.mm.yyyy') d0104_gueltig_bis
    --, TO_CHAR(d010101.angemeldet, 'dd.mm.yyyy') d010101_angemeldet
    --, TO_CHAR(d010101.gueltig_bis, 'dd.mm.yyyy') d010101_gueltig_bis
    , 
      a0104.bez || '(' || TO_CHAR(d0104.gueltig_von, 'dd.mm.yyyy') ||
      CASE WHEN d0104.gueltig_bis < DATE '9999-01-01' THEN '-'||TO_CHAR(d0104.gueltig_bis, 'dd.mm.yyyy') END || ')' || CRLF || ' - Betriebsart ' ||    
      ax.a010108_bez || '(' || TO_CHAR(d010101.angemeldet, 'dd.mm.yyyy') ||
      CASE WHEN d010101.gueltig_bis < DATE '9999-01-01' THEN '-'||TO_CHAR(d010101.gueltig_bis, 'dd.mm.yyyy') END ||')'
      AS text
    FROM vis_d010101 d010101
    JOIN vis_va0089_zbr_betriebstyp ax ON d010101.a010108_sid = ax.a010108_sid
    JOIN vis_d0104 d0104 ON d0104.d010101_id = d010101.id
    AND d0104.deleted = 0
    AND d0104.aktiv = 1
    AND d0104.gueltig_bis = vDateMax -- EST-738
    JOIN vis_a0104 a0104 ON a0104.sid = d0104.a0104_sid
    WHERE d010101.deleted = 0
    AND d010101.aktiv = 1
    AND d010101.abgemeldet IS NULL
    AND d010101.d0101_id = pD0101_ID
    AND d0104.gueltig_von < d010101.angemeldet
  ) dx;

  TYPE tC3 IS TABLE OF c3%ROWTYPE; 
  vC3 tC3;

  CURSOR c4 (pD0101_ID IN VARCHAR2) IS
  SELECT
    LISTAGG(dx.text, CRLF) WITHIN GROUP (ORDER BY dx.a0104_bez, dx.a010108_bez) text
  FROM (
    SELECT 
      a0104.bez a0104_bez
    , ax.a010108_bez a010108_bez
    , a0104.bez || '(' || TO_CHAR(d0104.gueltig_von, 'dd.mm.yyyy') ||
      CASE WHEN d0104.gueltig_bis < DATE '9999-01-01' THEN '-'||TO_CHAR(d0104.gueltig_bis, 'dd.mm.yyyy') END || ')' || CRLF || ' - Betriebsart ' ||    
      ax.a010108_bez || '(' || TO_CHAR(d010101.angemeldet, 'dd.mm.yyyy') ||
      CASE WHEN d010101.gueltig_bis < DATE '9999-01-01' THEN '-'||TO_CHAR(d010101.gueltig_bis, 'dd.mm.yyyy') END ||')'
      AS text
    FROM vis_d010101 d010101
    JOIN vis_va0089_zbr_betriebstyp ax ON d010101.a010108_sid = ax.a010108_sid
    JOIN vis_d0104 d0104 ON d0104.d010101_id = d010101.id
    AND d0104.deleted = 0
    AND d0104.aktiv = 1
    AND d0104.anzahl6 IS NULL
    AND d0104.gueltig_bis = vDateMax -- EST-738
    JOIN vis_a0104 a0104 ON a0104.sid = d0104.a0104_sid
    WHERE d010101.deleted = 0
    AND d010101.aktiv = 1
    AND d010101.abgemeldet IS NULL
    AND d010101.d0101_id = pD0101_ID
  ) dx;

  TYPE tC4 IS TABLE OF c4%ROWTYPE; 
  vC4 tC4;


  vFehler PLS_INTEGER := 0; 
BEGIN

  OPEN c1(pD0101.id);
  FETCH c1 BULK COLLECT INTO vC1 LIMIT 999;
  CLOSE c1;
  
  IF vC1.COUNT > 0 THEN
    FOR i IN vC1.FIRST .. vC1.LAST LOOP
      AddError(pTEXT => 'Die Tierzahlen knnen nicht exportiert werden, da die Tierzahlen mehreren Betriebsarten innerhalb eines Bestandes zugeordnet sind:' || CRLF ||
                         vC1(i).listagg_bez 
      , pPRIO => 1
      , pREGEL => '11.01'
      , pIgnor_im_Batch => FALSE);

      vFehler := vFehler + 1;

    END LOOP;
  END IF;

  OPEN c2(pD0101.id);
  FETCH c2 BULK COLLECT INTO vC2 LIMIT 999;
  CLOSE c2;
  
  IF vC2.COUNT > 0 THEN
    FOR i IN vC2.FIRST .. vC2.LAST LOOP
      AddError(pTEXT => 'Die Tierzahlen knnen nicht exportiert werden, da die Tierart mehrmals vorhanden:' || CRLF ||
                         vC2(i).listagg_bez 
      , pPRIO => 1
      , pREGEL => '11.02'
      , pIgnor_im_Batch => FALSE);

      vFehler := vFehler + 1;

    END LOOP;
  END IF;

  -- Gltigkeit der Tierart mit Betriebsart prfen
  IF vFehler = 0 THEN

    OPEN c3(pD0101.id);
    FETCH c3 BULK COLLECT INTO vC3 LIMIT 999;
    CLOSE c3;
    
    IF vC3.COUNT > 0 THEN
      FOR i IN vC3.FIRST .. vC3.LAST LOOP
        IF vC3(i).text IS NOT NULL THEN
          AddError(pTEXT => 'Die Tierzahlen knnen nicht exportiert werden, da die Gltigkeit der Tierart auerhalb der Gltigkeit der Betriebsart liegt:' || CRLF ||
                             vC3(i).text 
          , pPRIO => 1
          , pREGEL => '11.03'
          , pIgnor_im_Batch => FALSE);

          vFehler := vFehler + 1;
        END IF;
      END LOOP;
    END IF;
  
  END IF;
  
  -- Gltigkeit der Tierart mit Betriebsart prfen
  IF vFehler = 0 THEN

    OPEN c4(pD0101.id);
    FETCH c4 BULK COLLECT INTO vC4 LIMIT 999;
    CLOSE c4;
    
    IF vC4.COUNT > 0 THEN
      FOR i IN vC4.FIRST .. vC4.LAST LOOP
        IF vC4(i).text IS NOT NULL THEN
          AddError(pTEXT => 'Zur Tierart sind keine Tierzahlen eingetragen. Bitte korrigieren Sie ihre Eingabe oder melden Sie bitte die Tierart bzw. die gesamte Betriebsart ab, sofern keine weiteren Tiere vorhanden sind. :' || CRLF ||
                             vC4(i).text 
          , pPRIO => 1
          , pREGEL => '11.04'
          , pIgnor_im_Batch => FALSE);

          vFehler := vFehler + 1;
        END IF;
      END LOOP;
    END IF;
  
  END IF;  
END ChkTierangaben;

PROCEDURE ChkD0101(pD0101_ID IN VARCHAR2) AS 
BEGIN

  vErrors := NULL;
  vWarnings := NULL;
  vResult := 0;
  vPrio := 99;
  vBAcnt := 0;
  vStopErrors := 0;
  vBAnotExport := 0;
  vPlausi := tbPlausi();
  ReadAllData(pD0101_ID);  

  ChkBea;
  
  ChkBezeichnung;  --(vD0101);


  IF vVerfahren = QUELLE_IDV_NRW THEN
    ChkHVName;  --(vD0101);
    IF chkPERS_ID(vD0101) = 1 THEN NULL; END IF;
  END IF;  
  
  IF vVerfahren = QUELLE_IDV_NRW THEN
    ChkGueltig( vD0101, 'Betriebssttte');
  ELSE
    ChkGueltigBA( vD0101);
  END IF;    

  ChkBetriebsarten; -- muss vor ChkStandortAdresse, wegen vBAnotExport

  IF vVerfahren = QUELLE_IDV_NRW THEN
    ChkFM_KOD(vD0101);
  END IF;    

  ChkStandortAdresse(vD0101, 'Standortadresse');

  IF vD0101.id <> vD0101.d0101_id3 THEN -- abweichender Betreiber
    ChkPostAdresse(vD0101$3, 'Postadresse Betreiber');
    IF vVerfahren = QUELLE_IDV_NRW  THEN
      ChkPostAdresse(vD0101, 'Postadresse');    
    END IF;
  ELSE -- kein abweichender Betreiber aber abweichende Postanschrift
    ChkPostAdresse(vD0101, 'Postadresse');
  END IF;
  
  -- 02.05.2012
  IF vD0101.abmeldung > vDateMin THEN
    IF zbr_aus_data.vErstMode THEN
      ChkHIT_Registriernummer(vD0101, 'Betriebssttte', vRegNr, True);
    END IF;
  ELSE
    ChkHIT_Registriernummer(vD0101, 'Betriebssttte', vRegNr, True);
    IF vVerfahren = QUELLE_IDV_NRW  THEN
      ChkHIT_RegNr2(vD0101, vRegNr);
    END IF;
      
    -- 03.04.2013 todo 49487090 
--      IF vD0101.id <> vD0101.d0101_id3 AND vGKZ2 <> vGKZ2NRW THEN
--        ChkHIT_Registriernummer(vD0101$3, 'Betreiber', vRegNr$3, False); 
--        --ChkGueltigkeit('Betreiber', pD0101_ID);   
--      END IF;
  END IF;
    
  ChkNZR(vD0101);  
  
  -- Telefon 01.03.2012
  IF vVerfahren <> QUELLE_IDV_NRW THEN
    IF vD0101.id <> vD0101.d0101_id3 THEN -- abweichender Betreiber
      ChkTelefon(vD0101$3, 'Betreiber');
    END IF;
    ChkTelefon(vD0101, 'Betrieb');
  END IF;  
    
  IF vD0101.id = vD0101.d0101_id3 THEN -- abweichender Betreiber
    ChkRechtsform(vD0101,'Betreiber');
  ELSE
    ChkRechtsform(vD0101$3,'Betreiber');
  END IF;

	-- todo 56329090
	Chk_Betreiber_ID(vD0101);
  
  --- todo 62246090
  IF vVerfahren <> QUELLE_IDV_NRW AND vD0101.id <> vD0101.d0101_id3 THEN
     ChkGkzBetreiber(vD0101$3, 'Postadresse Betreiber');
  END IF;

  IF vVerfahren <> QUELLE_IDV_NRW AND vD0101.abmeldung IS NULL 
  AND NOT ZBR_AUS_DATA.vErstMode THEN
    ChkTierangaben(vD0101);
  END IF;
  
  vD0101 := NULL;
  vD0101$3 := NULL;
  vRegnr := NULL;
  vRegnr$3 := NULL;
  
END ChkD0101;
/*******************************************************************************
 Plausibilittsprfung fr einen Betrieb
 Parameter:
 - pD0101_ID : VIS_D0101.ID des zu prfenden Betriebes
 - pResult : Rckgabewert der Prfung
             0 - alles in Ordnung
             1 - Warnungen enthalten
             2 - Fehler enthalten
 - pErrors : Rckgabe der Fehlermeldungen
 - pWarnings : Rckgabe der Warnungen             
*******************************************************************************/
PROCEDURE SBS_AUSGANG(pBatchMode IN BOOLEAN, pD0101_ID IN VARCHAR2, pResult OUT INT, pErrors OUT NOCOPY CLOB, pWarnings OUT NOCOPY CLOB) AS
BEGIN
 
  IF vVerfahren = QUELLE_IDV_NRW THEN -- fr TH bereits bei der Declaration definiert
    /*SELECT a010145.sid INTO vA010145_SID_HIT
    FROM vis_a010145 a010145
    WHERE a010145.skz = 10
      AND a010145.deleted = 0
      AND a010145.code = '01901301';*/
    vA010145_SID_HIT := 1468008;  
  END IF;

  vBatchMode := pBatchMode;
  ChkD0101(pD0101_ID);
  pErrors := vErrors;
  pWarnings := vWarnings;
  pResult := vResult;
END SBS_AUSGANG; 

-- pPrtStatus : geplanter Protokollstatus, bei 5 erfolgt Verarbetung wie bei A Neu 
PROCEDURE SBS_AUSGANG(pD0101_ID IN VARCHAR2, pResult OUT INT, pErrors OUT NOCOPY CLOB, pWarnings OUT NOCOPY CLOB, pPrtStatus IN INT) AS
BEGIN
  --vErstMode := False;
  IF pPrtStatus = 5 THEN
    vD0101IsNew := 5;
  END IF;  
  SBS_AUSGANG(False, pD0101_ID, pResult, pErrors, pWarnings);
END SBS_AUSGANG;

--PROCEDURE SBS_AUSGANG01(pD0101_ID IN VARCHAR2, pResult OUT INT, pErrors OUT CLOB, pWarnings OUT CLOB) AS
--BEGIN
--  vErstMode := True;
--  SBS_AUSGANG(False, pD0101_ID, pResult, pErrors, pWarnings);
--  vErstMode := False;
--END;

PROCEDURE SBS_AUSGANG(pD0101_ID IN VARCHAR2) AS
 vResult1 INT;
 vErrors1 CLOB;
 vWarnings1 CLOB;
BEGIN
  SBS_AUSGANG(False, pD0101_ID, vResult1, vErrors1, vWarnings1);
END SBS_AUSGANG; 

PROCEDURE SBS_AUSGANG(pD0101_ID IN VARCHAR2, pGKZ2 IN VARCHAR2) AS
 vResult1 INT;
 vErrors1 CLOB;
 vWarnings1 CLOB;
BEGIN
  SBS_AUSGANG(False, pD0101_ID, vResult1, vErrors1, vWarnings1);
END SBS_AUSGANG;  

PROCEDURE SBS_AUSGANGBatch(pD0101_ID IN VARCHAR2, pResult OUT INT, pErrors OUT NOCOPY CLOB, pWarnings OUT NOCOPY CLOB) AS
BEGIN
  --vErstMode := False;
  SBS_AUSGANG(True, pD0101_ID, pResult, pErrors, pWarnings);
END SBS_AUSGANGBatch;

FUNCTION ClearData RETURN NUMBER AS
BEGIN

  vRegnr := NULL; 
  vRegNr$3 := NULL;
 
  vBA := NULL;
  vErrors := NULL;
  vWarnings := NULL;
  vD0101 := NULL;
  vD0101$3 := NULL;

  RETURN 1;
END;

FUNCTION ReadStatus RETURN tbStatus PIPELINED AS
 vStatus tStatus;
BEGIN
  vStatus.result := NVL(vResult, 3);
  vStatus.errors := vErrors;
  vStatus.warnings := vWarnings;
  PIPE ROW(vStatus);
  vErrors := NULL;
  vWarnings := NULL;
  vResult := NULL;
  RETURN;
END ReadStatus;





/**
  Plausiprfung fr die Erstbefllung
  
Einen Betrieb gezielt prfen:
select dx.* from table( zbr_aus.PlausiErstbefuellung( '3BDF577C64A844D3BD06341F2FC51D43' )) dx

Alle Betriebe mit einer HIT-Nummer, die noch nicht ber die Erstbefllung im Ausgangskorb sind. Es werden nur die Betriebe mit Plausi-Fehlern ausgegeben:
select dx.* from table( zbr_aus.PlausiErstbefuellung ) dx

Alle Betriebe aus AGB, wobei eine gezielt Prfung erfolgt und alle Betriebe in der Ergebnismenge enthalten sind:
select d0101.code , dx.error_message 
from  vis_d0101 d0101
cross join table( zbr_aus.PlausiErstbefuellung( d0101.id ) ) dx
where d0101.code LIKE 'ABG%'

Alle Betriebe aus AGB mit Fehlern:
select d1.* from (
select d0101.code , dx.error_message 
from  vis_d0101 d0101
cross join table( zbr_aus.PlausiErstbefuellung( d0101.id ) ) dx
where d0101.code LIKE 'ABG%'
) d1
where d1.error_message like 'Fehler%'

**/
FUNCTION PlausiErstbefuellung (
  pD0101_ID IN vis_d0101.id%TYPE, 
  pHinweise IN NUMBER := 1, 
  pFehler IN NUMBER := 1,
  pEinzeln IN NUMBER := 1) RETURN tbPlausi PIPELINED
AS 
  TYPE tZBR_AUS IS TABLE OF CurZBR_AUS%ROWTYPE;
  vZBR_AUS tZBR_AUS;   

  --vPlausi2 zbr_aus_data.tPlausi;
  vPlausi1 tPlausi;
  --vPlausi2 tPlausi;
  vCnt  PLS_INTEGER; 
  vCnt1 PLS_INTEGER; 
  vCnt2 PLS_INTEGER; 
  
  CURSOR cChk (pID IN vis_d0101.id%TYPE) IS
  SELECT 
    ( SELECT MAX(uc.d0101_id) 
      FROM aus_d_usecase uc 
      WHERE uc.usecase = 'ERSTBEFUELLUNG'
      AND uc.d0101_id = pID ) uc_d0101_id ,
  
    ( SELECT MAX(d010102.d0101_id)       
      FROM vis_d010102 d010102 
      WHERE d010102.deleted = 0
        AND d010102.a010145_sid = 514001 --Registriernummer (HIT)
        AND d010102.d0101_id = pID ) d010102_d0101_id  
  
  FROM DUAL;  
  
  vChk cChk%ROWTYPE;
    
BEGIN
 
  ZBR_AUS_DATA.vErstMode := True;
  --Init();

  ZBR_AUS_DATA.vBts_Cnt := 0;
  ZBR_AUS_DATA.vBts_ID := '-1';

  ZBR_AUS_DATA.vPrtStatus := 0;   
  
  ZBR_AUS_DATA.vPlausiResult := 0;
  ZBR_AUS_DATA.vPlausiErrors := NULL; 
  ZBR_AUS_DATA.vPlausiWarnings := NULL;
  ZBR_AUS_DATA.vAnz_Usecases := -2;

  ZBR_AUS_DATA.vBatchMode := FALSE;  
    
  IF CurZBR_AUS%ISOPEN THEN
    CLOSE CurZBR_AUS;
  END IF;
    
  OPEN CurZBR_AUS (pD0101_ID);
  LOOP
  
    FETCH CurZBR_AUS BULK COLLECT INTO vZBR_AUS LIMIT 500;
    IF vZBR_AUS.COUNT = 0 AND pD0101_ID <> '%' THEN

      --vPlausi2.d0101_id := pD0101_ID;

      OPEN cChk (pD0101_ID);
      FETCH cChk INTO vChk;
      IF cChk%FOUND THEN

        --vPlausi.error_message := 'Keine Registriernummer (HIT) vorhanden oder bereits im Ausgangskorb.';
        IF vChk.uc_d0101_id <> '-1' THEN
          vPlausi1.text := 'Betriebssttte ist bereits im Ausgangskorb zur Erstbefllung.';
          PIPE ROW(vPlausi1);      
        
--        ELSIF vChk.D010102_d0101_ID IS NULL THEN        
--          vPlausi.error_message := 'Betriebssttte hat keine Registriernummer (HIT).';
--          PIPE ROW(vPlausi);      
          
        END IF;    
 
      END IF;
      CLOSE cChk;
              
    END IF;  
      
    EXIT WHEN vZBR_AUS.COUNT = 0; 
    
    FOR iZBR_AUS IN vZBR_AUS.FIRST .. vZBR_AUS.LAST LOOP    
      zbr_aus_data.vAnz_Usecases := -2;
      
      --ZBR_PLAUSI.SBS_AUSGANGBatch( vZBR_AUS(iZBR_AUS).D0101_ID, ZBR_AUS_DATA.vPlausiResult, ZBR_AUS_DATA.vPlausiErrors, ZBR_AUS_DATA.vPlausiWarnings);
      SBS_AUSGANG( vZBR_AUS(iZBR_AUS).D0101_ID, ZBR_AUS_DATA.vPlausiResult, ZBR_AUS_DATA.vPlausiErrors, ZBR_AUS_DATA.vPlausiWarnings, 0);
      vCnt1 := 0;
      vCnt2 := 0;
      vCnt := 0;
      IF vPlausi IS NOT NULL AND vPlausi.COUNT > 0 THEN
        IF pEinzeln = 1 THEN
          FOR i IN vPlausi.FIRST .. vPlausi.LAST LOOP
            IF vPlausi(i).text IS NOT NULL 
            AND vPlausi(i).regel NOT IN ('01.02', '01.03', '01.04', '05.15') -- Prfungen auf vor- und rckdatiert 
            THEN
            
              IF (vPlausi(i).result = 1 AND pHinweise = 1) OR
              (vPlausi(i).result = 2 AND pFehler = 1) THEN
              
                PIPE ROW(vPlausi(i));
                vCnt := vCnt + 1;
              ELSE
                CASE vPlausi(i).result 
                WHEN 1 THEN 
                  vCnt1 := vCnt1 + 1;
                WHEN 2 THEN 
                  vCnt2 := vCnt2 + 1;
                ELSE NULL;
                END CASE;
                
              END IF;
            END IF;           
          
          END LOOP;
          
          CASE
          WHEN vCnt = 0 AND vCnt1 = 0 AND vCnt2 = 0 THEN
            vPlausi1.text := 'OK';
            vPlausi1.result := 0;
            vPlausi1.Typ := 'Info';
            vPlausi1.regel := '00.01';
            PIPE ROW(vPlausi1);                  
          WHEN pHinweise = 0 AND pFehler = 0 THEN
            vPlausi1.text := '' || 
              CASE WHEN vCnt1 = 1 THEN '1 Hinweis ' WHEN vCnt1 > 1 THEN vCnt1 || ' Hinweise ' END ||
              CASE WHEN vCnt2 > 0 THEN  vCnt2 || ' Fehler' END;             
            vPlausi1.result := vCnt1 + vCnt2;
            vPlausi1.Typ := 'Info';
            vPlausi1.regel := '00.02';
            PIPE ROW(vPlausi1);           
          ELSE NULL;
          END CASE;        
        
        ELSE
          vPlausi1.text := NULL;
          vPlausi1.result := 0;
          vPlausi1.typ := NULL;
          vPlausi1.regel := NULL;
          
          -- nur Fehler
          FOR i IN vPlausi.FIRST .. vPlausi.LAST LOOP
            IF vPlausi(i).text IS NOT NULL AND vPlausi(i).result = 2 THEN
              IF pFehler = 1 THEN
                vPlausi1.result := 2;
                vPlausi1.text := CASE WHEN vCnt2 = 0 THEN 'Fehler' ELSE vPlausi1.text END || CRLF || 
                                 vPlausi(i).regel || ': ' || vPlausi(i).text;                                         
                vCnt := vCnt + 1;                
              END IF;
              vCnt2 := vCnt2 + 1;
                             
            END IF;           
          
          END LOOP;

          -- nur Hinweise
          FOR i IN vPlausi.FIRST .. vPlausi.LAST LOOP
            IF vPlausi(i).text IS NOT NULL AND vPlausi(i).result = 1 THEN
              IF pHinweise = 1 THEN
                IF vPlausi1.result = 0 THEN
                  vPlausi1.result := 1;
                END IF;
                IF vCnt1 = 0 THEN 
                  vPlausi1.text := CASE WHEN vPlausi1.text IS NOT NULL THEN vPlausi1.text || CRLF END ||
                                   'Hinweis';
                END IF;
                vPlausi1.text := vPlausi1.text || CRLF ||
                                 vPlausi(i).regel || ': ' || vPlausi(i).text;                                         
                vCnt := vCnt + 1;                
              END IF;
              vCnt1 := vCnt1 + 1;
                             
            END IF;           
          
          END LOOP;
          
          IF vCnt = 0 THEN
            vPlausi1.text := '' || 
              CASE WHEN vCnt1 = 1 THEN '1 Hinweis ' WHEN vCnt1 > 1 THEN vCnt1 || ' Hinweise ' END ||
              CASE WHEN vCnt2 > 0 THEN  vCnt2 || ' Fehler' END;             
            vPlausi1.result := vCnt1 + vCnt2;
            vPlausi1.Typ := 'Info';
            vPlausi1.regel := '00.02';
            PIPE ROW(vPlausi1);           
          ELSE
            PIPE ROW(vPlausi1);                       
          END IF;           
        
        END IF; -- pEinzeln
          
      ELSE
        vPlausi1.text := 'OK';
        vPlausi1.result := 0;
        vPlausi1.Typ := 'Info';
        vPlausi1.regel := '00.01';
        PIPE ROW(vPlausi1);  
      END IF;       
      
--      IF pD0101_ID <> '%' AND ZBR_AUS_DATA.vPlausiResult < 2 THEN 
        --vPlausi.d0101_id := pD0101_ID;
--        vPlausi1.text := 'keine Fehler';
        --PIPE ROW(vPlausi);        
        
--      ELSIF ZBR_AUS_DATA.vPlausiResult = 2 THEN -- bei Fehler Betrieb 
       
       --vPlausi.d0101_id := vZBR_AUS(iZBR_AUS).D0101_ID;
---------------------------------------------
         

     
--            vResPlausi.typ    := CASE vStatus(i).result WHEN 1 THEN 'Hinweis' WHEN 2 THEN 'Fehler ' END;
--            vResPlausi.regel  := vStatus(i).regel;
--            vResPlausi.result := vStatus(i).result;
--            
--            CASE
--            WHEN vStatus(i).errors IS NOT NULL THEN
--              vResPlausi.text   := vStatus(i).errors;
--              
--            WHEN vStatus(i).warnings IS NOT NULL THEN
--              vResPlausi.text := vStatus(i).warnings;
--            ELSE vResPlausi.text := NULL;
--            END CASE;
--            
--            IF vResPlausi.text IS NOT NULL THEN
--              PIPE ROW(vResPlausi);
--            END IF;
--          END LOOP;
          
--        END IF;
      
--      END IF;  -- vPlausiResult
    END LOOP;  -- iZBR_AUS    
    
  END LOOP; -- alle Betriebe
  CLOSE CurZBR_AUS;
  ZBR_AUS_DATA.vErstMode := False;
  
  RETURN;
  
END PlausiErstbefuellung;



FUNCTION Version RETURN VARCHAR2 AS
BEGIN
  RETURN '$Revision: 990 $';
END Version;

BEGIN
  GetS07Verfahren;

END ZBR_PLAUSI;
/

