
ALTER SESSION SET PLSQL_CODE_TYPE = NATIVE;
/

alter session set plsql_optimize_level = 3;
/

/*
alter session set "_disable_fast_validate"=true;
DROP PACKAGE ZBR_AUS_DATA;

alter session set plsql_warnings = 'Enable:All', 'Disable:(6002, 6006, 6005)'; 
alter session set plsql_warnings = 'Disable:All';
*/ 

CREATE OR REPLACE PACKAGE ZBR_AUS_DATA AS
/* 
SVN Revisionsinformationen
$Revision: 822 $ 
*/ 
  SUBTYPE tID IS VARCHAR2(32);


  TYPE tAusgStatus IS RECORD (
    bts_id tID,
    PlausiResult NUMBER(10),
    Anz_Usecases NUMBER(10),  -- grer 0 Anz. Usecases
                              -- 0 keine Usecases
                              -- -1 keine neuen Daten fr den Ausgangskorb
                              -- -2 Plausifehler vorhanden  
                              -- -3 keine Daten gelesen beim Verarbeiten - Fehler
                                
    PLausiWarnings CLOB,
    PlausiErrors CLOB );
    
  TYPE tbAusgStatus IS TABLE OF tAusgStatus;    

  TYPE tKom IS RECORD ( TELEFON VARCHAR2(255), FAX VARCHAR2(255), MOBIL  VARCHAR2(255), EMAIL  VARCHAR2(255), INTERNET VARCHAR2(255));

  TYPE tAdr IS RECORD ( verw aus_d_verwaltung%ROWTYPE,
                        kat  aus_d_kataster%ROWTYPE,
                        padr aus_d_postadresse%ROWTYPE,
                        adr  aus_d_adresse%ROWTYPE,
                        typ  VARCHAR2(20) );                                               

  TYPE tAbt_Adr IS RECORD ( Abt aus_d_abteilung%ROWTYPE,
                            Adr tAdr,
                            Adr2 tAdr);
  
  TYPE tbAbt_Adr IS TABLE OF tAbt_Adr;
  
  TYPE tbBTA_ABT IS TABLE OF aus_r_bta_abt%ROWTYPE;

  TYPE tbBTA IS TABLE OF aus_d_betriebsart%ROWTYPE;
  
  TYPE tbReg IS TABLE OF aus_d_registrierung%ROWTYPE;
  
  TYPE tTIR IS RECORD (
    ID          aus_d_tierangaben.id%TYPE
  , D_BTS_ID    aus_d_tierangaben.D_BTS_ID%TYPE
  , D_BTA_ID    aus_d_tierangaben.D_BTA_ID%TYPE
  , BEZEICHNUNG aus_d_tierangaben.BEZEICHNUNG%TYPE
  , CODE        aus_d_tierangaben.CODE%TYPE
  , ANZAHL      aus_d_tierangaben.ANZAHL%TYPE
  , GUELTIG_VON aus_d_tierangaben.GUELTIG_VON%TYPE
  , GUELTIG_BIS aus_d_tierangaben.GUELTIG_BIS%TYPE
  , REF_ID      aus_d_tierangaben.REF_ID%TYPE
  , BTA_CODE    aus_d_betriebsart.code%TYPE );
  TYPE tbTIR IS TABLE OF tTIR;
  
  --TYPE tbUsecase IS TABLE OF aus_d_usecase%ROWTYPE;                              
 
  TYPE tUsc IS RECORD (
   id         aus_d_usecase.ID%TYPE, 
   d_bts_id   aus_d_usecase.D_BTS_ID%TYPE, 
   d0101_id   aus_d_usecase.D0101_ID%TYPE, 
   usecase    aus_d_usecase.USECASE%TYPE, 
   mandant    aus_d_usecase.MANDANT%TYPE, 
   user_sid   aus_d_usecase.USER_SID%TYPE, 
   lastmodified aus_d_usecase.LASTMODIFIED%TYPE, 
   gueltig_von  aus_d_usecase.GUELTIG_VON%TYPE, 
   gueltig_bis  aus_d_usecase.GUELTIG_BIS%TYPE, 
   aend_art   aus_d_usecase.AEND_ART%TYPE, 
   aend_grund aus_d_usecase.AEND_GRUND%TYPE, 
   aend_bem   aus_d_usecase.AEND_BEM%TYPE, 
   alter_wert aus_d_usecase.ALTER_WERT%TYPE, 
   neuer_wert aus_d_usecase.NEUER_WERT%TYPE, 
   d_bts_id2  aus_d_usecase.D_BTS_ID2%TYPE, 
   ref_id     aus_d_usecase.REF_ID%TYPE,
   ref_id_alt aus_d_usecase.REF_ID_ALT%TYPE);
    
  TYPE tbUsc IS TABLE OF tUsc;

  TYPE tbPrt IS TABLE OF aus_d_protokoll%ROWTYPE;
  
  TYPE tFkt IS RECORD( Fkt      aus_d_funktion%ROWTYPE,
                       Pers     aus_d_person%ROWTYPE,
                       Adr      tAdr,
                       Adr2     tAdr,
                       --Adr_PERS tAdr,
                       Reg      tbReg,
                       Kom      tKom);
  
  TYPE tPrs1 IS RECORD (
   ID           aus_d_person.ID%TYPE,
   KURZBEZ1     aus_d_person.KURZBEZ1%TYPE, 
   KURZBEZ2     aus_d_person.KURZBEZ2%TYPE, 
   TYP          aus_d_person.TYP%TYPE, 
   ANREDE       aus_d_person.ANREDE%TYPE, 
   TITEL        aus_d_person.TITEL%TYPE, 
   VORNAME      aus_d_person.VORNAME%TYPE, 
   NACHNAME     aus_d_person.NACHNAME%TYPE,
   VORSATZ_NACHNAME aus_d_person.VORSATZ_NACHNAME%TYPE,
   NACHSATZ_NACHNAME aus_d_person.NACHSATZ_NACHNAME%TYPE,
   
   --GEBURTSDATUM aus_d_person.GEBURTSDATUM%TYPE, 
   --GEBURTSORT   aus_d_person.GEBURTSORT%TYPE, 
   BEZEICHNUNG  aus_d_person.BEZEICHNUNG%TYPE, 
   BEZEICHNUNG2 aus_d_person.BEZEICHNUNG2%TYPE, 
   RECHTSFORM   aus_d_person.RECHTSFORM%TYPE, 
   --PERS_ID      aus_d_person.PERS_ID%TYPE, 
   REF_ID       aus_d_person.REF_ID%TYPE,
   TELEFON      aus_d_kommunikation.komdata%TYPE,
   FAX          aus_d_kommunikation.komdata%TYPE,
   MOBIL        aus_d_kommunikation.komdata%TYPE,
   EMAIL        aus_d_kommunikation.komdata%TYPE,
   GEBURTSDATUM DATE,
   GEBURTSORT   VARCHAR2(1 CHAR),
   GEBURTSNAME  VARCHAR2(1 CHAR),
   GEBURTSLAND  VARCHAR2(1 CHAR),
   A0101_03_SID NUMBER(10),
   A0101_70_SID NUMBER(10)
  );
  TYPE tbPrs1 IS TABLE OF tPrs1;
  
  TYPE tBTS1 IS RECORD (
    ID aus_d_betriebsstaette.id%TYPE,
    zusatzbez aus_d_betriebsstaette.zusatzbez%TYPE,
    gueltig_von aus_d_betriebsstaette.gueltig_von%TYPE,
    gueltig_bis aus_d_betriebsstaette.gueltig_bis%TYPE,
    REF_ID aus_d_betriebsstaette.ref_id%TYPE,
    telefon aus_d_kommunikation.komdata%TYPE,
    fax aus_d_kommunikation.komdata%TYPE,
    mobil aus_d_kommunikation.komdata%TYPE,
    --internet aus_d_kommunikation.komdata%TYPE,
    email aus_d_kommunikation.komdata%TYPE);
    
  TYPE tbBTS1 IS TABLE OF tBTS1;
  
  TYPE tbBTS IS TABLE OF aus_d_betriebsstaette%ROWTYPE;
                                  
  TYPE tBTS IS RECORD( Bts        aus_d_betriebsstaette%ROWTYPE,
                       Usecases   tbUsc, --,
                       Prot       aus_d_protokoll%ROWTYPE,                       
                       Reg        tbReg,
                       Abt_Adr    tbAbt_Adr,
                       Bta        tbBta,
                       Bta_Abt    tbBTA_ABT,
                       Adr_BTRO   tAdr,
                       Adr_BTRO2  tAdr,
                       Adr_BTRA   tAdr,
                       Adr_BTRA2  tAdr,
                       Fkt_HV     tFkt,
                       Fkt_INH    tFkt,
                       Kom        tKom,
                       TIR        tbTIR  
                       ); 
  
  TYPE tZBR_AUS IS RECORD ( 
    d0101_id vis_d0101.id%TYPE,
    d0101_id3 vis_d0101.d0101_id3%TYPE,
    d0101_upd_date DATE,
    d3_upd_date DATE,
    d010101_upd_date DATE,
    D010101_del_date DATE,
    D010200_upd_date DATE,
    D010102_upd_date DATE,
    D010110_upd_date DATE);

  TYPE tbZBR_AUS IS TABLE OF tZBR_AUS;    
  
  TYPE tAdr1 IS RECORD ( --adr AUS_D_ADRESSE%ROWTYPE), 
    id AUS_D_ADRESSE.ID%TYPE, 
    --FreiText AUS_D_ADRESSE.FreiBez%TYPE,
    --Postbezeichnung AUS_D_POSTADRESSE.Postbezeichnung%TYPE, 
    WECHSEL AUS_D_ADRESSE.WECHSEL%TYPE, 
    --gueltig_von AUS_D_ADRESSE.gueltig_von%TYPE, 
    --gueltig_bis AUS_D_ADRESSE.gueltig_bis%TYPE, 
    --TYP AUS_D_ADRESSE.TYP%TYPE, 
    --ADRESSZUSATZ AUS_D_ADRESSE.ADRESSZUSATZ%TYPE, 
    --typ AUS_D_ADRESSE.TYPE%TYPE, 
    --bundesland AUS_D_ADRESSE.BUNDESLAND%TYPE, 
    --bezirk AUS_D_ADRESSE.BEZIRK%TYPE, 
    --kreis AUS_D_ADRESSE.KREIS%TYPE, 
    GEMEINDE AUS_D_VERWALTUNG.GEMEINDE%TYPE, 
    --fkz AUS_D_ADRESSE.GKZ%TYPE, 
    --REGIONALSCHLUESSEL AUS_D_VERWALTUNG.REGIONALSCHLUESSEL%TYPE,
    POSTFACH_JN aus_d_postadresse.postfach_jn%TYPE, 
    STRASSE AUS_D_POSTADRESSE.STRASSE%TYPE, 
    Hausnummer AUS_D_POSTADRESSE.Hausnr%TYPE, 
    Hausnummernzusatz AUS_D_POSTADRESSE.Hausnrzusatz%TYPE, 
    Postfach AUS_D_POSTADRESSE.Postfach%TYPE, 
    Staat AUS_D_POSTADRESSE.Staat%TYPE, 
    PLZ AUS_D_POSTADRESSE.PLZ%TYPE, 
    Ort AUS_D_POSTADRESSE.Ort%TYPE, 
    Ortsteil AUS_D_POSTADRESSE.Ortsteil%TYPE, 
    --Teilort AUS_D_ADRESSE.Teilort%TYPE, 
    Flurnummer AUS_D_KATASTER.Flurnummer%TYPE, 
    Flurstueck AUS_D_KATASTER.Flurstueck%TYPE, 
    Gemarkung AUS_D_KATASTER.Gemarkung%TYPE, 
    X_Wert AUS_D_KATASTER.X_Wert%TYPE, 
    Y_Wert AUS_D_KATASTER.Y_Wert%TYPE, 
    Rechtswert AUS_D_KATASTER.Rechtswert%TYPE, 
    Hochwert AUS_D_KATASTER.Hochwert%TYPE, 
    --Koordinatenherkunft AUS_D_ADRESSE.Koordinatenherkunft%TYPE, 
    --s09_sid AUS_D_ADRESSE.S09_SID%TYPE, 
    --ins_date AUS_D_ADRESSE.INS_DATE%TYPE, 
    --glo_a24_sid AUS_D_ADRESSE.GLO_A24_SID%TYPE,
    gkz AUS_D_VERWALTUNG.gkz%TYPE );  
  
  TYPE tbAdr1 IS TABLE OF tAdr1;
   
  vDateMin CONSTANT DATE := TO_DATE('31.12.1920', 'dd.mm.yyyy');
  vDateMax CONSTANT DATE := TO_DATE('01.01.9999', 'dd.mm.yyyy');
  vDate01_01_0001 CONSTANT DATE := TO_DATE('01.01.0001', 'dd.mm.yyyy');
  NRW CONSTANT VARCHAR2(2) := '05';  -- GKZ2 fr NRW
  vA0101_03_SID_Default CONSTANT NUMBER(10) := 402001; -- sonstige juristische Person
  --vA010145_SID_HIT CONSTANT NUMBER(10) := 514001; -- 0102 Registriernummer (HIT)
    
  vBTS_Cnt INT := 0;
  vFunktionID AUS_D_FUNKTION.ID%TYPE;
  --vFunktionID2 AUS_D_FUNKTION.ID%TYPE;
  vFunktionID3 AUS_D_FUNKTION.ID%TYPE;
  --vCnt INT;
  vPersonID AUS_D_PErson.ID%TYPE;
  --vPersonID2 AUS_D_PErson.ID%TYPE;
  vPersonID3 AUS_D_PErson.ID%TYPE;
  vPostadrID1 AUS_D_POSTADRESSE.ID%TYPE; -- Adresse
  vPostadrID2 AUS_D_POSTADRESSE.ID%TYPE; -- abweichende Postadresse
  vPostadrID3 AUS_D_POSTADRESSE.ID%TYPE; -- Postadresse Betreiber
  vAdresseID1 AUS_D_ADRESSE.ID%TYPE;
  vAdresseID2 AUS_D_ADRESSE.ID%TYPE;
  vAdresseID3 AUS_D_ADRESSE.ID%TYPE;  -- Adresse Betreiber
  vKatasterID1 AUS_D_KATASTER.ID%TYPE;
  vKatasterID2 AUS_D_KATASTER.ID%TYPE;
  vVerwaltungID1 AUS_D_VERWALTUNG.ID%TYPE;
  vVerwaltungID2 AUS_D_VERWALTUNG.ID%TYPE;
  vBTS_ID AUS_D_BETRIEBSSTAETTE.ID%TYPE;
  vID VARCHAR2(32);
  vD0101_ID VIS_d0101.ID%TYPE; 
  vLastModified DATE;
  vProtokoll_Mandant aus_d_protokoll.mandant%type;
  vBTRO_ID VARCHAR2(32);
  vBTRA_ID VARCHAR2(32);
  -- verschoben nach zbr_aus vGKZ2 VARCHAR2(2);
  --vKomTelID VARCHAR2(32);
  --vKomFaxID VARCHAR2(32);
  --vKomEMailID VARCHAR2(32);
  --vKomMobilID VARCHAR2(32);
  --vKomInternetID VARCHAR2(32);
  
  vVerwID VARCHAR2(32);
  vKatID VARCHAR2(32);
  vPostID VARCHAR2(32);
  vKOM_TEL vis_d0101.kom_tel%TYPE;
  vKom_fax vis_d0101.kom_fax%TYPE;
  vKom_mobil vis_d0101.kom_mobil%TYPE;
  vKOM_EMAIL vis_d0101.kom_email%TYPE;
  vKOM_INTERNET vis_d0101.kom_internet%TYPE;
  vKOM_SONST vis_d0101.kom_sonst%TYPE;
  vLastUpdDate  DATE;
  vPrtStatus NUMBER(2);
   
  vPlausiResult PLS_INTEGER := 0;
  vPlausiErrors CLOB := NULL; 
  vPlausiWarnings CLOB := NULL;  
  vAnz_Usecases PLS_INTEGER := -1;
     
  vBatchMode BOOLEAN := FALSE;  -- Ausfhrung im Batch oder manuell
  vErstMode BOOLEAN := FALSE;   -- Erstbefllung

  vD010101_HITgueltig_von DATE; -- alteste gueltig_von der HIT-Betriebsarten
 
  --vD0101_gueltig_von DATE; -- Anmeldedatum der Betriebssttte
  vDefault_gueltig_von CONSTANT DATE := TO_DATE('01.01.1900', 'dd.mm.yyyy');  
  
  bCommit BOOLEAN := TRUE; -- automatischen Commit

  v31_12_1920 CONSTANT DATE := TO_DATE('31.12.1920', 'dd.mm.yyyy');
  v01_01_1753 CONSTANT DATE := TO_DATE('01.01.1753', 'dd.mm.yyyy');
  CRLF CONSTANT VARCHAR2(2) := CHR(13)||CHR(10);
 
/*******************************************************************************  
  NRW  TH
  HV   -
  INH  Betreiber
  BTRA Postadresse
  BTRO Standortadresse 
  IDV  BI
*******************************************************************************/
  INH CONSTANT VARCHAR2(3) := 'INH';
  Betreiber CONSTANT VARCHAR2(9) := 'Betreiber';
  BI CONSTANT VARCHAR2(2) := 'BI';
  IDV CONSTANT VARCHAR2(10) := 'IDV';
  IDV_INH CONSTANT VARCHAR2(10) := 'IDV-INH';
  BTRO CONSTANT VARCHAR2(4) := 'BTRO';
  BTRA CONSTANT VARCHAR2(4) := 'BTRA';
  StandortAdr CONSTANT VARCHAR2(20) := 'Standortadresse';
  PostAdr CONSTANT VARCHAR2(20) := 'Postadresse';
  HV CONSTANT VARCHAR2(2) := 'HV';
  DH_BALVI CONSTANT ein_d_usecase.datenherkunft%TYPE := 'BALVI iP';
  vINH VARCHAR2(20) := INH;
  vIDV VARCHAR2(20) := IDV;
  vIDV_INH VARCHAR2(20) := IDV_INH;
  vHV VARCHAR2(20) := HV;
  vBTRO VARCHAR2(20) := BTRO;  -- Standortanschrift
  vBTRA VARCHAR2(20) := BTRA;  -- Postanschrift

  -- Ergebnis der Plausiprfung als Tabelle 
  TYPE tPlausi IS RECORD (
    d0101_id vis_d0101.id%TYPE,
    error_message ein_d_usecase.error_message%TYPE );
    
  TYPE tbPlausi IS TABLE OF tPlausi;  
    
END ZBR_AUS_DATA;
/
