/*<TOAD_FILE_CHUNK>*/

ALTER SESSION SET PLSQL_CODE_TYPE = NATIVE;

ALTER SESSION SET PLSQL_OPTIMIZE_LEVEL = 3;

/*
ALTER SESSION SET PLSQL_CODE_TYPE = INTERPRETED;

DROP PACKAGE ZBR_AUS;

alter session set plsql_warnings = 'Enable:All', 'Disable:(6002, 6006, 6005)'; 
alter session set plsql_warnings = 'Disable:All'; 
*/

CREATE OR REPLACE PACKAGE ZBR_AUS AS
/* 
SVN Revisionsinformationen:
   $Revision: 841 $ 
*/

  A010145_BETREIBER_ID CONSTANT NUMBER(10) := 1606001;
  A010145_HIT_NR CONSTANT NUMBER(10) := 514001;
  A010145_IDV_BETREIBER_ID CONSTANT NUMBER(10) := 1474008;
  A0302_05_RUHT CONSTANT NUMBER(10) := 625001;
  A0302_05_ERTEILT CONSTANT NUMBER(10) := 28001;

  QUELLE_IDV_NRW CONSTANT VARCHAR2(20) := 'IDV-SFDP'; 
  QUELLE_ZBR CONSTANT VARCHAR2(20) := 'ZBR';
  QUELLE_XGEWERBE CONSTANT VARCHAR2(20) := 'XGEWERBE';
  BA_GROUP CONSTANT VARCHAR2(5) := 'GROUP';
  Betreiber CONSTANT VARCHAR2(10) := 'Betreiber';
  
  vVerfahren VARCHAR2(20);  
  
 
  CURSOR CurZBR_AUS (pID IN vis_d0101.id%TYPE := '%') IS
    SELECT d0101.id d0101_id, d0101.d0101_id3       
    FROM VIS_D0101 d0101
    JOIN vis_d0101 d3 ON d3.id = d0101.d0101_id3
                        
    WHERE d0101.deleted = 0
      AND d0101.skz = 1
      AND d0101.id LIKE pID      
      -- HIT-Nr. fr BTS vorhanden
      AND EXISTS( 
        SELECT 1 
        FROM vis_d010102 d010102 
        WHERE d010102.deleted = 0
          AND d010102.a010145_sid = A010145_HIT_NR --Registriernummer (HIT)
          AND d010102.d0101_id = d0101.id )
      -- Betreiber-ID wenn abweichender BTR vorhanden
      -- bei Betreiber mit SKZ=99 Prfung auf Betreiber-ID sonst HIT-Nr.          
      -- 28.05.2015 wird in der Plausi berprft nicht mehr hier, 
      -- damit diese Betriebe als Fehler im Eingangskorb ausgewertet werden knnen 
      /*AND EXISTS( 
        SELECT 1 
        FROM vis_d010102 d010102 
        WHERE d010102.deleted = 0
          AND d010102.a010145_sid = 
            CASE WHEN d3.skz = 99 THEN 1606001 --Betreiber_ID (Betriebsregister) 
            ELSE 514001 --Registriernummer (HIT)
            END 
          AND d010102.d0101_id = d0101.d0101_id3 )   */
          
      /* gibt es nicht bei der Erstbefllung AND d0101.ID NOT IN ( 
        SELECT d1.d0101_id 
        FROM aus_d_gesperrt d1 
        WHERE d1.gesperrt_jn = 1
        AND d1.gesperrt_bis > SYSDATE 
      ) */ 
      -- relevante BA muss vorhanden sein
--      AND d0101.id IN (
--        SELECT d010101.d0101_id
--        FROM vis_d010101 d010101
--        JOIN vis_va0089_hit_betriebstyp_16 ax ON ax.sid = d010101.a010108_sid 
--         AND ax.tv_pos IN (d010101.gewerbsmaessig, 2)
--         AND d010101.deleted = 0
--         --15.07.2014 AND d010101.aktiv = 1
--         -- todo 57553090: 02.04.2015
--         AND ( ax.axx1_code NOT LIKE '020403%' OR
--            EXISTS ( 
--              SELECT 1
--              FROM VIS_VD010102$01 dx
--              WHERE dx.d0101_id = d010101.d0101_id
--              AND dx.a010145_sid IN ( 1330001, 1331001, 1135001, 1136001)
--              AND SYSDATE BETWEEN dx.f$gueltig_von AND dx.f$gueltig_bis )
--          )
--       )
      AND d0101.ID NOT IN ( 
        SELECT d1.d0101_id 
        FROM aus_d_usecase d1 
        WHERE d1.usecase = 'ERSTBEFUELLUNG'
      )  
    /* 28.05.2014: Falls Betrieb schon im Eingangskorb dann wird jetzt die alte Meldung 
       berschrieben    
       AND d0101.ID NOT IN ( 
        SELECT d1.d0101_id 
        FROM ein_d_usecase d1
        WHERE d1.usecase = 'ERSTBEFUELLUNG'
      )  */                                                      
    ORDER BY CASE WHEN d0101.id = d0101.d0101_id3 THEN 0 ELSE 1 END; 

  vGKZ2 VARCHAR2(2);

-- Erstbefllung
-- 08.07.2013 entfernt
--PROCEDURE Ausgangskorb01(pUserSID IN INT, pBTS_Cnt OUT INT);
--vTmp int := -1;
PROCEDURE Erstbefuellung(pD0101_ID IN VARCHAR2 := '%');
FUNCTION Ausgangskorb( pUserSID NUMBER, 
                       pD0101_ID VARCHAR2,
                       pLastModified DATE := ZBR_AUS_DATA.vDateMin,
                       pForce NUMBER := 0,
                       pPrtStatus NUMBER := 0
                     ) RETURN NUMBER;

-- 08.07.2013 procedure entfernt
--PROCEDURE Ausgangskorb( pUserSID IN NUMBER, 
--                        pD0101_ID IN VARCHAR2,
--                        pLastModified IN DATE := vDateMin,
--                        pForce IN NUMBER := 0,
--                        pPrtStatus IN NUMBER := 0,
--                        pBtsCnt OUT NUMBER,
--                        pPlausiResult OUT INT,
--                        pPlausiMessage OUT VARCHAR2
--                      ); 

-- wird vom JB bei bertragung zum Register verwendet
PROCEDURE Ausgangskorb( pUserSID IN NUMBER, 
                        pD0101_ID IN VARCHAR2,
                        pLastModified IN DATE := ZBR_AUS_DATA.vDateMin,
                        pForce IN NUMBER := 0,
                        pPrtStatus IN NUMBER := 0,
                        pBtsCnt OUT NUMBER,
                        pPlausiResult OUT NUMBER,
                        pPlausiWarnings OUT NOCOPY VARCHAR2,
                        pPlausiErrors OUT NOCOPY VARCHAR2                        
                       );

PROCEDURE DeleteByProtID( pProtID VARCHAR2);
PROCEDURE DeleteByUsecaseID( pUsecaseID IN VARCHAR2);
PROCEDURE DeleteByBtsID( pBtsID VARCHAR2);
PROCEDURE DeleteLastBy(pTyp IN VARCHAR2, pValue IN zbr_aus_data.tID);
FUNCTION LastBTS_ID RETURN VARCHAR2;

FUNCTION LastModified RETURN DATE;
   
PROCEDURE WriteMeldung(pD0101_ID IN VARCHAR2, pUsecase IN VARCHAR2 := 'AUTOEXPORT');

FUNCTION PersBez(pNName IN VARCHAR2, pVName IN VARCHAR2, pTitel IN VARCHAR2) RETURN VARCHAR2;
FUNCTION PersBez(pNName IN VARCHAR2, pVName IN VARCHAR2, pTitel IN VARCHAR2, pLen PLS_INTEGER) RETURN VARCHAR2;
FUNCTION PersNachname(pNName IN VARCHAR2, pVorsatz IN VARCHAR2, pNachsatz IN VARCHAR2) RETURN VARCHAR2;
FUNCTION CreatePersonBez(pNName IN VARCHAR2, pVName IN VARCHAR2,
                         pVorsatz IN VARCHAR2, pNachsatz  IN VARCHAR2, 
                         pTitel IN VARCHAR2) RETURN VARCHAR2;

PROCEDURE Init;
--PROCEDURE Init( pGKZ2 IN VARCHAR2);

FUNCTION Version RETURN VARCHAR2;
  
PROCEDURE Create_HitKurzBez( pBez1 IN VARCHAR2, pBez2 IN VARCHAR2, pKurzBez1 OUT NOCOPY VARCHAR2, pKurzBez2 OUT NOCOPY VARCHAR2);  
 
FUNCTION ZBR_AUS_D0101(
  pD0101_ID IN ZBR_AUS_DATA.tID, 
  pLastModified IN DATE, 
  pForce IN PLS_INTEGER) RETURN ZBR_AUS_DATA.tbZBR_AUS PIPELINED;   
  
--FUNCTION GetUsecases( pD0101_ID IN ZBR_AUS_DATA.tID
--, pUserSID IN PLS_INTEGER, pMandant IN PLS_INTEGER
--, pLastModified IN DATE) RETURN ZBR_AUS_DATA.tbUsc PIPELINED;
FUNCTION CreateUsecase( pD0101_ID IN ZBR_AUS_DATA.tID
, pUserSID IN PLS_INTEGER, pMandant IN PLS_INTEGER
, pLastModified IN DATE
, pUpdLastModified OUT BOOLEAN) RETURN PLS_INTEGER;
PROCEDURE Fill_Bts(pBTS OUT NOCOPY ZBR_AUS_DATA.tBTS, pBTS_ID IN ZBR_AUS_DATA.tID) ;
FUNCTION FillAusgangskorb(pD0101_ID IN ZBR_AUS_DATA.tID, pUserSID IN NUMBER) RETURN ZBR_AUS_DATA.tID;   
FUNCTION AusgStatus RETURN ZBR_AUS_DATA.tbAusgStatus PIPELINED;

-- BTS_ID des letzten Standes im Ausgangskorb ermitteln
FUNCTION GetLastBTS_IDbyD0101_ID( pD0101_ID IN zbr_aus_data.tID) RETURN zbr_aus_data.tID;

/** Lesefunktionen **/
/** Protokoll mit Status = 0,5,6  
    - 0 - nicht verarbeitet, vor dem Vergleich, 
    - 2 - gesendet, zum Vergleich, 
    - 3 - nur zum Vergleich, wird nicht und wurde nicht gesendet, 
    - 4 - nur zum Vergleich mit dem Eingangskorb, 
    - 5 - neuer Betrieb ohne Dublettenabgleich senden, 
    - 6 - ohne Plausiprfung
    sortiert nach INS_DATE aufsteigend
  Bsp. SELECT dx.* FROM TABLE( zbr_aus.ReadPrt0 ) dx
**/ 
FUNCTION ReadPrt0 RETURN ZBR_AUS_DATA.tbPrt PIPELINED;
-- Protokoll zu einer BTS_ID
-- Bsp.: SELECT dx.* FROM TABLE( zbr_aus.ReadPrt('C46B4B3012B34C4783EFEFA17CC69D19')) dx
FUNCTION ReadPrt(pBTS_ID IN ZBR_AUS_DATA.tID) RETURN ZBR_AUS_DATA.tbPrt PIPELINED;
/** Alle Uscases zu einer BTS_ID in der richtigen Reihenfolge sortiert 
  Bsp.: SELECT dx.* FROM TABLE( ZBR_AUS.ReadUsc('DC7467DCD9D94A4E986510018924DD20')) dx
**/
FUNCTION ReadUsc(pBTS_ID IN ZBR_AUS_DATA.tID) RETURN ZBR_AUS_DATA.tbUsc PIPELINED;

/** nur eine Protokoll-Datensatz aus dem Ausgangskorb entsprechend der Prio und Reihenfolge ermitteln
  Bsp.: SELECT dx.* FROM TABLE( zbr_aus.ReadPrtPrio) dx
**/
FUNCTION ReadPrtPrio RETURN ZBR_AUS_DATA.tbPrt PIPELINED;

/** Betriebssttte einschl Kommunikationsmittel zu einer BTS_ID
  Bsp.: SELECT dx.* FROM TABLE( ZBR_AUS.ReadBts('C46B4B3012B34C4783EFEFA17CC69D19')) dx
**/
FUNCTION ReadBTS(pBTS_ID IN ZBR_AUS_DATA.tID) RETURN ZBR_AUS_DATA.tbBTS1 PIPELINED;
/** Betriebsarten
  Typ: 
  - BTS oder NULL (Standard) alle zu einer Betriebssttte ber BTS_ID
  - ID gezielt eine Betriebsart ber ID
  Bsp.: SELECT dx.* FROM TABLE( ZBR_AUS.ReadBta('C46B4B3012B34C4783EFEFA17CC69D19', 'BTS')) dx
**/
FUNCTION ReadBTA(pID IN ZBR_AUS_DATA.tID, pTyp IN VARCHAR2) RETURN ZBR_AUS_DATA.tbBTA PIPELINED;
/** Tierangaben
  Typ: 
  - BTS oder NULL (Standard) alle zu einer Betriebssttte ber BTS_ID
  - ID gezielt eine Tierangabe ber ID
  Bsp.: SELECT dx.* FROM TABLE( ZBR_AUS.ReadTIR('C46B4B3012B34C4783EFEFA17CC69D19', 'BTS')) dx
**/
FUNCTION ReadTIR(pID IN ZBR_AUS_DATA.tID, pTyp IN VARCHAR2) RETURN ZBR_AUS_DATA.tbTIR PIPELINED;
/** Registrierungen
 Typ: 
 - BTS oder NULL (Standard) alle zu einer Betriebssttte ber BTS_ID
 - ID gezielt eine Registrierung ber ID
 - BTR alle zum Betreiber der Betriebssttte ber BTS_ID
  Bsp.: SELECT dx.* FROM TABLE( ZBR_AUS.ReadReg('C46B4B3012B34C4783EFEFA17CC69D19', 'BTS')) dx 
**/
FUNCTION ReadReg(pID IN ZBR_AUS_DATA.tID, pTyp IN VARCHAR2) RETURN ZBR_AUS_DATA.tbReg PIPELINED;
/** komplette Adresse
  Typ: 
  - BTS_STO Standortadresse der Betriebssttte ber BTS_ID
  - BTS_PST Postadresse der Betriebssttte ber BTS_ID
  - BTS_ADR Adresse der Betriebssttte direkt ber AUS_D_ADRESSE.ID
  - BTR_STO Standortadresse des Betreibers ber BTS_ID
  - BTR_PST Postadresse des Betreibers ber BTS_ID
  - BTR_ADR Adresse des Betreibers direkt ber AUS_D_ADRESSE.ID
  Bsp.: SELECT dx.* FROM TABLE( ZBR_AUS.ReadAdr('C46B4B3012B34C4783EFEFA17CC69D19', 'BTS_STO')) dx 
**/
FUNCTION ReadAdr(pID IN ZBR_AUS_DATA.tID, pTyp IN VARCHAR2) RETURN ZBR_AUS_DATA.tbAdr1 PIPELINED;
/** Betreiber einschl. Kommunikationsmittel
  Typ:
  - BTS ber BTS_ID
  - ID ber aus_d_person.id  
  Bsp.: SELECT dx.* FROM TABLE( ZBR_AUS.ReadBTR('C46B4B3012B34C4783EFEFA17CC69D19', 'BTS')) dx 
**/  
FUNCTION ReadBtr(pID IN ZBR_AUS_DATA.tID, pTyp IN VARCHAR2) RETURN ZBR_AUS_DATA.tbPrs1 PIPELINED;
FUNCTION ReadBtr2(pID IN ZBR_AUS_DATA.tID, pTyp IN VARCHAR2) RETURN ZBR_AUS_DATA.tbPrs1 PIPELINED;
/** Besttigung einer BTS_ID in aus_d_protokoll
  Bsp.:
  BEGIN 
    zbr_aus.PrtConfirm(('C46B4B3012B34C4783EFEFA17CC69D19');
  END;
**/
PROCEDURE PrtConfirm(pBTS_ID IN ZBR_AUS_DATA.tID);
PROCEDURE PrtConfirm(pBTS_ID IN ZBR_AUS_DATA.tID, pStatus IN NUMBER);
/** Besttigung eines Usecases ber ein_d_usecase.id
  Sind alle usecases zu einem Protokoll besttigt wird das Protokoll auch besttigt.
  Bsp.:
  BEGIN
    zbr_aus.UscConfirm(('D7832B8E19F445C5B0DB7818E44F8345');
  END;    
**/
PROCEDURE UscConfirm(pUSC_ID IN ZBR_AUS_DATA.tID);

/**
  Prio aller nicht gesendeten Protokolle zu einem Betrieb anpassen
**/
PROCEDURE UpdPrtPrio(pD0101_ID IN ZBR_AUS_DATA.tID, pPrio IN NUMBER);

FUNCTION PlausiErstbefuellung (pD0101_ID IN vis_d0101.id%TYPE := '%') RETURN zbr_aus_data.tbPlausi PIPELINED;

FUNCTION GetVerfahren RETURN VARCHAR2;
PROCEDURE GetS07Verfahren DETERMINISTIC;
PROCEDURE GroupBa(pBTS_ID IN ZBR_AUS_DATA.tID);
END zbr_aus;
/

/**

kompletten Ausgangskorb lschen
  
TRUNCATE TABLE AUS_R_ABT_ADR;
TRUNCATE TABLE AUS_R_ABT_REG;
TRUNCATE TABLE AUS_R_BTA_ABT;
TRUNCATE TABLE AUS_R_BTS_ADR;
TRUNCATE TABLE AUS_R_BTS_BEHOER;
TRUNCATE TABLE AUS_R_BTS_BZH;
TRUNCATE TABLE AUS_R_BTS_KOM;
TRUNCATE TABLE AUS_R_BTS_REG;
TRUNCATE TABLE AUS_R_FKT_ADR;
TRUNCATE TABLE AUS_R_FKT_KOM;
TRUNCATE TABLE AUS_R_FKT_REG;
TRUNCATE TABLE AUS_R_PERS_ADR;
TRUNCATE TABLE AUS_R_PERS_FKT;
TRUNCATE TABLE AUS_R_PERS_KOM;
TRUNCATE TABLE AUS_R_PERS_REG;


DELETE AUS_D_ABTEILUNG;
TRUNCATE TABLE AUS_D_USECASE;
DELETE AUS_D_ADRESSE;
DELETE AUS_D_BEHOERDE;
DELETE AUS_D_BETRIEBSART;
DELETE AUS_D_BEZIEHUNG;
DELETE AUS_D_FUNKTION;
TRUNCATE TABLE AUS_D_GESPERRT;
DELETE AUS_D_KATASTER;
DELETE AUS_D_KOMMUNIKATION;
DELETE AUS_D_PERSON;
DELETE AUS_D_POSTADRESSE;
TRUNCATE TABLE AUS_D_PROTOKOLL;
DELETE AUS_D_REGISTRIERUNG;
TRUNCATE TABLE  AUS_D_TAETIGKEIT;
TRUNCATE TABLE  AUS_D_TIERANGABEN;
DELETE AUS_D_VERWALTUNG;

DELETE AUS_D_BETRIEBSSTAETTE;  
  
**/  

/*
declare v INT;
begin
  --DELETE_ZBR;
  v := ZBR_aus.Ausgangskorb(99, '06D44BB3426E4246ADDAB3C01E7F423F', NULL);
  --rollback;
  commit;
  DBMS_OUTPUT.PUT_LINE (v);
end;
-- Mit Fehler- und Warnungsrckgabe
declare v INT;
        BtsCnt INT;
        PlausiResult INT;
        PlausiWarnings  VARCHAR2(4000);
        PlausiErrors  VARCHAR2(4000);
begin
  --DELETE_ZBR;
  zbr_aus_data.bCommit := false;
  --ZBR_aus.Ausgangskorb(99, '1C1E8CED4ACB4077A748B1E2E40BCAA5', NULL, 0, 0, BtsCnt, PlausiResult, PlausiWarnings, PlausiErrors);

  ZBR_aus.Ausgangskorb(
    pUserSid => 99, 
    pD0101_ID => NULL, 
    pLastModified => DATE '2099-01-01', 
    pForce => 0, 
    pPrtStatus => 0, 
    pBtsCnt => vBtsCnt, 
    pPlausiResult => vPlausiResult, 
    pPlausiWarnings => vPlausiWarnings, 
    pPlausiErrors => vPlausiErrors);
    
  --rollback;
  DBMS_OUTPUT.PUT_LINE ('BTSCnt: ' || BtsCnt);
  DBMS_OUTPUT.PUT_LINE ('PlausiResult: ' || PlausiResult);
  DBMS_OUTPUT.PUT_LINE ('PlausiWarnings: ' || PlausiWarnings);
  DBMS_OUTPUT.PUT_LINE ('PlausiErrors: ' || PlausiErrors);
END;

Defaultdatensatz anlegen
INSERT INTO EIN_D_BETRIEBSSTAETTE (ID, ZUSATZBEZ, GUELTIG_VON, GUELTIG_BIS, REF_ID)
VALUES ('-1', 'Erstbefllung', NULL, NULL, NULL);

Beispiel zum Testen writemeldung
begin
  ZBR_AUS.VPLAUSIRESULT := 2; -- Fehler
  ZBR_AUS.VPLAUSIERRORS := 'Das ist der Fehler.';
  zbr_aus.vplausiwarnings := 'Das ist die Warnung.';
  zbr_aus.writemeldung('1C1E8CED4ACB4077A748B1E2E40BCAA5');
end;

-- Usecase-Ermittlung
declare 
  vUsc zbr_aus_data.tbUsc;
  pUpdLastModified boolean;
begin
  ZBR_AUS_DATA.VLASTMODIFIED := sysdate;
  ZBR_AUS_DATA.vLastUpdDate := sysdate;
  zbr_aus.vGKZ2 := '16';
  blv_sys.set_Gkz2('16');
  for c1 in (
    select id
    from vis_d0101
    where code = '658KA'
  ) loop
    
    if ZBR_AUS.FILLAUSGANGSKORB(c1.id, 99) is not null then
      DBMS_OUTPUT.PUT_LINE('ZBR_AUS.CreateUsecase: ' || ZBR_AUS.CreateUsecase(c1.id, 99, 99, to_date('01.01.0001', 'dd.mm.yyyy'), pUpdLastModified  ) );            
    else
      DBMS_OUTPUT.PUT_LINE ( 'ZBR_AUS.FILLAUSGANGSKORB = False' );
    end if;
  end loop;  
end;

select d0101.code, d0101.id d0101_id, prt.id, prt.ins_date, uc.*
from vis_d0101 d0101
join aus_d_protokoll prt on prt.d0101_id = d0101.id
and prt.d_bts_id = ZBR_AUS.LastBTS_ID
left join aus_d_usecase uc on uc.d_bts_id = prt.d_bts_id
order by prt.ins_date desc
;

*/

/*<TOAD_FILE_CHUNK>*/
--------------------------------------------------------------------------------
CREATE OR REPLACE PACKAGE BODY ZBR_AUS AS

/* SVN Informationen
$Revision: 841 $
*/


PROCEDURE Clear_BTS( pBTS IN OUT NOCOPY ZBR_AUS_DATA.tBTS);

FUNCTION AusgStatus RETURN ZBR_AUS_DATA.tbAusgStatus PIPELINED AS
  v1 ZBR_AUS_DATA.tAusgStatus;
BEGIN
  v1.bts_id := ZBR_AUS_DATA.vBTS_ID;
  v1.PlausiResult := ZBR_AUS_DATA.vPlausiResult; 
  v1.PlausiErrors := ZBR_AUS_DATA.vPlausiErrors;
  v1.PlausiWarnings := ZBR_AUS_DATA.vPlausiWarnings;
  v1.anz_usecases := ZBR_AUS_DATA.vAnz_Usecases;
  PIPE ROW(v1);
  RETURN;
END AusgStatus;

-- Warnungen fortschreiben
PROCEDURE AddWarning(p1 IN VARCHAR2) AS
BEGIN
  zbr_aus_data.vPlausiWarnings := 
    CASE WHEN zbr_aus_data.vPlausiWarnings IS NULL THEN NULL 
    ELSE zbr_aus_data.vPlausiWarnings ||  ZBR_AUS_DATA.CRLF 
    END || p1;

END AddWarning;
 
-- Fehler fortschreiben
-- pWarning = True: Fehler wird als Warnung geschrieben 
-- p1 = NULL: alle Fehler werden gelscht und alle folgende Fehler nicht protokolliert
--            das Fehler aufgetreten sind wird protokolliert aber ohne Fehlertext 
PROCEDURE AddError( p1 IN VARCHAR2) AS
BEGIN

  CASE
  WHEN p1 IS NULL THEN
    zbr_aus_data.vPlausiErrors := NULL;
  WHEN zbr_aus_data.vPlausiResult = 2 AND zbr_aus_data.vPlausiErrors IS NULL THEN 
    NULL;     
  --WHEN p1 IS NOT NULL THEN
  ELSE 
    zbr_aus_data.vPlausiErrors := 
      CASE WHEN zbr_aus_data.vPlausiErrors IS NULL THEN NULL 
      ELSE zbr_aus_data.vPlausiErrors || zbr_aus_data.CRLF 
      END || p1 ;
  
  END CASE;
  zbr_aus_data.vPlausiResult := 2;
    
END AddError;

FUNCTION IsEqual (pV1 IN VARCHAR2, pV2 IN VARCHAR2 ) RETURN PLS_INTEGER DETERMINISTIC AS
vRes PLS_INTEGER := 0;
BEGIN
  IF pV1 = pV2 OR (pV1 IS NULL AND pV2 IS NULL) THEN 
    vRes := 1;
  END IF;
  RETURN vRes;
END IsEqual;

FUNCTION IsEqual (pV1 IN DATE, pV2 IN DATE ) RETURN PLS_INTEGER DETERMINISTIC AS
vRes PLS_INTEGER := 0;
BEGIN
  IF pV1 = pV2 OR (pV1 IS NULL AND pV2 IS NULL) THEN
    vRes := 1;
  END IF;
  RETURN vRes;
END IsEqual;

FUNCTION IsEqual (pV1 IN NUMBER, pV2 IN NUMBER ) RETURN PLS_INTEGER DETERMINISTIC AS
vRes PLS_INTEGER := 0;
BEGIN
  IF pV1 = pV2 OR (pV1 IS NULL AND pV2 IS NULL) THEN
    vRes := 1;
  END IF;
  RETURN vRes;
END IsEqual;
FUNCTION IsEqual (pV1 IN BOOLEAN, pV2 IN BOOLEAN ) RETURN PLS_INTEGER DETERMINISTIC AS
vRes PLS_INTEGER := 0;
BEGIN
  IF pV1 = pV2 OR (pV1 IS NULL AND pV2 IS NULL) THEN
    vRes := 1;
  END IF;
  RETURN vRes;
END IsEqual;


FUNCTION LastBTS_ID RETURN VARCHAR2 AS
BEGIN
  RETURN ZBR_AUS_DATA.vBTS_ID;
END LastBTS_ID;
   
FUNCTION LastModified RETURN DATE AS
BEGIN
  RETURN ZBR_AUS_DATA.vLastModified;
END LastModified;  
  
FUNCTION Get_ID (pID VARCHAR2) RETURN VARCHAR2 AS
  vRes VARCHAR2(32);
BEGIN
  IF pID IS NULL THEN
    vRes := SYS_GUID();
  ELSE
    vRes := pID;
  END IF; 
  RETURN vRes;
END Get_ID;


-- BTS_ID des letzten Standes im Ausgangskorb ermitteln
FUNCTION GetLastBTS_IDbyD0101_ID( pD0101_ID IN zbr_aus_data.tID) RETURN zbr_aus_data.tID AS

 -- Letzten Stand im Ausgangskorb1
  CURSOR c1 (pID1 IN vis_d0101.id%TYPE ) IS 
  SELECT dx.* FROM (
    SELECT prt.d_bts_id
    FROM aus_d_protokoll prt
    WHERE prt.d0101_id = pID1
    AND prt.status IN (0, 2, 3, 5, 6, 10)
    AND prt.deleted = 0
    ORDER BY prt.ins_date DESC NULLS LAST
  ) dx WHERE ROWNUM = 1;
  
  v1 zbr_aus_data.tID;
BEGIN

  OPEN c1 (pD0101_ID);
  FETCH c1 INTO v1;
  CLOSE c1;
  
  RETURN v1;
END GetLastBTS_IDbyD0101_ID;

PROCEDURE GetS07Verfahren DETERMINISTIC AS
vS07_code CONSTANT vis_s07.code%TYPE := 'BTR';
vS0701_Code CONSTANT vis_s07.code%TYPE := 'VERFAHREN';
vWert vis_s0702.wert%TYPE; 
BEGIN  

  SELECT MAX(s07.wert) 
  INTO vVerfahren
  FROM vis_vs07 s07
  WHERE s07.s07_code = vS07_Code
  AND s07.s0701_code = vS0701_Code;

  IF vVerfahren IS NULL THEN
    IF blv_sys.get_gkz2 = ZBR_AUS_DATA.NRW THEN
      vVerfahren := QUELLE_IDV_NRW;
    ELSE
      vVerfahren := QUELLE_ZBR;
    END IF;
  END IF;

END GetS07Verfahren;

FUNCTION GetVerfahren RETURN VARCHAR2 AS
BEGIN
  GetS07Verfahren;
  RETURN vVerfahren;
END;

PROCEDURE Init /*( pGKZ2 IN VARCHAR2)*/ AS
BEGIN
  --vGKZ2 := pGKZ2;
  GetS07Verfahren;
  IF vVerfahren = QUELLE_IDV_NRW /*vGKZ2 = ZBR_AUS_DATA.NRW*/ THEN
    ZBR_AUS_DATA.vINH      := ZBR_AUS_DATA.INH;
    ZBR_AUS_DATA.vIDV      := ZBR_AUS_DATA.IDV;
    ZBR_AUS_DATA.vIDV_INH  := ZBR_AUS_DATA.IDV_INH;
    ZBR_AUS_DATA.vHV       := ZBR_AUS_DATA.HV;
    ZBR_AUS_DATA.vBTRO     := ZBR_AUS_DATA.BTRO;
    ZBR_AUS_DATA.vBTRA     := ZBR_AUS_DATA.BTRA;
  ELSE
    ZBR_AUS_DATA.vINH      := ZBR_AUS_DATA.Betreiber;
    ZBR_AUS_DATA.vIDV      := ZBR_AUS_DATA.BI;
    ZBR_AUS_DATA.vIDV_INH  := ZBR_AUS_DATA.IDV_INH;
    ZBR_AUS_DATA.vHV       := NULL;
    ZBR_AUS_DATA.vBTRO     := ZBR_AUS_DATA.StandortAdr;
    ZBR_AUS_DATA.vBTRA     := ZBR_AUS_DATA.PostAdr;  
  END IF;
END;

PROCEDURE Cursor_ZBR_AUS_TH(
  pD0101_ID IN ZBR_AUS_DATA.tID, 
  pLastModified IN DATE, 
  pForce IN NUMBER, 
  pD010101_OK IN NUMBER,
  pCur OUT SYS_REFCURSOR) AS

v31_12_1920 CONSTANT DATE := zbr_aus_data.v31_12_1920;

BEGIN

  -- TH
  OPEN pCur FOR
  SELECT --COUNT(*) OVER (PARTITION BY NULL) cnt,
  dx.*
  FROM (
    SELECT d0101.id, d3.id d0101_id3, 
  --  MAX(
  --  GREATEST(
      MAX( d0101.upd_date) d0101_upd_date, 
      MAX( d3.upd_date) d3_upd_date, 
      NVL( MAX(d010101.upd_date), v31_12_1920 ) d010101_upd_date, 
      NVL( MAX(d010101.del_date), v31_12_1920 ) d010101_del_date, 
    -- Hauptansprechpartner 
      MAX(NVL(
      ( SELECT GREATEST( 
           NVL( d0102.upd_date, v31_12_1920),
           NVL( d010200.upd_date, v31_12_1920))
        FROM VIS_D010200 d010200 
        JOIN vis_d0102 d0102 ON d0102.id = d010200.d0102_id  
        AND d010200.deleted = 0
        AND d0102.deleted = 0
        --AND ( d010200.upd_date > pLastModified OR d0102.upd_date > pLastModified)  
        WHERE  d010200.id = d0101.d010200_id2  
      ), v31_12_1920)) d010200_upd_date --, 
      -- d010200 ende

     , NVL(
      ( SELECT MAX(
          CASE WHEN d010102.upd_date < d010102.del_date THEN d010102.del_date ELSE d010102.upd_date END            
          )
        FROM --VIS_VD010102$01 
            VIS_D010102 d010102  -- todo 64959090         
        WHERE d010102.d0101_id = d0101.id
        AND d010102.DELETED IN (0,-2)
        AND d010102.a010145_sid IN ( A010145_HIT_NR, 1576001, 1574001, 541001, 1459001, A010145_BETREIBER_ID, 1330001, 1331001, 1135001, 1136001 )
      ), v31_12_1920) d010102_upd_date 

      --sid       code    skz del bez
      --514001    0102    10  0   Registriernummer (HIT)
      --1576001   010201  10  -1  Unternehmen-Ident Nr.
      --1574001   010202  10  -1  Person-Ident Nr.
      --541001    0104    10  0   TSK-Nr.
      --1459001   010417  30  0   Ermchtigung zur Ausstellung von Heimtierausweisen und Entnahme von Blutpr. zur Titrierung Tollwutantik. gem. VO (EU) 576/2013
      --1606001   0103    10  0  Betreiber_ID (Betriebsregister)
      --1330001   01042103  60  0   Zulassung Transportunternehmen nach Art. 10 Abs. 1 VO (EG) Nr. 1/2005
      --1331001   01042104  60  0   Zulassung Transportunternehmen (lange Befrderungen) nach Art. 11 Abs. 1 VO (EG) Nr. 1/2005      
      --1135001   01042101  60  0   Zulassung Transportunternehmer nach  13 ViehVerkV u. Art. 10 Abs. 1 VO (EG) 1/2005
      --1136001   01042102  60  0   Zulassung Transportunternehmer (lange Befrderungen) nach  13 ViehVerkV u. Art. 11 Abs. 1 VO (EG) 1/2005           
    , v31_12_1920 d010110_upd_date       

    FROM VIS_D0101 d0101
    JOIN vis_d0101 d3 ON d3.id = d0101.d0101_id3  -- Betreiber
      AND d0101.id LIKE pD0101_ID
      AND d0101.deleted = 0
      AND d0101.skz = 1
      AND d0101.ID NOT IN ( SELECT d1.d0101_id FROM aus_d_gesperrt d1 
                            WHERE d1.gesperrt_jn = 1
                            AND d1.gesperrt_bis > SYSDATE 
                          )                

    -- bei Erstbefllung muss keine BA vorhanden sein
    /* 24.07.2012 LEFT*/ /*06.05.2013*/ 
    -- 01.04.2014 LEFT 
    JOIN VIS_D010101 d010101 
    --JOIN vis_a010108 a010108 ON a010108.sid = d010101.a010108_sid
    ON d010101.d0101_id = d0101.id
      AND d010101.deleted IN( 0, -2)
      -- 25.08.2017 auch nderungen der Historie bercksichtigen
      --AND d010101.aktiv = 1
      -- 16.07.2013 AND d010101.upd_date > :vLastModified
      --AND a010108.skz in (1,2,3,4,5)
      --AND (a010108.auswahl = 1 OR pD010101_ok = 0)
      AND d010101.a010108_sid IN  
        (
          SELECT ax.a010108_sid FROM vis_va0089_zbr_betriebstyp ax
          WHERE ax.auswahl = 1 OR pD010101_ok = 0
          --WHERE ax.a010108_sid = a010108.sid
          --AND ax.tv_pos IN (d010101.gewerbsmaessig, 2)               
        )
        
      -- Hauptansprechpartner
  --    LEFT JOIN VIS_D010200 d010200 
  --    JOIN vis_d0102 d0102 ON d0102.id = d010200.d0102_id      
  --    ON d010200.id = d0101.d010200_id2 --11.06.2014 d010200.d0101_id = d0101.id 
  --      AND d010200.deleted = 0
  --      --11.06.2014 AND d010200.hauptansprechpartner = 1  
  --      AND d0102.deleted = 0
  --      AND ( d010200.upd_date > :vLastModified OR d0102.upd_date > :vLastModified)
                                  
--    -- Registrierungen
--    LEFT JOIN VIS_VD010102$01 d010102 ON d010102.d0101_id = d0101.id
--      AND d010102.upd_date > :vLastModified
--      --AND d010102.a010145_code IN ( '0102', '010201', '010202', '0104')
--      --AND d010102.a010145_skz = 10
            
  --  -- Abteilung
  --  LEFT JOIN VIS_D0103 d0103 ON d0103.d0101_id = d0101.id
  --    AND d0103.upd_date > :vLastModified
  --    AND d0103.deleted = 0           
          
    WHERE (d010101.id IS NOT NULL OR pD010101_ok = 0) -- im Batch muss Betriebsart vorh. sein
    GROUP BY d0101.id, d3.id, d3.d0101_id3 
    --ORDER BY case when d3.id = d3.d0101_id3 THEN 0 ELSE 1 END 
    ) dx
  WHERE 
--    GREATEST(
--      dx.d0101_upd_date, 
--      dx.d3_upd_date, 
--      dx.d010101_upd_date, 
--      dx.d010101_del_date, 
--      dx.d010200_upd_date, 
--      dx.d010102_upd_date) >= pLastModified 

  /*  (
      dx.d0101_upd_date >= pLastModified OR
      dx.d3_upd_date >= pLastModified OR
      dx.d010101_upd_date >= pLastModified OR
      dx.d010101_del_date >= pLastModified OR
      dx.d010200_upd_date >= pLastModified OR
      dx.d010102_upd_date >= pLastModified ) 
      
  AND */ ( NVL( ( SELECT MAX( prot.lastmodified)
                 FROM aus_d_protokoll prot
                 WHERE prot.deleted = 0
                   AND prot.d0101_id = dx.id
               ) , v31_12_1920) <                              
                  GREATEST(
                      dx.d0101_upd_date, 
                      dx.d3_upd_date, 
                      dx.d010101_upd_date, 
                      dx.d010101_del_date, 
                      dx.d010200_upd_date, 
                      dx.d010102_upd_date)                          
               OR pForce = 1 )
  ORDER BY case when dx.id = dx.d0101_id3 THEN 0 ELSE 1 END,
  GREATEST( dx.d0101_upd_date, 
            dx.d3_upd_date, 
            dx.d010101_upd_date, 
            dx.d010101_del_date, 
            dx.d010200_upd_date, 
            dx.d010102_upd_date); 

END Cursor_ZBR_AUS_TH;
 
PROCEDURE Cursor_ZBR_AUS_NRW(
  pD0101_ID IN ZBR_AUS_DATA.tID, 
  pLastModified IN DATE, 
  pForce IN NUMBER, 
  pD010101_OK IN NUMBER,
  pCur OUT SYS_REFCURSOR) AS
  
v31_12_1920 CONSTANT DATE := zbr_aus_data.v31_12_1920;
BEGIN
  -- NRW
  OPEN pCur FOR
  SELECT --COUNT(*) OVER (PARTITION BY NULL) cnt,
  dx.*
  FROM (
    SELECT d0101.id, d3.id d0101_id3, 
      MAX( d0101.upd_date) d0101_upd_date, 
      MAX( d3.upd_date) d3_upd_date, 
      NVL( MAX(d010101.upd_date), v31_12_1920 ) d010101_upd_date, 
      NVL( MAX(d010101.del_date), v31_12_1920 ) d010101_del_date, 
    -- Hauptansprechpartner 
      MAX(NVL(
      ( SELECT GREATEST( 
           NVL( d0102.upd_date, v31_12_1920),
           NVL( d010200.upd_date, v31_12_1920))
        FROM VIS_D010200 d010200 
        JOIN vis_d0102 d0102 ON d0102.id = d010200.d0102_id  
        AND d010200.deleted = 0
        AND d0102.deleted = 0
        AND ( d010200.upd_date > pLastModified OR d0102.upd_date > pLastModified)    
        WHERE d010200.id = d0101.d010200_id2
      ), v31_12_1920)) d010200_upd_date --, 
      -- d010200 ende

     , NVL(
      ( SELECT MAX(CASE WHEN d1.del_date > d1.upd_date THEN d1.del_date ELSE d1.upd_date END )
        -- todo 62008090
        FROM VIS_D010102 d1
        JOIN VIS_A010145 a1 ON a1.sid = d1.a010145_sid
        JOIN VIS_A0302 a2 ON a2.sid = d1.a0302_05_sid
        AND a1.sid = d1.a010145_sid 
        AND d1.a0302_05_sid = a2.sid 
        AND (a2.abgeschlossen = 1 OR a2.SID = -1) 
        --AND d1.DELETED > -2 
        --VIS_VD010102$01 d010102 
        WHERE d1.d0101_id = d0101.id
        AND (d1.upd_date > pLastModified OR d1.del_date > pLastModified)                   
        AND ( 
        ( (a1.code IN ( '0104', '0118', '01901301', '01901302') 
           AND a1.skz = 10 ) OR
          (a1.code LIKE '011103%' AND a1.skz = 60) --OR  -- FM Zul.         
          --17.08.215 (d010102.a010145_code LIKE '021104%' AND d010102.a010145_skz = 70) -- FM Reg.           
        )               
       ) 
      ), v31_12_1920) d010102_upd_date     
   
     , NVL(
      ( SELECT MAX(d010110.upd_date)               
        FROM vis_d010110 d010110 
        WHERE d010110.d0101_id = d0101.id
        AND d010110.a01080201_sid IN (15610001, 17975001)
        AND d010110.upd_date > pLastModified      
        AND d010110.deleted = 0    
      ), v31_12_1920) d010110_upd_date 
      --15610001    FM-Ttigkeit(en)  FM_KOD
      --17975001    FM-Ttigkeit(en) gltig ab  FM_KOD_AB
      --17976001    Angaben zu den FM-Ttigkeiten gem. Kodierkatalog  FM_KOD_ANG
      --17977001    FM-Ttigkeit(en) an HIT  FM_KOD_AN_HIT
      --19596001    FM-Ttigkeit(en) detailliert  FM_KOD_D
      
    FROM VIS_D0101 d0101
    JOIN vis_d0101 d3 ON d3.id = d0101.d0101_id3  -- Betreiber
      AND d0101.id LIKE pD0101_ID
      AND d0101.deleted = 0
      AND d0101.skz = 1
      AND d0101.ID NOT IN ( SELECT d1.d0101_id FROM aus_d_gesperrt d1 
                            WHERE d1.gesperrt_jn = 1
                            AND d1.gesperrt_bis > SYSDATE 
                          )         
    -- bei Erstbefllung muss keine BA vorhanden sein
    /* 24.07.2012 LEFT*/ /*06.05.2013*/ 
    LEFT JOIN VIS_D010101 d010101 
    JOIN vis_a010108 a010108 ON a010108.sid = d010101.a010108_sid
    ON d010101.d0101_id = d0101.id
      AND d010101.deleted IN( 0, -2)
      AND d010101.aktiv = 1
      -- 16.07.2013 AND d010101.upd_date > :vLastModified
      AND a010108.skz IN (1,2,3,5)
      AND (a010108.auswahl = 1 OR pD010101_ok = 0)
      AND ( 
               
               ( a010108.fb LIKE '%H%' OR
                 a010108.fb LIKE '%U%' OR 
                 a010108.fb LIKE '%D%' OR 
                 a010108.fb LIKE '%P%' OR 
                 a010108.fb LIKE '%T%' OR 
                 a010108.fb LIKE '%A%' OR 
                 a010108.fb LIKE '%F%' OR 
                 a010108.fb LIKE '%W%' OR 
                 a010108.fb LIKE '%R%' OR 
                 a010108.fb LIKE '%N%' OR 
                 a010108.fb LIKE '%L%' )
          )                           
      AND 
        (  
          a010108.skz = 2 OR -- alle LM-Betriebsarten, auer in Thringen
          -- 29.08.2013
          EXISTS 
            (
              SELECT 1 FROM vis_va0089_hit_betriebstyp_05 ax
              WHERE ax.sid = a010108.sid
              AND ax.tv_pos IN (d010101.gewerbsmaessig, 2)  
            )
        )
            
    -- Hauptansprechpartner
  --  LEFT JOIN VIS_D010200 d010200 ON d010200.id = d0101.d010200_id2 --11.06.2014 d010200.d0101_id = d0101.id 
  --    AND d010200.deleted = 0
  --    --11.06.2014 AND d010200.hauptansprechpartner = 1  
  --  LEFT JOIN vis_d0102 d0102 ON d0102.id = d010200.d0102_id
  --    AND d0102.deleted = 0
  --    AND ( d010200.upd_date > :vLastModified OR d0102.upd_date > :vLastModified)
  --      
    -- Registrierungen
  --  LEFT JOIN VIS_VD010102$01 d010102 ON d010102.d0101_id = d0101.id
  --    AND d010102.upd_date > :vLastModified
  --    --todo 55327090: 30.10.2014
  --    --AND ((d010102.a010145_code IN ( '0104', '0118', '01901301') AND vGKZ2 = :NRW) OR
  --    --     (d010102.a010145_code IN ('0102', '010201', '010202', '0104') AND vGKZ2 <> :NRW))
  --    --AND d010102.a010145_skz = 10                         
  --    AND ( 
  --      ( (d010102.a010145_code IN ( '0104', '0118', '01901301', '01901302') 
  --         AND d010102.a010145_skz = 10 ) OR
  --        (d010102.a010145_code LIKE '011103%' AND d010102.a010145_skz = 60) OR  -- FM Zul.         
  --        (d010102.a010145_code LIKE '021104%' AND d010102.a010145_skz = 70) -- FM Reg.           
  --      )               
  --     ) 
            
    -- Abteilung
    --LEFT JOIN VIS_D0103 d0103 ON d0103.d0101_id = d0101.id
    --  AND d0103.upd_date > :vLastModified
    --  AND d0103.deleted = 0 
          
    -- BA-Merkmale FM-KOD und FM_KOD_AB
  --  LEFT JOIN vis_d010110 d010110 ON d010110.d0101_id = d0101.id
  --  AND d010110.a01080201_sid IN (15610001, 17975001)
  --  AND d010110.upd_date > :vLastModified      
  --  AND d010110.deleted = 0

      --15610001    FM-Ttigkeit(en)  FM_KOD
      --17975001    FM-Ttigkeit(en) gltig ab  FM_KOD_AB
      --17976001    Angaben zu den FM-Ttigkeiten gem. Kodierkatalog  FM_KOD_ANG
      --17977001    FM-Ttigkeit(en) an HIT  FM_KOD_AN_HIT
      --19596001    FM-Ttigkeit(en) detailliert  FM_KOD_D
          
    WHERE (d010101.id IS NOT NULL OR pD010101_ok = 0) -- im Batch muss Betriebsart vorh. sein
    GROUP BY d0101.id, d3.id, d3.d0101_id3 
    ) dx
  WHERE 
--  GREATEST(
--      dx.d0101_upd_date, 
--      dx.d3_upd_date, 
--      dx.d010101_upd_date, 
--      dx.d010101_del_date, 
--      dx.d010200_upd_date, 
--      dx.d010102_upd_date,
--      dx.d010110_upd_date) >= pLastModified 
  (
      dx.d0101_upd_date >= pLastModified OR
      dx.d3_upd_date >= pLastModified OR
      dx.d010101_upd_date >= pLastModified OR
      dx.d010101_del_date >= pLastModified OR
      dx.d010200_upd_date >= pLastModified OR
      dx.d010102_upd_date >= pLastModified OR
      dx.d010110_upd_date >= pLastModified ) 
      
  AND ( NVL( ( SELECT MAX( prot.lastmodified)
                 FROM aus_d_protokoll prot
                 WHERE prot.deleted = 0
                   AND prot.d0101_id = dx.id
               ) , v31_12_1920) <                              
                  GREATEST(
                      dx.d0101_upd_date, 
                      dx.d3_upd_date, 
                      dx.d010101_upd_date, 
                      dx.d010101_del_date, 
                      dx.d010200_upd_date, 
                      dx.d010102_upd_date,
                      dx.d010110_upd_date)                          
               OR pForce = 1 )
  ORDER BY CASE WHEN dx.id = dx.d0101_id3 THEN 0 ELSE 1 END;
  
END Cursor_ZBR_AUS_NRW;
 
PROCEDURE ParamsAusgangskorb(
  pD0101_ID IN VARCHAR2,
  pLastModified IN DATE,
  vD0101_ID OUT NOCOPY VARCHAR2,
  vLastModified OUT DATE,
  vD010101_ok OUT PLS_INTEGER) AS 
BEGIN

  vD0101_ID := NVL(pD0101_ID, '%'); 
  vLastModified := NVL(pLastModified, ZBR_AUS_DATA.vDateMin);

  -- berprfung Direktmodus oder Batch-Verarbeitung
  IF LENGTH(pD0101_ID) = 32 AND INSTR(pD0101_ID, '%') = 0 THEN 
    vD010101_ok := 0;
  ELSE
    vD010101_ok := 1;
  END IF; 

END ParamsAusgangskorb;

/**
Ausgabe der betroffenen Betriebe als Tabelle
alle Betriebe mit nderungen nach dem 01.01.2014

SELECT dx.*
FROM TABLE ( zbr_aus.ZBR_AUS_D0101(null, '01.01.2014', 0) ) dx
;

gezielt nur ein Betriebe

SELECT d0101.code, d0101.bez, dx.*
FROM vis_d0101 d0101 
CROSS JOIN TABLE ( zbr_aus.ZBR_AUS_D0101(d0101.id, null, 0) ) dx
WHERE d0101.code = '08215017007218'
**/
FUNCTION ZBR_AUS_D0101(
  pD0101_ID IN ZBR_AUS_DATA.tID, 
  pLastModified IN DATE, 
  pForce IN PLS_INTEGER) RETURN ZBR_AUS_DATA.tbZBR_AUS PIPELINED AS

vD0101_ID ZBR_AUS_DATA.tID; 
vLastModified DATE; 
vForce PLS_INTEGER; 
vD010101_OK PLS_INTEGER;
TYPE tCurZBR_AUS IS REF CURSOR RETURN ZBR_AUS_DATA.tZBR_AUS;
CurZBR_AUS tCurZBR_AUS;
vZBR_AUS ZBR_AUS_DATA.tbZBR_AUS;  
BEGIN

  ParamsAusgangskorb(
    pD0101_ID,
    pLastModified,
    vD0101_ID,
    vLastModified,
    vD010101_ok);

  IF vVerfahren = QUELLE_IDV_NRW /*vGKZ2 = ZBR_AUS_DATA.NRW*/ THEN
    Cursor_ZBR_AUS_NRW(vD0101_ID, vLASTMODIFIED, pFORCE, vD010101_OK, CurZBR_AUS);
  ELSE
    Cursor_ZBR_AUS_TH(vD0101_ID, vLASTMODIFIED, pFORCE, vD010101_OK, CurZBR_AUS);
  END IF;
  LOOP
    FETCH CurZBR_AUS BULK COLLECT INTO vZBR_AUS LIMIT 500;
    EXIT WHEN vZBR_AUS.COUNT = 0;     
  
    FOR iZBR_AUS IN vZBR_AUS.FIRST .. vZBR_AUS.LAST LOOP
      PIPE ROW ( vZBR_AUS(iZBR_AUS) );
    END LOOP;  
  END LOOP;
  CLOSE CurZBR_AUS;
  RETURN;
  
END ZBR_AUS_D0101;

FUNCTION GetRegIdx( pReg IN ZBR_AUS_DATA.tbReg, pArt IN aus_d_registrierung.art%TYPE) RETURN PLS_INTEGER AS
vRes PLS_INTEGER := -1;
BEGIN
  IF pReg.count > 0 THEN
    FOR iReg IN pReg.FIRST .. pReg.LAST LOOP
      IF pReg(iReg).ART = pArt THEN
        vRes := iReg;
        EXIT;
      END IF;
    END LOOP;
  END IF;
  RETURN vRes;        
END GetRegIdx;

PROCEDURE GroupBa(pBTS_ID IN ZBR_AUS_DATA.tID) AS
  CURSOR cBa (pID IN ZBR_AUS_DATA.tID) IS
  
    WITH d1 AS (
      SELECT
        d1.code, d1.bez, d1.art, d1.fachbereich
      , d1.gueltig_von, NVL(d1.gueltig_bis, zbr_aus_data.vDATEMAX) gueltig_bis, d1.gewerbsmaessig
             
      FROM aus_d_betriebsart d1
      WHERE NOT EXISTS( 
        SELECT 1
        FROM aus_d_betriebsart d0
        WHERE d0.code = d1.code
        AND d0.gewerbsmaessig = d1.gewerbsmaessig
        AND d0.gueltig_von < d1.gueltig_von
        AND NVL(d0.gueltig_bis, zbr_aus_data.vDATEMAX) > NVL(d1.gueltig_bis, zbr_aus_data.vDATEMAX) 
        AND d0.d_bts_id = pID)
      AND d1.d_bts_id = pID
      AND NOT EXISTS( SELECT 1 FROM aus_d_betriebsart ba WHERE ba.d_bts_id = pID AND ba.scope = BA_GROUP )        
    )
  
    SELECT DISTINCT
    d11.* FROM (
      SELECT d1.code, d1.art, d1.fachbereich, d1.bez
      , d1.gueltig_von, d1.gueltig_bis, d1.gewerbsmaessig
      -- Vorgnger
      ,  CASE WHEN d1.gueltig_von >= LAG(d1.gueltig_von, 1) OVER ( PARTITION BY d1.code, d1.gewerbsmaessig ORDER BY d1.gueltig_von, d1.gueltig_bis)
              AND d1.gueltig_von <= LAG(d1.gueltig_bis, 1) OVER ( PARTITION BY d1.code, d1.gewerbsmaessig ORDER BY d1.gueltig_von, d1.gueltig_bis)
         THEN 0 ELSE 1 END is_min 
      -- Nachfolger
      ,  CASE WHEN d1.gueltig_bis <= LEAD(d1.gueltig_bis, 1) OVER ( PARTITION BY d1.code, d1.gewerbsmaessig ORDER BY d1.gueltig_von, d1.gueltig_bis)
              AND d1.gueltig_bis >= LEAD(d1.gueltig_von, 1) OVER ( PARTITION BY d1.code, d1.gewerbsmaessig ORDER BY d1.gueltig_von, d1.gueltig_bis)
         THEN 0 ELSE 1 END is_max 
             
      FROM d1
    ) d11
    WHERE d11.is_min = 1
    OR d11.is_max = 1
    ORDER BY d11.code, d11.gewerbsmaessig, d11.gueltig_von ;
    
  TYPE tbCBa IS TABLE OF cBa%ROWTYPE;  
  vCBa tbCBa;
  TYPE tbBa IS TABLE OF aus_d_betriebsart%ROWTYPE;
  vBA tbBA;
  viBA PLS_INTEGER := 0; 
  viCBA PLS_INTEGER := 0;
  vIns PLS_INTEGER := 0; 
BEGIN

  OPEN cBA(pBTS_ID);
  FETCH cBA BULK COLLECT INTO vCBA;
  CLOSE cBA;
  
  IF vCBa.COUNT > 0 THEN -- Gruppierung noch nicht durchgefhrt, alte Daten vor der Anpassung oder neue Daten

    vBA := tbBA();
    viCBa := 1;
    
    WHILE viCBA <= vCBa.COUNT LOOP

      IF vIns = 2 OR viCBA = 1 THEN 
        vBA.extend;
        viBA := viBA + 1; 
      END IF;
        
      vBA(viBA).bez := vCBa(viCBa).bez;
      vBA(viBA).code := vCBa(viCBa).code;
      vBA(viBA).art := vCBa(viCBa).art;
      vBA(viBA).fachbereich := vCBa(viCBa).fachbereich;
      vBA(viBA).gewerbsmaessig := vCBa(viCBa).gewerbsmaessig;
      vIns := 0;
    
      WHILE vIns < 2 AND viCBA <= vCBa.COUNT LOOP 
        IF vCBa(viCBa).is_min = 0 AND vCBa(viCBa).is_max = 0 THEN -- Sicherheitsabbruch
          EXIT;
        END IF;
       
        IF vCBa(viCBa).is_min = 1 THEN
          vBA(viBA).gueltig_von := vCBa(viCBa).gueltig_von;
          vIns := vIns + 1;
        END IF;
        IF vCBa(viCBa).is_max = 1 THEN
          vBA(viBA).gueltig_bis := vCBa(viCBa).gueltig_bis;
          vIns := vIns + 1;
        END IF;

        viCBa := viCBa + 1; 
        
      END LOOP;  
      
    END LOOP; 
  
   FORALL i IN vBA.FIRST .. vBA.LAST 
    INSERT INTO aus_d_betriebsart (
      CODE, BEZ, FACHBEREICH, ART, D_BTS_ID, GUELTIG_VON, GUELTIG_BIS, GEWERBSMAESSIG, SCOPE
    ) VALUES (
    vBa(i).code, vBa(i).bez, vBa(i).fachbereich, vBa(i).art, pBTS_ID, vBa(i).gueltig_von, vBa(i).gueltig_bis, vBa(i).gewerbsmaessig, BA_GROUP );    
  
  END IF;
    -- ID = DEFAULT SYS_GUID
    -- REF_ID = NULL
     
--  END IF;

--    INSERT INTO aus_d_betriebsart (
--      CODE, BEZ, FACHBEREICH, ART, D_BTS_ID, GUELTIG_VON, GUELTIG_BIS, GEWERBSMAESSIG, SCOPE
--    ) 
--    SELECT DISTINCT
--      d1.code, d1.bez, d1.fachbereich, d1.art, pBTS_ID d_bts_id
--    , MIN(d1.gueltig_von) OVER ( PARTITION BY d1.code, d1.gueltig_bis, d1.gewerbsmaessig ) von
--    , FIRST_VALUE( NVL(d1.gueltig_bis, ZBR_AUS_DATA.vDATEMAX) ) OVER ( PARTITION BY d1.code, d1.gueltig_von, d1.gewerbsmaessig ORDER BY d1.gueltig_bis DESC NULLS FIRST) bis
--    , d1.gewerbsmaessig gew 
--    , BA_GROUP scope
--    FROM aus_d_betriebsart d1
--    WHERE d1.d_bts_id = pBTS_ID
--    AND NOT EXISTS( SELECT 1 FROM aus_d_betriebsart ba WHERE ba.d_bts_id = pBTS_ID AND ba.scope = BA_GROUP ) ; 
--   
  
END GroupBa;

FUNCTION Datetime2Str(p1 DATE) RETURN VARCHAR2 AS
BEGIN

  IF TRUNC(p1) = p1 THEN  
    RETURN TO_CHAR( p1, 'dd.mm.yyyy');
  ELSE
    RETURN TO_CHAR( p1, 'dd.mm.yyyy HH24:MI:SS');
  END IF;  

END;

/**
  Usecases ermitteln und als Tabelle zurck geben
**/
FUNCTION CreateUsecase2( pD0101_ID IN ZBR_AUS_DATA.tID
, pUserSID IN PLS_INTEGER, pMandant IN PLS_INTEGER
, pLastModified IN DATE
, pUpdLastModified OUT BOOLEAN
, pRes IN OUT NUMBER ) RETURN ZBR_AUS_DATA.tbUsc AS
  
  vUsc ZBR_AUS_DATA.tUsc;
  vtUsc ZBR_AUS_DATA.tbUsc := ZBR_AUS_DATA.tbUsc();
  vBTS1 ZBR_AUS_DATA.tBTS;
  vBTS2 ZBR_AUS_DATA.tBTS;
  vBTS_ID1 ZBR_AUS_DATA.tID;
  vBTS_ID2 ZBR_AUS_DATA.tID;
  vIdxBAAktiv_2 PLS_INTEGER; -- zur Historie gehrender AKTIV-Eintrag
   
  vAlterWert aus_d_usecase.alter_wert%TYPE := NULL;
  vNeuerWert aus_d_usecase.neuer_wert%TYPE := NULL;
  
  vD0101 vis_d0101%ROWTYPE;
  vD0101_3 vis_d0101%ROWTYPE;
  vUcErmitteln BOOLEAN := TRUE;

 -- Letzten Stand im Ausgangskorb1
  CURSOR c1 (pID1 IN vis_d0101.id%TYPE) IS 
  SELECT dx.* FROM (
    SELECT prt.d_bts_id
    FROM aus_d_protokoll prt
    WHERE prt.d0101_id = pID1
    AND prt.status IN (0, 2, 3, 5, 6, 10)
    AND prt.deleted = 0
    ORDER BY prt.ins_date DESC NULLS LAST
  ) dx WHERE ROWNUM < 3;
  
  FUNCTION CrtPersBez( pPrs IN aus_d_person%ROWTYPE) RETURN VARCHAR2 AS
  BEGIN
    RETURN TRIM( BOTH FROM pPrs.Kurzbez1 || ' ' || pPrs.kurzbez2);
  END;
  -- p0: 1 wenn sich die Werte unterscheiden
  -- p1: Prfix fr die Werte
  -- p2: Neuer Wert
  -- p3: Alter Wert
  PROCEDURE NeuerAlterWert(p0 IN OUT PLS_INTEGER, p1 IN VARCHAR2, p2 IN VARCHAR2, p3 IN VARCHAR2, p4 IN BOOLEAN := FALSE) AS
  BEGIN
    IF IsEqual(p2, p3) = 0 THEN
      p0 := 1;
      vAlterWert := vAlterWert || p1 || p3 || zbr_aus_data.CRLF;  
      vNeuerWert := vNeuerWert || p1 || p2 || zbr_aus_data.CRLF;
    ELSIF p4 THEN
      vAlterWert := vAlterWert || p1 || p3 || zbr_aus_data.CRLF;  
      vNeuerWert := vNeuerWert || p1 || p2 || zbr_aus_data.CRLF;
    END IF;    
  END NeuerAlterWert;
  PROCEDURE NeuerAlterWert(p0 IN OUT PLS_INTEGER, p1 IN VARCHAR2, p2 IN DATE, p3 IN DATE, p4 IN BOOLEAN := FALSE) AS
  BEGIN
  -- todo 66571090
--    IF IsEqual(p2, p3) = 0 THEN
--      p0 := 1;
--      vAlterWert := vAlterWert || p1 || TO_CHAR(p3, 'dd.mm.yyyy') || zbr_aus_data.CRLF;  
--      vNeuerWert := vNeuerWert || p1 || TO_CHAR(p2, 'dd.mm.yyyy') || zbr_aus_data.CRLF;
--    ELSIF p4 THEN
--      vAlterWert := vAlterWert || p1 || TO_CHAR(p3, 'dd.mm.yyyy') || zbr_aus_data.CRLF;  
--      vNeuerWert := vNeuerWert || p1 || TO_CHAR(p2, 'dd.mm.yyyy') || zbr_aus_data.CRLF;    
--    END IF;    

    IF IsEqual(p2, p3) = 0 THEN
      p0 := 1;
      vAlterWert := vAlterWert || p1 || Datetime2Str(p3) || zbr_aus_data.CRLF;  
      vNeuerWert := vNeuerWert || p1 || Datetime2Str(p2) || zbr_aus_data.CRLF;
    ELSIF p4 THEN
      vAlterWert := vAlterWert || p1 || Datetime2Str(p3) || zbr_aus_data.CRLF;  
      vNeuerWert := vNeuerWert || p1 || Datetime2Str(p2) || zbr_aus_data.CRLF;    
    END IF;    


  END NeuerAlterWert;
  PROCEDURE NeuerAlterWert(p0 IN OUT PLS_INTEGER, p1 IN VARCHAR2, p2 IN NUMBER, p3 IN NUMBER, p4 IN BOOLEAN := FALSE) AS
  BEGIN
    IF IsEqual(p2, p3) = 0 THEN
      p0 := 1;
      vAlterWert := vAlterWert || p1 || p3 || zbr_aus_data.CRLF;  
      vNeuerWert := vNeuerWert || p1 || p2 || zbr_aus_data.CRLF;
    ELSIF p4 THEN
      vAlterWert := vAlterWert || p1 || p3 || zbr_aus_data.CRLF;  
      vNeuerWert := vNeuerWert || p1 || p2 || zbr_aus_data.CRLF;    
    END IF;    
  END NeuerAlterWert;  
  PROCEDURE NeuerAlterWert(p0 IN OUT PLS_INTEGER, p1 IN VARCHAR2, p2 IN BOOLEAN, p3 IN BOOLEAN, p4 IN BOOLEAN := FALSE) AS
  BEGIN
    IF IsEqual(p2, p3) = 0 THEN
      p0 := 1;
      vAlterWert := vAlterWert || p1 || CASE p3 WHEN TRUE THEN 'Ja' WHEN FALSE THEN 'Nein' END || zbr_aus_data.CRLF;  
      vNeuerWert := vNeuerWert || p1 || CASE p2 WHEN TRUE THEN 'Ja' WHEN FALSE THEN 'Nein' END || zbr_aus_data.CRLF;
    ELSIF p4 THEN
      vAlterWert := vAlterWert || p1 || CASE p3 WHEN TRUE THEN 'Ja' WHEN FALSE THEN 'Nein' END || zbr_aus_data.CRLF;  
      vNeuerWert := vNeuerWert || p1 || CASE p2 WHEN TRUE THEN 'Ja' WHEN FALSE THEN 'Nein' END || zbr_aus_data.CRLF;    
    END IF;    
  END NeuerAlterWert; 

  PROCEDURE InsUsc(
    pUsecase IN aus_d_usecase.usecase%TYPE
  , pAlter_Wert IN aus_d_usecase.Alter_Wert%TYPE
  , pNeuer_Wert IN aus_d_usecase.Neuer_Wert%TYPE
  , pAend_Grund IN aus_d_usecase.aend_grund%TYPE
  , pAend_art IN aus_d_usecase.aend_art%TYPE
  , pRef_ID IN ZBR_AUS_DATA.tID
  , pRef_ID_ALT IN ZBR_AUS_DATA.tID) AS
  BEGIN
    vUsc := NULL;
    vUsc.ID := SYS_GUID();
    vUsc.d_bts_id := vBts_ID1;
    vUsc.d0101_id := pD0101_id;
    vUsc.usecase := pUsecase;
    vUsc.mandant := pMandant; 
    vUsc.user_sid :=  pUserSID;
    vUsc.lastmodified := pLastModified;
    vUsc.Aend_art := pAend_art;
    vUsc.Aend_grund := pAend_Grund;
    vUsc.Alter_Wert := RTRIM( pAlter_Wert, zbr_aus_data.CRLF);
    vUsc.Neuer_Wert := RTRIM( pNeuer_Wert, zbr_aus_data.CRLF);
    vUsc.ref_id := pRef_ID; 
    vUsc.d_bts_id2 := vBTS_ID2;
    vUsc.ref_id_alt := pRef_ID_ALT;   
  END InsUsc;


  PROCEDURE InsUsc2 AS
  BEGIN
    vtUsc.EXTEND;
    vtUsc(vtUsc.LAST) := vUsc;    
  END InsUsc2;
  
  FUNCTION ABMELD_BTR RETURN PLS_INTEGER AS -- Abmelden Betriebssttte
  vRes PLS_INTEGER := 0;
  BEGIN

    IF vBTS1.bts.gueltig_bis IS NOT NULL AND vBts2.bts.gueltig_bis IS NULL THEN
      InsUsc('ABMELD_BTR', null, TO_CHAR( vBts1.bts.gueltig_bis, 'dd.mm.yyyy'), 1937001, 0, vBTS1.bts.id, vBTS2.bts.id);      
      vUsc.gueltig_von := vBts1.bts.gueltig_von;
      vUsc.gueltig_bis := vBts1.bts.gueltig_bis;
      vRes := 1;
    END IF;
    RETURN vRes;
  END ABMELD_BTR;
  
  FUNCTION AEND_BEZ_BTR RETURN PLS_INTEGER AS -- ndern der zusatzbezeichnung der Betriebssttte
  vRes PLS_INTEGER := 0;
  BEGIN

    IF IsEqual(vBTS1.bts.zusatzbez, vBts2.bts.zusatzbez) = 0 THEN
      InsUsc('AEND_BEZ_BTR', vBts2.bts.zusatzbez, vBTS1.bts.zusatzbez, 1932001, 0, vBTS1.bts.id, vBTS2.bts.id);      
      vUsc.gueltig_von := vBts1.bts.gueltig_von;
      vUsc.gueltig_bis := vBts1.bts.gueltig_bis;
      vRes := 1;
    END IF;
    RETURN vRes;
  END AEND_BEZ_BTR;

  -- pAdrNeu neue Werte
  -- pAdrAlt alte Werte
  FUNCTION AEND_ADR(pUsecase IN VARCHAR2, pIsPost IN PLS_INTEGER, pAdrNeu IN ZBR_AUS_DATA.tAdr, pAdrAlt IN ZBR_AUS_DATA.tAdr) RETURN PLS_INTEGER AS -- ndern der Standortadresse der BTS
  vRes PLS_INTEGER := 0;
  BEGIN

    vAlterWert := NULL;
    vNeuerWert := NULL;
    IF pIsPost = 0 THEN
      IF pAdrNeu.adr.wechsel IN ( 1, 2) OR pAdrAlt.adr.wechsel IN ( 1, 2) THEN
    
        NeuerAlterWert( vRes, NULL, 
          CASE pAdrNeu.adr.wechsel 
          WHEN 0 THEN 'Standard'
          WHEN 1 THEN 'wechselnder Standort'
          WHEN 2 THEN 'freitextliche Standortbeschreibung'
          END
          , CASE pAdrAlt.adr.wechsel
          WHEN 0 THEN 'Standard'
          WHEN 1 THEN 'wechselnder Standort'
          WHEN 2 THEN 'freitextliche Standortbeschreibung'
          END);
      
      END IF;     
    
    END IF;
    NeuerAlterWert( vRes, 'STRASSE: ', pAdrNeu.padr.strasse, pAdrAlt.padr.strasse);
    NeuerAlterWert( vRes, 'HAUSNR: ', pAdrNeu.padr.hausnr, pAdrAlt.padr.hausnr);
    NeuerAlterWert( vRes, 'HAUSNRZUSATZ: ', pAdrNeu.padr.hausnrzusatz, pAdrAlt.padr.hausnrzusatz);
    NeuerAlterWert( vRes, 'PLZ: ', pAdrNeu.padr.plz, pAdrAlt.padr.plz);
    NeuerAlterWert( vRes, 'ORTSTEIL: ', pAdrNeu.padr.ortsteil, pAdrAlt.padr.ortsteil);
    NeuerAlterWert( vRes, 'ORT: ', pAdrNeu.padr.ort, pAdrAlt.padr.ort);

    IF pIsPost = 1 THEN
      NeuerAlterWert( vRes, 'POSTFACH: ', pAdrNeu.padr.postfach, pAdrAlt.padr.postfach);
    END IF;
    NeuerAlterWert( vRes, 'STAAT: ', pAdrNeu.padr.staat, pAdrAlt.padr.staat);
    
    IF pIsPost = 0 THEN
      NeuerAlterWert( vRes, 'GKZ: ', pAdrNeu.verw.gkz, pAdrAlt.verw.gkz);
      NeuerAlterWert( vRes, 'BEZIRK: ', pAdrNeu.verw.bezirk, pAdrAlt.verw.bezirk);
      NeuerAlterWert( vRes, 'KREIS: ', pAdrNeu.verw.kreis, pAdrAlt.verw.kreis);
      NeuerAlterWert( vRes, 'BUNDESLAND: ', pAdrNeu.verw.bundesland, pAdrAlt.verw.bundesland);
      NeuerAlterWert( vRes, 'REGIONALSSCHLSSEL: ', pAdrNeu.verw.regionalschluessel, pAdrAlt.verw.regionalschluessel);

      NeuerAlterWert( vRes, 'FLURNUMMER: ', pAdrNeu.kat.flurnummer, pAdrAlt.kat.flurnummer);
      NeuerAlterWert( vRes, 'FLURSTUECK: ', pAdrNeu.kat.flurstueck, pAdrAlt.kat.flurstueck);
      NeuerAlterWert( vRes, 'GEMARKUNG: ', pAdrNeu.kat.gemarkung, pAdrAlt.kat.gemarkung);
      NeuerAlterWert( vRes, 'x-wert: ', pAdrNeu.kat.x_wert, pAdrAlt.kat.x_wert);
      NeuerAlterWert( vRes, 'y-wert: ', pAdrNeu.kat.y_wert, pAdrAlt.kat.y_wert);
      NeuerAlterWert( vRes, 'rechtswert: ', pAdrNeu.kat.rechtswert, pAdrAlt.kat.rechtswert);
      NeuerAlterWert( vRes, 'hochwert: ', pAdrNeu.kat.hochwert, pAdrAlt.kat.hochwert);
    END IF;
     
    IF vRes = 1 THEN
      InsUsc( pUsecase, vAlterWert, vNeuerWert, 1932001, 0, pAdrNeu.adr.id, pAdrAlt.adr.id);      
      vUsc.gueltig_von := vBts1.bts.gueltig_von;
      vUsc.gueltig_bis := vBts1.bts.gueltig_bis;
      vRes := 1;
    END IF;
    vAlterWert := NULL;
    vNeuerWert := NULL;
    RETURN vRes;
  END AEND_ADR;  

  FUNCTION AEND_STANDORT_BTR RETURN PLS_INTEGER AS -- ndern der Standortadresse der BTS
  BEGIN    
    RETURN AEND_ADR('AEND_STANDORT_BTR', 0, vBTS1.Adr_BTRO, vBTS2.Adr_BTRO);
  END AEND_STANDORT_BTR;   
  
  FUNCTION AEND_POST_ADR_BETREI RETURN PLS_INTEGER AS -- ndern der Postadresse des Betreibers
  BEGIN
    RETURN AEND_ADR('AEND_POST_ADR_BETREI', 1, vBTS1.FKT_INH.ADR, vBTS2.FKT_INH.ADR);
  END AEND_POST_ADR_BETREI;    

  FUNCTION KOMM(pUsecase IN VARCHAR2, pKomNeu IN ZBR_AUS_DATA.tKom, pKomAlt IN ZBR_AUS_DATA.tKom) RETURN PLS_INTEGER AS
  vRes PLS_INTEGER := 0;
  BEGIN
    vAlterWert := NULL;
    vNeuerWert := NULL;  

    NeuerAlterWert(vRes, 'TELEFON: ', pKomNeu.telefon, pKomAlt.telefon);
    NeuerAlterWert(vRes, 'MOBIL: ', pKomNeu.mobil, pKomAlt.mobil);
    NeuerAlterWert(vRes, 'EMAIL: ', pKomNeu.email, pKomAlt.email);
    NeuerAlterWert(vRes, 'FAX: ', pKomNeu.fax, pKomAlt.fax);    
    IF vRes = 1 THEN
       CASE
       WHEN pUsecase = 'AEND_KOM_BTR' THEN
         InsUsc( pUsecase, vAlterWert, vNeuerWert, 1937001, 1, vBTS1.bts.id, vBTS2.bts.id );     
       WHEN pUsecase = 'AEND_KOM_BETREI' THEN
         InsUsc( pUsecase, vAlterWert, vNeuerWert, 1937001, 1, vBTS1.fkt_inh.pers.id, vBTS2.fkt_inh.pers.id );     
       END CASE;
    END IF;
    vAlterWert := NULL;
    vNeuerWert := NULL;             
    RETURN vRes;
  END KOMM;

  FUNCTION KOM_BTR RETURN PLS_INTEGER AS -- Kommunikationsmittel BTS
  BEGIN
    RETURN Komm('AEND_KOM_BTR', vBts1.kom, vBts2.kom);   
  END KOM_BTR;

  FUNCTION KOM_BETREI RETURN PLS_INTEGER AS -- Kommunikationsmittel Betreiber
  BEGIN
    RETURN Komm('AEND_KOM_BETREI', vBts1.Fkt_INH.kom, vBts2.Fkt_INH.kom);   
  END KOM_BETREI;

  FUNCTION AEND_BETREI RETURN PLS_INTEGER AS -- Betreiberwechsel
  vRes PLS_INTEGER := 0;
  vRegIdx1 PLS_INTEGER := -1;
  vRegIdx2 PLS_INTEGER := -1;
  vRegNr1 aus_d_registrierung.nummer%TYPE := NULL; 
  vRegNr2 aus_d_registrierung.nummer%TYPE := NULL;
  vOK BOOLEAN;
  
  CURSOR cAK_BTR (pREF_ID IN VARCHAR2, pBTS_ID IN VARCHAR2) IS
    SELECT dx.* FROM (
      SELECT prt.d_bts_id, reg.id reg_id
      FROM aus_d_person prs
      JOIN aus_d_funktion fkt on fkt.d_pers_id = prs.id
      JOIN aus_d_protokoll prt on prt.d_bts_id = fkt.d_bts_id
      LEFT JOIN aus_r_fkt_reg r1 
        JOIN aus_d_registrierung reg on reg.id = r1.d_reg_id
        AND reg.art = 'BI'
      ON r1.d_fkt_id = fkt.id
      WHERE prs.ref_id = pRef_ID
      AND fkt.d_bts_id <> pBTS_ID
      ORDER by prt.ins_date DESC
      ) dx 
    WHERE ROWNUM = 1;  
  
  vAK_Btr cAK_BTR%ROWTYPE;
  
  BEGIN
    vAlterWert := NULL;
    vNeuerWert := NULL; 

    -- todo 58184090: Betreiberwechsel nur wenn sich d0101_id3 und Betreiber-ID ndert
    -- bei gleicher d0101_id3 und genderter Betreiber-ID -> kein Betreiberwechsel
    
    /* Bedingungen fr Betreiberwechsel
    - in den Altdaten ist D0101_ID = D0101_ID3 (kein abweichender Betreiber vorhanden) 
       und jetzt ist D0101_ID3 gendert und BetreiberID sind gleich -> kein AEND_BETREI
    - in den Altdaten ist D0101_ID <> D0101_ID3 (abweichender Betreiber vorh.) 
      und D0101_ID3 ist gendert -> immer Betreiberwechsel  
    */
    IF IsEqual( vBTS1.FKT_INH.PERS.REF_ID, vBTS2.FKT_INH.PERS.REF_ID) = 0 THEN

      vRegIdx1 := GetRegIdx( vBTS1.FKT_INH.Reg, 'BI' );
      vRegIdx2 := GetRegIdx( vBTS2.FKT_INH.Reg, 'BI' );
      vRegNr1 := CASE WHEN vRegIdx1 > 0 THEN vBTS1.FKT_INH.Reg(vRegIdx1).nummer END;
      vRegNr2 := CASE WHEN vRegIdx2 > 0 THEN vBTS2.FKT_INH.Reg(vRegIdx2).nummer END;
      vOK := FALSE;

      CASE
      WHEN IsEqual( vRegNr1, vRegNr2 ) = 1 AND vBTS2.bts.ref_id = vBTS2.FKT_INH.PERS.REF_ID THEN -- Altdaten kein abweichender Betreiber
        vOK := FALSE; -- kein Betreiberwechsel
      
      --WHEN IsEqual( vRegNr1, vRegNr2 ) = 0 THEN -- BetreiberID gendert
      ELSE
        vOK := TRUE;

        IF vRegNr1 IS NULL THEN
          -- letzten Stand im AK ermitteln:
          -- hat dort BetreiberID oder ist nicht vorhanden -> USECASE ermitteln
          -- im AK vorhanden aber ohne BetreiberID -> USECASE verzgern
          
          OPEN cAK_BTR(vBTS1.FKT_INH.PERS.REF_ID, vBTS1.BTS.ID);
          FETCH cAK_Btr INTO vAK_Btr;
          
          IF cAK_Btr%FOUND AND vAK_Btr.reg_id IS NULL THEN 
            vOK := FALSE;
            vRes := 2;
          ELSE
            vOK := True;
          END IF;  
          CLOSE cAK_Btr;
        END IF;    
                  
      END CASE;        
      
      IF vOK THEN 
        NeuerAlterWert( vRes, 'Bezeichnung: ', CrtPersBez(vBTS1.FKT_INH.pers) , CrtPersBez(vBTS2.FKT_INH.Pers), TRUE );
        NeuerAlterWert( vRes, 'Betreiber-Id: ', vRegNr1 , vRegNr2, TRUE );
        
        /*vAlterWert := 'Bezeichnung: ' || CrtPersBez(vBTS2.FKT_INH.Pers) || zbr_aus_data.CRLF ||
                      'Betreiber-Id: ' || CASE WHEN vRegIdx2 > 0 THEN vBTS2.FKT_INH.Reg(vRegIdx2).nummer END;

        vNeuerWert := 'Bezeichnung: ' || CrtPersBez(vBTS1.FKT_INH.pers) || zbr_aus_data.CRLF || 
                      'Betreiber-Id: ' || CASE WHEN vRegIdx1 > 0 THEN vBTS1.FKT_INH.Reg(vRegIdx1).nummer END;*/
        InsUsc('AEND_BETREI', vAlterWert, vNeuerWert, 1937001, 1, vBTS1.FKT_INH.PERS.id, vBTS2.FKT_INH.PERS.id);    
        vRes := 1;
      END IF;  
    END IF;
    vAlterWert := NULL;
    vNeuerWert := NULL; 

    RETURN vRes;   
  END AEND_BETREI;

  FUNCTION AEND_NAME_BETREI RETURN PLS_INTEGER AS -- ndern der Standortadresse des BTR
  vRes PLS_INTEGER := 0;
  BEGIN
    vAlterWert := NULL;
    vNeuerWert := NULL;
    NeuerAlterWert( vRes, 'Typ: ', vBts1.fkt_inh.pers.typ, vBts2.fkt_inh.pers.typ);
    NeuerAlterWert( vRes, 'Kurzbez1: ', vBts1.fkt_inh.pers.kurzbez1, vBts2.fkt_inh.pers.kurzbez1);
    NeuerAlterWert( vRes, 'Kurzbez2: ', vBts1.fkt_inh.pers.kurzbez2, vBts2.fkt_inh.pers.kurzbez2);
    NeuerAlterWert( vRes, 'Anrede: ', vBts1.fkt_inh.pers.anrede, vBts2.fkt_inh.pers.anrede);
    NeuerAlterWert( vRes, 'Titel: ', vBts1.fkt_inh.pers.titel, vBts2.fkt_inh.pers.titel);
    NeuerAlterWert( vRes, 'Vorname: ', vBts1.fkt_inh.pers.vorname, vBts2.fkt_inh.pers.vorname);
    --todo 66378090 
    NeuerAlterWert( vRes, 'Nachname: ', vBts1.fkt_inh.pers.nachname, vBts2.fkt_inh.pers.nachname);
    NeuerAlterWert( vRes, 'Vorsatz-Nachname: ', vBts1.fkt_inh.pers.vorsatz_nachname, vBts2.fkt_inh.pers.vorsatz_nachname);
    NeuerAlterWert( vRes, 'Nachsatz-Nachname: ', vBts1.fkt_inh.pers.nachsatz_nachname, vBts2.fkt_inh.pers.nachsatz_nachname);
    -- todo 5843090 15.06.2015 NeuerAlterWert( vRes, 'Bezeichnung: ', CrtPersBez( vBts1.fkt_inh.pers ) , CrtPersBez(vBts2.fkt_inh.pers) );
    NeuerAlterWert( vRes, 'Bezeichnung: ', vBts1.fkt_inh.pers.bezeichnung , vBts2.fkt_inh.pers.bezeichnung );
      
    IF vRes = 1 THEN
      InsUsc( 'AEND_NAME_BETREI', vAlterWert, vNeuerWert, 1937001, 1, vBTS1.FKT_INH.PERS.ID, vBTS2.FKT_INH.PERS.ID);      
      vUsc.gueltig_von := vBts1.bts.gueltig_von;
      vUsc.gueltig_bis := vBts1.bts.gueltig_bis;
      vRes := 1;
    END IF;
    vAlterWert := NULL;
    vNeuerWert := NULL;
    RETURN vRes;
  END AEND_NAME_BETREI; 

  FUNCTION BA RETURN PLS_INTEGER AS
    vRes PLS_INTEGER := 0;
    v1 PLS_INTEGER := 0; 
    vID0 zbr_aus_data.tID := '-1';
    vID0_ABMELD_BA BOOLEAN := FALSE;    
    -- Betriebsarten
    CURSOR cBA (pBTS_ID1 IN ein_d_betriebsstaette.id%TYPE, pBTS_ID2 IN ein_d_betriebsstaette.id%TYPE) IS
    SELECT ba1.id id_1, ba2.id id_2
    , ba1.aktiv aktiv_1, ba2.aktiv aktiv_2
    , ba1.id0 id0_1, ba2.id0 id0_2 
    , ba1.code code_1, ba2.code code_2
    , ba1.bez bez_1, ba2.bez bez_2
    , ba1.gewerbsmaessig gewerbsmaessig_1, ba2.gewerbsmaessig gewerbsmaessig_2
    , ba1.gueltig_von gueltig_von_1, ba2.gueltig_von gueltig_von_2
    , ba1.gueltig_bis gueltig_bis_1, ba2.gueltig_bis gueltig_bis_2
    , ba1.ref_id ref_id_1, ba2.ref_id ref_id_2 
    FROM  -- aktueller Stand
    ( SELECT ba.*, d010101.aktiv, d010101.id0, d010101.id d010101_id 
      FROM aus_d_betriebsart ba 
      JOIN vis_d010101 d010101 ON d010101.id = ba.ref_id --AND d010101.deleted = 0
      WHERE ba.d_bts_id = pBTS_ID1
    ) ba1
    FULL JOIN (  -- alter Stand
      SELECT ba.* , d010101.aktiv, d010101.id0, d010101.id d010101_id 
      FROM aus_d_betriebsart ba 
      JOIN vis_d010101 d010101 ON d010101.id = ba.ref_id --AND d010101.deleted = 0 
      WHERE ba.d_bts_id = pBTS_ID2
    ) ba2 ON ba1.ref_id = ba2.ref_id
    ORDER BY ba1.id0 NULLS LAST, ba1.gueltig_von NULLS LAST, ba1.gueltig_bis;   
    
    -- Zulassungen als Betriebsarten
    CURSOR cBA2 (pBTS_ID1 IN ein_d_betriebsstaette.id%TYPE, pBTS_ID2 IN ein_d_betriebsstaette.id%TYPE) IS
    SELECT ba1.id id_1, ba2.id id_2
    , ba1.aktiv aktiv_1, ba2.aktiv aktiv_2
    , ba1.id0 id0_1, ba2.id0 id0_2 
    , ba1.code code_1, ba2.code code_2
    , ba1.bez bez_1, ba2.bez bez_2
    , ba1.gewerbsmaessig gewerbsmaessig_1, ba2.gewerbsmaessig gewerbsmaessig_2
    , ba1.gueltig_von gueltig_von_1, ba2.gueltig_von gueltig_von_2
    , ba1.gueltig_bis gueltig_bis_1, ba2.gueltig_bis gueltig_bis_2
    , ba1.ref_id ref_id_1, ba2.ref_id ref_id_2 
    FROM
    ( SELECT ba.*, 1 aktiv, ba.ref_id id0, ba.ref_id d010101_id --d010102.id id0, d010102.id d010101_id 
      FROM aus_d_betriebsart ba 
      JOIN vis_d010102 d010102 ON d010102.id = ba.ref_id --AND d010102.deleted = 0
      WHERE ba.d_bts_id = pBTS_ID1
    ) ba1
    FULL JOIN (  -- alter Stand
      SELECT ba.* , 1 aktiv, ba.ref_id id0, ba.ref_id d010101_id -- d010102.id id0, d010102.id d010101_id 
      FROM aus_d_betriebsart ba 
      JOIN vis_d010102 d010102 ON d010102.id = ba.ref_id --AND d010102.deleted = 0 
      WHERE ba.d_bts_id = pBTS_ID2
    ) ba2 ON ba1.ref_id = ba2.ref_id;

    TYPE tbBA IS TABLE OF cBA%ROWTYPE; 
    vtBA tbBA;
    vtBA2 tbBA;
    
    -- Existiert zu pID0 ein neuer Historieneintrag
    FUNCTION ExistsNeueHistorie( pID0 IN vis_d010101.id0%TYPE) RETURN BOOLEAN AS
      vRes BOOLEAN := FALSE;
    BEGIN
      FOR i IN vtBA.FIRST .. vtBA.LAST LOOP
        IF vtBA(i).ID0_1 = pID0 AND vtBA(i).ID_2 IS NULL AND vtBA(i).aktiv_1 = 0 THEN
          vRes := TRUE;
          EXIT;
        END IF; 
      END LOOP;  
      RETURN vRes;
    END ExistsNeueHistorie;
  
    FUNCTION GetIdxAktivAlt( pID0 IN vis_d010101.id0%TYPE) RETURN PLS_INTEGER AS
      vRes PLS_INTEGER := -1;
    BEGIN
      FOR i IN vtBA.FIRST .. vtBA.LAST LOOP
        IF vtBA(i).ID0_2 = pID0 AND vtBA(i).aktiv_2 = 1 THEN
          vRes := i;
          EXIT;
        END IF; 
      END LOOP;  
      RETURN vRes;
   END GetIdxAktivAlt;

  -- pIdx1 Index neue Daten, pIdx2 Index alte Daten
  -- pGueltig_bis: bei TRUE Prfung GUELTIG_BIS
  FUNCTION KORR_BA (pIdx1 IN PLS_INTEGER, pIdx2 IN PLS_INTEGER, pGueltig_bis IN BOOLEAN) RETURN PLS_INTEGER AS
    vRes PLS_INTEGER := 0;
  BEGIN  
        -- irgend ein Feld hat sich gendert -> KORR_BA - als letztes prfen        
    IF (vtBA(pIdx1).id_1 <> '-1' AND vtBA(pIdx2).id_2 <> '-1') AND (
        IsEqual( vtBA(pIdx1).bez_1, vtBA(pIdx2).bez_2) = 0 OR
        IsEqual( vtBA(pIdx1).CODE_1, vtBA(pIdx2).CODE_2) = 0 OR
        IsEqual( vtBA(pIdx1).gueltig_von_1, vtBA(pIdx2).gueltig_von_2) = 0 OR
        (pGueltig_bis AND IsEqual( vtBA(pIdx1).gueltig_bis_1, vtBA(pIdx2).gueltig_bis_2) = 0) OR
        IsEqual( vtBA(pIdx1).gewerbsmaessig_1, vtBA(pIdx2).gewerbsmaessig_2) = 0 ) THEN

      NeuerAlterWert( v1, 'Bezeichnung: ', vtBA(pIdx1).bez_1, vtBA(pIdx2).bez_2, True);
      NeuerAlterWert( v1, 'Code: ', vtBA(pIdx1).code_1, vtBA(pIdx2).code_2);
      NeuerAlterWert( v1, 'Gltig von: ', vtBA(pIdx1).gueltig_von_1, vtBA(pIdx2).gueltig_von_2);
      --IF pGueltig_bis THEN
        NeuerAlterWert( v1, 'Gltig bis: ', vtBA(pIdx1).gueltig_bis_1, vtBA(pIdx2).gueltig_bis_2);
      --END IF;
      NeuerAlterWert( v1, 'Gewerbsmig: ', vtBA(pIdx1).gewerbsmaessig_1, vtBA(pIdx2).gewerbsmaessig_2, True);

      InsUsc('KORR_BA', vAlterWert, vNeuerWert, 1937001, 1, vtBA(pIdx1).id_1, vtBA(pIdx2).id_2 );
      InsUsc2();
      vRes := vRes + 1;
      vAlterWert := NULL;
      vNeuerWert := NULL;
    END IF;
    RETURN vRes;
  END KORR_BA;
  
  BEGIN
    OPEN cBA (vBTS_ID1, vBTS_ID2);
    FETCH cBA BULK COLLECT INTO vtBA LIMIT 9999;
    CLOSE cBA;
    -- Spezialbehandlung 010417 Zulassung als Betriebsart
    IF vVerfahren <> QUELLE_IDV_NRW /*vGKZ2 <> zbr_aus_data.NRW*/ THEN
      OPEN cBA2 (vBTS_ID1, vBTS_ID2);
      FETCH cBA2 BULK COLLECT INTO vtBA2 LIMIT 9999;
      CLOSE cBA2;
       
      IF vtBA2.COUNT > 0 THEN
        FOR i IN vtBA2.FIRST .. vtBA2.LAST LOOP
          vtBA.EXTEND;  
          vtBA(vtBA.LAST) := vtBA2( i );
        END LOOP;
      END IF;
    END IF;
    
    IF vtBA.COUNT > 0 THEN
            
      FOR iBA IN vtBA.FIRST .. vtBA.LAST LOOP
        vAlterWert := NULL;
        vNeuerWert := NULL;        
        vIdxBAAktiv_2 := GetIdxAktivAlt( vtBA(iBA).id0_1 );
        IF vID0 <> vtBA(iBA).id0_1 THEN
          vID0_ABMELD_BA := FALSE;
          vID0 := vtBA(iBA).id0_1;
        END IF;
        CASE         
        -- neue aktive und keine alten Daten oder neue Historie -> ANMELD_BA
        WHEN (vtBA(iBA).aktiv_1 = 1 AND
        (vtBA(iBA).id_2 IS NULL OR ExistsNeueHistorie( vtBA(iBA).ID0_1) ) ) THEN
        
          NeuerAlterWert( v1, 'Bezeichnung: ', vtBA(iBA).bez_1, NULL, True); -- immer ausgeben
          NeuerAlterWert( v1, 'Gltig von: ', vtBA(iBA).gueltig_von_1, NULL, True); -- immer ausgeben
          NeuerAlterWert( v1, 'Gltig bis: ', vtBA(iBA).gueltig_bis_1, NULL);
          NeuerAlterWert( v1, 'Gewerbsmig: ', vtBA(iBA).gewerbsmaessig_1, NULL, True);

          InsUsc('ANMELD_BA', NULL, vNeuerWert, 1937001, 1, vtBA(iBA).id_1, NULL );
          InsUsc2();
          vRes := vRes + 1;        
        
        -- neue Historie ohne alten AKTIV-Eintrag
        WHEN ( vtBA(iBA).aktiv_1 = 0 AND vIdxBAAktiv_2 < 1 ) THEN
        
          NeuerAlterWert( v1, 'Bezeichnung: ', vtBA(iBA).bez_1, NULL, True); -- immer ausgeben
          NeuerAlterWert( v1, 'Gltig von: ', vtBA(iBA).gueltig_von_1, NULL, True); -- immer ausgeben
          NeuerAlterWert( v1, 'Gltig bis: ', vtBA(iBA).gueltig_bis_1, NULL);
          NeuerAlterWert( v1, 'Gewerbsmig: ', vtBA(iBA).gewerbsmaessig_1, NULL, True);

          InsUsc('ANMELD_BA', NULL, vNeuerWert, 1937001, 1, vtBA(iBA).id_1, NULL );
          InsUsc2();
          vRes := vRes + 1;
  
        -- neue Historie 
        -- ohne alten AKTIV -> ANMELD_BA
        -- sonst ABMELD_BA mit Verweis auf alten AKTIV 
        WHEN vtBA(iBA).aktiv_1 = 0 AND vtBA(iBA).id_2 IS NULL THEN

          -- ABMELD_BA nur fr ersten neuen Historiensatz, alle anderen werden ANMELD_BA
          IF vIdxBAAktiv_2 > 0 AND NOT vID0_ABMELD_BA THEN
            vID0_ABMELD_BA := TRUE;
            vRes := vRes + KORR_BA(iBA, vIdxBAAktiv_2, False);

            NeuerAlterWert( v1, 'Bezeichnung: ', vtBA(iBA).bez_1, vtBA(vIdxBAAktiv_2).bez_2, True);
            NeuerAlterWert( v1, 'Gltig von: ', vtBA(iBA).gueltig_von_1, vtBA(vIdxBAAktiv_2).gueltig_von_2, True); -- immer ausgeben
            NeuerAlterWert( v1, 'Gltig bis: ', vtBA(iBA).gueltig_bis_1, vtBA(vIdxBAAktiv_2).gueltig_bis_2, True); -- immer ausgeben
            NeuerAlterWert( v1, 'Gewerbsmig: ', vtBA(iBA).gewerbsmaessig_1, vtBA(vIdxBAAktiv_2).gewerbsmaessig_2, True);

            InsUsc('ABMELD_BA', vAlterWert, vNeuerWert, 1937001, 1, vtBA(iBA).id_1, vtBA(vIdxBAAktiv_2).id_2 );

          ELSE
            NeuerAlterWert( v1, 'Bezeichnung: ', vtBA(iBA).bez_1, NULL, True); -- immer ausgeben
            NeuerAlterWert( v1, 'Gltig von: ', vtBA(iBA).gueltig_von_1, NULL, True); -- immer ausgeben
            NeuerAlterWert( v1, 'Gltig bis: ', vtBA(iBA).gueltig_bis_1, NULL, True); -- immer ausgeben
            NeuerAlterWert( v1, 'Gewerbsmig: ', vtBA(iBA).gewerbsmaessig_1, NULL, True);

            InsUsc('ANMELD_BA', NULL, vNeuerWert, 1937001, 1, vtBA(iBA).id_1, NULL );

          END IF;
          
          InsUsc2();
          vRes := vRes + 1;
          
        -- neu gueltig_bis gesetzt und alt nicht gesetzt bzw. alt nicht vorhanden
        WHEN vtBA(iBA).aktiv_1 = 1 AND vtBA(iBA).gueltig_bis_1 > ZBR_AUS_DATA.vDateMin AND vtBA(iBA).gueltig_bis_2 IS NULL THEN

          vRes := vRes + KORR_BA(iBA, iBA, FALSE);

          NeuerAlterWert( v1, 'Bezeichnung: ', vtBA(iBA).bez_1, vtBA(iBA).bez_2, True);
          NeuerAlterWert( v1, 'Gltig von: ', vtBA(iBA).gueltig_von_1, vtBA(iBA).gueltig_von_2, True); -- immer ausgeben
          NeuerAlterWert( v1, 'Gltig bis: ', vtBA(iBA).gueltig_bis_1, vtBA(iBA).gueltig_bis_2, True); -- immer ausgeben
          NeuerAlterWert( v1, 'Gewerbsmig: ', vtBA(iBA).gewerbsmaessig_1, vtBA(iBA).gewerbsmaessig_2, TRUE);

          IF vtBA(iBA).id_2 IS NULL THEN
            InsUsc('ABMELD_BA', NULL, vNeuerWert, 1937001, 1, vtBA(iBA).id_1, vtBA(iBA).id_2 );
          ELSE
            InsUsc('ABMELD_BA', vAlterWert, vNeuerWert, 1937001, 1, vtBA(iBA).id_1, vtBA(iBA).id_2 );
          END IF;

          InsUsc2();
          vRes := vRes + 1;          
        
        -- keine neue REF_ID zur alte REF_ID vorhanden -> STORNO_BA 
        WHEN vtBA(iBA).id_1 IS NULL AND vtBA(iBA).id_2 IS NOT NULL THEN

          NeuerAlterWert( v1, 'Bezeichnung: ', NULL, vtBA(iBA).bez_2, True);
          NeuerAlterWert( v1, 'Gltig von: ', NULL, vtBA(iBA).gueltig_von_2);
          NeuerAlterWert( v1, 'Gltig bis: ', NULL, vtBA(iBA).gueltig_bis_2);
          NeuerAlterWert( v1, 'Gewerbsmig: ', NULL, vtBA(iBA).gewerbsmaessig_2, True);

          InsUsc('STORNO_BA', vAlterWert, NULL, 1937001, 1,  NULL, vtBA(iBA).id_2 );
          InsUsc2();
          vRes := vRes + 1;

        -- irgend ein Feld hat sich gendert -> KORR_BA - als letztes prfen        
        /*WHEN (vtBA(iBA).id_1 <> '-1' AND vtBA(iBA).id_2 <> '-1') AND (
        IsEqual( vtBA(iBA).bez_1, vtBA(iBA).bez_2) = 0 OR
        IsEqual( vtBA(iBA).CODE_1, vtBA(iBA).CODE_2) = 0 OR
        IsEqual( vtBA(iBA).gueltig_von_1, vtBA(iBA).gueltig_von_2) = 0 OR
        IsEqual( vtBA(iBA).gueltig_bis_1, vtBA(iBA).gueltig_bis_2) = 0 OR
        IsEqual( vtBA(iBA).gewerbsmaessig_1, vtBA(iBA).gewerbsmaessig_2) = 0 ) THEN

          NeuerAlterWert( v1, 'Bezeichnung: ', vtBA(iBA).bez_1, vtBA(iBA).bez_2, True);
          NeuerAlterWert( v1, 'Code: ', vtBA(iBA).code_1, vtBA(iBA).code_2);
          NeuerAlterWert( v1, 'Gltig von: ', vtBA(iBA).gueltig_von_1, vtBA(iBA).gueltig_von_2);
          NeuerAlterWert( v1, 'Gltig bis: ', vtBA(iBA).gueltig_bis_1, vtBA(iBA).gueltig_bis_2);
          NeuerAlterWert( v1, 'Gewerbsmig: ', vtBA(iBA).gewerbsmaessig_1, vtBA(iBA).gewerbsmaessig_2);

          InsUsc('KORR_BA', vAlterWert, vNeuerWert, 1937001, 1, vtBA(iBA).id_1, vtBA(iBA).id_2 );
          InsUsc2();
          vRes := vRes + 1;
          */  
        ELSE --NULL; -- alles OK kein usecase
          vRes := vRes + KORR_BA(iBA, iBA, TRUE);  

        END CASE;  
      END LOOP;
      vUsc := NULL;
    END IF;      
    RETURN vRes;
  END BA;
  
  PROCEDURE AlleBa AS
  v1 PLS_INTEGER := 0; 
  BEGIN
    FOR c1 IN (
    
      SELECT ba1.id id1, ba2.id id2
      , ba1.code code1, ba2.code code2
      , ba1.bez bez1, ba2.bez bez2
      , ba1.gewerbsmaessig gew1
      , ba2.gewerbsmaessig gew2
      , ba1.gueltig_von von1, ba2.gueltig_von von2
      , ba1.gueltig_bis bis1, ba2.gueltig_bis bis2
      , ba1.ref_id ref_id1, ba2.ref_id ref_id2 
      FROM  -- aktueller Stand
      ( SELECT ba.* 
        FROM aus_d_betriebsart ba 
        WHERE ba.d_bts_id = vBTS_ID1
      ) ba1
      FULL JOIN (  -- alter Stand
        SELECT ba.* 
        FROM aus_d_betriebsart ba 
        WHERE ba.d_bts_id = vBTS_ID2
      ) ba2 ON ba1.ref_id = ba2.ref_id
      ORDER BY ba1.code, ba2.code
    ) LOOP 

      vAlterWert := NULL;
      vNeuerWert := NULL;        
        
      NeuerAlterWert( v1, 'Bezeichnung: ',  c1.bez1, c1.bez2, True);
      NeuerAlterWert( v1, 'Code: ',         c1.code1, c1.code2, True);
      NeuerAlterWert( v1, 'Gltig von: ',   c1.von1, c1.von2, True);
      NeuerAlterWert( v1, 'Gltig bis: ',   c1.bis1, c1.bis2, True);
      NeuerAlterWert( v1, 'Gewerbsmig: ', CASE c1.gew1 WHEN 1 THEN TRUE WHEN 0 THEN FALSE END, CASE c1.gew2 WHEN 1 THEN TRUE WHEN 0 THEN FALSE END, True);

      InsUsc('ERSTBEFUELLUNG', vAlterWert, vNeuerWert, 0, 1, c1.id1, c1.id2 );
      InsUsc2();

    END LOOP;  
  END AlleBa;

  FUNCTION BaGroup RETURN PLS_INTEGER AS
    vRes PLS_INTEGER := 0;
    v1 PLS_INTEGER := 0; 
    vID0 zbr_aus_data.tID := '-1';
    vID0_ABMELD_BA BOOLEAN := FALSE;    
    -- Betriebsarten
--    CURSOR cBA (pBTS_ID1 IN ein_d_betriebsstaette.id%TYPE, pBTS_ID2 IN ein_d_betriebsstaette.id%TYPE) IS
--    SELECT ba1.id id_1, ba2.id id_2
--    , ba1.aktiv aktiv_1, ba2.aktiv aktiv_2
--    , ba1.id0 id0_1, ba2.id0 id0_2 
--    , ba1.code code_1, ba2.code code_2
--    , ba1.bez bez_1, ba2.bez bez_2
--    , ba1.gewerbsmaessig gewerbsmaessig_1, ba2.gewerbsmaessig gewerbsmaessig_2
--    , ba1.gueltig_von gueltig_von_1, ba2.gueltig_von gueltig_von_2
--    , ba1.gueltig_bis gueltig_bis_1, ba2.gueltig_bis gueltig_bis_2
--    , ba1.ref_id ref_id_1, ba2.ref_id ref_id_2 
--    FROM  -- aktueller Stand
--    ( SELECT ba.*, d010101.aktiv, d010101.id0, d010101.id d010101_id 
--      FROM aus_d_betriebsart ba 
--      JOIN vis_d010101 d010101 ON d010101.id = ba.ref_id --AND d010101.deleted = 0
--      WHERE ba.d_bts_id = pBTS_ID1
--    ) ba1
--    FULL JOIN (  -- alter Stand
--      SELECT ba.* , d010101.aktiv, d010101.id0, d010101.id d010101_id 
--      FROM aus_d_betriebsart ba 
--      JOIN vis_d010101 d010101 ON d010101.id = ba.ref_id --AND d010101.deleted = 0 
--      WHERE ba.d_bts_id = pBTS_ID2
--    ) ba2 ON ba1.ref_id = ba2.ref_id
--    ORDER BY ba1.id0 NULLS LAST, ba1.gueltig_von NULLS LAST, ba1.gueltig_bis;   
 
    
    CURSOR cBA (pBTS_ID1 IN ein_d_betriebsstaette.id%TYPE, pBTS_ID2 IN ein_d_betriebsstaette.id%TYPE) IS
    SELECT d3.* FROM 
    (    
      SELECT 
        d1.id id1, d1.code code1, d1.bez bez1, d1.von von1, CASE WHEN d1.bis = ZBR_AUS_DATA.vDATEMAX THEN NULL ELSE d1.bis END bis1, d1.gew gew1, d1.fb fb1, d1.art art1
      , d2.id id2, d2.code code2, d2.bez bez2, d2.von von2, CASE WHEN d2.bis = ZBR_AUS_DATA.vDATEMAX THEN NULL ELSE d2.bis END bis2, d2.gew gew2, d2.fb fb2, d2.art art2
      , CASE 
        WHEN d1.code IS NULL THEN 'STORNO_BA'
        WHEN d2.code IS NULL THEN 'ANMELD_BA'
        WHEN /*d1.id = d2.id and d1.code <> d2.code OR */ d1.gew <> d2.gew OR d1.von <> d2.von 
          or ( d1.bis <> d2.bis AND d2.bis <> ZBR_AUS_DATA.vDATEMAX /*AND d1.bis <> date '9999-01-01'*/) THEN 'KORR_BA'  
        WHEN d2.bis = ZBR_AUS_DATA.vDATEMAX AND d1.bis < ZBR_AUS_DATA.vDATEMAX THEN 'ABMELD_BA'
        END usecase 
      FROM (
        SELECT d1.id
        , d1.code, d1.bez, d1.fachbereich fb, d1.art
        , d1.gueltig_von von
        , NVL( d1.gueltig_bis, ZBR_AUS_DATA.vDATEMAX) bis
        , d1.gewerbsmaessig gew 
        FROM aus_d_betriebsart d1
        WHERE d1.scope = BA_GROUP
        AND d1.d_bts_id = pBTS_ID1
      ) d1 
      FULL JOIN ( 
        SELECT d2.id   
        , d2.code, d2.bez, d2.fachbereich fb, d2.art
        , d2.gueltig_von von
        , NVL(d2.gueltig_bis, ZBR_AUS_DATA.vDATEMAX) bis
        , d2.gewerbsmaessig gew 
        FROM aus_d_betriebsart d2
        WHERE d2.d_bts_id = pBTS_ID2
        AND d2.scope = BA_GROUP
      ) d2 ON d1.code = d2.code 
      AND (d1.bis = d2.bis or d1.von = d2.von) 
      AND d1.gew = d2.gew
    ) d3
    WHERE d3.usecase IS NOT NULL;
    
    TYPE tbBA IS TABLE OF cBA%ROWTYPE; 
    vtBA tbBA;
      
  BEGIN
    OPEN cBA (vBTS_ID1, vBTS_ID2);
    FETCH cBA BULK COLLECT INTO vtBA LIMIT 99999;
    CLOSE cBA;
    
    IF vtBA.COUNT > 0 THEN            
      FOR iBA IN vtBA.FIRST .. vtBA.LAST LOOP
                
        vAlterWert := NULL;
        vNeuerWert := NULL;        
        CASE         
        -- neue aktive und keine alten Daten oder neue Historie -> ANMELD_BA
        WHEN vtBA(iBA).usecase = 'ANMELD_BA' THEN
        
          NeuerAlterWert( v1, 'Bezeichnung: ',  vtBA(iBA).bez1, NULL, True); -- immer ausgeben
          NeuerAlterWert( v1, 'Code: ',         vtBA(iBA).code1, NULL, True); -- immer ausgeben
          NeuerAlterWert( v1, 'Gltig von: ',   vtBA(iBA).von1, NULL, True); -- immer ausgeben
          NeuerAlterWert( v1, 'Gltig bis: ',   vtBA(iBA).bis1, NULL);
          NeuerAlterWert( v1, 'Gewerbsmig: ', CASE vtBA(iBA).gew1 WHEN 1 THEN TRUE WHEN 0 THEN FALSE END, NULL, True);
          
          InsUsc('ANMELD_BA', NULL, vNeuerWert, 1937001, 1, vtBA(iBA).id1, NULL );
          InsUsc2();
          vRes := vRes + 1;        
        
        WHEN vtBA(iBA).usecase = 'ABMELD_BA' THEN

          NeuerAlterWert( v1, 'Bezeichnung: ',  vtBA(iBA).bez1, vtBA(iBA).bez2, True);
          NeuerAlterWert( v1, 'Gltig von: ',   vtBA(iBA).von1, vtBA(iBA).von2, True); -- immer ausgeben
          NeuerAlterWert( v1, 'Gltig bis: ',   vtBA(iBA).bis1, vtBA(iBA).bis2, True); -- immer ausgeben
          NeuerAlterWert( v1, 'Gewerbsmig: ', CASE vtBA(iBA).gew1 WHEN 1 THEN TRUE WHEN 0 THEN FALSE END, CASE vtBA(iBA).gew2 WHEN 1 THEN TRUE WHEN 0 THEN FALSE END, True);

          InsUsc('ABMELD_BA', vAlterWert, vNeuerWert, 1937001, 1, vtBA(iBA).id1, vtBA(iBA).id2 );          
          InsUsc2();
          vRes := vRes + 1;
          
        WHEN vtBA(iBA).usecase = 'STORNO_BA' THEN

          NeuerAlterWert( v1, 'Bezeichnung: ' , NULL, vtBA(iBA).bez2, True);
          NeuerAlterWert( v1, 'Code: ',         NULL, vtBA(iBA).code2);
          NeuerAlterWert( v1, 'Gltig von: '  , NULL, vtBA(iBA).von2);
          NeuerAlterWert( v1, 'Gltig bis: '  , NULL, vtBA(iBA).bis2);
          NeuerAlterWert( v1, 'Gewerbsmig: ', NULL, CASE vtBA(iBA).gew2 WHEN 1 THEN TRUE WHEN 0 THEN FALSE END, True);

          InsUsc('STORNO_BA', vAlterWert, NULL, 1937001, 1,  NULL, vtBA(iBA).id2 );
          InsUsc2();
          vRes := vRes + 1;

        WHEN vtBA(iBA).usecase = 'KORR_BA' THEN
          NeuerAlterWert( v1, 'Bezeichnung: ',  vtBA(iBA).bez1,  vtBA(iBA).bez2, True);
          NeuerAlterWert( v1, 'Code: ',         vtBA(iBA).code1, vtBA(iBA).code2);
          NeuerAlterWert( v1, 'Gltig von: ',   vtBA(iBA).von1,  vtBA(iBA).von2);
          NeuerAlterWert( v1, 'Gltig bis: ',   vtBA(iBA).bis1,  vtBA(iBA).bis2);
          NeuerAlterWert( v1, 'Gewerbsmig: ', CASE vtBA(iBA).gew1 WHEN 1 THEN TRUE WHEN 0 THEN FALSE END, CASE vtBA(iBA).gew2 WHEN 1 THEN TRUE WHEN 0 THEN FALSE END, True);

          InsUsc('KORR_BA', vAlterWert, vNeuerWert, 1937001, 1, vtBA(iBA).id1, vtBA(iBA).id2 );
          InsUsc2();
          vRes := vRes + 1;
        ELSE NULL;
        END CASE;  
      END LOOP;
      vUsc := NULL;
    END IF;  
    
--    IF vRes > 0 THEN
--      -- alle Betriebsarten alt - neu ohne Usecase ausgeben
--      AlleBa();    
--    END IF;
        
    RETURN vRes;
  END BaGroup;



  -- Ermittlung nderung wechselnder Standort
  FUNCTION WechselnderStandort RETURN PLS_INTEGER AS
  vRes PLS_INTEGER := 0;
  vSYSDATE DATE := TRUNC(SYSDATE);
  BEGIN
    CASE
    -- war und ist wechselnder Standort
    WHEN vBTS1.Adr_btro.adr.wechsel = 1 AND vBTS2.Adr_btro.adr.wechsel = 1 THEN
      vRes := 1;
    -- war und ist nicht mehr wechselnder Standort
    WHEN vBTS1.Adr_btro.adr.wechsel <> 1 AND vBTS2.Adr_btro.adr.wechsel = 1 THEN
      vRes := 2;
    -- war nicht und ist jetzt wechselnder Standort
    WHEN vBTS1.Adr_btro.adr.wechsel = 1 AND vBTS2.Adr_btro.adr.wechsel <> 1 THEN
      vRes := 3;
      -- alle nicht abgemeldeten BA abmelden.
      UPDATE aus_d_betriebsart
      SET gueltig_bis = vSYSDATE
      WHERE gueltig_bis IS NULL
      AND d_bts_id = vBTS1.bts.id;
    
      IF SQL%ROWCOUNT > 0 THEN
        AddWarning('Die Betriebssttte hat einen wechselnden Standort. Deshalb werden alle Betriebsarten abgemeldet bertragen.'); 
      END IF;
           
    ELSE vRes := 0;
    END CASE;
    RETURN vRes;
  END WechselnderStandort;

  FUNCTION AbmeldenBa RETURN PLS_INTEGER AS
  vRes PLS_INTEGER := 0; 
  vSYSDATE DATE := TRUNC(SYSDATE);
  BEGIN
  
    UPDATE aus_d_betriebsart
    SET gueltig_bis = vSYSDATE
    WHERE NVL(gueltig_bis, ZBR_AUS_DATA.vDATEMAX) = ZBR_AUS_DATA.vDATEMAX
    AND d_bts_id = vBTS1.bts.id;
      
    vRes := SQL%ROWCOUNT;
    RETURN vRes;
        
  END;
  -- Ermittlung nderung bezglich ZB (GKZ5) Betriebssttte - Betreiber
  FUNCTION ChkGKZ5 RETURN PLS_INTEGER AS
  vRes PLS_INTEGER := 0;
  vBtsGKZ1 VARCHAR2(5) := NVL( SUBSTR( vBTS1.Adr_btro.verw.gkz, 1, 5), CHR(9));
  vBtsGKZ2 VARCHAR2(5) := NVL( SUBSTR( vBTS2.Adr_btro.verw.gkz, 1, 5), CHR(9));
  vBtrGKZ1 VARCHAR2(5) := NVL( SUBSTR( vBTS1.fkt_inh.adr.verw.gkz, 1, 5), CHR(9));
  vBtrGKZ2 VARCHAR2(5) := NVL( SUBSTR( vBTS2.fkt_inh.adr.verw.gkz, 1, 5), CHR(9));
  
  BEGIN
  
    CASE
    -- war und ist abweichend
    WHEN vBtsGKZ1 <> vBtrGKZ1 AND vBtsGKZ2 <> vBtrGkz2 THEN
      vRes := 1;
    -- war und ist nicht mehr abweichend
    WHEN vBtsGKZ1 = vBtrGKZ1 AND vBtsGKZ2 <> vBtrGkz2 THEN
     vRes := 2;
    -- war nicht und ist jetzt abweichend
    WHEN vBtsGKZ1 <> vBtrGKZ1 AND vBtsGKZ2 = vBtrGkz2 THEN
      vRes := 3;
      -- alle nicht abgemeldeten BA abmelden.
      /*UPDATE aus_d_betriebsart
      SET gueltig_bis = TRUNC(SYSDATE)
      WHERE gueltig_bis IS NULL
      AND d_bts_id = vBTS1.bts.id;
    
      IF SQL%ROWCOUNT > 0 THEN
        AddWarning('Der Betreiber der Betriebssttte Zirkus sitzt nicht im Zustndigkeitsbereich. Deshalb werden alle Betriebsarten abgemeldet bertragen.'); 
      END IF;*/
           
    ELSE vRes := 0;
    END CASE;
    
    RETURN vRes;
  END ChkGKZ5;
  
  -- 0: aktuell kein Zirkus vorhanden
  -- 1: hatte nicht und hat jetzt Zirkus 
  -- 2: hatte und hat Zirkus
  FUNCTION ExistsBaZirkus RETURN PLS_INTEGER AS
  vRes PLS_INTEGER := 0; 
  BEGIN
    IF vBTS1.bta.count > 0 THEN
      FOR i IN vBTS1.BTA.FIRST .. vBTS1.BTA.LAST LOOP
        
        IF vBTS1.BTA(i).CODE = '040202' THEN -- Zirkus
          vRes := 1;
          IF vBTS2.BTA.COUNT > 0 THEN -- berprfung Zirkus Altdaten
            FOR i2 IN vBTS2.BTA.FIRST .. vBTS2.BTA.LAST LOOP
              IF vBTS2.BTA(i2).CODE = '040202' THEN -- Zirkus
                vRes := 2;
              END IF;
              EXIT WHEN vRes = 2;
            END LOOP;
          END IF;
        END IF;
        
        EXIT WHEN vRes > 0;      
      END LOOP;
    END IF;    
    RETURN vRes;  
  END ExistsBaZirkus;
  
BEGIN

  pUpdLastModified := True;
  vUcErmitteln := False;
  
  OPEN c1( pD0101_ID);
  FETCH c1 INTO vBTS_ID1;
  FETCH c1 INTO vBTS_ID2;
  CLOSE c1;


  -- wenn zum aktuellen Betreiber noch nicht gesendete Usecase AEND_BETREI vorliegen, 
  -- dann diese Sendung abbrechen
  DECLARE 
    CURSOR cTestBtr (pBTS_ID IN zbr_aus_data.tID) IS
    SELECT LISTAGG( d1.code, ', ') WITHIN GROUP ( ORDER BY d1.ins_date ) text
    FROM (
      SELECT d0101.code, MIN(prt1.ins_date) ins_date
      FROM aus_d_funktion fkt
      JOIN aus_d_protokoll prt ON prt.d_bts_id = fkt.d_bts_id
      JOIN aus_d_person prs ON prs.id = fkt.d_pers_id
      AND prs.ref_id <> '-1'
      JOIN aus_d_person prs1 on prs1.ref_id = prs.ref_id
      JOIN aus_d_funktion fkt1 ON fkt1.d_pers_id = prs1.id  
      AND fkt1.typ = Betreiber
      JOIN aus_d_protokoll prt1 on prt1.d_bts_id = fkt1.d_bts_id
      AND prt1.ins_date < prt.ins_date
      AND prt1.d0101_id <> prt.d0101_id 
      AND prt1.deleted = 0
      AND prt1.status IN (0, 5, 6)
      JOIN aus_d_usecase uc1 ON uc1.d_bts_id = fkt1.d_bts_id 
      AND uc1.status = 0
      AND uc1.usecase = 'AEND_BETREI'
      JOIN vis_d0101 d0101 ON d0101.id = uc1.d0101_id
      WHERE fkt.typ = Betreiber
      AND prt.d_bts_id = pBTS_ID
      GROUP BY d0101.code
      ORDER BY 2
    ) d1
    WHERE ROWNUM < 11;
    vTestBtr cTestBtr%ROWTYPE;  
  BEGIN
    OPEN cTestBtr(vBts_ID1);
    FETCH cTestBtr INTO vTestBtr;
    CLOSE cTestBtr;

    vUcErmitteln := vTestBtr.text IS NULL;   
    
    IF vTestBtr.text IS NOT NULL THEN
      vtUsc := ZBR_AUS_DATA.tbUsc();
      pUpdLastModified := False;
      AddWarning('Fr den Betreiber bzw. dessen Betriebssttten liegen noch nicht gesendete nderungen vor:' || zbr_aus_data.CRLF ||
                  vTestBtr.text || zbr_aus_data.CRLF ||
                  'nderungen knnen deshalb noch nicht bertragen werden.'); 
      pRes := -1;
    END IF;
  END;
  
  IF vUcErmitteln THEN 
    GroupBa(vBTS_ID1); -- Betriebsarten gruppieren aktueller Stand  
      
    Fill_BTS(vBTS1, vBTS_ID1);
    clear_bts(vBTS2);  -- 23.11.2015    
    
    SELECT d0101.* INTO vD0101
    FROM vis_d0101 d0101
    WHERE d0101.id = pD0101_ID;
    
    IF vD0101.id = vD0101.d0101_id3 THEN
      vD0101_3 := vD0101;
    ELSE
      SELECT d0101.* INTO vD0101
      FROM vis_d0101 d0101
      WHERE d0101.id = vD0101.D0101_ID3;  
    END IF;  

    IF vBTS_ID2 IS NULL THEN -- ANMELD_BTR
      vUcErmitteln := False;
      CASE  
      WHEN vBTS1.Adr_btro.adr.wechsel = 1 THEN -- todo 56675090: wechselnder Standort nicht exportieren
        AddError('Die Betriebssttte hat einen wechselnden Standort. Deshalb wird sie nicht an das Betriebsregister bertragen.'); 

      -- todo 58194090 23.06.2015
      -- wenn BA Zirkus vorhanden und Betriebssttte in anderem GKZ5 als Betreiber -> dann nicht exportieren
      WHEN NVL( SUBSTR( vBTS1.Adr_btro.verw.gkz, 1, 5), CHR(9)) <> NVL( SUBSTR( vBTS1.fkt_inh.adr.verw.gkz, 1, 5), CHR(9)) AND ExistsBaZirkus > 0 THEN    
        AddError('Der Betreiber der Betriebssttte Zirkus sitzt nicht im Zustndigkeitsbereich. Deshalb wird sie nicht an das Betriebsregister bertragen.'); 
      
      ELSE
            
        InsUsc('ANMELD_BTR', NULL, 'Neuanlage', 1930001, 0, vBTS_ID1, NULL);

        /* todo 58867090
          -- An- und Abmeldung aus Betrieb ermitteln
          SELECT TRUNC(d0101.anmeldung)
          , CASE WHEN NVL(d0101.abmeldung, ZBR_AUS_DATA.vDateMax) = ZBR_AUS_DATA.vDateMax THEN ZBR_AUS_DATA.vDate01_01_0001 ELSE TRUNC(d0101.abmeldung) END
          INTO vUsc.gueltig_von, vUsc.gueltig_bis
          FROM vis_d0101 d0101 WHERE d0101.id = pD0101_ID;
        */
        
        vUsc.gueltig_von := vBTS1.BTS.gueltig_von;
        vUsc.gueltig_bis := NVL(vBTS1.BTS.gueltig_bis, ZBR_AUS_DATA.vDate01_01_0001) ;
        
        InsUsc2();
      END CASE;
    ELSE  
    
      GroupBa(vBTS_ID2); -- Betriebsarten gruppieren letzter Stand  

      Fill_BTS(vBTS2, vBTS_ID2);

      IF WechselnderStandort() IN (0, 2, 3) THEN
        vUcErmitteln := TRUE; 
      ELSE
        AddError('Die Betriebssttte hat einen wechselnden Standort. Deshalb wird sie nicht an das Betriebsregister bertragen.');     
        vUcErmitteln := FALSE; 
        pRes := -1;
      END IF;
      
      IF vUcErmitteln THEN

        CASE ExistsBaZirkus() 
        WHEN 0 THEN -- aktuell kein Zirkus vorhanden
          NULL;
        WHEN 2 THEN -- hatte und hat Zirkus 
          CASE ChkGKZ5()
          WHEN 0 THEN  -- im ZB 
            NULL; 

          WHEN 1 THEN -- ZB war und ist abweichend
            IF ZBR_AUS_DATA.vBatchMode THEN
              AddError('');
            ELSE 
              AddError('Der Betreiber der Betriebssttte Zirkus sitzt nicht im Zustndigkeitsbereich. Deshalb wird sie nicht an das Betriebsregister bertragen.');     
            END IF;
            vUcErmitteln := FALSE;  
            pRes := -1;       

          WHEN 2 THEN -- war und ist nicht mehr abweichend 
            NULL;

          WHEN 3 THEN -- war nicht und ist jetzt abweichend
            IF AbmeldenBa() > 0 THEN  -- alle nicht abgemeldeten BA abmelden
              AddWarning('Der Betreiber der Betriebssttte Zirkus sitzt nicht im Zustndigkeitsbereich. Deshalb werden alle Betriebsarten abgemeldet bertragen.');      
            END IF;
            vUcErmitteln := TRUE;
          ELSE 
            vUcErmitteln := TRUE;
          END CASE;
          /*IF ChkGKZ5() IN (0, 2, 3) THEN
            vUcErmitteln := TRUE;
          ELSE
            AddError('Der Betreiber der Betriebssttte Zirkus sitzt nicht im Zustndigkeitsbereich. Deshalb wird sie nicht an das Betriebsregister bertragen.');     
            vUcErmitteln := FALSE;         
          END IF;*/ 
          
        WHEN 1 THEN -- hatte nicht und hat jetzt Zirkus, wenn GKZ5 auerhalb dann alle BA abmelden
          CASE ChkGKZ5()
          WHEN 0 THEN  -- im ZB 
            vUcErmitteln := TRUE; 

          WHEN 1 THEN -- ZB war und ist abweichend
            IF AbmeldenBa() > 0 THEN  -- alle nicht abgemeldeten BA abmelden
              AddWarning('Der Betreiber der Betriebssttte Zirkus sitzt nicht im Zustndigkeitsbereich. Deshalb werden alle Betriebsarten abgemeldet bertragen.');      
            END IF;
            vUcErmitteln := TRUE;
            
          WHEN 2 THEN -- war und ist nicht mehr abweichend 
            vUcErmitteln := TRUE;

          WHEN 3 THEN -- war nicht und ist jetzt abweichend
            IF AbmeldenBa() > 0 THEN  -- alle nicht abgemeldeten BA abmelden
              AddWarning('Der Betreiber der Betriebssttte Zirkus sitzt nicht im Zustndigkeitsbereich. Deshalb werden alle Betriebsarten abgemeldet bertragen.');      
            END IF;
            vUcErmitteln := TRUE;
          ELSE 
            vUcErmitteln := TRUE;
          END CASE;
        ELSE 
          vUcErmitteln := TRUE;
        END CASE;
      END IF;
    
    END IF; -- vUcErmitteln
       
    IF vUcErmitteln THEN
      -- todo 58864090: ABMELD_BTR wird nicht mehr gefeuert 
      --IF ABMELD_BTR() = 1 THEN -- Abmeldung einer BTS
      --  InsUsc2();       
      --END IF;

      IF AEND_BEZ_BTR() = 1 THEN -- ndern der Standortbezeichnung BTS
        InsUsc2();       
      END IF;

      -- ndern der Standortadresse der BTS, nur wenn nicht wechselnder Standort 
      IF vBTS1.Adr_btro.adr.wechsel <> 1 AND  AEND_STANDORT_BTR() = 1 THEN 
        InsUsc2();       
      END IF;

      IF KOM_BTR() = 1 THEN -- ndern der Kommunikationsmittel der BTS
        --PIPE ROW(vUsc);
        InsUsc2();    
      END IF;
      
      -- Betriebsarten
      --IF BA() > 0 THEN NULL; END IF;
      IF BaGroup() > 0 THEN NULL; END IF;
      
      -- Beginn Betreiber --------------------------------------------------------
      
      CASE AEND_BETREI()  
      WHEN 1 THEN -- Betreiberwechsel
        InsUsc2();      
      WHEN 2 THEN -- Betreiberwechsel und alle anderen Usecases verzgern
        vtUsc := ZBR_AUS_DATA.tbUsc();
        pUpdLastModified := False;
        AddWarning('Der neue Betreiber ist im Register noch nicht registriert. nderungen knnen deshalb noch nicht bertragen werden.'); 
        pRes := -1;
      ELSE

        IF AEND_NAME_BETREI() = 1 THEN -- ndern Bezeichnung des Betreibers
          InsUsc2();       
        END IF;      
            
        IF AEND_POST_ADR_BETREI() = 1 THEN -- ndern der Postadresse des Betreibers
          InsUsc2();       
        END IF;
            
        IF KOM_BETREI() = 1 THEN -- ndern der Kommunikationsmittel des Betreibers
          InsUsc2();       
        END IF; 
      
      END CASE;

    END IF;  -- wechselnder Standort
  END IF;
    
  RETURN vtUsc;
END CreateUsecase2;


--FUNCTION GetUsecases(pD0101_ID IN ZBR_AUS_DATA.tID
--, pUserSID IN PLS_INTEGER, pMandant IN PLS_INTEGER
--, pLastModified IN DATE) RETURN ZBR_AUS_DATA.tbUsc PIPELINED AS
--v1 ZBR_AUS_DATA.tbUsc;
--BEGIN 
--  v1 := CreateUsecase2( pD0101_ID, pUserSID, pMandant, pLastModified );
--  IF v1.COUNT > 0 THEN
--    FOR i IN v1.FIRST .. v1.LAST LOOP
--      PIPE ROW(v1(i));
--    END LOOP; 
--  END IF;
--  RETURN;
--END GetUsecases;


FUNCTION CreateUsecase( pD0101_ID IN ZBR_AUS_DATA.tID
, pUserSID IN PLS_INTEGER, pMandant IN PLS_INTEGER
, pLastModified IN DATE
, pUpdLastModified OUT BOOLEAN ) RETURN PLS_INTEGER AS
 vRes PLS_INTEGER := 0;
 vUsc ZBR_AUS_DATA.tbUsc;
  
BEGIN

    vUsc := CreateUsecase2( pD0101_ID, pUserSID, pMandant, pLastModified, pUpdLastModified, vRes );
    IF vRes = 0 THEN
      vRes := vUsc.COUNT;
    END IF;
    
    IF vUsc IS NOT NULL AND vUsc.COUNT > 0 THEN
      
      FORALL iUsc IN vUsc.FIRST .. vUsc.LAST 
        INSERT INTO aus_d_usecase
        ( ID, D_BTS_ID, D0101_ID, USECASE, 
        MANDANT, USER_SID, LASTMODIFIED, 
        GUELTIG_VON, GUELTIG_BIS, AEND_ART, 
        AEND_GRUND, AEND_BEM, ALTER_WERT, NEUER_WERT, 
        D_BTS_ID2, REF_ID, REF_ID_ALT )
        VALUES (
        vUsc(iUsc).ID, vUsc(iUsc).D_BTS_ID, vUsc(iUsc).D0101_ID, vUsc(iUsc).USECASE, 
        vUsc(iUsc).MANDANT, vUsc(iUsc).USER_SID, vUsc(iUsc).LASTMODIFIED, 
        vUsc(iUsc).GUELTIG_VON, vUsc(iUsc).GUELTIG_BIS, vUsc(iUsc).AEND_ART, 
        vUsc(iUsc).AEND_GRUND, vUsc(iUsc).AEND_BEM, vUsc(iUsc).ALTER_WERT, vUsc(iUsc).NEUER_WERT, 
        vUsc(iUsc).D_BTS_ID2, vUsc(iUsc).REF_ID, vUsc(iUsc).REF_ID_ALT );      
      
    --ELSE 
    --  vRes := 0;        
    END IF;
 
  RETURN vRes;
END CreateUsecase;

-- Aus Text Hausnr. und Zusatz separieren
-- Prozedur ist nach blvUtils kopiert als SplitHsnr 
PROCEDURE SepHausNr(pText IN Varchar2, pNr OUT NOCOPY VARCHAR2, pZusatz OUT NOCOPY VARCHAR2) AS
  i2 PLS_INTEGER;
BEGIN
    
  IF pText IS NULL THEN
    pNr := NULL;
    pZusatz := NULL;
  ELSE
    i2 := 0;
    FOR i IN 1 .. LENGTH(pText) LOOP
      IF IsNumeric( SUBSTR(pText, i, 1)) = 1 THEN
        i2 := i;
      ELSE
        EXIT;
      END IF;
        
    END LOOP;
      
    IF i2 > 0 THEN
      pNr := SUBSTR(pText, 1, i2);
      pZusatz := SUBSTR(pText, i2+1);
    ELSE
      pNr := pText;
      pZusatz := NULL;
    END IF;        
    
  END IF;
     
END SepHausNr;
  
-- aus Name, Vorname und Titel bezeichnung erzeugen
-- pNName
-- pVName
-- pTitel
-- pLen
FUNCTION PersBez(pNName IN VARCHAR2, pVName IN VARCHAR2, pTitel IN VARCHAR2, pLen PLS_INTEGER) RETURN VARCHAR2 AS
BEGIN
  RETURN SUBSTR( PersBez(pNName, pVName, pTitel), 1,pLen);
END PersBez;


FUNCTION PersBez(pNName IN VARCHAR2, pVName IN VARCHAR2, pTitel IN VARCHAR2) RETURN VARCHAR2 AS
  vRes VARCHAR2(200);
BEGIN

  vRes := pNName;
  vRes := vRes || CASE WHEN vRes IS NOT NULL AND pVName IS NOT NULL THEN ', ' END || pVName;
  vRes := vRes || CASE WHEN vRes IS NOT NULL AND pTitel IS NOT NULL THEN ', ' END || pTitel;   
  
  RETURN vRes;
  
END PersBez;
  
FUNCTION fD_PERSON( pID IN VARCHAR2, pANREDE IN VARCHAR2, pBEZEICHNUNG IN VARCHAR2, 
                    pBEZEICHNUNG2 IN VARCHAR2, pGEBURTSDATUM IN DATE, pGEBURTSORT IN VARCHAR2, 
                    pKURZBEZ1 IN VARCHAR2, pKURZBEZ2 IN VARCHAR2, 
                    pNACHNAME IN VARCHAR2, pVorsatz_nachname IN VARCHAR2, pNachsatz_nachname IN VARCHAR2, 
                    pRECHTSFORM IN VARCHAR2, pTITEL IN VARCHAR2, pVORNAME IN VARCHAR2, pTyp IN VARCHAR2, pPers_ID IN VARCHAR2, pRef_ID IN VARCHAR2)
RETURN VARCHAR2 AS 
  vKurzBez1 aus_d_person.kurzbez1%TYPE := NULL;
  vKurzBez2 aus_d_person.kurzbez2%TYPE := NULL;
  vPers_ID aus_d_person.pers_id%TYPE;
BEGIN
  ZBR_AUS_DATA.vID := GET_ID(pID);
  vPers_ID := NVL(pPERS_ID, '0');
  -- natrliche Person 
  IF pTyp = 'NP' THEN
    IF pKurzbez1 IS NULL THEN
      vKurzBez1 := PersBez(pNachname, pVorname, pTitel);

      IF LENGTH(vKurzBez1) > 30 THEN
        vKurzBez1 := NULL;
      --IF LENGTH( pNachname || ', ' || pVORNAME) <= 30 THEN
      --  vKurzBez1 := pNachname || ', ' || pVORNAME;
      END IF;
    ELSE
      IF pKurzbez1 <> '#' THEN
        vKurzbez1 := pKurzbez1;
        vKurzBez2 := pKurzbez2;
      END IF;
    END IF;
    
    INSERT INTO AUS_D_PERSON (ID, ANREDE, BEZEICHNUNG, BEZEICHNUNG2, GEBURTSDATUM, GEBURTSORT,KURZBEZ1, KURZBEZ2, NACHNAME, vorsatz_nachname, nachsatz_nachname, RECHTSFORM, TITEL, VORNAME, Typ, PERS_ID, REF_ID)
    VALUES ( ZBR_AUS_DATA.vID , pANREDE , NULL, NULL, pGEBURTSDATUM, pGEBURTSORT, vKURZBEZ1, vKURZBEZ2, pNACHNAME, pVorsatz_nachname, pNachsatz_nachname, NULL, pTITEL, pVORNAME, pTyp, vPers_ID, pRef_ID );  

  ELSE -- juristische Person

    INSERT INTO AUS_D_PERSON (ID, ANREDE, BEZEICHNUNG, BEZEICHNUNG2, GEBURTSDATUM, GEBURTSORT,KURZBEZ1, KURZBEZ2, NACHNAME, RECHTSFORM, TITEL, VORNAME, Typ, PERS_ID, REF_ID)
    VALUES ( ZBR_AUS_DATA.vID , NULL , pBEZEICHNUNG, pBEZEICHNUNG2, NULL, NULL, pKURZBEZ1, pKURZBEZ2, NULL, pRECHTSFORM, NULL, NULL, pTyp, vPers_ID, pREF_ID );  
    
  END IF;
    
  RETURN ZBR_AUS_DATA.vID;
END fD_PERSON; 

FUNCTION PersNachname(pNName IN VARCHAR2, pVorsatz IN VARCHAR2, pNachsatz IN VARCHAR2) RETURN VARCHAR2 AS
  vRes VARCHAR2(200);
BEGIN

  vRes := TRIM(pVorsatz || ' ' || pNName);
  IF pNachsatz IS NOT NULL THEN
    vRes := vRes || ', ' || pNachsatz;
  END IF;
  
  RETURN vRes;
  
END PersNachname;

-- einen kompletten Namen erzeugen 
-- in der Form Nachname, Vorname Vorsatz, Nachsatz, Titel 
FUNCTION CreatePersonBez(pNName IN VARCHAR2, pVName IN VARCHAR2,
                         pVorsatz IN VARCHAR2, pNachsatz  IN VARCHAR2, 
                         pTitel IN VARCHAR2) RETURN VARCHAR2 AS
BEGIN
  RETURN PNName ||
       CASE WHEN pVName || pVorsatz IS NOT NULL THEN  ', ' || TRIM(pVName || ' ' || pVorsatz) END || 
       CASE WHEN pNachsatz IS NOT NULL THEN  ', ' || pNachsatz END || 
       CASE WHEN pTitel IS NOT NULL THEN ', ' || pTitel END;
END CreatePersonBez;


  
FUNCTION fD_Postadresse( pSTAAT IN VARCHAR2, pPLZ IN VARCHAR2,                        
pORT IN VARCHAR2, pORTSTEIL IN VARCHAR2, pPostfach_JN IN NUMBER, pPOSTFACH IN VARCHAR2, 
pSTRASSE IN VARCHAR2, pHAUSNR IN VARCHAR2, pHausnrzusatz IN VARCHAR2) RETURN VARCHAR2 AS 
  
  vNr AUS_D_POSTADRESSE.HAUSNR%TYPE;
  vZusatz AUS_D_POSTADRESSE.HAUSNRZUSATZ%TYPE;
BEGIN

  IF  pSTAAT IS NULL AND 
      pPLZ IS NULL AND                        
      pORT IS NULL AND
      pORTSTEIL IS NULL AND
      pPOSTFACH IS NULL AND
      pSTRASSE IS NULL AND 
      pHAUSNR IS NULL AND
      pHausnrzusatz IS NULL THEN
  
    ZBR_AUS_DATA.vID := NULL;
  ELSE  
  
    ZBR_AUS_DATA.vID := SYS_GUID();
    IF pPostfach_jn = 0 THEN
      SepHausNr(pHausnr, vNr, vZusatz); -- Aufteilung Hausnr und Zusatz
      IF pHausnrzusatz IS NOT NULL THEN -- Hausnrzusatz gewinnt immer
        vZusatz := pHausnrzusatz;
      END IF; 
    END IF;
    
    INSERT INTO AUS_D_Postadresse (ID , HAUSNR , HAUSNRZUSATZ , PLZ, ORT , ORTSTEIL , POSTFACH , STAAT , STRASSE, POSTFACH_JN)
    VALUES (ZBR_AUS_DATA.vID , vNr , vZusatz , pPLZ, pORT , pORTSTEIL , pPOSTFACH , pSTAAT , pSTRASSE, pPostfach_JN);
  
  END IF;

  RETURN ZBR_AUS_DATA.vID;

END fD_Postadresse;    

FUNCTION fD_Verwaltung( pGKZ VARCHAR2, pREGIONALSCHLUESSEL VARCHAR2, pSTAAT VARCHAR2)
RETURN VARCHAR2 AS 
  vVerw aus_d_verwaltung%ROWTYPE;
BEGIN
 ZBR_AUS_DATA.vID := NULL;

  
  --IF pGKZ IS NULL AND pREGIONALSCHLUESSEL IS NULL AND pSTAAT IS NULL THEN
  IF pStaat = '276' THEN -- todo 62246090
    
    ZBR_AUS_DATA.vID := SYS_GUID();
    vVerw.ID := ZBR_AUS_DATA.vID;
    vVerw.BEZIRK := SUBSTR(pGKZ, 3,1) ;
    vVerw.BUNDESLAND := SUBSTR(pGKZ,1,2);
    -- todo 62246090 IF ZBR_AUS_DATA.vErstMode AND LENGTH(pGKZ) = 5 THEN
      vVerw.GKZ := RPAD(pGKZ, 8, '0');
    --ELSE
    --  vVerw.GKZ := pGKZ;
    --END IF;
    vVerw.KREIS := SUBSTR(pGKZ,4,2);
    vVerw.REGIONALSCHLUESSEL := pREGIONALSCHLUESSEL;
    vVerw.STAAT := pSTAAT;
    vVerw.GEMEINDE := SUBSTR(pGKZ,6,3);

    INSERT INTO AUS_D_Verwaltung ( ID, BEZIRK ,BUNDESLAND, GKZ, KREIS ,REGIONALSCHLUESSEL, STAAT, GEMEINDE )
    VALUES(  vVerw.ID
        ,vVerw.BEZIRK 
        ,vVerw.BUNDESLAND
        ,vVerw.GKZ
        ,vVerw.KREIS
        ,vVerw.REGIONALSCHLUESSEL
        ,vVerw.STAAT
        ,vVerw.GEMEINDE );

  END IF;

  RETURN ZBR_AUS_DATA.vID;

END fD_Verwaltung;   
  
FUNCTION fD_Kataster( pFLURNUMMER VARCHAR2, pFLURSTUECK VARCHAR2, pGEMARKUNG VARCHAR2, pX_Wert FLOAT, pY_Wert FLOAT, pRechtswert FLOAT, pHochwert FLOAT)
RETURN VARCHAR2 AS 
BEGIN

  IF pFLURNUMMER IS NULL AND 
    pFLURSTUECK  IS NULL AND 
    pGEMARKUNG IS NULL AND 
    pX_Wert IS NULL AND 
    pY_Wert IS NULL AND 
    pHOCHWERT IS NULL AND
    pRECHTSWERT IS NULL THEN 
    
    ZBR_AUS_DATA.vID := NULL;

  ELSE      
    
    ZBR_AUS_DATA.vID := SYS_GUID();
    INSERT INTO AUS_D_Kataster ( ID, FLURNUMMER, FLURSTUECK, GEMARKUNG, X_WERT, Y_WERT, HOCHWERT, RECHTSWERT)
    VALUES (ZBR_AUS_DATA.vID, pFLURNUMMER, pFLURSTUECK, pGEMARKUNG, pX_Wert, pY_Wert, pHOCHWERT, pRECHTSWERT);
  END IF;
  RETURN ZBR_AUS_DATA.vID;
END fD_Kataster; 
  
--FUNCTION fD_Adr_komplett( pID VARCHAR2, pBEZIRK IN VARCHAR2, pBUNDESLAND IN VARCHAR2, pGKZ8 IN VARCHAR2, pKREIS IN VARCHAR2, pREGIONALSCHLUESSEL IN VARCHAR2, pSTAAT IN VARCHAR2, pGemeinde IN VARCHAR2,
--                          pFLURNUMMER IN VARCHAR2, pFLURSTUECK IN VARCHAR2, pGEMARKUNG IN VARCHAR2, pX_Wert IN FLOAT, pY_Wert FLOAT, pRechtswert IN FLOAT, pHochwert IN FLOAT,
--                          pLand IN VARCHAR2, pPLZ IN VARCHAR2, pORT IN VARCHAR2, pORTSTEIL IN VARCHAR2, pPOSTFACH IN VARCHAR2, pSTRASSE IN VARCHAR2, pHAUSNR IN VARCHAR2, pHAUSNRZUSATZ IN VARCHAR2, pWechsel IN NUMBER)
--RETURN VARCHAR2 AS 
--  vID VARCHAR2(32);
--
--BEGIN
--  
--    ZBR_AUS_DATA.vVerwID := fD_Verwaltung(NULL, pBEZIRK, pBundesland, pGKZ8, pKREIS, pRegionalschluessel, pStaat, pGemeinde);          
--    -- Kataster
--    ZBR_AUS_DATA.vKatID := fD_Kataster(NULL, NULL, pFLURSTUECK, pGEMARKUNG, pX_Wert, pY_Wert, pRECHTSWERT, pHOCHWERT );      
--    -- Standortadresse
--    ZBR_AUS_DATA.vPostID := fD_Postadresse(NULL, pLand, pPlz, pORT, pORTSTEIL , pPOSTFACH , pSTRASSE, pHAUSNR, pHAUSNRZUSATZ );
--    -- D_ADRESSE
--    ZBR_AUS_DATA.vID := GET_ID(pID);
--    INSERT INTO aus_d_adresse ( ID, FREIBEZ, WECHSEL, D_KAT_ID, D_PADR_ID, D_VERW_ID, gueltig_von)
--    VALUES (ZBR_AUS_DATA.vID, NULL, NULL, ZBR_AUS_DATA.vKatID, ZBR_AUS_DATA.vPostID, ZBR_AUS_DATA.vVerwID, ZBR_AUS_DATA.vLastUpddate);
--    RETURN ZBR_AUS_DATA.vID;   
--END fD_Adr_komplett;
  
PROCEDURE pD_Reg_komplett( pD0101_ID VARCHAR2, pPersonID VARCHAR2, pFunkID VARCHAR2, pBTS_ID VARCHAR2) AS
  vID VARCHAR2(32);

  TYPE tNummern IS TABLE OF VARCHAR2(75);
  tbNummern tNummern := tNummern();
  v1 VARCHAR2(75);
  vBiExists PLS_INTEGER := 0;  

TYPE tReg IS RECORD (
  nummer vis_d010102.nummer%TYPE,
  gueltig_von vis_d010102.gueltig_von%TYPE,
  gueltig_bis vis_d010102.gueltig_bis%TYPE,
  a010145_code vis_a010145.code%TYPE,
  art aus_d_registrierung.art%TYPE,
  zusatz vis_d010102.bem%TYPE,
  ref_id vis_d010102.id%TYPE);

TYPE tbReg IS TABLE OF tReg;
vReg tbReg;
 
-- NRW zustzl. als BA exportieren 
vBTA_ID aus_d_betriebsart.id%TYPE;
TYPE tBA IS RECORD (
  code aus_d_betriebsart.code%TYPE,
  bez aus_d_betriebsart.bez%TYPE,
  art aus_d_betriebsart.art%TYPE,
  gueltig_von aus_d_betriebsart.gueltig_von%TYPE,
  gueltig_bis aus_d_betriebsart.gueltig_bis%TYPE,
  ref_id aus_d_betriebsart.ref_id%TYPE,
  fb aus_d_betriebsart.fachbereich%type);
   
TYPE tbBA IS TABLE OF tBA;
vBA tbBA := tbBA();
vBApos PLS_INTEGER := 0;
vZusatz aus_d_registrierung.zusatz%TYPE;
 
BEGIN   
 
  IF vVerfahren = QUELLE_IDV_NRW /*vGKZ2 = ZBR_AUS_DATA.NRW*/ THEN
    
    vBA.EXTEND(3);
    vBA(1).gueltig_bis := ZBR_AUS_DATA.vDATEMIN;
    vBA(2).gueltig_bis := ZBR_AUS_DATA.vDATEMIN;
    vBA(3).gueltig_bis := ZBR_AUS_DATA.vDATEMIN;

    SELECT dx.* BULK COLLECT INTO vReg
    FROM (
      SELECT d010102.nummer 
           , d010102.gueltig_von gueltig_von
           , d010102.gueltig_bis
           , a010145_code
           , CASE WHEN d010102.a010145_skz = 10 THEN
                CASE d010102.a010145_code 
                WHEN '0104' THEN 'TSK' 
                WHEN '0118' THEN 'INVEKOS'
                WHEN '01901301' THEN 'IDV'
                WHEN '01901302' THEN 'IDV-INH'
                WHEN '0102' THEN 'BI'
                WHEN '0103' THEN 'BI'  -- Betreiber-ID als BI ausgeben
                WHEN '010201' THEN 'UI'
                WHEN '010202' THEN 'PI'
                ELSE NULL                 
                END 
             WHEN d010102.a010145_skz = 60 AND d010102.a010145_code LIKE '0111%' THEN 'FMZULNR'               
             --17.08.2015 WHEN d010102.a010145_skz = 70 AND d010102.a010145_code LIKE '021104%' THEN 'FMZULREG'
             WHEN d010102.a010145_sid = 1459001 THEN 'BA' -- code 010417
             ELSE NULL  
             END art
           , D010102.BEM zusatz
           , d010102.id ref_id
      -- 15.05.2012 VIS_VD010102 ausgetauscht gegen VIS_VD010102$01
      -- bei Abmeldung sind sonst keine Reg.-Nr. im Ausgangskorb     
      FROM VIS_VD010102$01 d010102 
      WHERE d010102.d0101_id = pD0101_ID        
       AND ( 
          (d010102.a010145_code IN ( '0104', '0118', '01901301', '01901302') 
             AND d010102.a010145_skz = 10 ) OR
            (d010102.a010145_code LIKE '011103%' AND d010102.a010145_skz = 60) --OR  -- FM Zul.         
            --17.08.2015 (d010102.a010145_code LIKE '021104%' AND d010102.a010145_skz = 70) -- FM Reg.           
          )               
           
     UNION ALL
     SELECT d0101.code
          , d0101.anmeldung
          , d0101.abmeldung
          , NULL code
          , 'BALVI' art
          , NULL zusatz
          , d0101.id ref_id
     FROM vis_d0101 d0101 
     WHERE id = pD0101_ID
       AND d0101.code IS NOT NULL
      ORDER BY gueltig_bis DESC NULLS FIRST 
    ) dx;
    
  ELSE -- TH
  
    SELECT dx.* BULK COLLECT INTO vReg
    FROM (
      SELECT 
             d010102.nummer nummer                         
           , d010102.gueltig_von gueltig_von           
           , d010102.gueltig_bis gueltig_bis           
           , d010102.a010145_code
           , CASE WHEN d010102.a010145_skz = 10 THEN
                CASE d010102.a010145_code 
                WHEN '0104' THEN 'TSK' 
                --WHEN '0118' THEN 'INVEKOS'
                --WHEN '01901301' THEN 'IDV'
                --WHEN '01901302' THEN 'IDV-INH'
                WHEN '0102' THEN 'BI'
                WHEN '0103' THEN 'BI'  -- Betreiber-ID als BI ausgeben
                WHEN '010201' THEN 'UI'
                WHEN '010202' THEN 'PI'
                ELSE NULL                 
                END 
             ELSE NULL  
             END art
           , D010102.BEM zusatz
           , d010102.id ref_id
      -- 15.05.2012 VIS_VD010102 ausgetauscht gegen VIS_VD010102$01
      -- bei Abmeldung sind sonst keine Reg.-Nr. im Ausgangskorb     
      FROM VIS_VD010102$01 d010102 
      WHERE d010102.d0101_id = pD0101_ID  
        AND d010102.a010145_sid IN ( 
          A010145_HIT_NR, 1576001, 1574001, 541001,
          CASE WHEN pFunkID IS NOT NULL THEN A010145_BETREIBER_ID END 
          )
          --sid       code      skz del bez
          --514001    0102      10  0   Registriernummer (HIT)
          --1576001   010201    10  -1  Unternehmen-Ident Nr.
          --1574001   010202    10  -1  Person-Ident Nr.
          --541001    0104      10  0   TSK-Nr.
          --1459001   010417    30  0   Ermchtigung zur Ausstellung von Heimtierausweisen und Entnahme von Blutpr. zur Titrierung Tollwutantik. gem. VO (EU) 576/2013
          --1606001   0103      10  0   Betreiber_ID (Betriebsregister)
          --1330001   01042103  60  0   Zulassung Transportunternehmen nach Art. 10 Abs. 1 VO (EG) Nr. 1/2005
          --1331001   01042104  60  0   Zulassung Transportunternehmen (lange Befrderungen) nach Art. 11 Abs. 1 VO (EG) Nr. 1/2005          
          --1135001   01042101  60  0   Zulassung Transportunternehmer nach  13 ViehVerkV u. Art. 10 Abs. 1 VO (EG) 1/2005
          --1136001   01042102  60  0   Zulassung Transportunternehmer (lange Befrderungen) nach  13 ViehVerkV u. Art. 11 Abs. 1 VO (EG) 1/2005
     ---------------------------------------------------------------------------
     -- Zulassungen Transportunternehmen und Heimtierpass
     UNION ALL
        SELECT dx.nummer, dx.gueltig_von, dx.gueltig_bis, dx.a010145_code, dx.art, dx.zusatz, dx.ref_id FROM (
          SELECT DISTINCT
             -- Zulassungen ohne Nummern, damit doppelte Zulassungen nicht doppelt als BA angelegt werden
             NULL nummer                         
           , FIRST_VALUE( d010102.gueltig_von ) OVER 
              ( PARTITION BY 
                  CASE 
                  WHEN d010102.deleted <> 0 THEN NULL
                  WHEN d010102.a010145_sid IN( 1459001 ) THEN 'BTA1' -- code 010417
                  WHEN d010102.a010145_sid IN( 1330001, 1135001 ) THEN 'BTA2' -- code 01042103, 01042101
                  WHEN d010102.a010145_sid IN( 1331001, 1136001 ) THEN 'BTA3' -- code 01042104, 01042102
                  END 
                ORDER BY d010102.gueltig_von )
             gueltig_von
           
           , FIRST_VALUE( d010102.gueltig_bis ) OVER 
              ( PARTITION BY 
                  CASE 
                  WHEN d010102.deleted <> 0 THEN NULL
                  WHEN d010102.a010145_sid IN( 1459001 ) THEN 'BTA1' -- code 010417
                  WHEN d010102.a010145_sid IN( 1330001, 1135001 ) THEN 'BTA2' -- code 01042103, 01042101
                  WHEN d010102.a010145_sid IN( 1331001, 1136001 ) THEN 'BTA3' -- code 01042104, 01042102
                  END 
                ORDER BY d010102.gueltig_bis DESC NULLS FIRST )
             gueltig_bis
             
           , FIRST_VALUE( a010145.code ) OVER 
              ( PARTITION BY 
                  CASE 
                  WHEN d010102.a010145_sid IN( 1459001 ) THEN 'BTA1' -- code 010417
                  WHEN d010102.a010145_sid IN( 1330001, 1135001 ) THEN 'BTA2' -- code 01042103, 01042101
                  WHEN d010102.a010145_sid IN( 1331001, 1136001 ) THEN 'BTA3' -- code 01042104, 01042102
                  END 
                ORDER BY d010102.ins_date NULLS FIRST )    
             a010145_code       
           , CASE 
             WHEN d010102.deleted <> 0 THEN NULL
             WHEN d010102.a010145_sid IN( 1459001 ) THEN 'BTA1' -- code 010417
             WHEN d010102.a010145_sid IN( 1330001, 1135001 ) THEN 'BTA2' -- code 01042103, 01042101
             WHEN d010102.a010145_sid IN( 1331001, 1136001 ) THEN 'BTA3' -- code 01042104, 01042102 
             END art
           --, D010102.BEM zusatz
           ,NULL zusatz         
           --, d010102.id ref_id
           , FIRST_VALUE( d010102.id ) OVER 
              ( PARTITION BY 
                  CASE 
                  WHEN d010102.a010145_sid IN( 1459001 ) THEN 'BTA1' -- code 010417
                  WHEN d010102.a010145_sid IN( 1330001, 1135001 ) THEN 'BTA2' -- code 01042103, 01042101
                  WHEN d010102.a010145_sid IN( 1331001, 1136001 ) THEN 'BTA3' -- code 01042104, 01042102
                  END 
                ORDER BY d010102.ins_date NULLS FIRST ) 
              ref_id          
          FROM --VIS_VD010102$01 d010102 
               VIS_D010102 d010102, VIS_A010145 A010145, VIS_A0302 a2      
          WHERE d010102.a010145_sid = a010145.sid AND d010102.a0302_05_sid = a2.sid AND (a2.abgeschlossen = 1 OR a2.SID = -1) 
            --AND d010102.DELETED > -2 gelschte verwenden damit REF_ID bei Wiederholung gleich bleibt
            AND d010102.d0101_id = pD0101_ID  
            AND d010102.a010145_sid IN ( 1459001, 1330001, 1331001, 1135001, 1136001 )
              --sid       code      skz del bez
              --1459001   010417    30  0   Ermchtigung zur Ausstellung von Heimtierausweisen und Entnahme von Blutpr. zur Titrierung Tollwutantik. gem. VO (EU) 576/2013
              --1330001   01042103  60  0   Zulassung Transportunternehmen nach Art. 10 Abs. 1 VO (EG) Nr. 1/2005
              --1331001   01042104  60  0   Zulassung Transportunternehmen (lange Befrderungen) nach Art. 11 Abs. 1 VO (EG) Nr. 1/2005          
              --1135001   01042101  60  0   Zulassung Transportunternehmer nach  13 ViehVerkV u. Art. 10 Abs. 1 VO (EG) 1/2005
              --1136001   01042102  60  0   Zulassung Transportunternehmer (lange Befrderungen) nach  13 ViehVerkV u. Art. 11 Abs. 1 VO (EG) 1/2005
        ) dx WHERE dx.art IS NOT NULL
     -- Ende Zulassung Transportunternehmen / Heimtierpass
     ---------------------------------------------------------------------------            
     UNION ALL
     SELECT d0101.code
          , d0101.anmeldung
          , d0101.abmeldung
          , NULL code
          , 'BALVI' art
          , NULL zusatz
          , d0101.id ref_id
     FROM vis_d0101 d0101 
     WHERE id = pD0101_ID
      AND d0101.code IS NOT NULL
    ORDER BY gueltig_bis DESC NULLS FIRST        
    ) dx;

  END IF;
  
  IF vReg.COUNT > 0 THEN
    FOR iReg IN vReg.FIRST .. vReg.LAST LOOP    
    
      v1 :=  vReg(iReg).Art|| CHR(9) || vReg(iReg).Nummer;
      IF v1 NOT MEMBER OF tbNummern THEN -- wegen doppelter Nummern z.B. 0102 und 0103 bei Betreibern
        -- Nummer merken
        tbNummern.EXTEND;
        tbNummern(tbNummern.LAST) := v1; 
        
        IF vReg(iReg).art LIKE 'BTA%' THEN
                              
          vBApos := vBApos + 1;
          IF vBA.count < vBApos THEN
            vBA.EXTEND;
          END IF;

          vBA(vBApos).code         := '89' || vReg(iReg).a010145_code; 
          vBA(vBApos).gueltig_von  := vReg(iReg).gueltig_von;
          vBA(vBApos).gueltig_bis  := vReg(iReg).gueltig_bis;
          vBA(vBApos).ref_id       := vReg(iReg).ref_id;
          
          CASE vReg(iReg).art
          WHEN 'BTA1' THEN
            vBA(vBApos).bez          := 'Heimtierpass';
            vBA(vBApos).art          := 'HIT';
            vBA(vBApos).fb           := 'VET'; 
          WHEN 'BTA2' THEN
            vBA(vBApos).bez          := 'Transporteur, gem VO(EG) 1/2005 Art.10 - normale Befrderungsdauer';
            vBA(vBApos).art          := 'HIT';
            vBA(vBApos).fb           := 'VET'; 
          WHEN 'BTA3' THEN
            vBA(vBApos).bez          := 'Transporteur, gem VO(EG) 1/2005 Art.11 - lange Befrderungsdauer';
            vBA(vBApos).art          := 'HIT';
            vBA(vBApos).fb           := 'VET'; 
          END CASE;  
          CONTINUE;  
        END IF;        
        
        IF NOT (vBiExists = 1 AND vReg(iReg).ART = 'BI') THEN
              
          -- in TH keine Registrierungen ohne Nummern anlegen
          IF vVerfahren = QUELLE_IDV_NRW /*vGKZ2 = ZBR_AUS_DATA.NRW*/ OR vReg(iReg).nummer IS NOT NULL THEN
        
            vID := SYS_GUID();
            vZusatz := SUBSTR(vReg(iReg).zusatz, 1, 255);
            INSERT INTO aus_d_registrierung (ID, ART, CODE, NUMMER, ZUSATZ, GUELTIG_VON, GUELTIG_BIS, ref_id)
            VALUES( vID, vReg(iReg).art, vReg(iReg).a010145_code, vReg(iReg).nummer, vZusatz, vReg(iReg).gueltig_von, vReg(iReg).gueltig_bis, vReg(iReg).ref_id);
                 
            IF pPersonID IS NOT NULL THEN 
              INSERT INTO AUS_R_PERS_REG (D_PERS_ID, D_REG_ID) VALUES (pPersonID, vID);
            END IF;

            IF pFunkID IS NOT NULL THEN 
              INSERT INTO AUS_R_FKT_REG (D_FKT_ID, D_REG_ID) VALUES (pFunkID, vID);
            END IF;

            IF pBTS_ID IS NOT NULL THEN 
              INSERT INTO AUS_R_BTS_REG (D_BTS_ID, D_REG_ID) VALUES (pBTS_ID, vID);
            END IF; 
                   
          END IF;
          
          -- NRW zustzl. als BA exportieren
          --011103* ZU10 (nur auswhlbare)
          --02110401* R51
          --02110402* R52
          IF vVerfahren = QUELLE_IDV_NRW /*vGKZ2 = ZBR_AUS_DATA.NRW*/ THEN
            DECLARE
            PROCEDURE Proc1(p1 IN OUT NOCOPY tBA) AS
            BEGIN
              IF p1.gueltig_von IS NULL 
              OR p1.gueltig_von > vReg(iReg).gueltig_von THEN
                p1.gueltig_von := vReg(iReg).gueltig_von;
              END IF;
              
              p1.gueltig_bis := GREATEST(p1.gueltig_bis, vReg(iReg).gueltig_bis);
              
            END;
            BEGIN
              CASE 
              WHEN vReg(iReg).a010145_code LIKE '011103%' THEN
                vBA(1).code := 'ZU10';
                vBA(1).art := 'HFMUN';
                Proc1(vBA(1));                
              WHEN vReg(iReg).a010145_code LIKE '02110401%' THEN
                vBA(2).code := 'R51';
                vBA(2).art := 'HFMUN';
                Proc1(vBA(2));
              WHEN vReg(iReg).a010145_code LIKE '02110402%' THEN
                vBA(3).code := 'R52';
                vBA(3).art := 'HFMUN';
                Proc1(vBA(3));                
              ELSE NULL;
              END CASE;
            END;
          
          END IF;          
        END IF;
        
        IF vReg(iReg).ART = 'BI' THEN
          vBiExists := 1;
        END IF;
        
      END IF;

    END LOOP;
    
    IF pBTS_ID IS NOT NULL AND vBA.COUNT > 0 THEN

      FOR iBA IN vBA.FIRST .. vBA.LAST LOOP
        IF vBA(iBA).code IS NOT NULL THEN              
          vBTA_ID := SYS_GUID();
          INSERT INTO AUS_D_BETRIEBSART (ID, ART, CODE, BEZ, FACHBEREICH, D_BTS_ID, gueltig_von, gueltig_bis, ref_id, gewerbsmaessig)
          VALUES (vBTA_ID, vBA(iBA).art, vBA(iBA).code, vBA(iBA).bez, NVL(vBA(iBA).fb, 'NOT_VALID'), pBTS_ID, vBA(iBA).gueltig_von, vBA(iBA).gueltig_bis, vBA(iBA).ref_id, 0);
        END IF;    
      END LOOP;
      
    END IF;
  END IF;
END pD_Reg_komplett;
  
  
  
FUNCTION fD_Kom( pID VARCHAR2, pKOMDATA VARCHAR2, pKOMTYP VARCHAR2)
RETURN VARCHAR2 AS BEGIN
  IF pKomData IS NOT NULL THEN
    ZBR_AUS_DATA.vID := GET_ID(pID);
    INSERT INTO aus_d_kommunikation ( ID, KOMDATA, KOMTYP)
    VALUES( ZBR_AUS_DATA.vID, pKOMDATA, pKOMTYP);
  ELSE
    ZBR_AUS_DATA.vID := NULL;
  END IF;
  RETURN ZBR_AUS_DATA.vID;
END;

PROCEDURE pD_Kom_Ref(pRef VARCHAR2, pID VARCHAR2, pRefID VARCHAR2) AS 
BEGIN
  CASE 
  WHEN pRef LIKE '%P%' THEN
    INSERT INTO aus_r_pers_kom(D_KOM_ID, D_PERS_ID) VALUES( pID, pRefID);
  WHEN pRef LIKE '%F%' THEN
    INSERT INTO aus_r_fkt_kom(D_KOM_ID, D_Fkt_ID) VALUES( pID, pRefID);
  WHEN pRef LIKE '%B%' THEN
    INSERT INTO aus_r_bts_kom(D_KOM_ID, D_BTS_ID) VALUES( pID, pRefID);
  ELSE
    NULL;      
  END CASE;    
END;

  
PROCEDURE pD_Kom_komplett( pPersonID VARCHAR2, pFunkID VARCHAR2, pBTS_ID VARCHAR2, pTel VARCHAR2, pFax VARCHAR2, pMobil VARCHAR2, pEmail VARCHAR2, pInternet VARCHAR2, pSonst VARCHAR2) AS
  vID VARCHAR2(32);
  PROCEDURE Add_Ref AS
  BEGIN
    IF pPersonID IS NOT NULL THEN
      pD_Kom_Ref('P', vID, pPersonID);
    END IF;
    IF pFunkID IS NOT NULL THEN
      pD_Kom_Ref('F', vID, pFunkID);
    END IF;
    IF pBTS_ID IS NOT NULL THEN
      pD_Kom_Ref('B', vID, pBTS_ID);
    END IF;      
  END;
BEGIN   
  --vKomTelID := NULL;
  --vKomFaxID := NULL;
  --vKomEMailID := NULL;
  --vKomMobilID := NULL;
  --vKomInternet := NULL;  
  
  IF pTel IS NOT NULL THEN
    vID := fD_Kom(NULL, SUBSTR(pTel, 1, 25), 'TELEFON'); -- 10.10.2013 von 30 auf 25 gendert
    --vKomTelID := vID;
    Add_Ref();
  END IF;
  
  -- Fax
  IF pFax IS NOT NULL THEN
    vID := fD_Kom(NULL, pFax, 'FAX');
    --vKomFaxID := vID;
    Add_Ref();
  END IF;        
  
  -- Mobil
  IF pMobil IS NOT NULL THEN
    vID := fD_Kom(NULL, pMobil, 'MOBIL');
    --vKomMobilID := vID;
    Add_Ref();
  END IF;        

  -- EMail
  IF pEmail IS NOT NULL THEN
    vID := fD_Kom(NULL, pEmail, 'EMAIL');
    --vKomEMailID := vID;
    Add_Ref();
  END IF;              

  -- Internet
  IF vVerfahren = QUELLE_IDV_NRW /*vGKZ2 = ZBR_AUS_DATA.NRW*/ AND pInternet IS NOT NULL THEN
    vID := fD_Kom(NULL, pInternet, 'INTERNET');
    --vKomInternetID := vID;
    Add_Ref();
  END IF;              
  
END pD_Kom_komplett;

-- Status zu vis_d010102 anlegen
PROCEDURE InsertD0300( pD010102_ID IN ZBR_AUS_DATA.tID) AS 
--vBem vis_d0300.bem%TYPE;
vGuid ZBR_AUS_DATA.tID;
vSysdate CONSTANT DATE := SYSDATE; 
BEGIN
  IF pD010102_ID <> '-1' THEN
    vGUID := SYS_GUID();
    --vBem := 'Gltig bis: <' || TO_CHAR(pD010102_ID(i).Gueltig_bis, 'dd.mm.yyyy') || '> zu <leer>';
    INSERT INTO vis_d0300 ( ID, A0302_SID, MANDANT, CODE, CODEN, BEZ, /*BEM,*/ INS_USER, INS_DATE, UPD_USER, UPD_DATE, DELETED, DEL_USER, DEL_DATE, FB, ZB, REF_TABLE, REF_OBJ, REF_ID, DATUM, A0302_01_SID, D0101_ID, GUELTIG_VON, GUELTIG_BIS, DATUM2, BEM2, BEM3, DATUM3, BEZ2, BEZ3)
    SELECT vGUID --ID
    , d010102.A0302_05_SID   
    , d010102.mandant MANDANT
    , NULL CODE
    , NULL CODEN
    , (SELECT bez FROM vis_a0302 WHERE sid = d010102.a0302_05_sid ) BEZ  -- 36001
    --, vBem  BEM
    --, 'Gltig bis: <' || TO_CHAR(D010102.Gueltig_bis, 'dd.mm.yyyy') || '> zu <leer>' bem
    , d010102.UPD_USER INS_USER
    , vSYSDATE INS_DATE
    , d010102.UPD_USER
    , vSYSDATE UPD_DATE
    , 0 DELETED
    , -1 DEL_USER
    , NULL DEL_DATE
    , d010102.FB
    , d010102.ZB 
    , 'VIS_D010102' REF_TABLE
    , '1.01.02' REF_OBJ
    , D010102.ID REF_ID
    , vSYSDATE DATUM
    , -1 A0302_01_SID
    , d010102.D0101_ID D0101_ID
    , D010102.GUELTIG_VON_STAT GUELTIG_VON, D010102.GUELTIG_BIS_STAT GUELTIG_BIS, NULL DATUM2, NULL BEM2, NULL BEM3, NULL DATUM3, NULL BEZ2, NULL BEZ3  
    FROM vis_d010102 d010102
    WHERE id = pD010102_ID;
 
  END IF;
END InsertD0300;  

------------------------------------------------------------------------------
PROCEDURE pBA_Abt(pD0101_ID VARCHAR2, pBTS_ID VARCHAR2) AS
  vBTA_ID AUS_D_BETRIEBSART.ID%TYPE;
  vAbtID AUS_D_ABTEILUNG.ID%TYPE;
  TYPE tAbt IS RECORD ( D010101_ID ZBR_AUS_DATA.tID, ABT_ID ZBR_AUS_DATA.tID );
  TYPE tbAbt IS TABLE OF tAbt;
  Abt tbAbt := tbAbt();
  vVerwaltungID VARCHAR2(32);
  vKatasterID   VARCHAR2(32);
  vPostadrID    VARCHAR2(32);
  vBTRB_ID      VARCHAR2(32);
  vCode         VARCHAR2(128);
  vFachbereich  aus_d_betriebsart.fachbereich%TYPE;
  vBA_Angemeldet vis_d0101.anmeldung%TYPE := NULL;
  vBa_Abgemeldet vis_d010101.abgemeldet%TYPE := NULL;
  vBA_Abgem_Exists BOOLEAN := FALSE;
  v01_01_1753 CONSTANT DATE := zbr_aus_data.v01_01_1753; 
  vExists4551 BOOLEAN := False;
  vDefaFmZulReg aus_d_registrierung.nummer%TYPE := '055620320365'; -- todo 60394090 '053650320365';
  vMinAngemeldet DATE;  
  vMaxAbgemeldet DATE;  
  vReg_ID zbr_aus_data.tID := SYS_GUID();
  vSysdate DATE := SYSDATE;
  vSYS_Guid ZBR_AUS_DATA.tID;
  PROCEDURE Insert_BA( pD010101_ID IN VARCHAR2, pCode IN VARCHAR2, pMax_bez IN VARCHAR2, pMax_gewerbsmaessig IN NUMBER, pMax_Art IN VARCHAR2, pMin_Angemeldet IN DATE, pMax_abgemeldet IN DATE) AS
  BEGIN

    IF pmax_art = 'HIT' THEN
      IF pMin_angemeldet < ZBR_AUS_DATA.vD010101_HITgueltig_von THEN
        ZBR_AUS_DATA.vD010101_HITgueltig_von := pMin_angemeldet;
      END IF;
    END IF;  
     
    IF vBA_Angemeldet IS NULL THEN
      vBA_Angemeldet := pMin_Angemeldet;  -- 1. Anmeldedatum <> NULL
    ELSIF vBA_angemeldet > pMin_Angemeldet THEN   
      vBA_Angemeldet := pMin_Angemeldet;  -- lteste Anmeldedatum       
    END IF; 

   -- letzte Abmeldedatum, wenn NULL dann gibt es noch angemeldete BA's
    IF pMax_abgemeldet IS NULL OR NOT vBA_Abgem_Exists THEN
      vBA_abgemeldet := pMax_abgemeldet; -- Abmeldedatum = NULL, angemeldete BA vorh.
      vBA_Abgem_Exists := True;
    ELSIF vBA_abgemeldet < pMax_abgemeldet THEN
      vBA_abgemeldet := pMax_abgemeldet;  -- neuestes Abmeldedatum
      vBA_Abgem_Exists := True;
    END IF;    
    
    IF vVerfahren <> QUELLE_IDV_NRW /*vGKZ2 <> ZBR_AUS_DATA.NRW*/ OR vCode <> pCode THEN  -- Gruppierung nur in NRW sonst alle BA exportieren  
      vBTA_ID := SYS_GUID();
      INSERT INTO AUS_D_BETRIEBSART (ID, ART, CODE, BEZ, FACHBEREICH, D_BTS_ID, gueltig_von, gueltig_bis, ref_id, gewerbsmaessig)
      VALUES (vBTA_ID, pmax_art, pcode, pmax_bez, vFachbereich, pBTS_ID, pmin_angemeldet, pmax_abgemeldet, pd010101_id, pmax_gewerbsmaessig);
        
      vCode := pCode;
            
    END IF;
      
    -- Zuordnung zu Abteilungen prfen
    IF Abt.Count > 0 THEN
      FOR iAbt IN Abt.FIRST .. Abt.Last LOOP
        IF Abt(iAbt).d010101_id = pd010101_id THEN
          INSERT INTO aus_r_bta_abt (d_abt_id, d_bta_id)
          VALUES (Abt(iAbt).abt_id, vBTA_ID );
        END IF;
      END LOOP;
    END IF;

  
  END;
BEGIN
    
  -- Betriebsarten   
  vCode := CHR(9);
  ZBR_AUS_DATA.vD010101_HITgueltig_von := ZBR_AUS_DATA.vDateMax;    
  CASE 
  WHEN vVerfahren = QUELLE_IDV_NRW /*vGKZ2 = ZBR_AUS_DATA.NRW*/ THEN
    vFachbereich := 'NOT_VALID';
    
    -- Abteilungen
    FOR c1 IN (
      SELECT d0103.id d0103_id ,
        d0103.abt_nummer, d0103.bez, a0101_47.bez a0101_47_bez, d0103.gueltig_von, d0103.gueltig_bis,
        d0103.FLURSTUECK, d0103.GEMARKUNG, d0103.GEMEINDE, d0103.GKZ,
        d0103.ORT, d0103.ORTSTEIL, d0103.PLZ, d0103.STRASSE, d0103.HAUSNR, d0103.HAUSNRZUSATZ, 
        d0103.HOCHWERT, d0103.RECHTSWERT, d0103.X_WERT, d0103.Y_WERT, a24.iso_nr land,
        SUBSTR(d0103.gkz,1,3) bezirk, SUBSTR(d0103.gkz,1,8) gkz8, SUBSTR(d0103.gkz,1,2) bl,
        SUBSTR(d0103.gkz,1,5) kreis, '0000000' regionalschluessel
      FROM vis_d0103 d0103
      JOIN vis_a0101 a0101_47 ON a0101_47.sid = d0103.a0101_47_sid
       AND d0103.deleted = 0
       AND d0103.d0101_id = pD0101_ID
      JOIN glo_a24 a24 ON a24.sid = d0103.glo_a24_sid
    ) LOOP
         
      vAbtID := GET_ID(NULL); 
      INSERT INTO aus_d_abteilung (  ID, D_BTS_ID, ABTEILUNGSART, GUELTIG_VON, GUELTIG_BIS, NUMMER, BEZ, ref_id) 
      VALUES (vAbtID, pBTS_ID, c1.a0101_47_bez, c1.gueltig_von, c1.gueltig_bis, c1.abt_nummer, c1.bez, c1.d0103_id );
          
      IF c1.Ort IS NOT NULL THEN
        
        vVerwaltungID := fD_Verwaltung( c1.GKZ8, c1.Regionalschluessel, c1.Land);          
        vKatasterID := fD_Kataster( null, c1.FLURSTUECK, c1.GEMARKUNG, c1.X_Wert, c1.Y_Wert, c1.RECHTSWERT, c1.HOCHWERT );      
        vPostadrID := fD_Postadresse( c1.Land, c1.Plz, c1.ORT, c1.ORTSTEIL, 0 , NULL , c1.STRASSE, c1.HAUSNR, c1.HAUSNRZUSATZ );
        -- D_ADRESSE
        vBTRB_ID := GET_ID(NULL);
        INSERT INTO aus_d_adresse ( ID, FREIBEZ, WECHSEL, D_KAT_ID, D_PADR_ID, D_VERW_ID, gueltig_von)
        VALUES (vBTRB_ID, NULL, NULL, vKatasterID, vPostadrID, vVerwaltungID, ZBR_AUS_DATA.vLastUpddate);      
        
        INSERT INTO AUS_R_ABT_ADR (D_ADR_ID, D_ABT_ID, TYP)
        VALUES( vBTRB_ID, vAbtID, 'BTRB');    
        
      END IF;
        
      -- Zuordnung zur Registrierung AUS_D_REGISTRIERUNG.ART = 'BTRB' und
      -- AUS_D_REGISTRIERUNG.NUMMER = D0103.abt_nummer      
  --      FOR c2 IN ( 
  --        SELECT reg.id
  --        FROM aus_d_registrierung reg
  --        JOIN aus_r_bts_reg r_bts ON r_bts.d_reg_id = reg.id
  --         AND r_bts.d_bts_id = pBTS_ID
  --         AND reg.nummer = c1.abt_nummer
  --      ) LOOP
  --      
  --        INSERT INTO aus_r_abt_reg (d_abt_id, d_reg_id)
  --        VALUES (vAbtID, c2.id);               
  --      
  --      END LOOP; 
        
      -- Betriebsarten zur Abteilung merken fr Zuordnung zu R_BTA_ABT
      FOR c2 IN (
        SELECT d010301.d010101_id
        FROM vis_d010301 d010301
        WHERE d010301.d0103_id = c1.d0103_id
         AND d010301.deleted = 0
      ) LOOP
        
        Abt.EXTEND;
        abt(abt.last).d010101_id := c2.d010101_id;
        abt(abt.last).abt_id := vAbtId;               
        
      END LOOP;            
      
    END LOOP;

    FOR c1 IN (        
      SELECT d010101_id, code, --art,  bez, fachbereich, angemeldet, abgemeldet,
        MAX(art) KEEP (DENSE_RANK FIRST ORDER BY art DESC NULLS LAST) OVER (PARTITION BY code) max_art,
        MAX(bez) KEEP (DENSE_RANK FIRST ORDER BY bez DESC NULLS LAST) OVER (PARTITION BY code) max_bez,
        MAX(gewerbsmaessig) KEEP (DENSE_RANK FIRST ORDER BY gewerbsmaessig DESC NULLS LAST) OVER (PARTITION BY code) max_gewerbsmaessig,
        MIN(angemeldet) KEEP (DENSE_RANK FIRST ORDER BY angemeldet NULLS LAST) OVER (PARTITION BY code) min_angemeldet,
        MAX(abgemeldet) KEEP (DENSE_RANK FIRST ORDER BY abgemeldet DESC NULLS FIRST) OVER (PARTITION BY code) max_abgemeldet
      FROM(
        SELECT d010101.id d010101_id,
          CASE WHEN a010108.skz = 2 THEN 'ADV'
            /* todo 59018090 02.11.2015 nur noch ADV fr SKZ = 2 und sonst HIT exportieren               
               WHEN a010108.fb LIKE '%H%' THEN 'ADV'
               WHEN a010108.fb LIKE '%U%' THEN 'HIT'
               WHEN a010108.fb LIKE '%D%' THEN 'HIT'
               WHEN a010108.fb LIKE '%P%' THEN 'HIT'
               WHEN a010108.fb LIKE '%T%' THEN 'HIT'
               WHEN a010108.fb LIKE '%A%' THEN 'XXX'
               WHEN a010108.fb LIKE '%F%' THEN 'ADV'
               WHEN a010108.fb LIKE '%W%' THEN 'ADV'
               WHEN a010108.fb LIKE '%R%' THEN 'XXX'
               WHEN a010108.fb LIKE '%N%' THEN 'XXX'
               WHEN a010108.fb LIKE '%L%' THEN 'LegReg' */
          ELSE 'HIT' -- 02.11.2015 NULL
          END art,          
          CASE WHEN a010108.skz = 2 THEN RPAD(a010108.code, 7, '0')
          ELSE ax.axx2_code 
          END code,
          a010108.bez bez, 
          D010101.ANGEMELDET angemeldet, D010101.ABGEMELDET abgemeldet, 
          d010101.gewerbsmaessig
        FROM vis_d010101 d010101 
        JOIN vis_a010108 a010108 ON a010108.sid = d010101.a010108_sid
         AND d010101.deleted = 0
         AND d010101.aktiv = 1
         AND d010101.d0101_id = pD0101_ID
         AND a010108.skz in (1,2,3,5)
         AND (  a010108.fb LIKE '%H%' OR
                a010108.fb LIKE '%U%' OR 
                a010108.fb LIKE '%D%' OR 
                a010108.fb LIKE '%P%' OR 
                a010108.fb LIKE '%T%' OR 
                a010108.fb LIKE '%A%' OR 
                a010108.fb LIKE '%F%' OR 
                a010108.fb LIKE '%W%' OR 
                a010108.fb LIKE '%R%' OR 
                a010108.fb LIKE '%N%' OR 
                a010108.fb LIKE '%L%' )
        LEFT JOIN vis_va0089_hit_betriebstyp_05 ax ON ax.sid = a010108.sid
        WHERE 
         a010108.skz = 2 OR -- alle LM-Betriebsarten
        -- nur Betriebsarten, die im Zuordnungskatalog enthalten sind
        ax.sid > 0              
        ) dx
        WHERE code IS NOT NULL
          AND art IS NOT NULL
        ORDER BY code --, angemeldet NULLS LAST, abgemeldet NULLS LAST
    ) LOOP
      Insert_BA( c1.D010101_ID, c1.Code, c1.Max_bez, c1.Max_gewerbsmaessig, 
                 c1.Max_Art, c1.Min_Angemeldet, c1.Max_abgemeldet);
    END LOOP;
    
    -- zustzlich FM-Betriebsarten ohne Gruppierung nach Code
    vCode := CHR(9);
    FOR c1 IN (        
      SELECT d010101_id, code, --art,  bez, fachbereich, angemeldet, abgemeldet,
        art,
        bez bez,
        gewerbsmaessig gewerbsmaessig,
        angemeldet angemeldet,
        FIRST_VALUE(angemeldet) OVER( PARTITION BY NULL ORDER BY angemeldet NULLS LAST) min_angemeldet,
        FIRST_VALUE(abgemeldet) OVER( PARTITION BY NULL ORDER BY abgemeldet DESC NULLS FIRST) max_abgemeldet,
        abgemeldet abgemeldet
      FROM(
        SELECT d010101.id d010101_id,
          CASE WHEN a010108.skz = 2 THEN 'ADV'
            /* 02.11.2015 todo 59018090
               WHEN a010108.fb LIKE '%H%' THEN 'ADV'
               WHEN a010108.fb LIKE '%U%' THEN 'HIT'
               WHEN a010108.fb LIKE '%D%' THEN 'HIT'
               WHEN a010108.fb LIKE '%P%' THEN 'HIT'
               WHEN a010108.fb LIKE '%T%' THEN 'HIT'
               WHEN a010108.fb LIKE '%A%' THEN 'XXX'
               WHEN a010108.fb LIKE '%F%' THEN 'ADV'
               WHEN a010108.fb LIKE '%W%' THEN 'ADV'
               WHEN a010108.fb LIKE '%R%' THEN 'XXX'
               WHEN a010108.fb LIKE '%N%' THEN 'XXX'
               WHEN a010108.fb LIKE '%L%' THEN 'LegReg'  */
          ELSE 'HIT' -- 02.11.2015 NULL
          END art,          
          a010108.code,
          a010108.bez bez, 
          D010101.ANGEMELDET angemeldet, D010101.ABGEMELDET abgemeldet, 
          d010101.gewerbsmaessig
        FROM vis_d010101 d010101 
        JOIN vis_a010108 a010108 ON a010108.sid = d010101.a010108_sid
         AND d010101.deleted = 0
         AND d010101.aktiv = 1
         AND d010101.d0101_id = pD0101_ID
         AND (  a010108.fb LIKE '%H%' OR
                a010108.fb LIKE '%U%' OR 
                a010108.fb LIKE '%D%' OR 
                a010108.fb LIKE '%P%' OR 
                a010108.fb LIKE '%T%' OR 
                a010108.fb LIKE '%A%' OR 
                a010108.fb LIKE '%F%' OR 
                a010108.fb LIKE '%W%' OR 
                a010108.fb LIKE '%R%' OR 
                a010108.fb LIKE '%N%' OR 
                a010108.fb LIKE '%L%' )
        JOIN vis_va0089_hit_betriebstyp_05 ax ON ax.sid = a010108.sid
        AND ax.axx2_code = '4551' -- nur FM-Betriebsarten             
        ) dx
        WHERE code IS NOT NULL
          AND art IS NOT NULL
        ORDER BY code --, angemeldet NULLS LAST, abgemeldet NULLS LAST    
    ) LOOP
      vExists4551 := True;
      vMinAngemeldet := c1.min_angemeldet;
      vMaxAbgemeldet := c1.max_abgemeldet;
      Insert_BA( c1.D010101_ID, c1.Code, c1.bez, c1.gewerbsmaessig, 
                 'BALVI' /*10.10.2014 todo 55323090 c1.Art*/, c1.Angemeldet, c1.abgemeldet);
    END LOOP; -- FM-Betriebsarten nicht gruppiert
    
    IF vExists4551 THEN
      INSERT INTO AUS_D_REGISTRIERUNG (ID, ART, CODE, NUMMER, ZUSATZ, GUELTIG_VON, GUELTIG_BIS, REF_ID)
      VALUES (vReg_ID, 'FMZULREG', '02110402' , vDefaFmZulReg, NULL, NVL(vMinAngemeldet, zbr_aus_data.vDefault_gueltig_von), vMaxAbgemeldet, NULL); 
      
      INSERT INTO AUS_R_BTS_REG (D_BTS_ID, D_REG_ID) VALUES (pBTS_ID, vReg_ID);
            
      -- BEZ, CODE, FACHBEREICH, REF_ID, SCOPE, GEWERBSMAESSIG
      vSys_Guid := SYS_GUID();
      INSERT INTO aus_d_betriebsart (  ID, ART, CODE,  D_BTS_ID, GUELTIG_VON, GUELTIG_BIS)              
      VALUES ( vSYS_GUID, 'HFMUN', 'R52', pBTS_ID, NVL(vMinAngemeldet, zbr_aus_data.vDefault_gueltig_von), vMaxAbgemeldet); 
    END IF;
    
    -- FM-Ttigkeits-Kodierungen
    DECLARE
      vFM_KOD VARCHAR2(100) := NULL;
      vFM_KOD_AB VARCHAR2(20);
      vID VARCHAR2(32);
    BEGIN
    
      --15610001    FM-Ttigkeit(en)  FM_KOD
      --17975001    FM-Ttigkeit(en) gltig ab  FM_KOD_AB
      --17976001    Angaben zu den FM-Ttigkeiten gem. Kodierkatalog  FM_KOD_ANG
      --17977001    FM-Ttigkeit(en) an HIT  FM_KOD_AN_HIT
      --19596001    FM-Ttigkeit(en) detailliert  FM_KOD_D
   
      FOR c1 IN (
        SELECT d010110.id, a01080201.fieldcode, d010110.wert   
        FROM vis_a010802 a010802
        JOIN vis_d010110 d010110 ON d010110.d0101_id = pD0101_id   
          AND d010110.deleted = 0
          AND d010110.a010802_sid = a010802.sid
          AND d010110.wert IS NOT NULL      
        JOIN vis_a01080201 a01080201 ON d010110.a01080201_sid = a01080201.sid
          AND a01080201.a010802_sid = a010802.sid
          AND a01080201.fieldcode IN( 'FM_KOD', 'FM_KOD_AB')
          AND a010802.code = '1210'
          AND a010802.deleted = 0      
      ) LOOP
        IF c1.fieldcode = 'FM_KOD' THEN
          vFM_KOD := c1.wert;
          vID := c1.id;
        ELSIF c1.fieldcode = 'FM_KOD_AB' THEN
          vFM_KOD_AB := c1.wert;
        END IF;          
      END LOOP;
      -- mit Komma getrennte Kodierung separieren und einzeln als Betriebstyp HFMUN speichern
      IF vFM_KOD IS NOT NULL THEN
        vFM_KOD := REPLACE(vFM_KOD, ' ', NULL);
        FOR cKod IN ( 
            SELECT REGEXP_SUBSTR(vFM_KOD, '[^,]+', 1, LEVEL) code 
            FROM dual
            CONNECT BY REGEXP_SUBSTR(vFM_KOD, '[^,]+', 1, LEVEL) IS NOT NULL
         ) LOOP            
          Insert_BA( vID, cKod.Code, 'FM-Kodierung ' || cKod.Code || ' vom ' || TO_DATE(vFM_KOD_AB, 'dd.mm.yyyy'), 0, 
                     'HFMUN', TO_DATE(vFM_KOD_AB, 'dd.mm.yyyy'), NULL);
        END LOOP;
      END IF;  
    END;
    
  ELSE -- Thringen
    vFachbereich := 'VET';
    
    FOR c1 IN (
      --12.09.2014
      --SELECT code, bez, gewerbsmaessig, MIN(gueltig_von) gueltig_von, MAX(gueltig_bis) gueltig_bis
      --, MAX(d010101_id) KEEP( DENSE_RANK FIRST ORDER BY aktiv DESC, gueltig_bis NULLS LAST) id
      --FROM (    
        SELECT 
          -- 15.07.2014 d010101.id d010101_id,
          d010101.id /*d010101_id*/, d010101.id0,
          --'BALVI' art,    
          ax.a010108_bez bez, ax.a010108_code code,
          --15.07.2014 D010101.ANGEMELDET angemeldet, D010101.ABGEMELDET abgemeldet,
          CASE WHEN d010101.gueltig_von = v01_01_1753 THEN D010101.ANGEMELDET ELSE gueltig_von END gueltig_von,
          d010101.gueltig_bis, 
          d010101.gewerbsmaessig, d010101.aktiv
        FROM vis_d010101 d010101 
        -- nur Betriebsarten, die im Zuordnungskatalog enthalten sind  
        JOIN vis_va0089_zbr_betriebstyp ax ON ax.a010108_sid = d010101.a010108_sid 
         --AND ax.tv_pos IN (d010101.gewerbsmaessig, 2)
         AND d010101.deleted = 0
         --15.07.2014 AND d010101.aktiv = 1
         AND d010101.d0101_id = pD0101_ID  
         -- todo 57553090: 02.04.2015
         -- vorh. Zulassung mit Gltigkeit, die die BA einschliesst
         --AND ( ( ax.axx1_code NOT LIKE '020403%' AND ax.axx1_code <> '0406' ) OR
         AND ( ( ax.a010108_code NOT LIKE '020403%' AND ax.a010108_code <> '0406' ) OR
            EXISTS ( 
              -- 30.09.2015 todo 59034090
              SELECT 1 --FROM (
                --SELECT MIN(dx.f$gueltig_von) f$gueltig_von, MAX(dx.f$gueltig_bis) f$gueltig_bis
                FROM VIS_VD010102$01 dx
                WHERE dx.a010145_sid IN ( 1330001, 1331001, 1135001, 1136001)
                AND dx.d0101_id = pD0101_id
              --) dx2 

              -- Logik aus der Plausi  Bsp. ipi_btr WE-00292
              --WHERE NOT d010101.gueltig_von BETWEEN dx2.f$gueltig_von AND dx2.f$gueltig_bis AND
              --      NOT d010101.gueltig_bis BETWEEN dx2.f$gueltig_von AND dx2.f$gueltig_bis AND
              --      NOT dx2.f$gueltig_von BETWEEN d010101.gueltig_von AND d010101.gueltig_bis AND
              --      NOT dx2.f$gueltig_bis BETWEEN d010101.gueltig_von AND d010101.gueltig_bis THEN

              --WHERE d010101.gueltig_von >= dx2.f$gueltig_von 
              --AND d010101.gueltig_bis <= dx2.f$gueltig_bis                           
              )
            )
          --1330001   01042103  60  0   Zulassung Transportunternehmen nach Art. 10 Abs. 1 VO (EG) Nr. 1/2005
          --1331001   01042104  60  0   Zulassung Transportunternehmen (lange Befrderungen) nach Art. 11 Abs. 1 VO (EG) Nr. 1/2005          
          --1135001   01042101  60  0   Zulassung Transportunternehmer nach  13 ViehVerkV u. Art. 10 Abs. 1 VO (EG) 1/2005
          --1136001   01042102  60  0   Zulassung Transportunternehmer (lange Befrderungen) nach  13 ViehVerkV u. Art. 11 Abs. 1 VO (EG) 1/2005

    ) LOOP             
      --Insert_BA( c1.D010101_ID, c1.Code, c1.bez, c1.gewerbsmaessig, c1.Art, c1.Angemeldet, c1.abgemeldet);
      Insert_BA( c1.ID, c1.Code, c1.bez, c1.gewerbsmaessig, 'BALVI', 
                  c1.gueltig_von, 
                  CASE WHEN c1.gueltig_bis = ZBR_AUS_DATA.vDateMax THEN NULL ELSE c1.gueltig_bis END );            
    END LOOP;
  
    -- 23.04.2012 Anmeldedatum des Betriebes von den Betriebsarten bernehmen
  
    DECLARE
      vVon DATE;
      vBis DATE;
      CRLF CONSTANT VARCHAR2(2) := CHR(13)||CHR(10);
      TYPE tbID IS TABLE OF ZBR_AUS_DATA.tID;
      vD010102_ID tbID;
      vA0302_05_SID vis_d010102.a0302_05_sid%TYPE;
      vStat_Von DATE;
    BEGIN
      -- 01.06.2015 nur wenn nicht NULL
      UPDATE aus_d_betriebsstaette
      SET gueltig_von = NVL(vBA_Angemeldet, gueltig_von)
      -- 08.10.2013 letzte Abmeldedatum der BA bernehmen
      , gueltig_bis = NVL(vBa_Abgemeldet, gueltig_bis)
      WHERE id = ZBR_AUS_DATA.vBTS_ID
      RETURNING gueltig_von, gueltig_bis INTO vVon, vBis; 
    
      IF zbr_aus_data.vErstMode THEN
        IF vBis IS NULL THEN 
          vStat_Von := vVon;
          vA0302_05_SID := A0302_05_ERTEILT;
        ELSE 
          vStat_Von := vBis;
          vA0302_05_SID := A0302_05_RUHT;
        END IF;
      
        UPDATE vis_d010102
        SET --upd_date = vSysdate
          --, upd_user = vUser
            gueltig_von = vVon
          , gueltig_bis = vBis
          , gueltig_von_stat = vStat_Von
          , a0302_05_sid = vA0302_05_SID  
          , bem = TO_CHAR(vSysdate, 'dd.mm.yyyy')||': Gltigkeit whrend der Erstbefllung angepasst (alte Werte: '||
                  ' von ' || TO_CHAR(gueltig_von,'dd.mm.yyyy') || ' bis ' || TO_CHAR(gueltig_bis, 'dd.mm.yyyy') ||
                  CASE WHEN a0302_05_sid <> vA0302_05_SID THEN ' und Status gesetzt' END ||
                  CASE WHEN bem IS NOT NULL THEN CRLF || bem END
        WHERE d0101_id = pD0101_ID
        AND deleted = 0
        AND a010145_sid = A010145_HIT_NR 
        AND ( NVL(gueltig_von, ZBR_AUS_DATA.vDATEMIN) <> vVon 
           OR NVL(gueltig_bis, ZBR_AUS_DATA.vDATEMAX) <> NVL(vBis, ZBR_AUS_DATA.vDATEMAX) 
           OR a0302_05_sid <> vA0302_05_SID           
           )
        RETURNING ID BULK COLLECT INTO vD010102_ID;
        
        IF SQL%ROWCOUNT > 0 THEN 
          -- BI im Ausgangskorb aktualisieren
          FORALL i IN vD010102_ID.FIRST .. vD010102_ID.LAST
            UPDATE aus_d_registrierung
            SET gueltig_von = vVon
            , gueltig_bis = vBis 
            WHERE ref_id = vD010102_ID(i);
                    
          -- Statushistorie anlegen
          FOR i IN vD010102_ID.FIRST .. vD010102_ID.LAST LOOP
            InsertD0300( vD010102_ID(i) );          
          END LOOP;
        END IF;
      
      END IF; -- zbr_aus_data.vErstMode
         
    END;  
  
  END CASE;
      
END pBA_Abt;


-- Tierangaben in den Ausgangskorb bertragen
-- auer NRW
PROCEDURE pTIR(pD0101_ID VARCHAR2, pBTS_ID VARCHAR2) AS 
vTIR ZBR_AUS_DATA.tbTIR := ZBR_AUS_DAtA.tbTIR();
TYPE tD0104 IS RECORD (
  ref_ID vis_d0104.id%TYPE,
  bez vis_a0104.bez%TYPE,
  code vis_a0104.code%TYPE,
  anzahl vis_d0104.anzahl6%TYPE,
  gueltig_von vis_d0104.gueltig_von%TYPE,
  gueltig_bis vis_d0104.gueltig_bis%TYPE,
  --a010108_code vis_a010108.code%TYPE,
  d_bta_id aus_d_tierangaben.d_bta_id%TYPE );
TYPE tbD0104 IS TABLE OF tD0104;
vD0104 tbD0104;

BEGIN
  SELECT MIN(d0104.id), a0104.bez, a0104.code, SUM(d0104.anzahl6), MIN(d0104.gueltig_von), MAX(d0104.gueltig_bis), bta.id d_bta_id 
  BULK COLLECT INTO vD0104
  FROM vis_d0104 d0104
  JOIN vis_a0104 a0104 ON a0104.sid = d0104.a0104_sid
  JOIN vis_d010101 d010101 ON d010101.id = d0104.d010101_id
  --JOIN vis_a010108 a010108 on a010108.sid = d010101.a010108_sid
  JOIN aus_d_betriebsart bta ON bta.ref_id = d010101.id
  AND bta.d_bts_id = pBTS_ID
  WHERE d0104.deleted = 0
  AND d0104.d0101_id = pD0101_ID
  AND d0104.aktiv = 1
  AND d0104.anzahl6 > 0
  GROUP BY a0104.bez, a0104.code, bta.id;
     
  IF vD0104.COUNT > 0 THEN
    vTIR.EXTEND( vD0104.COUNT );
    FOR i IN vD0104.FIRST .. vD0104.LAST LOOP
      vTIR(i).ID := SYS_GUID();
      vTIR(i).D_BTS_ID := pBTS_ID;
      vTIR(i).REF_ID := vD0104(i).ref_id;
      vTIR(i).bezeichnung := vD0104(i).bez;
      vTIR(i).code := vD0104(i).code;
      vTIR(i).anzahl := vD0104(i).anzahl;
      vTIR(i).gueltig_von := vD0104(i).gueltig_von;
      vTIR(i).gueltig_bis := vD0104(i).gueltig_bis;  
      vTIR(i).d_bta_id := vD0104(i).d_bta_id;    
    END LOOP;
  
    FORALL i IN vTIR.FIRST .. vTIR.LAST 
    INSERT INTO aus_d_tierangaben
    ( ID, D_BTS_ID, D_BTA_ID, BEZEICHNUNG, CODE, 
      ANZAHL, GUELTIG_VON, GUELTIG_BIS, REF_ID )
    VALUES ( 
    vTIR(i).ID, vTIR(i).D_BTS_ID, vTIR(i).D_BTA_ID, vTIR(i).BEZEICHNUNG, vTIR(i).CODE, 
    vTIR(i).ANZAHL, vTIR(i).GUELTIG_VON, vTIR(i).GUELTIG_BIS, vTIR(i).REF_ID
    );
    
  END IF;

END pTIR;

/*******************************************************************************
 Fehlermeldung in den Ausgangskorb schreiben wennn die Packagevariable 
 vPlausiResult 1 oder 2 ist
 Parameter
 pD0101_ID : VIS_D0101.ID
 ausgewertet werden die Packagevariablen vPlausiWarnings und vPlausiErrors
*******************************************************************************/
PROCEDURE WriteMeldung(pD0101_ID IN VARCHAR2, pUsecase IN VARCHAR2 := 'AUTOEXPORT') AS
  vEIN_D_USECASE ein_d_usecase%ROWTYPE;
BEGIN
 
  CASE
  WHEN ZBR_AUS_DATA.vPlausiResult = 2 AND ZBR_AUS_DATA.vPlausiErrors IS NOT NULL THEN -- nur wenn Fehler dann schreiben    
        
    vEIN_D_USECASE.ID := SYS_GUID();
    vEIN_D_USECASE.D_BTS_ID := '-1';
    vEIN_D_USECASE.D0101_ID := pD0101_ID;
    vEIN_D_USECASE.datenherkunft := zbr_aus_data.dh_balvi;
    vEIN_D_USECASE.USECASE := pUsecase; -- 11.07.2013 alter Wert 'FEHLER EXPORT
    
    SELECT mandant, NVL(anmeldung, ZBR_AUS_DATA.vDateMin), fb, SUBSTR(zb, 1, 5) 
    INTO vEIN_D_USECASE.MANDANT, vEIN_D_USECASE.GUELTIG_VON, vEIN_D_USECASE.FB, vEin_d_usecase.zb
    FROM vis_d0101 WHERE id = pD0101_ID;
    
    vEIN_D_USECASE.USER_SID := -1;
    vEIN_D_USECASE.LASTMODIFIED := SYSDATE;
    vEIN_D_USECASE.GUELTIG_BIS := ZBR_AUS_DATA.vDateMax;
    
    vEIN_D_USECASE.AEND_ART := '3'; -- 20.08.2015 'Fehler Export';
    
    vEIN_D_USECASE.AEND_GRUND := CASE ZBR_AUS_DATA.vPlausiResult
                                 WHEN 2 THEN 'Fehler' 
                                 WHEN 1 THEN 'Warnung'
                                 WHEN 0 THEN 'OK'
                                 ELSE 'Error Plausiresult'
                                 END;
    
    vEIN_D_USECASE.AEND_BEM := NULL;
    vEIN_D_USECASE.ALTER_WERT := NULL;
    vEIN_D_USECASE.NEUER_WERT := NULL;
    vEIN_D_USECASE.D_BTS_ID2 := NULL;
    vEIN_D_USECASE.ERROR_MESSAGE := 'Fehler:' || CHR(13) || ZBR_AUS_DATA.vPlausiErrors;
    vEIN_D_USECASE.INS_DATE := SYSDATE;
    vEIN_D_USECASE.INS_USER := -1;
    vEIN_D_USECASE.DELETED := 0;
    vEIN_D_USECASE.DEL_USER := -1;
    vEIN_D_USECASE.DEL_DATE := NULL;
    vEIN_D_USECASE.USER_NAME := NULL;
    vEIN_D_USECASE.BESTAETIGT := 0;    
    vEIN_D_USECASE.AUS_D_USECASE_ID := NULL;
    
    IF pUsecase IN( 'ERSTBEFUELLUNG', 'AUTOEXPORT') THEN
    
      MERGE INTO ein_d_usecase uc
      USING ( SELECT pUsecase usecase, vEin_d_usecase.d0101_id d0101_id
              FROM DUAL ) dx
      ON ( uc.usecase = dx.usecase AND uc.d0101_id = dx.d0101_id ) 
      WHEN MATCHED THEN UPDATE
      --UPDATE ein_d_usecase 
      SET deleted       = vEIN_D_USECASE.DELETED
        , del_user      = vEIN_D_USECASE.del_user
        , del_date      = vEIN_D_USECASE.del_date
        , lastmodified  = vEIN_D_USECASE.LASTMODIFIED
        , aend_grund    = vEIN_D_USECASE.AEND_GRUND
        , error_message = vEIN_D_USECASE.ERROR_MESSAGE
        , ins_date      = vEIN_D_USECASE.INS_DATE
      --WHERE usecase = pUsecase
      --AND d0101_id = vEin_d_usecase.d0101_id;
      WHEN NOT MATCHED THEN INSERT VALUES vEin_d_usecase;
      
      --IF SQL%ROWCOUNT = 0 THEN
      --  INSERT INTO EIN_D_USECASE VALUES vEin_d_usecase;    
      --END IF;  
    
    ELSE
      INSERT INTO EIN_D_USECASE VALUES vEin_d_usecase;
    END IF;
        
  ELSE NULL;  
  END CASE;
 
END WriteMeldung;

/*******************************************************************************
 Fehlermeldung in den Ausgnagskorb schreiben wennn die Packagevariable 
 vPlausiResult 1 oder 2 ist
 Parameter
 pD0101_ID : VIS_D0101.ID
 ausgewertet werden die Packagevariablen vPlausiWarnings und vPlausiErrors
*******************************************************************************/
PROCEDURE WriteUseCaseErstbefuellung(pBTS_ID IN VARCHAR2, pD0101_ID IN VARCHAR2, 
                                    pLastModified IN DATE, pGueltig_von IN DATE, 
                                    pGueltig_bis IN DATE, pMandant IN PLS_INTEGER ) AS
  --vMsg CLOB := NULL;
  vAUS_D_USECASE aus_d_usecase%ROWTYPE;
BEGIN
        
  vAUS_D_USECASE.ID := SYS_GUID();
  vAUS_D_USECASE.D_BTS_ID := pBTS_ID;
  vAUS_D_USECASE.D0101_ID := pD0101_ID;
  vAUS_D_USECASE.USECASE := 'ERSTBEFUELLUNG';
    
  vAUS_D_USECASE.MANDANT := pMandant;
  vAUS_D_USECASE.GUELTIG_VON := NVL(pGueltig_von, ZBR_AUS_DATA.vDateMin);
  vAUS_D_USECASE.GUELTIG_BIS := NVL(pGueltig_bis, ZBR_AUS_DATA.vDateMax);
    
  vAUS_D_USECASE.USER_SID := -1;
  vAUS_D_USECASE.LASTMODIFIED := pLastModified;
  vAUS_D_USECASE.AEND_ART := 'Erstbefllung';
  vAUS_D_USECASE.AEND_GRUND := 'Erstbefllung';
  vAUS_D_USECASE.AEND_BEM := NULL;
  vAUS_D_USECASE.ALTER_WERT := NULL;
  vAUS_D_USECASE.NEUER_WERT := NULL;
  vAUS_D_USECASE.D_BTS_ID2 := NULL;
  vAUS_D_USECASE.STATUS := 0;
  
  INSERT INTO AUS_D_USECASE VALUES vAUS_d_usecase; 
 
END WriteUseCaseErstbefuellung;

/*******************************************************************************
  Fllen des Ausgangskorbs
  Parameter: wie Function AUSGANGSKORB
  pBtsCnt : Rckgabewert der Function AUSGANGSKORB
  pPlausiResult : Rckgabe aus der Plausiprfung, nicht im Batchmodus
                  0 : alles in Ordnung
                  1 : Warnungen enthalten
                  2 : Fehler enthalten, Betrieb ist nicht im Ausgangskorb
 pPlausiWarnings : Warnungen
 pPlausiErrors : Fehler
*******************************************************************************/
PROCEDURE Ausgangskorb( pUserSID IN NUMBER, 
                        pD0101_ID IN VARCHAR2,
                        pLastModified IN DATE := ZBR_AUS_DATA.vDateMin,
                        pForce IN NUMBER := 0,
                        pPrtStatus IN NUMBER := 0,
                        pBtsCnt OUT NUMBER,
                        pPlausiResult OUT NUMBER,
                        pPlausiWarnings OUT NOCOPY VARCHAR2,
                        pPlausiErrors OUT NOCOPY VARCHAR2                       
                       )  AS
BEGIN

  pBtsCnt := Ausgangskorb( pUserSID, pD0101_ID, pLastModified, pForce, pPrtStatus);

  IF NOT ZBR_AUS_DATA.vBatchMode THEN
    pPlausiResult := ZBR_AUS_DATA.vPlausiResult;
    pPlausiWarnings := SUBSTR(ZBR_AUS_DATA.vPlausiWarnings, 1, 4000);
    pPlausiErrors := SUBSTR(ZBR_AUS_DATA.vPlausiErrors, 1, 4000);
  END IF;
END Ausgangskorb;                       

-- Aus pBez1 und pBez2 wird pKurzBez1 und pKurzBez2 mit max. 30 Zeichen erstellt
-- Ist pBez1 zu lang wird der rest in pKurzbez2 bernommen
-- dabei wird versucht bei einem Leerzeichen zu trennen
PROCEDURE Create_HitKurzBez( pBez1 IN VARCHAR2, pBez2 IN VARCHAR2, pKurzBez1 OUT NOCOPY VARCHAR2, pKurzBez2 OUT NOCOPY VARCHAR2) AS
 vBlank PLS_INTEGER;
BEGIN
  IF LENGTH(pBez1) > 30 THEN
    vBlank := INSTR( SUBSTR(pBez1, 1, 30) , ' ', -1); -- letztes Leerzeichen innerhalb der ersten 30

    IF vBlank > 0 AND vBlank <= 30 THEN
      pKurzBez1 := SUBSTR( pBez1, 1, vBlank);
      pKurzBez2 := SUBSTR( SUBSTR( pBez1, vBlank + 1) || ' ' || pBez2, 1, 30);  
    
    ELSE -- kein Leerzeichen vorhanden - abschneiden bei 30
      pKurzBez1 := SUBSTR( pBez1, 1, 30);
      pKurzBez2 := SUBSTR( SUBSTR( pBez1, 31) || ' ' || pBez2, 1, 30);
    
    END IF;
  ELSE
    pKurzBez1 := SUBSTR(pBez1, 1, 30);
    pKurzBez2 := SUBSTR(pBez2, 1, 30);
  END IF;
END Create_HitKurzBez;

FUNCTION FillAusgangskorb(pD0101_ID IN ZBR_AUS_DATA.tID, pUserSID IN NUMBER) RETURN ZBR_AUS_DATA.tID AS

  CURSOR cD0101 (cD0101_ID IN ZBR_AUS_DATA.tID) IS 
        WITH a0089_a0101_03 AS (
          SELECT a0089.bez, a0089.axx1_sid, A0089.AXX2_CODE 
          FROM vis_a0089 a0089
          WHERE a0089.deleted = 0 AND a0089.axx1_table = 'VIS_A0101' AND a0089.axx1_skz = 3 
            AND a0089.axx2_table = 'HIT_RE_FRM' AND a0089.zb IN ( blv_sys.get_gkz2()/*vGKZ2*/, '%') ),
              
          A0101_03 AS ( SELECT sid, code FROM vis_a0101 WHERE deleted = 0 AND skz = 3)  
                      
        SELECT d0101.id d0101_id, d0101.mandant d0101_mandant
        , d0101.code d0101_code, d0101.bez d0101_bez, d0101.name1 d0101_name1
        , d0101.anrede d0101_anrede, d0101.titel d0101_titel, d0101.vname d0101_vname, d0101.nname d0101_nname
        , d0101.vorsatz_nname d0101_vorsatz_nname, d0101.nachsatz_nname d0101_nachsatz_nname
        , d0101.ambulant_jn d0101_ambulant_jn, d0101.strasse d0101_strasse, d0101.hausnr d0101_hausnr, d0101.hausnrzusatz d0101_hausnrzusatz, D0101.BEZ_ART d0101_bez_art, D0101.PLZ d0101_plz, d0101.ort d0101_ort, d0101.ortsteil d0101_ortsteil, a24.iso_nr d0101_land
        , ZBR_AUS_DATA.vBTRO d0101_adr_typ, SUBSTR(d0101.gkz,1,8) d0101_gkz8, SUBSTR(d0101.gkz,1,3) d0101_bezirk, SUBSTR(d0101.gkz,1,2) d0101_bl, SUBSTR(d0101.gkz,1,5) d0101_kreis, '0000000' d0101_regionalschluessel 

        , d0101.hit_p_bez_1 d0101_hit_p_bez_1 
        , d0101.hit_p_bez_2 d0101_hit_p_bez_2
        , d0101.hit_bez_1 d0101_hit_bez_1 
        , d0101.hit_bez_2 d0101_hit_bez_2

        , D0101.ABW_POST d0101_abw_post
        , CASE WHEN D0101.IS_POSTFACH = 1 THEN d0101.p_strasse ELSE NULL END d0101_p_postfach
        , CASE WHEN d0101.is_postfach = 0 THEN d0101.p_strasse ELSE NULL END d0101_p_strasse
        , d0101.p_hausnr d0101_p_hausnr, d0101.p_hausnrzusatz d0101_p_hausnrzusatz, D0101.p_PLZ d0101_p_plz, d0101.p_ort d0101_p_ort, d0101.p_ortsteil d0101_p_ortsteil, a24_p.iso_nr d0101_p_land
        , D0101.IS_POSTFACH D0101_IS_POSTFACH
        
        , ZBR_AUS_DATA.vBTRA d0101_p_adr_typ, D0101.P_BEZ_ART d0101_p_bez_art

        , d0101.rechtswert d0101_rechtswert, d0101.hochwert d0101_hochwert, d0101.x_wert d0101_x_wert, d0101.y_wert d0101_y_wert
        , d0101.anmeldung d0101_anmeldung, d0101.abmeldung d0101_abmeldung, TRUNC(d0101.upd_date) d0101_upd_date
        , d0101.flurnummer d0101_flurnummer, d0101.flurstueck d0101_flurstueck, d0101.gemarkung d0101_gemarkung
        , D0101.KOM_TEL d0101_kom_tel, d0101.kom_fax d0101_kom_fax, D0101.KOM_INTERNET d0101_kom_internet, D0101.KOM_EMAIL d0101_kom_email, d0101.kom_mobil d0101_kom_mobil, D0101.KOM_SONST d0101_kom_sonst
        
        , d0101$3.id d0101$3_id, d0101$3.code d0101$3_code, d0101$3.bez d0101$3_bez, d0101$3.name1 d0101$3_name1
        , d0101$3.anrede d0101$3_anrede, d0101$3.titel d0101$3_titel, d0101$3.vname d0101$3_vname, d0101$3.nname d0101$3_nname
        , d0101$3.vorsatz_nname d0101$3_vorsatz_nname, d0101$3.nachsatz_nname d0101$3_nachsatz_nname
        , d0101$3.strasse d0101$3_strasse, d0101$3.hausnr d0101$3_hausnr, d0101$3.hausnrzusatz d0101$3_hausnrzusatz, D0101$3.BEZ_ART d0101$3_bez_art,  D0101$3.PLZ d0101$3_plz, d0101$3.ort d0101$3_ort, d0101$3.ortsteil d0101$3_ortsteil, a24$3.iso_nr d0101$3_land
        , ZBR_AUS_DATA.vBTRO d0101$3_adr_typ, SUBSTR(d0101$3.gkz,1,8) d0101$3_gkz8, SUBSTR(d0101$3.gkz,1,3) d0101$3_bezirk, SUBSTR(d0101$3.gkz,1,2) d0101$3_bl, SUBSTR(d0101$3.gkz,1,5) d0101$3_kreis, '0000000' d0101$3_regionalschluessel
     
        , d0101$3.hit_p_bez_1 d0101$3_hit_p_bez_1 
        , d0101$3.hit_p_bez_2 d0101$3_hit_p_bez_2
        , d0101$3.hit_bez_1 d0101$3_hit_bez_1 
        , d0101$3.hit_bez_2 d0101$3_hit_bez_2
          
        , D0101$3.ABW_POST d0101$3_abw_post
        
        , CASE WHEN D0101$3.IS_POSTFACH = 1 THEN d0101$3.p_strasse ELSE NULL END d0101$3_p_postfach
        , CASE WHEN d0101$3.is_postfach = 0 THEN d0101$3.p_strasse ELSE NULL END d0101$3_p_strasse
        , d0101$3.p_hausnr d0101$3_p_hausnr, d0101$3.p_hausnrzusatz d0101$3_p_hausnrzusatz , D0101$3.p_PLZ d0101$3_p_plz, d0101$3.p_ort d0101$3_p_ort, d0101$3.p_ortsteil d0101$3_p_ortsteil, a24$3_p.iso_nr d0101$3_p_land
        , D0101$3.IS_POSTFACH D0101$3_IS_POSTFACH
        
        , ZBR_AUS_DATA.vBTRA d0101$3_p_adr_typ, D0101$3.P_BEZ_ART d0101$3_p_bez_art, D0101$3.P_anrede d0101$3_p_anrede, D0101$3.P_name d0101$3_p_name, D0101$3.P_name1 d0101$3_p_name1
          
        , d0101$3.rechtswert d0101$3_rechtswert, d0101$3.hochwert d0101$3_hochwert, d0101$3.x_wert d0101$3_x_wert, d0101$3.y_wert d0101$3_y_wert
        , d0101$3.anmeldung d0101$3_anmeldung, TRUNC(d0101$3.upd_date) d0101$3_upd_date
        , d0101$3.flurnummer d0101$3_flurnummer, d0101$3.flurstueck d0101$3_flurstueck, d0101$3.gemarkung d0101$3_gemarkung
        , D0101$3.KOM_TEL d0101$3_kom_tel, d0101$3.kom_fax d0101$3_kom_fax, D0101$3.KOM_INTERNET d0101$3_kom_internet, D0101$3.KOM_EMAIL d0101$3_kom_email, d0101$3.kom_mobil d0101$3_kom_mobil, D0101$3.KOM_SONST d0101$3_kom_sonst

          -- wenn keine Rechtsform vorhanden ist dann "sonstige juristische Person" SID 402001 verwenden
          -- nur in NRW Zuordnungskatalog verwenden
        , CASE WHEN vVerfahren = QUELLE_IDV_NRW /*vGKZ2 = ZBR_AUS_DATA.NRW*/ THEN         
          (SELECT axx2_code FROM a0089_a0101_03 
           WHERE a0089_a0101_03.axx1_sid = CASE WHEN D0101.A0101_03_SID = -1 THEN ZBR_AUS_DATA.vA0101_03_SID_Default ELSE D0101.A0101_03_SID END ) 

          ELSE 
           (SELECT a0101_03.code FROM a0101_03 WHERE a0101_03.sid = CASE WHEN D0101.A0101_03_SID = -1 THEN ZBR_AUS_DATA.vA0101_03_SID_Default ELSE D0101.A0101_03_SID END ) 

          END d0101_a0101_03_axx2_code

        , CASE WHEN vVerfahren = QUELLE_IDV_NRW /*vGKZ2 = ZBR_AUS_DATA.NRW*/ THEN
          (SELECT axx2_code FROM a0089_a0101_03 
           WHERE a0089_a0101_03.axx1_sid =  CASE WHEN D0101$3.A0101_03_SID = -1 THEN ZBR_AUS_DATA.vA0101_03_SID_Default ELSE D0101$3.A0101_03_SID END )

          ELSE 
           (SELECT a0101_03.code FROM a0101_03 WHERE a0101_03.sid = CASE WHEN D0101$3.A0101_03_SID = -1 THEN ZBR_AUS_DATA.vA0101_03_SID_Default ELSE D0101$3.A0101_03_SID END ) 
          END d0101$3_a0101_03_axx2_code
            
        , D0101.A0101_03_SID D0101_A0101_03_SID
        , D0101$3.A0101_03_SID  D0101$3_A0101_03_SID  
        , d0101.d010200_id2 d0101_d010200_id2
        , d0101$3.d010200_id2 d0101$3_d010200_id2
        , d0101$3.daten_herkunft d0101$3_daten_herkunft  
        , CASE WHEN vVerfahren = QUELLE_IDV_NRW /*'vGKZ2 = ZBR_AUS_DATA.NRW*/ THEN        
              ( SELECT MAX(d010102.nummer) 
                FROM VIS_D010102 d010102 
                WHERE d010102.deleted = 0 
                  and d010102.d0101_id = d0101.id 
                  AND a010145_sid = A010145_IDV_BETREIBER_ID --IDV-Betreiber ID Code '01901302'
               ) 
           ELSE NULL END pers_id
            
        , CASE WHEN vVerfahren = QUELLE_IDV_NRW /*vGKZ2 = ZBR_AUS_DATA.NRW*/ THEN 
              ( SELECT MAX(d010102.nummer) 
                  FROM VIS_D010102 d010102 
                  WHERE d010102.deleted = 0 
                    and d010102.d0101_id = d0101$3.id 
                    AND a010145_sid = A010145_IDV_BETREIBER_ID --IDV-Betreiber ID Code '01901302'
                ) 
           ELSE NULL END pers_id$3  
        , CASE WHEN vVerfahren <> QUELLE_IDV_NRW /*vGKZ2 <> ZBR_AUS_DATA.NRW*/ AND EXISTS(
          SELECT 1 FROM aus_d_protokoll prt WHERE prt.d0101_id = d0101.id ) THEN 0
          ELSE 1 END IsNew       
        from vis_d0101 d0101
        join glo_a24 a24 on a24.sid = d0101.glo_a24_sid
        join glo_a24 a24_p on a24_p.sid = d0101.glo_a24_sid2
        join vis_d0101 d0101$3 on d0101$3.id = d0101.d0101_id3
        join glo_a24 a24$3 on a24$3.sid = d0101$3.glo_a24_sid
        join glo_a24 a24$3_p on a24$3_p.sid = d0101$3.glo_a24_sid2
        where d0101.id = cD0101_ID; 
         
  vD0101 cD0101%ROWTYPE;
  vRes ZBR_AUS_DATA.tID := '-1';
  vBem vis_d0101.bem%TYPE;  
  vGUID ZBR_AUS_DATA.tID;
  vTimestamp TIMESTAMP;
  vCnt PLS_INTEGER;
  vKurzBez1 VARCHAR2(30);
  vKurzBez2 VARCHAR2(30);
BEGIN

  OPEN cD0101 ( pD0101_ID );
  FETCH cD0101 INTO vD0101;
  CLOSE cD0101;
  IF vD0101.d0101_id <> '-1' THEN             
        
    -- 20.07.2012 Lastmodified darf nicht in der Zukunft liegen
    IF ZBR_AUS_DATA.vLastUpdDate > SYSDATE THEN
      ZBR_AUS_DATA.vLastUpdDate := SYSDATE;
    END IF;
                                
    -- wenn Rechtsform nicht vorhanden, 
    -- dann in VIS_D0101 auf "sonstige juristische Person" setzen bei Firma, wenn kein abweichender Betreiber vorhanden
    IF vVerfahren <> QUELLE_IDV_NRW /*vGKZ2 <> ZBR_AUS_DATA.NRW*/ THEN  -- 01.08.2013
      IF vD0101.d0101_a0101_03_sid = -1 AND vD0101.d0101_bez_art = 'F' AND vD0101.d0101_id = vD0101.d0101$3_id THEN -- keine Rechtsform vorhanden
        vBem := TO_CHAR(SYSDATE, 'dd.mm.yyyy') || ' Rechtsform "sonstige juristische Person" gesetzt'; 
        UPDATE vis_d0101
        SET upd_date = SYSDATE
          , a0101_03_sid = ZBR_AUS_DATA.vA0101_03_SID_Default
          , bem = BEM || CASE WHEN bem IS NOT NULL THEN CHR(13) END || vBem                       
        WHERE id = vD0101.d0101_id;
      END IF;
              
      -- Rechtsform beim Betreiber prfen
      IF vD0101.d0101_id <> vD0101.d0101$3_id AND vD0101.d0101$3_a0101_03_sid = -1 
      AND vD0101.d0101$3_bez_art = 'F' THEN -- keine Rechtsform beim Betreiber vorhanden
        vBem := TO_CHAR(SYSDATE, 'dd.mm.yyyy') || ' Rechtsform "sonstige juristische Person" gesetzt';
        UPDATE vis_d0101
        SET upd_date = SYSDATE
          , a0101_03_sid = ZBR_AUS_DATA.vA0101_03_SID_Default
          , bem = BEM || CASE WHEN bem IS NOT NULL THEN CHR(13) END || vBem                      
        WHERE id = vD0101.d0101$3_id;
              
      END IF;
    END IF;
               
    -- AUS_D_BETRIEBSSTAETTE
    ZBR_AUS_DATA.vBTS_ID := SYS_GUID(); -- vD0101.d0101_id; 
    INSERT INTO AUS_D_BETRIEBSSTAETTE ( id, ZUSATZBEZ, gueltig_von, gueltig_bis, ref_id) VALUES
    ( ZBR_AUS_DATA.vBTS_ID, vD0101.d0101_name1, vD0101.d0101_anmeldung, vD0101.d0101_abmeldung, vD0101.d0101_id);
        
    IF ZBR_AUS_DATA.vBatchMode THEN
      ZBR_AUS_DATA.vProtokoll_Mandant := vD0101.d0101_mandant;
    ELSE     
      BEGIN
        SELECT s50_sid00 INTO ZBR_AUS_DATA.vProtokoll_Mandant
        FROM vis_s50
        WHERE sid = pUserSID
          AND deleted = 0;
                  
        EXCEPTION WHEN NO_DATA_FOUND THEN ZBR_AUS_DATA.vProtokoll_Mandant := vD0101.d0101_mandant;
              
      END;
    END IF;
    -- Protokoll anlegen
    vGUID := SYS_GUID();
    vTimeStamp := SYSTIMESTAMP;
    ZBR_AUS_DATA.vPrtStatus := NVL(ZBR_AUS_DATA.vPrtStatus, 0);
    INSERT INTO aus_d_protokoll (ID, D_BTS_ID, D0101_ID, STATUS, INS_DATE, USER_SID, LASTMODIFIED, mandant)
    VALUES (vGUID, ZBR_AUS_DATA.vBTS_ID, pD0101_ID, ZBR_AUS_DATA.vPrtStatus, vTIMESTAMP, pUserSID, ZBR_AUS_DATA.vLastUpdDate, ZBR_AUS_DATA.vProtokoll_Mandant );
                
    /*24.07.2012
    IF vErstMode = 1 THEN
      WriteUseCaseErstbefuellung(vBTS_ID,cD0101.ID, 
                            vLastUpdDate, vD0101.d0101_anmeldung, 
                            vD0101.d0101_abmeldung, vProtokoll_Mandant );
    END IF;*/
            
    -- Registrierungen zur Betriebssttte
    -- muss vor den Abteilungen erfolgen
    pD_Reg_komplett( vD0101.d0101_id --pD0101_ID VARCHAR2
                   , NULL --pPersonID VARCHAR2
                   , NULL --pFunkID VARCHAR2
                   , ZBR_AUS_DATA.vBTS_ID);      
            
    -- Betriebsarten - Abteilungen      
    pBA_Abt( vD0101.D0101_id, ZBR_AUS_DATA.vBTS_ID); 
    
    -- Tierangaben wenn neu und nicht NRW
    -- muss nach den Betriebsarten laufen
    IF vD0101.IsNew = 1 AND vVerfahren <> QUELLE_IDV_NRW /*vGKZ2 <> zbr_aus_data.NRW*/ AND NOT ZBR_AUS_DATA.vErstMode THEN
      pTIR(vD0101.D0101_id, ZBR_AUS_DATA.vBTS_ID);    
    END IF;
            
    ZBR_AUS_DATA.vPostadrID1 := NULL;
    ZBR_AUS_DATA.vPostadrID2 := NULL;
    ZBR_AUS_DATA.vAdresseID1 := NULL;
    ZBR_AUS_DATA.vAdresseID2 := NULL;
    ZBR_AUS_DATA.vKatasterID1 := NULL;
    ZBR_AUS_DATA.vKatasterID2 := NULL;
    ZBR_AUS_DATA.vVerwaltungID1 := NULL;
    ZBR_AUS_DATA.vVerwaltungID2 := NULL;
    ZBR_AUS_DATA.vFunktionID := NULL;
    ZBR_AUS_DATA.vFunktionID3 := NULL;
            
    -- Standortadresse der Betriebssttte
    -- Adressen
    -- Verwaltung
    ZBR_AUS_DATA.vVerwaltungID1 := fD_Verwaltung(vD0101.d0101_GKZ8, vD0101.d0101_Regionalschluessel, vD0101.d0101_Land);          
    -- Kataster
    ZBR_AUS_DATA.vKatasterID1 := fD_Kataster( vD0101.d0101_flurnummer, vD0101.d0101_FLURSTUECK, vD0101.d0101_GEMARKUNG, vD0101.d0101_X_Wert, vD0101.d0101_Y_Wert, vD0101.d0101_RECHTSWERT, vD0101.d0101_HOCHWERT );      
    -- Standortadresse
    ZBR_AUS_DATA.vPostadrID1 := fD_Postadresse( vD0101.d0101_Land, vD0101.d0101_Plz, vD0101.d0101_ORT, vD0101.d0101_ORTSTEIL, 0 , NULL , vD0101.d0101_STRASSE, vD0101.d0101_HAUSNR, vD0101.d0101_hausnrzusatz );
    -- D_ADRESSE
    ZBR_AUS_DATA.vBTRO_ID := GET_ID(NULL);
    INSERT INTO aus_d_adresse ( ID, FREIBEZ, WECHSEL, D_KAT_ID, D_PADR_ID, D_VERW_ID
            , gueltig_von)
    VALUES (ZBR_AUS_DATA.vBTRO_ID, NULL, vD0101.d0101_ambulant_jn, ZBR_AUS_DATA.vKatasterID1, ZBR_AUS_DATA.vPostadrID1, ZBR_AUS_DATA.vVerwaltungID1, 
            --CASE WHEN vErstMode = 1 THEN vLastUpdDate ELSE GREATEST(vLastUpdDate, vD0101.d0101_anmeldung) END );      
            GREATEST(ZBR_AUS_DATA.vLastUpdDate, vD0101.d0101_anmeldung) );      
       
    ZBR_AUS_DATA.vID := GET_ID(NULL);
    INSERT INTO AUS_R_BTS_ADR (ID, TYP, D_ADR_ID, D_BTS_ID)
    VALUES( ZBR_AUS_DATA.vID, ZBR_AUS_DATA.vBTRO, ZBR_AUS_DATA.vBTRO_ID, ZBR_AUS_DATA.vBTS_ID);

    -- abweichende Postadresse 
    IF vD0101.d0101_Abw_post = 1 THEN
            
      ZBR_AUS_DATA.vPostadrID1 := fD_Postadresse( vD0101.d0101_P_land, vD0101.d0101_P_plz, vD0101.d0101_P_ORT, vD0101.d0101_P_ORTSTEIL, vD0101.d0101_IS_POSTFACH , vD0101.d0101_P_postfach , vD0101.d0101_P_STRASSE, vD0101.d0101_P_HAUSNR, vD0101.d0101_P_HAUSNRZUSATZ );
      IF vD0101.d0101_gkz8 IS NOT NULL AND vD0101.d0101_id = vD0101.d0101$3_ID THEN
        ZBR_AUS_DATA.vVerwaltungID2 := fD_Verwaltung( vD0101.d0101_GKZ8, vD0101.d0101_Regionalschluessel, vD0101.d0101_p_Land);          
      ELSE
        ZBR_AUS_DATA.vVerwaltungID2 := NULL;      
      END IF;
            
      ZBR_AUS_DATA.vBTRA_ID := GET_ID(NULL);
      INSERT INTO aus_d_adresse ( ID, FREIBEZ, WECHSEL, D_KAT_ID, D_PADR_ID, D_VERW_ID, 
              gueltig_von)
      VALUES (ZBR_AUS_DATA.vBTRA_ID, NULL, NULL, NULL, ZBR_AUS_DATA.vPostadrID1, ZBR_AUS_DATA.vVerwaltungID2, 
              --CASE WHEN vErstMode = 1 THEN vLastUpdDate ELSE GREATEST(vLastUpdDate, vD0101.d0101_anmeldung) END );
              GREATEST(ZBR_AUS_DATA.vLastUpdDate, vD0101.d0101_anmeldung) );
            
    ELSE
      -- keine abweichende Postadresse, dann wie BTRO zuordnen
      -- also Zuordnung nur als BTRA noch mal anlegen
      ZBR_AUS_DATA.vBTRA_ID := ZBR_AUS_DATA.vBTRO_ID;      
    END IF;

    -- bei Postanschrift immer ohne Kataster und Verwaltung
    -- deshalb immer neuen AUS_D_ADRESSE anlegen
    -- wird von JB geprft
    --vBTRA_ID := GET_ID(NULL);
    --INSERT INTO aus_d_adresse ( ID, FREIBEZ, WECHSEL, D_KAT_ID, D_PADR_ID, D_VERW_ID, gueltig_von)
    --VALUES (vBTRA_ID, NULL, NULL, NULL, vPostadrID1, NULL, vLastUpdDate);

    -- Zuordnung Postadresse zur Betriebssttte
    ZBR_AUS_DATA.vID := GET_ID(NULL);
    INSERT INTO AUS_R_BTS_ADR (ID, TYP, D_ADR_ID, D_BTS_ID)
    VALUES( ZBR_AUS_DATA.vID, ZBR_AUS_DATA.vBTRA, ZBR_AUS_DATA.vBTRA_ID, ZBR_AUS_DATA.vBTS_ID);        

    -- Ende Adresse Betriebssttte    
          
    -- Kommunikationsmittel der Betriebssttte
    pD_Kom_komplett(NULL, NULL, ZBR_AUS_DATA.vBTS_ID, vD0101.d0101_kom_tel, vD0101.d0101_kom_fax, vD0101.d0101_kom_mobil, vD0101.d0101_kom_email, vD0101.d0101_kom_internet, vD0101.d0101_kom_sonst);      
            
            
    /*************************************************************************
    Hauptverantwortlicher immer natrliche Person 
    ohne Adresse, Kommunikation und Registrierung
    -> D_PERSON (TYP=NP) mit D_FUNKTION (TYP=HV) anlegen 
    wenn D010200.HAUPTANSPRECHPARTNER = 1 vorhanden aus D010200 sonst D0101 
    und Fehler ausgeben (wie muss noch geklrt werden)       
    *************************************************************************/
    ZBR_AUS_DATA.vPersonID := NULL;
    vCnt := 0;
    IF vVerfahren = QUELLE_IDV_NRW /*vGKZ2 = ZBR_AUS_DATA.NRW*/ THEN -- HV nur in NRW verarbeiten
            
      -- existiert ein Hauptverantwortlicher
      /*IF vD0101.d0101_d010200_id2 = '-1' THEN
        vCnt := 0;
      ELSE
        /*SELECT COUNT(*) INTO vCnt
        FROM VIS_D010200 d010200
        JOIN vis_d0102 d0102 ON d0102.id = d010200.d0102_id
         AND d0102.deleted = 0
         AND D010200.DELETED = 0
         --11.06.2014 AND d010200.d0101_id = vD0101.D0101_ID
         --11.06.2014 AND D010200.hauptansprechpartner = 1
         AND d010200.id = vD0101.d0101_d010200_id2;
         vCnt := 1;
       END IF; */
                                   
      --IF vCnt = 1 THEN -- Hauptverantwortlicher aus D010200 verwenden
      IF vD0101.d0101_d010200_id2 <> '-1' THEN
              
        FOR cD0102 IN (
          SELECT d010200.id d010200_id, D0102.ANREDE, D0102.NNAME, D0102.VNAME, D0102.TITEL,
            --D010200.KOM_TEL, D010200.kom_fax, D010200.KOM_INTERNET, D010200.KOM_EMAIL, D010200.kom_mobil, D010200.KOM_SONST, 
            d0102.pers_id,
            d0102.vorsatz_nname, d0102.nachsatz_nname 
          FROM VIS_D010200 d010200
          JOIN vis_d0102 d0102 ON d0102.id = d010200.d0102_id
           AND d0102.deleted = 0
           AND D010200.DELETED = 0
           AND d010200.id = vD0101.d0101_d010200_id2
           --11.06.2014 AND d010200.d0101_id = vD0101.D0101_ID
           --11.06.2014 AND D010200.hauptansprechpartner = 1            
                    
        ) LOOP
                
          ZBR_AUS_DATA.vPersonID := fD_PERSON (
              NULL --ID
            , cD0102.anrede --ANREDE
            , NULL, NULL --BEZEICHNUNG
            , null  --GEBURTSDATUM
            , null  --GEBURTSORT
            , '#' --KURZBEZ1
            , NULL  --KURZBEZ2
            , cD0102.nname --PersNachname(cD0102.nname, cD0102.Vorsatz_NName, cD0102.Nachsatz_NName) --NACHNAME
            , cD0102.Vorsatz_NName, cD0102.Nachsatz_NName
            , NULL  --RECHTSFORM
            , cD0102.Titel  --TITEL
            , cD0102.VName  --VORNAME
            , 'NP'  -- Typ
            , cD0102.pers_id
            , cD0102.d010200_id
             );      
        END LOOP;  
             
        ZBR_AUS_DATA.vFunktionID := GET_ID(NULL);
        INSERT INTO aus_d_funktion (ID, ART, TYP, D_PERS_ID, D_BTS_ID, gueltig_von)
        VALUES( ZBR_AUS_DATA.vFunktionID, NULL, ZBR_AUS_DATA.vHV, ZBR_AUS_DATA.vPersonID, ZBR_AUS_DATA.vBTS_ID, ZBR_AUS_DATA.vLastUpdDate);                      
            
      ELSE -- kein D010200 vorh. -> Daten aus D0101 verwenden
              
        IF vD0101.d0101_nname IS NOT NULL THEN 
          ZBR_AUS_DATA.vPersonID := fD_PERSON (
              NULL --ID
            , vD0101.d0101_anrede --ANREDE
            , NULL, NULL --BEZEICHNUNG
            , null  --GEBURTSDATUM
            , null  --GEBURTSORT
            , '#'  --KURZBEZ1
            , NULL  --KURZBEZ2
            , vD0101.d0101_nname --PersNachname(vD0101.d0101_nname, vD0101.d0101_vorsatz_nname, vD0101.d0101_nachsatz_nname) --NACHNAME
            , vD0101.d0101_vorsatz_nname, vD0101.d0101_nachsatz_nname
            , NULL  --RECHTSFORM
            , vD0101.d0101_Titel  --TITEL
            , vD0101.d0101_VName  --VORNAME
            , 'NP'  -- Typ
            , NULL --pers_id
            , NULL --vD0101.D0101_ID
             );        

          ZBR_AUS_DATA.vFunktionID := GET_ID(NULL);
          INSERT INTO aus_d_funktion (ID, ART, TYP, D_PERS_ID, D_BTS_ID, gueltig_von)
          VALUES( ZBR_AUS_DATA.vFunktionID, NULL, ZBR_AUS_DATA.vHV, ZBR_AUS_DATA.vPersonID, ZBR_AUS_DATA.vBTS_ID, ZBR_AUS_DATA.vLastUpdDate);      

        END IF;
                
      END IF;                          
    END IF; -- Ende Hauptverantwortlicher fr NRW
            
    /*************************************************************************
    Betreiber   
    D_FUNKTION.TYP = 'INH'
    Unterscheidung bez_art = 'F' -> D_PERSON.TYP = 'JP' sonst 'NP'        
    *************************************************************************/   
    ZBR_AUS_DATA.vPersonID3 := 'X';
    ZBR_AUS_DATA.vKOM_TEL := NULL;
    ZBR_AUS_DATA.vKom_fax := NULL;
    ZBR_AUS_DATA.vKom_mobil := NULL;
    ZBR_AUS_DATA.vKOM_EMAIL := NULL;
    ZBR_AUS_DATA.vKOM_INTERNET := NULL;
    ZBR_AUS_DATA.vKOM_SONST := NULL;      

    -- Kommunikationsmittel nur bei abweichendem Betreiber
    --IF vD0101.d0101_id <> vD0101.d0101$3_id THEN 
      ZBR_AUS_DATA.vKOM_TEL      := vD0101.d0101$3_KOM_TEL;
      ZBR_AUS_DATA.vKom_fax      := vD0101.d0101$3_KOM_fax;
      ZBR_AUS_DATA.vKom_mobil    := vD0101.d0101$3_KOM_mobil;
      ZBR_AUS_DATA.vKOM_EMAIL    := vD0101.d0101$3_KOM_email;
      ZBR_AUS_DATA.vKOM_INTERNET := vD0101.d0101$3_KOM_internet;
      ZBR_AUS_DATA.vKOM_SONST    := vD0101.d0101$3_KOM_sonst;                  
    --END IF;                     
            
    IF vD0101.d0101$3_bez_art = 'F' THEN -- Betreiber als Firma
      
      -- 23.04.2015 todo 57671090
      IF blvUtils.bea_konform(vD0101.d0101$3_daten_herkunft) = 1 THEN
        vKurzBez1 := NVL( vD0101.d0101$3_hit_bez_1, SUBSTR(vD0101.d0101$3_bez, 1, 30) );
        vKurzBez2 := vD0101.d0101$3_hit_bez_2;
      ELSE 
        Create_HitKurzBez(
           CASE WHEN vD0101.d0101$3_abw_post = 1 
              THEN NVL( NVL(vD0101.d0101$3_hit_p_bez_1 ,vD0101.d0101$3_hit_bez_1), vD0101.d0101$3_p_name) 
              ELSE  NVL( vD0101.d0101$3_hit_bez_1, vD0101.d0101$3_p_name)    
            END
          , -- 01.08.2013  todo 50506090
            -- 07.03.2014 keine Unterscheidung NRW und TH
            --CASE WHEN vGKZ2 = NRW THEN
              CASE WHEN vD0101.d0101$3_abw_post = 1 
                THEN NVL(vD0101.d0101$3_hit_p_bez_2, vD0101.d0101$3_hit_bez_2) 
                ELSE vD0101.d0101$3_hit_bez_2   
              END
            --ELSE
            --  CASE WHEN vD0101.d0101$3_abw_post = 1 
            --    THEN NVL( NVL(vD0101.d0101$3_hit_p_bez_2, vD0101.d0101$3_hit_bez_2), vD0101.d0101$3_p_name1) 
            --    ELSE NVL( vD0101.d0101$3_hit_bez_2, vD0101.d0101$3_p_name1)   
            --  END
            --END 
          , vKurzBez1, vKurzBez2);
      END IF;
      
      ZBR_AUS_DATA.vPersonID3 := fD_PERSON (
          NULL --ID
        , vD0101.d0101$3_p_anrede --ANREDE
        , vD0101.d0101$3_p_name  -- BEZEICHNUNG1 
        , CASE WHEN vD0101.d0101$3_abw_post = 1 THEN vD0101.d0101$3_p_name1 ELSE NULL END  --BEZEICHNUNG2
        , null  --GEBURTSDATUM
        , null  --GEBURTSORT
        , vKurzBez1
        , vKurzBez2
        , vD0101.d0101$3_nname --PersNachname(vD0101.d0101$3_nname, vD0101.d0101$3_vorsatz_nname, vD0101.d0101$3_nachsatz_nname) --NACHNAME
        , vD0101.d0101$3_vorsatz_nname, vD0101.d0101$3_nachsatz_nname
        , vD0101.d0101$3_a0101_03_axx2_code  --RECHTSFORM
        , vD0101.d0101$3_Titel  --TITEL
        , vD0101.d0101$3_VName  --VORNAME
        , 'JP'  -- Typ
        , vD0101.pers_id$3
        , vD0101.D0101$3_ID
         );         
                                               
    ELSE  -- Betreiber als natrl. Person

      -- 23.04.2015 todo 57671090
      IF blvUtils.bea_konform(vD0101.D0101$3_daten_herkunft) = 1 THEN
        vKurzBez1 := NVL( vD0101.d0101$3_hit_bez_1, SUBSTR(vD0101.d0101$3_bez, 1, 30) );
        vKurzBez2 := vD0101.d0101$3_hit_bez_2;
      ELSE 

        Create_HitKurzBez(
            CASE WHEN vD0101.d0101$3_abw_post = 1  
               THEN NVL( NVL(vD0101.d0101$3_hit_p_bez_1, vD0101.d0101$3_hit_bez_1), vD0101.d0101$3_bez)  -- 20.05.2015 vD0101.d0101$3_bez 
               ELSE NVL(vD0101.d0101$3_hit_bez_1, vD0101.d0101$3_bez )
            END --KURZBEZ1
          , CASE WHEN vD0101.d0101$3_abw_post = 1  
                 THEN vD0101.d0101$3_hit_p_bez_2
                 ELSE vD0101.d0101$3_hit_bez_2 
            END --KURZBEZ2
          , vKurzBez1, vKurzBez2);
      END IF;            
      -- existiert ein Hauptverantwortlicher
      /* 11.08.2014 IF vD0101.d0101$3_d010200_id2 = '-1' THEN
        vCnt := 0;
      ELSE
        SELECT COUNT(*) INTO vCnt
        FROM vis_d010200 d010200
        JOIN vis_d0102 d0102 ON d0102.id = d010200.d0102_id
          --11.06.2014 AND d010200.hauptansprechpartner = 1
          AND d0102.deleted = 0
          AND d010200.deleted = 0
        --11.06.2014 WHERE d010200.d0101_id = vD0101.d0101$3_id
        AND d010200.id = vD0101.d0101$3_d010200_id2;

      END IF; */
                                
      -- 11.08.2014 IF vCnt = 1 THEN -- Hauptverantwortlicher aus D010200 verwenden
        vCnt := 0;  
        FOR cD0102 IN (
          /* 11.08.2014SELECT d010200.id d010200_id, D0102.ANREDE, D0102.NNAME, D0102.VNAME, D0102.TITEL,
            d0102.vorsatz_nname, d0102.nachsatz_nname,
            D010200.KOM_TEL, D010200.kom_fax, D010200.KOM_INTERNET, D010200.KOM_EMAIL, D010200.kom_mobil, D010200.KOM_SONST, 
            d0102.pers_id 
          FROM vis_d010200 d010200
          JOIN vis_d0102 d0102 ON d0102.id = d010200.d0102_id
            --11.06.2014 AND d010200.hauptansprechpartner = 1
            AND d0102.deleted = 0
            AND d010200.deleted = 0
          --11.06.2014 WHERE d010200.d0101_id = vD0101.d0101$3_id
            AND d010200.id = vD0101.d0101$3_d010200_id2 */

          SELECT d010200.id d010200_id, D0102.ANREDE, D0102.NNAME, D0102.VNAME, D0102.TITEL,
            d0102.vorsatz_nname, d0102.nachsatz_nname,
            D010200.KOM_TEL, D010200.kom_fax, D010200.KOM_INTERNET, D010200.KOM_EMAIL, D010200.kom_mobil, D010200.KOM_SONST, 
            d0102.pers_id 
          FROM vis_d010200 d010200
          JOIN vis_d0102 d0102 ON d0102.id = d010200.d0102_id
            AND d0102.deleted = 0
            AND d010200.deleted = 0
            AND d010200.d0101_id = vD0101.d0101$3_id
            AND d010200.inhaber = 1
                
        ) LOOP
            
--              Create_HitKurzBez(
--                 CASE WHEN vD0101.d0101$3_abw_post = 1  
--                       THEN NVL( NVL(vD0101.d0101$3_hit_p_bez_1, vD0101.d0101$3_hit_bez_1), vD0101.d0101$3_bez )  
--                       ELSE NVL(vD0101.d0101$3_hit_bez_1, vD0101.d0101$3_bez )
--                  END --KURZBEZ1
--                , CASE WHEN vD0101.d0101$3_abw_post = 1  
--                       THEN vD0101.d0101$3_hit_p_bez_2
--                       ELSE vD0101.d0101$3_hit_bez_2 
--                  END --KURZBEZ2
--                , vKurzBez1, vKurzBez2);            
          IF vKurzbez1 IS NULL THEN
            Create_HitKurzBez( CreatePersonBez(cD0102.nname, cD0102.vname, cD0102.vorsatz_nname, cD0102.nachsatz_nname, cD0102.titel),
                               NULL, vKurzbez1, vKurzbez2);
          END IF;              

          ZBR_AUS_DATA.vPersonID3 := fD_PERSON (
              NULL --ID
            , cD0102.anrede --ANREDE
            , NULL, NULL --BEZEICHNUNG
            , null  --GEBURTSDATUM
            , null  --GEBURTSORT
            , vKurzbez1  -- 24.07.2013
            , vKurzBez2  -- 24.07.2013
            , cD0102.nname --PersNachname(cD0102.nname, cD0102.vorsatz_nname, cD0102.Nachsatz_nname) --NACHNAME
            , cD0102.vorsatz_nname, cD0102.Nachsatz_nname
            , NULL  --RECHTSFORM
            , cD0102.Titel  --TITEL
            , cD0102.VName  --VORNAME
            , 'NP'  -- Typ
            , vD0101.pers_id$3 -- 27.01.2015 cD0102.pers_id
            , vD0101.d0101$3_id -- 26.03.2015 cD0102.d010200_ID
             );      
                     
          -- Kommunikationsmittel
          -- 23.04.2015 todo 57686090 
          IF vD0101.d0101_id = vD0101.d0101$3_id THEN -- Kommunikationsmittel wenn vorhanden und kein abweichender Betreiber
          --23.04.2015 todo 57686090 IF cD0102.KOM_TEL || cD0102.kom_fax || cD0102.kom_mobil || cD0102.KOM_EMAIL || cD0102.KOM_INTERNET || cD0102.KOM_SONST IS NOT NULL THEN  
            ZBR_AUS_DATA.vKOM_TEL      := cD0102.KOM_TEL;
            ZBR_AUS_DATA.vKom_fax      := cD0102.KOM_fax;
            ZBR_AUS_DATA.vKom_mobil    := cD0102.KOM_mobil;
            ZBR_AUS_DATA.vKOM_EMAIL    := cD0102.KOM_email;
            ZBR_AUS_DATA.vKOM_INTERNET := cD0102.KOM_internet;
            ZBR_AUS_DATA.vKOM_SONST    := cD0102.KOM_sonst;                        
            --pD_Kom_Komplett(vPersonID3, NULL, NULL, cD0102.KOM_TEL, cD0102.kom_fax, cD0102.kom_mobil, cD0102.KOM_EMAIL, cD0102.KOM_INTERNET, cD0102.KOM_SONST);
          END IF;
          --END IF;                    
          vCnt := 1;      
        END LOOP;                
              
      --11.08.2014 ELSE -- kein D010200 vorh. -> Daten aus D0101 verwenden
      IF vCnt = 0 THEN -- kein Inhaber vorhanden
--            Create_HitKurzBez(
--                CASE WHEN vD0101.d0101$3_abw_post = 1  
--                     THEN NVL( NVL(vD0101.d0101$3_hit_p_bez_1, vD0101.d0101$3_hit_bez_1), vD0101.d0101$3_bez )  
--                     ELSE NVL(vD0101.d0101$3_hit_bez_1, vD0101.d0101$3_bez )
--                END --KURZBEZ1
--              , CASE WHEN vD0101.d0101$3_abw_post = 1  
--                     THEN vD0101.d0101$3_hit_p_bez_2
--                     ELSE vD0101.d0101$3_hit_bez_2 
--                END --KURZBEZ2
--              , vKurzBez1, vKurzBez2);

        IF vKurzbez1 IS NULL THEN
          Create_HitKurzBez( CreatePersonBez(vD0101.d0101$3_nname, vD0101.d0101$3_vname, vD0101.d0101$3_vorsatz_nname, vD0101.d0101$3_nachsatz_nname, vD0101.d0101$3_titel),
                             NULL, vKurzbez1, vKurzbez2);
        END IF;              

              
        ZBR_AUS_DATA.vPersonID3 := fD_PERSON (
            NULL --ID
          , vD0101.d0101$3_anrede --ANREDE
          , NULL, NULL --BEZEICHNUNG
          , null  --GEBURTSDATUM
          , null  --GEBURTSORT
          , vKurzBez1 -- 24.07.2013
          , vKurzBez2 -- 24.07.2013
          , vD0101.d0101$3_nname --PersNachname(vD0101.d0101$3_nname, vD0101.d0101$3_vorsatz_nname, vD0101.d0101$3_nachsatz_nname) --NACHNAME
          , vD0101.d0101$3_vorsatz_nname, vD0101.d0101$3_nachsatz_nname
          , NULL  --RECHTSFORM
          , vD0101.d0101$3_Titel  --TITEL
          , vD0101.d0101$3_VName  --VORNAME
          , 'NP'  -- Typ
          , vD0101.pers_id$3 --27.01.2015 NULL --pers_id
          , vD0101.D0101$3_ID
           );        
              
      END IF; -- vCnt = 0
              
    END IF; -- vD0101.d0101$3_bez_art      
                  
    ZBR_AUS_DATA.vFunktionID3 := GET_ID(NULL);
    INSERT INTO aus_d_funktion (ID, ART, TYP, D_PERS_ID, D_BTS_ID, gueltig_von)
    VALUES( ZBR_AUS_DATA.vFunktionID3, NULL, ZBR_AUS_DATA.vINH, ZBR_AUS_DATA.vPersonID3, ZBR_AUS_DATA.vBTS_ID, ZBR_AUS_DATA.vLastUpdDate);                   

    -- Kommunikationsmittel zur Funktion
    pD_Kom_Komplett(NULL, ZBR_AUS_DATA.vFunktionID3, NULL, ZBR_AUS_DATA.vKOM_TEL, ZBR_AUS_DATA.vKom_fax, ZBR_AUS_DATA.vKom_mobil, ZBR_AUS_DATA.vKOM_EMAIL, ZBR_AUS_DATA.vKOM_INTERNET, ZBR_AUS_DATA.vKOM_SONST);      
            
    -- Postanschrift Betreiber
    IF vD0101.d0101_id = vD0101.d0101$3_id THEN -- kein abweichender Betreiber
      -- wenn kein abweichender Betreiber dann BTRA der Betriebssttte verwenden

      ZBR_AUS_DATA.vID := GET_ID(NULL);     
      INSERT INTO AUS_R_FKT_ADR (ID, TYP, D_ADR_ID, D_FKT_ID)
      VALUES( ZBR_AUS_DATA.vID, CASE WHEN vD0101.d0101$3_bez_art = 'F' THEN 'ORG' ELSE 'PERS' END, 
              ZBR_AUS_DATA.vBTRA_ID, ZBR_AUS_DATA.vFunktionID3);
              
    ELSE
      ZBR_AUS_DATA.vPostadrID3 := fD_Postadresse( vD0101.d0101$3_P_land, vD0101.d0101$3_P_plz, vD0101.d0101$3_P_ORT, vD0101.d0101$3_P_ORTSTEIL, vD0101.d0101$3_IS_POSTFACH, vD0101.d0101$3_P_Postfach,  vD0101.d0101$3_P_STRASSE, vD0101.d0101$3_P_HAUSNR, vD0101.d0101$3_P_HAUSNRZUSATZ );
      
      --IF vD0101.d0101$3_gkz8 IS NULL THEN
      --  ZBR_AUS_DATA.vVerwaltungID2 := NULL;
      --ELSE
      ZBR_AUS_DATA.vVerwaltungID2 := fD_Verwaltung( vD0101.d0101$3_GKZ8,NULL, vD0101.d0101$3_p_Land);          
      --END IF;
          
      -- D_ADRESSE
      ZBR_AUS_DATA.vAdresseID3 := GET_ID(NULL);
      INSERT INTO aus_d_adresse ( ID, FREIBEZ, WECHSEL, D_KAT_ID, D_PADR_ID, D_VERW_ID, 
              gueltig_von)
      VALUES (ZBR_AUS_DATA.vAdresseID3, NULL, NULL, NULL, ZBR_AUS_DATA.vPostadrID3, ZBR_AUS_DATA.vVerwaltungID2, 
              GREATEST(ZBR_AUS_DATA.vLastUpdDate, vD0101.d0101_anmeldung) );

      ZBR_AUS_DATA.vID := GET_ID(NULL);     
      INSERT INTO AUS_R_FKT_ADR (ID, TYP, D_ADR_ID, D_FKT_ID)
      VALUES( ZBR_AUS_DATA.vID, CASE WHEN vD0101.d0101$3_bez_art = 'F' THEN 'ORG' ELSE 'PERS' END, 
              ZBR_AUS_DATA.vAdresseID3, ZBR_AUS_DATA.vFunktionID3);       
    END IF;   
    -- Registrierungen zum Betreiber
    pD_Reg_komplett( vD0101.d0101$3_id --pD0101_ID VARCHAR2
                   , NULL --pPersonID VARCHAR2
                   , ZBR_AUS_DATA.vFunktionID3 --pFunkID VARCHAR2
                   , NULL);       
      
    vRes := ZBR_AUS_DATA.vBTS_ID;  
  END IF; -- cD0101
  RETURN vRes;
END;

/*******************************************************************************
  Fllen des Ausgangskorbs
  Parameter:
  - pUserSID: ausgefhrt von User fr das Protokoll
  - pLastModified: optional alle Betriebe mit nderungen ab diesem Zeitpunkt 
  - pD0101_ID: optional VIS_D0101.ID wenn gezielt ein Betrieb bertragen werden soll
  - pMandant_SID: im Batch der zu verarbeitende Mandant
  - pForce: optional, bei 1 wird die Erstellung im Ausgangskorb erzwungen auch 
            wenn keine neueren Daten im Vergleich zum letzten Protokolleintrag
            (AUS_PROTOKOLL.LASTMODIFIED) fr den Betrieb vorhanden sind
  - pPrtStatus: Vorgabe fr AUS_D_PROTOKOLL.STATUS 
    0 - nicht verarbeitet, vor dem Vergleich, 
    2 - gesendet, zum Vergleich, 
    3 - nur zum Vergleich, wird nicht und wurde nicht gesendet, 
    4 - nur zum Vergleich mit dem Eingangskorb, 
    5 - neuer Betrieb ohne Dublettenabgleich senden, 
    6 - ohne Plausiprfung, 
    7 - Einzelmodus zum Speichern als 0 fr den direkten Export,  
    10 - vor der Besttigung beim manuellen Export  
  Rckgabe: Anzahl geschriebene Betriebe in AUS_D_BETRIEBSTAETTE
*******************************************************************************/
FUNCTION Ausgangskorb( pUserSID NUMBER, 
                       pD0101_ID VARCHAR2,
                       pLastModified DATE := ZBR_AUS_DATA.vDateMin,
                       pForce NUMBER := 0,
                       pPrtStatus NUMBER := 0
                     ) RETURN NUMBER AS
  vCnt PLS_INTEGER;
  vD010101_ok PLS_INTEGER;
  vGUID ZBR_AUS_DATA.tID;
  vTimeStamp TIMESTAMP;
  vSYSDATE CONSTANT DATE := SYSDATE;
  vUpdLastModified BOOLEAN;
  
  TYPE tCurZBR_AUS IS REF CURSOR RETURN ZBR_AUS_DATA.tZBR_AUS;
  CurZBR_AUS tCurZBR_AUS;
  vZBR_AUS ZBR_AUS_DATA.tbZBR_AUS;   
BEGIN
 
  Init();

  ParamsAusgangskorb(
    pD0101_ID,
    pLastModified,
    ZBR_AUS_DATA.vD0101_ID,
    ZBR_AUS_DATA.vLastModified,
    vD010101_ok);  
  
  --vD0101_ID := NVL(pD0101_ID, '%'); 
  --vLastModified := NVL(pLastModified, vDateMin);
  ZBR_AUS_DATA.vBts_Cnt := 0;
  ZBR_AUS_DATA.vBts_ID := '-1';

  IF pPrtStatus IN (0,1,3,5,6,7,8) THEN
    ZBR_AUS_DATA.vPrtStatus := pPrtStatus;
  ELSE
    ZBR_AUS_DATA.vPrtStatus := 0;   
  END IF;
  
  ZBR_AUS_DATA.vPlausiResult := 0;
  ZBR_AUS_DATA.vPlausiErrors := NULL; 
  ZBR_AUS_DATA.vPlausiWarnings := NULL;
  ZBR_AUS_DATA.vAnz_Usecases := -1;

  -- berprfung Direktmodus oder Batch-Verarbeitung
  IF LENGTH(pD0101_ID) = 32 AND INSTR(pD0101_ID, '%') = 0 THEN 
    ZBR_AUS_DATA.vBatchMode := False;
    
    CASE
    WHEN ZBR_AUS_DATA.vPrtStatus = 0 AND vVerfahren <> QUELLE_IDV_NRW /*vGKZ2 <> ZBR_AUS_DATA.NRW*/ THEN  -- manueller Export 
      ZBR_AUS_DATA.vPrtStatus := 10; 
    WHEN pPrtStatus IN( 6, 7, 8) THEN  -- bei Ablehnung im EK wird mit 8 exportiert
      ZBR_AUS_DATA.vPrtStatus := 0;
    ELSE NULL;
    END CASE;
  --  vD010101_ok := 0;
  ELSE
    ZBR_AUS_DATA.vBatchMode := True;
  --  vD010101_ok := 1;   
  
  END IF;
  
  
  -- betroffene Betriebe selektieren
  IF vVerfahren = QUELLE_IDV_NRW /*vGKZ2 = ZBR_AUS_DATA.NRW*/ THEN
    Cursor_ZBR_AUS_NRW(ZBR_AUS_DATA.vD0101_ID, ZBR_AUS_DATA.vLASTMODIFIED, pFORCE, vD010101_OK, CurZBR_AUS);
  ELSE
    Cursor_ZBR_AUS_TH(ZBR_AUS_DATA.vD0101_ID, ZBR_AUS_DATA.vLASTMODIFIED, pFORCE, vD010101_OK, CurZBR_AUS);
  END IF;
  
  --ZBR_PLAUSI.vGKZ2 := blv_sys.get_gkz2; --vGKZ2;  
  
  LOOP
  
    FETCH CurZBR_AUS BULK COLLECT INTO vZBR_AUS LIMIT 500;
    EXIT WHEN vZBR_AUS.COUNT = 0; 
    
    FOR iZBR_AUS IN vZBR_AUS.FIRST .. vZBR_AUS.LAST LOOP    
      zbr_aus_data.vAnz_Usecases := -1;
      
      IF pPrtStatus IN( 3, 6 ) THEN -- keine Plausiprfung 01.08.2013 STATUS = 6
        -- Status = 6 wird als Status = 0 gespeichert
        ZBR_AUS_DATA.vPlausiResult := 0;
      ELSE
        
        DELETE ein_d_usecase
        WHERE d0101_id = vZBR_AUS(iZBR_AUS).D0101_ID
        AND aend_art IN ('3', '4'); -- Fehler vom Autoexport bzw. Register      
                
        -- im Batch Plausiprfung fr jeden Betrieb
        IF ZBR_AUS_DATA.vBatchMode THEN
          ZBR_PLAUSI.SBS_AUSGANGBatch( vZBR_AUS(iZBR_AUS).D0101_ID, ZBR_AUS_DATA.vPlausiResult, ZBR_AUS_DATA.vPlausiErrors, ZBR_AUS_DATA.vPlausiWarnings);
          WriteMeldung(vZBR_AUS(iZBR_AUS).D0101_ID);         
        ELSE
                     
          ZBR_PLAUSI.SBS_AUSGANG(pD0101_ID, ZBR_AUS_DATA.vPlausiResult, ZBR_AUS_DATA.vPlausiErrors, ZBR_AUS_DATA.vPlausiWarnings, pPrtStatus);

        END IF;
      END IF;

      IF ZBR_AUS_DATA.vPlausiResult < 2 THEN -- bei Fehler Betrieb nicht in Ausgangskorb schreiben
       
        ZBR_AUS_DATA.vLastUpdDate := GREATEST( vZBR_AUS(iZBR_AUS).d0101_upd_date,
                                  vZBR_AUS(iZBR_AUS).d3_upd_date,
                                  vZBR_AUS(iZBR_AUS).d010101_upd_date,
                                  vZBR_AUS(iZBR_AUS).d010101_del_date,
                                  vZBR_AUS(iZBR_AUS).d010200_upd_date,
                                  vZBR_AUS(iZBR_AUS).d010102_upd_date,
                                  vZBR_AUS(iZBR_AUS).d010110_upd_date);
        SAVEPOINT ausgangskorb;                              
        ZBR_AUS_DATA.vBTS_ID := FillAusgangskorb( vZBR_AUS(iZBR_AUS).D0101_id, pUserSID );

        IF ZBR_AUS_DATA.vBTS_ID <> '-1' THEN
        
          IF vVerfahren = QUELLE_IDV_NRW /* vGKZ2 = ZBR_AUS_DATA.NRW*/ THEN -- fr NRW        
            ZBR_AUS_DATA.vBTS_Cnt := ZBR_AUS_DATA.vBTS_Cnt + 1;
            IF ZBR_AUS_DATA.bCommit THEN
              COMMIT;
            END IF;
          
          ELSE -- Usecase ermitteln in TH Ausgangskorb gefllt
        
            IF pPrtStatus <> 3 THEN -- nur zum Vergleich in den Ausgangskorb, Usecases sind nicht notwendig                       
              zbr_aus_data.vAnz_Usecases := CreateUsecase( vZBR_AUS(iZBR_AUS).D0101_id, pUserSID, ZBR_AUS_DATA.vProtokoll_Mandant, ZBR_AUS_DATA.vLastUpdDate, vUpdLastModified); 
            ELSE
              zbr_aus_data.vAnz_Usecases := 0;
            END IF;
            
            IF pPrtStatus IN( 3, 8) OR zbr_aus_data.vAnz_Usecases > 0 THEN
              ZBR_AUS_DATA.vBTS_Cnt := ZBR_AUS_DATA.vBTS_Cnt + 1;
              IF ZBR_AUS_DATA.bCommit AND MOD(ZBR_AUS_DATA.vBTS_Cnt, 500) = 0 THEN                       
                COMMIT;              
              END IF;
            ELSE 
             
              ZBR_AUS_DATA.vBTS_ID := NULL;
              ROLLBACK TO ausgangskorb;
              
              IF zbr_aus_data.vAnz_Usecases = -1 AND NOT ZBR_AUS_DATA.vBatchMode THEN
                ZBR_AUS_DATA.vBTS_Cnt := -1;
              END IF;
             
              IF vVerfahren <> QUELLE_IDV_NRW /*vGKZ2 <> ZBR_AUS_DATA.NRW*/ AND vUpdLastModified THEN                            
                -- bei letzten Stand im Ausgangskorb LASTMODIFIED aktualisieren
                FOR cPrt IN (
                  SELECT dx.* FROM (
                    SELECT prt.rowid prt_rowid  --, prt.d_bts_id, prt.lastmodified, prt.ins_date
                    FROM aus_d_protokoll prt
                    WHERE prt.d0101_id = vZBR_AUS(iZBR_AUS).D0101_id
                    AND prt.status IN (0, 2, 3, 5, 6, 10)
                    AND prt.deleted = 0
                    --AND prt.lastmodified < ZBR_AUS_DATA.vLastUpdDate 
                    ORDER BY prt.ins_date DESC NULLS LAST
                  ) dx
                  WHERE ROWNUM = 1
                ) LOOP

                  UPDATE aus_d_protokoll
                  SET lastmodified = ZBR_AUS_DATA.vLastUpdDate
                  WHERE rowid = cPrt.prt_rowid;

                END LOOP;           
              END IF;                
            END IF;            
        
          END IF; -- NRW
        
        ELSE
          ZBR_AUS_DATA.vBTS_ID := NULL;
          zbr_aus_data.vAnz_Usecases := -3; -- keine Daten gefunden - Fehler 
          ROLLBACK TO ausgangskorb;
        END IF;                  
      ELSE
        zbr_aus_data.vAnz_Usecases := -2; -- Plausi-Fehler
      END IF;  -- vPlausiResult
    END LOOP;  -- iZBR_AUS
  END LOOP; -- alle Betriebe
    
  IF ZBR_AUS_DATA.bCommit THEN    
    COMMIT;
  END IF;
    
  RETURN ZBR_AUS_DATA.vBTS_Cnt;

END Ausgangskorb;

/**
  Plausiprfung fr die Erstbefllung
  
Einen Betrieb gezielt prfen:
select dx.* from table( zbr_aus.PlausiErstbefuellung( '3BDF577C64A844D3BD06341F2FC51D43' )) dx

Alle Betriebe mit einer HIT-Nummer, die noch nicht ber die Erstbefllung im Ausgangskorb sind. Es werden nur die Betriebe mit Plausi-Fehlern ausgegeben:
select dx.* from table( zbr_aus.PlausiErstbefuellung ) dx

Alle Betriebe aus AGB, wobei eine gezielt Prfung erfolgt und alle Betriebe in der Ergebnismenge enthalten sind:
select d0101.code , dx.error_message 
from  vis_d0101 d0101
cross join table( zbr_aus.PlausiErstbefuellung( d0101.id ) ) dx
where d0101.code LIKE 'ABG%'

Alle Betriebe aus AGB mit Fehlern:
select d1.* from (
select d0101.code , dx.error_message 
from  vis_d0101 d0101
cross join table( zbr_aus.PlausiErstbefuellung( d0101.id ) ) dx
where d0101.code LIKE 'ABG%'
) d1
where d1.error_message like 'Fehler%'

**/
FUNCTION PlausiErstbefuellung (pD0101_ID IN vis_d0101.id%TYPE := '%') RETURN zbr_aus_data.tbPlausi PIPELINED
AS 
  TYPE tZBR_AUS IS TABLE OF CurZBR_AUS%ROWTYPE;
  vZBR_AUS tZBR_AUS;   
  vPlausi zbr_aus_data.tPlausi;
  vCnt PLS_INTEGER; 
  
  CURSOR cChk (pID IN vis_d0101.id%TYPE) IS
  SELECT 
    ( SELECT MAX(uc.d0101_id) 
      FROM aus_d_usecase uc 
      WHERE uc.usecase = 'ERSTBEFUELLUNG'
      AND uc.d0101_id = pID ) uc_d0101_id ,
  
    ( SELECT MAX(d010102.d0101_id)       
      FROM vis_d010102 d010102 
      WHERE d010102.deleted = 0
        AND d010102.a010145_sid = A010145_HIT_NR --Registriernummer (HIT)
        AND d010102.d0101_id = pID ) d010102_d0101_id  
  
  FROM DUAL;  
  
  vChk cChk%ROWTYPE;
    
BEGIN
 
  ZBR_AUS_DATA.vErstMode := True;
  Init();

  ZBR_AUS_DATA.vBts_Cnt := 0;
  ZBR_AUS_DATA.vBts_ID := '-1';

  ZBR_AUS_DATA.vPrtStatus := 0;   
  
  ZBR_AUS_DATA.vPlausiResult := 0;
  ZBR_AUS_DATA.vPlausiErrors := NULL; 
  ZBR_AUS_DATA.vPlausiWarnings := NULL;
  ZBR_AUS_DATA.vAnz_Usecases := -2;

  ZBR_AUS_DATA.vBatchMode := FALSE;  
   
  --ZBR_PLAUSI.vGKZ2 := blv_sys.get_gkz2; --vGKZ2;
  
  IF CurZBR_AUS%ISOPEN THEN
    CLOSE CurZBR_AUS;
  END IF;
    
  OPEN CurZBR_AUS (pD0101_ID);
  LOOP
  
    FETCH CurZBR_AUS BULK COLLECT INTO vZBR_AUS LIMIT 500;
    IF vZBR_AUS.COUNT = 0 AND pD0101_ID <> '%' THEN

      vPlausi.d0101_id := pD0101_ID;

      OPEN cChk (pD0101_ID);
      FETCH cChk INTO vChk;
      IF cChk%FOUND THEN

        --vPlausi.error_message := 'Keine Registriernummer (HIT) vorhanden oder bereits im Ausgangskorb.';
        IF vChk.uc_d0101_id <> '-1' THEN
          vPlausi.error_message := 'Betriebssttte ist bereits im Ausgangskorb zur Erstbefllung.';
          PIPE ROW(vPlausi);      
        
        ELSIF vChk.D010102_d0101_ID IS NULL THEN        
          vPlausi.error_message := 'Betriebssttte hat keine Registriernummer (HIT).';
          PIPE ROW(vPlausi);      
          
        END IF;    
 
      END IF;
      CLOSE cChk;
              
    END IF;  
      
    EXIT WHEN vZBR_AUS.COUNT = 0; 
    
    FOR iZBR_AUS IN vZBR_AUS.FIRST .. vZBR_AUS.LAST LOOP    
      zbr_aus_data.vAnz_Usecases := -2;
      
      --ZBR_PLAUSI.SBS_AUSGANGBatch( vZBR_AUS(iZBR_AUS).D0101_ID, ZBR_AUS_DATA.vPlausiResult, ZBR_AUS_DATA.vPlausiErrors, ZBR_AUS_DATA.vPlausiWarnings);
      ZBR_PLAUSI.SBS_AUSGANG( vZBR_AUS(iZBR_AUS).D0101_ID, ZBR_AUS_DATA.vPlausiResult, ZBR_AUS_DATA.vPlausiErrors, ZBR_AUS_DATA.vPlausiWarnings, 0);
      
      IF pD0101_ID <> '%' AND ZBR_AUS_DATA.vPlausiResult < 2 THEN 
        vPlausi.d0101_id := pD0101_ID;
        vPlausi.error_message := 'keine Fehler';
        PIPE ROW(vPlausi);        
        
      ELSIF ZBR_AUS_DATA.vPlausiResult = 2 THEN -- bei Fehler Betrieb 
        vPlausi.d0101_id := vZBR_AUS(iZBR_AUS).D0101_ID;
        vPlausi.error_message := 'Fehler: ' || ZBR_AUS_DATA.vPlausiErrors ||
        CASE WHEN ZBR_AUS_DATA.vPlausiWarnings IS NOT NULL 
        THEN zbr_aus_data.CRLF || 'Hinweise: ' || ZBR_AUS_DATA.vPlausiWarnings END;
        PIPE ROW(vPlausi);        
      END IF;  -- vPlausiResult
    END LOOP;  -- iZBR_AUS    
    
  END LOOP; -- alle Betriebe
  CLOSE CurZBR_AUS;
  ZBR_AUS_DATA.vErstMode := False;
  
  RETURN;
  
END PlausiErstbefuellung;



/*******************************************************************************
  Erstbefllung des Ausgangskorbs
*******************************************************************************/
PROCEDURE Erstbefuellung(pD0101_ID IN VARCHAR2 := '%') AS
  TYPE tZBR_AUS IS TABLE OF CurZBR_AUS%ROWTYPE;
  vZBR_AUS tZBR_AUS;   
BEGIN
 
  ZBR_AUS_DATA.vErstMode := True;
  Init();

  ZBR_AUS_DATA.vBts_Cnt := 0;
  ZBR_AUS_DATA.vBts_ID := '-1';

  ZBR_AUS_DATA.vPrtStatus := 0;   
  
  ZBR_AUS_DATA.vPlausiResult := 0;
  ZBR_AUS_DATA.vPlausiErrors := NULL; 
  ZBR_AUS_DATA.vPlausiWarnings := NULL;
  ZBR_AUS_DATA.vAnz_Usecases := -2;

  ZBR_AUS_DATA.vBatchMode := FALSE;  
   
  --ZBR_PLAUSI.vGKZ2 := blv_sys.get_gkz2; --vGKZ2;
  
  IF CurZBR_AUS%ISOPEN THEN
    CLOSE CurZBR_AUS;
  END IF;
  
  OPEN CurZBR_AUS(pD0101_ID);
  LOOP
    FETCH CurZBR_AUS BULK COLLECT INTO vZBR_AUS LIMIT 500;
    EXIT WHEN vZBR_AUS.COUNT = 0; 
    
    FOR iZBR_AUS IN vZBR_AUS.FIRST .. vZBR_AUS.LAST LOOP    
      zbr_aus_data.vAnz_Usecases := -2;
      
      --ZBR_PLAUSI.SBS_AUSGANGBatch( vZBR_AUS(iZBR_AUS).D0101_ID, ZBR_AUS_DATA.vPlausiResult, ZBR_AUS_DATA.vPlausiErrors, ZBR_AUS_DATA.vPlausiWarnings);
      ZBR_PLAUSI.SBS_AUSGANG( vZBR_AUS(iZBR_AUS).D0101_ID, ZBR_AUS_DATA.vPlausiResult, ZBR_AUS_DATA.vPlausiErrors, ZBR_AUS_DATA.vPlausiWarnings, 0);

      IF ZBR_AUS_DATA.vPlausiResult < 2 THEN -- bei Fehler Betrieb nicht in Ausgangskorb schreiben
       
        ZBR_AUS_DATA.vLastUpdDate := SYSDATE;
        SAVEPOINT ausgangskorb;                              
        ZBR_AUS_DATA.vBTS_ID := FillAusgangskorb( vZBR_AUS(iZBR_AUS).D0101_id, -1 );

        IF ZBR_AUS_DATA.vBTS_ID <> '-1' THEN

          GroupBa(PBTS_ID => ZBR_AUS_DATA.vBTS_ID);  

          UPDATE aus_d_protokoll
          SET prio = 0, status = 0
          WHERE d_bts_id = ZBR_AUS_DATA.vBTS_ID;
           
          DELETE ein_d_usecase
          WHERE d0101_id = vZBR_AUS(iZBR_AUS).D0101_id
          AND usecase = 'ERSTBEFUELLUNG';
          
          WriteUsecaseErstbefuellung( ZBR_AUS_DATA.vBTS_ID, vZBR_AUS(iZBR_AUS).D0101_id, SYSDATE, NULL, NULL, ZBR_AUS_DATA.vProtokoll_Mandant );
          ZBR_AUS_DATA.vBTS_Cnt := ZBR_AUS_DATA.vBTS_Cnt + 1;
          IF ZBR_AUS_DATA.bCommit AND MOD(ZBR_AUS_DATA.vBTS_Cnt, 500) = 0 THEN                       
            COMMIT;              
          END IF;
                   
        ELSE
          ZBR_AUS_DATA.vBTS_ID := NULL;
          zbr_aus_data.vAnz_Usecases := -1; -- Kennzeichen keine aktuellen Daten 
          ROLLBACK TO ausgangskorb;
        END IF;                  
      ELSE
        WriteMeldung(vZBR_AUS(iZBR_AUS).D0101_ID, 'ERSTBEFUELLUNG');             
      END IF;  -- vPlausiResult
    END LOOP;  -- iZBR_AUS    
    
  END LOOP; -- alle Betriebe
  CLOSE CurZBR_AUS; 
   
  IF ZBR_AUS_DATA.bCommit THEN    
    COMMIT;
  END IF;

  ZBR_AUS_DATA.vErstMode := False;

END Erstbefuellung;


/*******************************************************************************
  Erstbefllung
  08.07.2013 entfernt
*******************************************************************************/ 
--PROCEDURE Ausgangskorb01(pUserSID IN INT, pBTS_Cnt OUT INT) AS
--BEGIN
--
--  vBatchMode := True;
----  vErstMode := 1;
--  
--  pBTS_Cnt := Ausgangskorb(pUserSID, NULL, NULL, 0, 1);  
--
--  vBatchMode := False;
----  vErstMode := 0;
--
--END;

/**
Letzten Stand im Ausgangskorb lschen
pTyp: Bestimmt welcher Wert ber pValue bergeben wird
mgliche Werte:
- D0101_ID
- D0101_CODE
**/
PROCEDURE DeleteLastBy(pTyp IN VARCHAR2, pValue IN zbr_aus_data.tID) AS

  CURSOR c1 (pCode IN VARCHAR2) IS
    select prt.id 
    from aus_d_protokoll prt
    join vis_d0101 d0101 on d0101.id = prt.d0101_id 
    and d0101.code = pCode
    order by prt.ins_date desc;

  CURSOR c2 (pID IN zbr_aus_data.tID) IS
    select prt.id 
    from aus_d_protokoll prt
    join vis_d0101 d0101 on d0101.id = prt.d0101_id 
    WHERE prt.d0101_id = pID
    order by prt.ins_date desc;

  vPRT_ID zbr_aus_data.tID := NULL;
BEGIN

  CASE pTyp
  WHEN 'D0101_CODE' THEN
    OPEN c1 (pValue);
    FETCH c1 INTO vPRT_ID;
    CLOSE c1;
  WHEN 'D0101_ID' THEN
    OPEN c2 (pValue);
    FETCH c2 INTO vPRT_ID;
    CLOSE c2;
  ELSE NULL;
  END CASE;
  
  IF vPRT_ID <> '-1' THEN
    DeleteByProtID(vPrt_ID);
  END IF;

END DeleteLastBy;

/*******************************************************************************
  kompletten Ausgangskorbs fr einen Protokolleintrag einschl. aller 
  folgenden Eintrge fr diesen Betrieb lschen
  Parameter:
  - pProtID: ID des Protokolls
*******************************************************************************/
PROCEDURE DeleteByProtID( pProtID VARCHAR2) AS
  vBTS_ID AUS_D_BETRIEBSSTAETTE.ID%TYPE;
  
--  CURSOR cUsc (pID IN ZBR_AUS_DATA.tID) IS
--  SELECT uc.d_bts_id2 
--  FROM aus_d_usecase uc 
--  WHERE uc.d_bts_id2 = pID;
    
--  vUsc cUsc%ROWTYPE;
  
  CURSOR cAdr (pID IN ZBR_AUS_DATA.tID) IS
  SELECT id, d_kat_id, d_padr_id, d_verw_id 
  FROM aus_d_adresse 
    WHERE ID IN ( 
      -- AUS_R_ABT_ADR
      SELECT r.d_adr_id
      FROM aus_d_abteilung abt
      JOIN AUS_R_ABT_ADR r ON abt.id = r.d_abt_id
       AND abt.d_bts_id = pID
      UNION ALL  -- AUS_R_PERS_ADR  
      SELECT R.D_ADR_ID
      FROM aus_d_funktion funk 
      JOIN aus_r_pers_adr r ON R.D_PERS_ID = FUNK.D_PERS_ID
       AND FUNK.D_BTS_ID = pID
      UNION ALL -- AUS_R_FUNK_ADR
      SELECT R.D_ADR_ID
      FROM aus_d_funktion funk 
      JOIN aus_r_fkt_adr r ON R.D_fkt_ID = FUNK.ID
       AND FUNK.D_BTS_ID = pID
      UNION ALL  -- AUS_R_BTS_ADR
      SELECT R.D_ADR_ID
      FROM aus_r_bts_adr r 
      WHERE r.D_BTS_ID = pID );
  
  TYPE tAdr IS TABLE OF cAdr%ROWTYPE ;  
  vAdr tAdr;  
BEGIN
  /*****************************************************************************
  1. BTS_ID bestimmen
  2. AUS_D_ADRESSEN ber
     - AUS_R_ABT_ADR - AUS_D_ABTEILUNG
     - AUS_R_PERS_ADR - AUS_D_PERSON - AUS_D_FUNKTION
     - AUS_R_FKT_ADR - AUS_D_FUNKTION
     - AUS_R_BTS_ADR    
    zustzlich lschen
    - AUS_D_VERWALTUNG
    - AUS_D_KATASTER
    - AUS_D_POSTADRESSE
     
  3. AUS_D_REGISTRIERUNG ber
     - AUS_R_BTS_REG
     - AUS_R_FKT_REG - AUS_D_FUNKTION
     - AUS_R_PERS_REG - AUS_D_PERSON - AUS_D_FUNKTION
     - AUS_R_ABT_REG
     
  4. AUS_D_KOMMUNIKATION ber
     - AUS_R_BTS_KOM
     - AUS_R_FKT_KOM - AUS_D_FUNKTION
     - AUS_R_PERS_KOM - AUS_D_PERSON - AUS_D_FUNKTION
  5. AUS_D_BEZIEHUNG ber
     - AUS_R_BTS_BZH
  6. AUS_D_PERSON ber
     - AUS_D_FUNKTION
  7. AUS_D_TNIERANGABEN
  8. AUS_D_BETRIEBSSTAETTE
  
  automatisch gelscht durch DELETE CASCADE Referenzen
  AUS_D_BETRIEBSSTAETTE
  - AUS_D_ABTEILUNG
  - AUS_D_BETRIEBSART
  - AUS_D_FUNKTION
  - AUS_D_PROTOKOLL
  - AUS_D_TAETIGKEIT
  - AUS_D_USECASE
  - AUS_R_BTS_ADR
  - AUS_R_BTS_BEHOER
  - AUS_R_BTS_BZH
  - AUS_R_BTS_KOM
  - AUS_R_BTS_REG
  *****************************************************************************/    
  FOR c1 IN (
    SELECT prt.d_bts_id
    FROM aus_d_protokoll prt0
    JOIN aus_d_protokoll prt ON prt.d0101_id = prt0.d0101_id
    AND prt.ins_date >= prt0.ins_date
    WHERE prt0.id = pProtID
    ORDER BY prt.ins_date DESC -- jngste zuerst lschen wegen aus_d_usecase.d_bts_id2
  ) LOOP
    
    vBTS_ID := c1.d_bts_id;
/*    --1.
    SELECT prot.d_bts_id INTO vBTS_ID
    FROM aus_d_protokoll prot
    WHERE prot.id = pProtID;
    
    -- berprfung ob BTS_ID in AUS_D_USE_CASE.D_BTS_ID2 verwendet wird, 
    -- dann Lschen nicht durchfhren 
    OPEN cUsc (vBTS_ID);
    FETCH cUsc INTO vUsc;
    CLOSE cUsc; 
    
    IF vUsc.d_bts_id2 IS NOT NULL THEN
      RETURN;
    END IF;
*/    
    --2. AUS_D_ADRESSE
    /*FOR cAdr IN (
      SELECT id, d_kat_id, d_padr_id, d_verw_id 
      FROM aus_d_adresse 
        WHERE ID IN ( 
          -- AUS_R_ABT_ADR
          SELECT r.d_adr_id
          FROM aus_d_abteilung abt
          JOIN AUS_R_ABT_ADR r ON abt.id = r.d_abt_id
           AND abt.d_bts_id = vBTS_id
          UNION ALL  -- AUS_R_PERS_ADR  
          SELECT R.D_ADR_ID
          FROM aus_d_funktion funk 
          JOIN aus_r_pers_adr r ON R.D_PERS_ID = FUNK.D_PERS_ID
           AND FUNK.D_BTS_ID = vBTS_ID
          UNION ALL -- AUS_R_FUNK_ADR
          SELECT R.D_ADR_ID
          FROM aus_d_funktion funk 
          JOIN aus_r_fkt_adr r ON R.D_fkt_ID = FUNK.ID
           AND FUNK.D_BTS_ID = vBTS_ID
          UNION ALL  -- AUS_R_BTS_ADR
          SELECT R.D_ADR_ID
          FROM aus_r_bts_adr r 
          WHERE r.D_BTS_ID = vBTS_ID )
    ) LOOP
    
      DELETE aus_d_verwaltung WHERE id = cAdr.d_verw_id;
      DELETE aus_d_kataster WHERE id = cAdr.d_kat_id;
      DELETE aus_d_postadresse WHERE id = cAdr.d_padr_id;
      DELETE aus_d_adresse WHERE id = cAdr.id;
      
    END LOOP; */
    
      
    OPEN cAdr (vBTS_ID); 
    FETCH cAdr BULK COLLECT INTO vAdr; 
    CLOSE cAdr;
    IF vAdr.COUNT > 0 THEN
      FORALL iAdr IN vAdr.FIRST .. vAdr.LAST    
        DELETE aus_d_verwaltung WHERE id = vAdr(iAdr).d_verw_id;
          
      FORALL iAdr IN vAdr.FIRST .. vAdr.LAST    
        DELETE aus_d_kataster WHERE id = vAdr(iAdr).d_kat_id;
    
      FORALL iAdr IN vAdr.FIRST .. vAdr.LAST    
        DELETE aus_d_postadresse WHERE id = vAdr(iAdr).d_padr_id;
      
      FORALL iAdr IN vAdr.FIRST .. vAdr.LAST    
        DELETE aus_d_adresse WHERE id = vAdr(iAdr).id;
    END IF;

    --3. AUS_D_REGISTRIERUNG ber
    --   AUS_R_BTS_REG
    DELETE AUS_D_REGISTRIERUNG 
    WHERE ID IN (
    SELECT R.D_REG_ID
    FROM aus_r_bts_reg r
    WHERE R.D_BTS_ID = vBTS_ID);
    
    -- AUS_R_FKT_REG - AUS_D_FUNKTION
    DELETE AUS_D_REGISTRIERUNG 
    WHERE ID IN (
    SELECT R.D_REG_ID 
    FROM aus_d_funktion funk 
    JOIN aus_r_fkt_reg r ON R.D_fkt_ID = FUNK.ID
     AND FUNK.D_BTS_ID = vBTS_ID);

    -- AUS_R_PERS_REG - AUS_D_PERSON - AUS_D_FUNKTION
    DELETE AUS_D_REGISTRIERUNG 
    WHERE ID IN (
    SELECT R.D_REG_ID 
    FROM aus_d_funktion funk 
    JOIN aus_r_pers_reg r ON R.D_pers_ID = FUNK.d_pers_ID
     AND FUNK.D_BTS_ID = vBTS_ID);     

    --   AUS_R_ABT_REG
    DELETE AUS_D_REGISTRIERUNG 
    WHERE ID IN (
    SELECT R.D_REG_ID 
    FROM aus_d_abteilung abt 
    JOIN aus_r_abt_reg r ON R.D_abt_ID = abt.ID
     AND abt.D_BTS_ID = vBTS_ID);     


    --4. AUS_D_KOMMUNIKATION ber
    -- AUS_R_BTS_KOM
    DELETE aus_d_kommunikation
    WHERE id IN (
    SELECT R.D_KOM_ID
    FROM aus_r_bts_kom r 
    WHERE R.D_BTS_ID = vBTS_ID);
    
    -- AUS_R_FKT_KOM - AUS_D_FUNKTION
    DELETE aus_d_kommunikation
    WHERE id IN (
    SELECT R.D_KOM_ID
    FROM aus_r_fkt_kom r
    JOIN aus_d_funktion funk ON funk.id = R.D_FKT_ID 
    WHERE funk.D_BTS_ID = vBTS_ID);
    
    -- AUS_R_PERS_KOM - AUS_D_PERSON - AUS_D_FUNKTION    
    DELETE aus_d_kommunikation
    WHERE id IN (
    SELECT R.D_KOM_ID
    FROM aus_r_pers_kom r
    JOIN aus_d_funktion funk ON funk.d_pers_id = R.D_pers_ID 
    WHERE funk.D_BTS_ID = vBTS_ID);
    
    --5. AUS_D_BEZIEHUNG ber
    -- AUS_R_BTS_BZH   
    DELETE aus_d_beziehung
    WHERE id IN (
    SELECT R.D_BZH_ID
    FROM aus_r_bts_bzh r 
    WHERE R.D_BTS_ID = vBTS_ID);   
    
    --6. AUS_D_PERSON ber
    -- AUS_D_FUNKTION
    DELETE aus_d_person
    WHERE id IN (
    SELECT funk.d_pers_id
    FROM aus_d_funktion funk 
    WHERE funk.D_BTS_ID = vBTS_ID); 
      
    --7. Tierangaben
    DELETE AUS_D_TIERANGABEN
    WHERE d_bts_id = vBTS_ID;
        
    --8. AUS_D_BETRIEBSSTAETTE
    DELETE AUS_D_BETRIEBSSTAETTE
    WHERE id = vBTS_ID;
  END LOOP;
END DeleteByProtID;

/*******************************************************************************
  kompletten Ausgangskorbs fr einen aus_d_betriebsstaette - Eintrag lschen
  Parameter:
  - pBtsID: aus_d_betriebsstaette.id
*******************************************************************************/
PROCEDURE DeleteByBtsID( pBtsID VARCHAR2) AS
vID ZBR_AUS_DATA.tID;
BEGIN

  SELECT prt.id INTO vID
  FROM aus_d_protokoll prt 
  WHERE prt.d_bts_id = pBtsID;
    
  DeleteByProtID(vID);
  
  EXCEPTION 
  WHEN no_data_found THEN 
    NULL;

END;


/*******************************************************************************
  kompletten Ausgangskorbs fr einen Usecase-Eintrag lschen
  Parameter:
  - pUsecaseID: ID des Usecase
*******************************************************************************/
PROCEDURE DeleteByUsecaseID( pUsecaseID IN VARCHAR2) AS
 vID aus_d_protokoll.id%TYPE;
BEGIN

  -- AUS_D_PROTOKOLL.ID ermittel ber usecase.id
  SELECT prt.id INTO vID
  FROM aus_d_usecase uc
  JOIN aus_d_protokoll prt ON prt.d_bts_id = uc.d_bts_id
  AND uc.id = pUsecaseID;
    
  DeleteByProtID(vID);
  
  EXCEPTION 
  WHEN no_data_found THEN 
    NULL;
  
END;

Function GetAdresse(pAdr_ID IN EIN_D_ADRESSE.ID%TYPE, pTyp IN VARCHAR2) RETURN ZBR_AUS_DATA.tAdr AS
  res ZBR_AUS_DATA.tAdr := NULL;
BEGIN


  IF pADR_ID IS NOT NULL THEN
  
    res.typ := pTyp;

    SELECT * INTO res.adr
    FROM aus_d_adresse 
    WHERE ID = pAdr_ID;
  
    res.adr.wechsel := NVL(res.adr.wechsel, 0); 
  
    IF res.adr.d_verw_id IS NOT NULL THEN      
      SELECT * INTO res.verw
      FROM aus_D_VERWALTUNG
      WHERE id = res.adr.d_verw_id;               
    END IF; 

    IF res.adr.d_kat_id IS NOT NULL THEN
      SELECT * INTO res.kat
      FROM aus_D_KATASTER
      WHERE id = res.adr.d_kat_id;               
    END IF;     


    IF res.adr.d_padr_id IS NOT NULL THEN
      SELECT * INTO res.padr
      FROM aus_D_POSTADRESSE
      WHERE id = res.adr.d_padr_id;    
                     
    END IF;     
 
  END IF;
 
  RETURN res;
END GetAdresse;


PROCEDURE Clear_BTS( pBTS IN OUT NOCOPY ZBR_AUS_DATA.tBTS) AS
BEGIN
  pBTS :=  NULL;
  pBTS.REG := ZBR_AUS_DATA.tbReg();
  pBTS.fkt_inh.reg := ZBR_AUS_DATA.tbReg();
  pBTS.fkt_hv.reg := ZBR_AUS_DATA.tbReg();
  pBTS.bta := ZBR_AUS_DATA.tbBTA();
  pBTS.Abt_Adr := ZBR_AUS_DATA.tbAbt_Adr();  
  pBTS.Bta_Abt := ZBR_AUS_DATA.tbBTA_ABT(); 
  pBTS.TIR := ZBR_AUS_DATA.tbTIR();   
END;

PROCEDURE Fill_Bts(pBTS OUT NOCOPY ZBR_AUS_DATA.tBTS, pBTS_ID IN ZBR_AUS_DATA.tID) AS
  --res NUMBER(10) := 1;
  vAdrId aus_d_adresse.id%TYPE;
  vTyp   aus_R_BTS_ADR.TYP%TYPE;
  vBTS_ID aus_d_betriebsstaette.id%TYPE := pBts_ID;
  vUsecaseAEND NUMBER(10) := 0;
  vOrder NUMBER(10) := 0;
  vCnt PLS_INTEGER;
  vReg_idv_inh aus_d_registrierung%ROWTYPE;
  vExt PLS_INTEGER;
BEGIN

  Clear_BTS(pBTS);

  IF vVerfahren = QUELLE_IDV_NRW /*vGKZ2 = ZBR_AUS_DATA.NRW*/ THEN
    ZBR_AUS_DATA.vINH  := ZBR_AUS_DATA.INH;
    ZBR_AUS_DATA.vIDV  := ZBR_AUS_DATA.IDV;
    ZBR_AUS_DATA.vIDV_INH  := ZBR_AUS_DATA.IDV_INH;
    ZBR_AUS_DATA.vHV   := ZBR_AUS_DATA.HV;
    ZBR_AUS_DATA.vBTRO := ZBR_AUS_DATA.BTRO;
    ZBR_AUS_DATA.vBTRA := ZBR_AUS_DATA.BTRA;    
  ELSE
    ZBR_AUS_DATA.vINH  := ZBR_AUS_DATA.Betreiber;
    ZBR_AUS_DATA.vIDV  := ZBR_AUS_DATA.BI;
    ZBR_AUS_DATA.vIDV_INH := ZBR_AUS_DATA.BI;
    ZBR_AUS_DATA.vHV   := NULL; -- nicht vorhanden
    ZBR_AUS_DATA.vBTRO := ZBR_AUS_DATA.StandortAdr;
    ZBR_AUS_DATA.vBTRA := ZBR_AUS_DATA.PostAdr;      
  END IF;

  /*IF pBTS_NR = 1 THEN
    vBTS_ID := pBTS_ID;
   
    IF pUsecase IN('STANDORT_AEND', 'BETR_POST_AEND', 'PERS_AEND', 'PERS_ADR_AEND', 'BTRB_STANDORT_AEND', 'AEND_BETREI', 'AEND_POST_ADR_BETREI') THEN
      vUsecaseAend := 1;
    ELSE
      vUsecaseAend := 0;
    END IF;  
     
  ELSE
    
    SELECT d_bts_id2 INTO vBTS_ID
    FROM aus_d_usecase d
    WHERE D.D_BTS_ID = pBTS_ID    
      AND d.usecase = pUsecase;
      
    IF NVL(vBTS_ID, '-1') = '-1' THEN
      --RETURN 0;
      Res := 0;
    END IF;
  END IF; */

  IF pBTS_ID IS NOT NULL THEN

    -- BTS
    SELECT * INTO pBTS.BTS
    FROM aus_d_betriebsstaette bts
    WHERE bts.id = vBTS_ID;
    pBTS.bts.gueltig_von := TRUNC(pBTS.bts.gueltig_von);
    pBTS.bts.gueltig_bis := TRUNC(pBTS.bts.gueltig_bis);
      
    -- UseCases
    /*SELECT d.* BULK COLLECT INTO pBTS.Usecases  
    FROM aus_d_usecase d 
    WHERE D.D_BTS_ID = vBTS_ID
     AND d.usecase = pUsecase; */  
      
    -- Protokoll, nicht bei alte Werte vorhanden
    SELECT * INTO pBTS.Prot
    FROM aus_d_protokoll prot
    WHERE prot.d_bts_id = vBTS_ID;
        
    -- Kommunikationsmittel
    FOR cKom IN (
      SELECT kom.*
      FROM aus_d_kommunikation kom
      JOIN aus_R_BTS_KOM r ON R.D_KOM_ID = kom.id
      AND r.d_bts_id = vBTS_ID
    ) LOOP     
      
      CASE
      WHEN cKom.komtyp = 'TELEFON' THEN
        pBTS.Kom.Telefon := cKom.komdata;
      WHEN cKom.komtyp = 'MOBIL' THEN
        pBTS.Kom.mobil := cKom.komdata;
      WHEN cKom.komtyp = 'EMAIL' THEN
        pBTS.Kom.email := cKom.komdata;
      WHEN cKom.komtyp = 'FAX' THEN
        pBTS.Kom.fax := cKom.komdata;
      WHEN cKom.komtyp = 'INTERNET' THEN
        pBTS.Kom.internet := cKom.komdata;
      ELSE
        NULL;
      END CASE;
    END LOOP; -- Kom
        
      
    IF vUsecaseAEND = 0 THEN
      
      -- Adresse BTRO
      BEGIN
        SELECT d_adr_id INTO vAdrId
        FROM aus_R_BTS_ADR r 
        WHERE r.d_bts_id = pBTS.bts.id
          AND r.typ = ZBR_AUS_DATA.vBTRO;
        
        pBTS.Adr_BTRO := GetAdresse(vAdrID, ZBR_AUS_DATA.vBTRO);

        EXCEPTION WHEN no_data_found THEN vAdrID := '-9999'; 
        
      END;
      
    ELSE -- AEND - mehrere Adressen vorhanden
      vOrder := 0;
      FOR c1 IN (
        SELECT adr.id adr_id
        FROM aus_R_BTS_ADR r 
        JOIN aus_d_adresse adr ON adr.id = r.d_adr_id
        WHERE r.d_bts_id = pBTS.bts.id
          AND r.typ = ZBR_AUS_DATA.vBTRO
        ORDER BY adr.gueltig_von DESC NULLS FIRST
      ) LOOP
        
        IF vOrder = 0 THEN
          pBTS.Adr_BTRO := GetAdresse(c1.adr_id, ZBR_AUS_DATA.vBTRO);      
          vOrder := 1;
        ELSE
          pBTS.Adr_BTRO2 := GetAdresse(c1.adr_id, ZBR_AUS_DATA.vBTRO);            
        END IF;
        
      END LOOP;
      
    END IF; 
      
    -- Adresse BTRA
    IF vUsecaseAEND = 0 THEN
      BEGIN
        SELECT d_adr_id INTO vAdrId
        FROM aus_R_BTS_ADR r 
        WHERE r.d_bts_id = pBTS.bts.id
          AND r.typ = ZBR_AUS_DATA.vBTRA;

        pBTS.Adr_BTRA := GetAdresse(vAdrID, ZBR_AUS_DATA.vBTRA);
        
        EXCEPTION WHEN no_data_found THEN vAdrID := '-9999'; 
        
      END;
      
    ELSE -- AEND - mehrere Adressen vorhanden   
      vOrder := 0;
      FOR c1 IN (
        SELECT adr.id adr_id
        FROM aus_R_BTS_ADR r 
        JOIN aus_d_adresse adr ON adr.id = r.d_adr_id
        WHERE r.d_bts_id = pBTS.bts.id
          AND r.typ = ZBR_AUS_DATA.vBTRA
        ORDER BY adr.gueltig_von DESC NULLS FIRST
      ) LOOP
        
        IF vOrder = 0 THEN
          pBTS.Adr_BTRA := GetAdresse(c1.adr_id, ZBR_AUS_DATA.vBTRA);      
          vOrder := 1;
        ELSE
          pBTS.Adr_BTRA2 := GetAdresse(c1.adr_id, ZBR_AUS_DATA.vBTRA);            
        END IF;
        
      END LOOP;
    END IF;
    
    -- Betriebsarten
    IF vVerfahren <> QUELLE_IDV_NRW /*vGKZ2 <> ZBR_AUS_DATA.NRW*/ THEN
      SELECT * 
      BULK COLLECT INTO pBTS.bta
      FROM aus_d_betriebsart
      WHERE d_bts_id = vBTS_ID
      AND NVL(scope, 'X') <> BA_GROUP;
    ELSE
      SELECT * 
      BULK COLLECT INTO pBTS.bta
      FROM aus_d_betriebsart
      WHERE d_bts_id = vBTS_ID
      AND art <> 'HFMUN'  -- ohne FM-Ttigkeitskodierung
      AND code <> '4551'; -- ohne Oberbegriff FM-Betriebsarten        
    END IF;
          
    IF pBTS.bta.COUNT > 0 AND vVerfahren = QUELLE_IDV_NRW /*vGKZ2 = ZBR_AUS_DATA.NRW*/ THEN     
      FOR i IN pBTS.bta.FIRST .. pBTS.bta.LAST LOOP              
        
        pBTS.bta(i).gueltig_von := TRUNC(pBTS.bta(i).gueltig_von);
        pBTS.bta(i).gueltig_bis := TRUNC(pBTS.bta(i).gueltig_bis);
        IF pBTS.bta(i).bez IS NULL THEN
          CASE
          WHEN pBTS.bta(i).art = 'ADV' THEN
            -- LM-Betriebsarten ohne Zuordnung
            SELECT MAX(bez) INTO pBTS.bta(i).bez
            FROM vis_a010108
            WHERE deleted = 0
              AND skz = 2
              AND RPAD(code, 7, '0') = RPAD( pBTS.bta(i).code, 7, '0');
            
          WHEN pBTS.bta(i).art = 'BALVI' THEN  -- 30.10.2014
            SELECT MAX(a010108.bez) INTO pBTS.bta(i).bez
            FROM vis_a0089 a0089 
            JOIN vis_a010108 a010108 ON a010108.code = a0089.axx1_code
            AND a010108.skz = a0089.axx1_skz
            AND a010108.deleted = 0
            WHERE a0089.deleted = 0
              AND a0089.zb IN (blv_sys.get_gkz2 /*vGKZ2*/, '%')  -- 21.03.2013 Zeile aktiviert
              AND a0089.axx2_table = 'HIT_BETRIEBSTYP'
              AND a0089.axx1_table = 'VIS_A010108'
              AND a0089.axx1_code = pBTS.bta(i).code
              AND a0089.tv_pos IN( pBTS.bta(i).gewerbsmaessig, 2);          
            
          ELSE      
              
            SELECT MAX(bez) INTO pBTS.bta(i).bez
            FROM vis_a0089
            WHERE deleted = 0
              AND zb IN ( blv_sys.get_gkz2/*vGKZ2*/, '%')  -- 21.03.2013 Zeile aktiviert
              AND axx2_table = 'HIT_BETRIEBSTYP'
              AND axx1_table = 'VIS_A010108'
              AND axx2_code = pBTS.bta(i).code
              AND tv_pos IN( pBTS.bta(i).gewerbsmaessig, 2);
            
          END CASE;
            
        END IF;
      END LOOP;
       
    END IF;

    -- Tierangaben
    IF vVerfahren <> QUELLE_IDV_NRW /*vGKZ2 <> ZBR_AUS_DATA.NRW*/ THEN
      SELECT tir.ID, tir.D_BTS_ID, tir.D_BTA_ID, tir.BEZEICHNUNG, tir.CODE, tir.ANZAHL, tir.GUELTIG_VON, tir.GUELTIG_BIS, tir.REF_ID, bta.code
      BULK COLLECT INTO pBTS.tir
      FROM aus_d_tierangaben tir
      JOIN aus_d_betriebsart bta ON bta.id = tir.d_bta_id 
      WHERE tir.d_bts_id = vBTS_ID;          
    END IF; 
    
    -- BTA_ABT
    /*SELECT r.* 
    BULK COLLECT INTO pBTS.bta_abt
    FROM aus_r_bta_abt r
    JOIN aus_d_betriebsart bta ON bta.id = R.D_BTA_ID 
    WHERE bta.d_bts_id = vBTS_ID;*/
      
    -- Abteilungen
    /*pBTS.abt_adr := tbAbt_Adr();
    FOR cAbt IN (
      SELECT abt.*
      FROM aus_d_abteilung abt
      WHERE abt.d_bts_id = vBTS_ID       
    ) LOOP
        
      pBTS.abt_adr.extend();
      vExt := pBTS.abt_adr.LAST;
      pBTS.abt_adr(vExt).abt := cAbt;
      pBTS.abt_adr(vExt).abt.gueltig_von := TRUNC(pBTS.abt_adr(vExt).abt.gueltig_von);
        
      IF vUsecaseAEND = 0 THEN
        FOR cAbt_Adr IN (
          SELECT * 
          FROM aus_r_abt_adr abt_adr 
          WHERE ABT_ADR.D_ABT_ID = cAbt.id
        ) LOOP
          
          pBTS.abt_adr(vExt).adr := GetAdresse(cAbt_Adr.d_adr_id, 'BTRB');
          
        END LOOP;
      ELSE
        vOrder := 0;
        FOR cAbt_Adr IN (
          SELECT * 
          FROM aus_r_abt_adr abt_adr 
          JOIN aus_d_adresse adr ON adr.id = ABT_ADR.D_ADR_ID
          WHERE ABT_ADR.D_ABT_ID = cAbt.id
          ORDER BY adr.gueltig_von NULLS FIRST
        ) LOOP
          
          IF vOrder = 0 THEN
            vOrder := 1;
            pBTS.abt_adr(pBTS.abt_adr.LAST).adr := GetAdresse(cAbt_Adr.d_adr_id, 'BTRB');
          ELSE
            pBTS.abt_adr(pBTS.abt_adr.LAST).adr2 := GetAdresse(cAbt_Adr.d_adr_id, 'BTRB');        
          END IF;
        END LOOP;   
      END IF;
    END LOOP;*/  -- Abteilung

    -- Registrierung zu Betriebsstaette 
    SELECT reg.* 
    BULK COLLECT INTO pBTS.reg 
    FROM aus_r_bts_reg r
    JOIN aus_d_registrierung reg ON reg.id = R.d_reg_id
    WHERE r.d_bts_id = vBTS_ID;  

    -- wenn keine Gltigkeit in Registrierung vorhanden, dann vom Betrieb bernehmen
    IF pBTS.reg.COUNT > 0 THEN
      FOR i IN pBTS.reg.FIRST .. pBTS.reg.LAST LOOP
                  
        IF pBTS.reg(i).gueltig_von IS NULL THEN
          pBTS.reg(i).gueltig_von := pBTS.bts.gueltig_von;
        ELSE
          pBTS.reg(i).gueltig_von := TRUNC(pBTS.reg(i).gueltig_von);
        END IF;  
            
        IF pBTS.reg(i).gueltig_bis IS NULL THEN
          pBTS.reg(i).gueltig_bis := pBTS.bts.gueltig_bis;
        ELSE
          pBTS.reg(i).gueltig_bis := TRUNC(pBTS.reg(i).gueltig_bis);
        END IF;    

      END LOOP; 
    END IF; 
     
    -- Hauptverantwortlicher, nur wenn auch vorhanden
    DECLARE
      CURSOR c1 IS
      SELECT D_BTS_ID
      FROM aus_d_funktion fkt
      WHERE fkt.typ = 'HV' 
       AND FKT.D_BTS_ID = vBTS_ID;
      v1 c1%ROWTYPE;
    BEGIN
      OPEN c1;
      FETCH c1 INTO v1;
      IF c1%FOUND THEN 
        vCnt := 1;
      ELSE
        vCnt := 0;
      END IF;
      CLOSE c1;
    END;    
    
    IF vCnt = 1 THEN
      
      SELECT fkt.* INTO pBTS.fkt_hv.fkt
      FROM aus_d_funktion fkt
      WHERE fkt.typ = 'HV' 
       AND FKT.D_BTS_ID = vBTS_ID;
        
      -- Hauptverantwortlicher - PERSON
      SELECT pers.* INTO pBTS.fkt_hv.pers
      FROM aus_d_person pers
      WHERE pers.id = pBTS.fkt_hv.fkt.d_pers_id;
        
      -- Hauptverantwortlicher - Kommunikation
      FOR cKom IN (
        SELECT kom.* 
        FROM aus_r_fkt_kom r
        JOIN aus_d_kommunikation kom ON KOM.ID = R.D_KOM_ID  
        WHERE r.d_fkt_id = pBTS.fkt_hv.fkt.id
      ) LOOP
        
        CASE
        WHEN cKom.komtyp = 'TELEFON' THEN
          pBTS.fkt_hv.Kom.Telefon := cKom.komdata;
        WHEN cKom.komtyp = 'MOBIL' THEN
          pBTS.fkt_hv.Kom.mobil := cKom.komdata;
        WHEN cKom.komtyp = 'EMAIL' THEN
          pBTS.fkt_hv.Kom.email := cKom.komdata;
        WHEN cKom.komtyp = 'FAX' THEN
          pBTS.fkt_hv.Kom.fax := cKom.komdata;
        WHEN cKom.komtyp = 'INTERNET' THEN
          pBTS.fkt_hv.Kom.internet := cKom.komdata;
        ELSE
          NULL;
        END CASE;    
              
      END LOOP;
      
    END IF;
      
    -- Hauptverantwortlicher - Registrierung
    SELECT reg.* BULK COLLECT INTO pBTS.fkt_hv.reg
    FROM aus_r_fkt_reg r
    JOIN aus_d_registrierung reg ON R.D_REG_ID = reg.id
    WHERE r.d_fkt_id = pBTS.fkt_hv.fkt.id;  

    IF pBTS.fkt_hv.reg.COUNT > 0 THEN
      FOR i IN pBTS.fkt_hv.reg.FIRST .. pBTS.fkt_hv.reg.LAST LOOP
        pBTS.fkt_hv.reg(i).gueltig_von := TRUNC(pBTS.fkt_hv.reg(i).gueltig_von);
        pBTS.fkt_hv.reg(i).gueltig_bis := TRUNC(pBTS.fkt_hv.reg(i).gueltig_bis);
      END LOOP; 
    END IF;

    -- wenn keine Gltigkeit in Registrierung vorhanden, dann vom Betrieb bernehmen
    /* wre falsch bei abweichendem Betreiber
    IF pBTS.fkt_hv.reg.COUNT > 0 THEN
      FOR i IN pBTS.fkt_hv.reg.FIRST .. pBTS.fkt_hv.reg.LAST LOOP
                  
        IF pBTS.fkt_hv.reg(i).gueltig_von IS NULL THEN
          pBTS.fkt_hv.reg(i).gueltig_von := pBTS.bts.gueltig_von;
        END IF;    
        IF pBTS.fkt_hv.reg(i).gueltig_bis IS NULL THEN
          pBTS.fkt_hv.reg(i).gueltig_bis := pBTS.bts.gueltig_bis;
        END IF;    

      END LOOP; 
    END IF; */

      
    -- Hauptverantwortlicher - Adresse
    IF vUsecaseAEND = 0 THEN
      BEGIN
        SELECT r.d_adr_id INTO vAdrId
        FROM aus_R_fkt_ADR r 
        WHERE r.d_fkt_id = pBTS.fkt_hv.fkt.id
         AND r.typ = 'PERS';

        pBTS.Fkt_HV.Adr := GetAdresse(vAdrID, 'PERS');
        
        EXCEPTION WHEN no_data_found THEN vAdrID := '-9999'; 
        
      END;
      
    ELSE
      vOrder := 0;
      FOR c1 IN (
        SELECT adr.id adr_id
        FROM aus_R_fkt_ADR r 
        JOIN aus_d_adresse adr ON adr.id = r.d_adr_id
        WHERE r.d_fkt_id = pBTS.fkt_hv.fkt.id
          AND r.typ = 'PERS'
        ORDER BY adr.gueltig_von NULLS FIRST
      ) LOOP
        
        IF vOrder = 0 THEN
          pBTS.Fkt_HV.Adr := GetAdresse(c1.adr_id, 'PERS');      
          vOrder := 1;
        ELSE
          pBTS.Fkt_HV.Adr2 := GetAdresse(c1.adr_id, 'PERS');            
        END IF;
        
      END LOOP;  
    END IF;
      
    -- Inhaber   
    FOR cInh IN ( 
      SELECT fkt.* --INTO pBTS.fkt_inh.fkt
      FROM aus_d_funktion fkt
      WHERE fkt.typ = CASE WHEN vVerfahren = QUELLE_IDV_NRW /*vGKZ2 = ZBR_AUS_DATA.NRW*/ THEN 'INH' ELSE Betreiber END 
       AND FKT.D_BTS_ID = vBTS_ID
    ) LOOP
      pBTS.fkt_inh.fkt := cInh;
    END LOOP; -- Inhaber
         
    -- Inhaber - Person
    FOR cInhPers IN (
      SELECT pers.* --INTO pBTS.fkt_inh.pers
      FROM aus_d_person pers
      WHERE pers.id = pBTS.fkt_inh.fkt.d_pers_id
    ) LOOP
      pBTS.fkt_inh.pers := cInhPers;   
    END LOOP;   

    /*IF vGKZ2 = NRW AND pBTS.fkt_inh.pers.id <> '-1' AND pBTS.fkt_inh.pers.Typ = 'NP'THEN
      SplitNachname(pBTS.fkt_inh.pers.nachname, 
                    pBTS.fkt_inh.pers.vorsatz_nachname, 
                    pBTS.fkt_inh.pers.nachsatz_nachname);
    END IF;*/

    -- Inhaber - Kommunikation
    FOR cKom IN (
      SELECT kom.* 
      FROM aus_r_fkt_kom r
      JOIN aus_d_kommunikation kom ON KOM.ID = R.D_KOM_ID  
      WHERE r.d_fkt_id = pBTS.fkt_inh.fkt.id
    ) LOOP
      
      CASE
      WHEN cKom.komtyp = 'TELEFON' THEN
        pBTS.fkt_inh.Kom.Telefon := cKom.komdata;
      WHEN cKom.komtyp = 'MOBIL' THEN
        pBTS.fkt_inh.Kom.mobil := cKom.komdata;
      WHEN cKom.komtyp = 'EMAIL' THEN
        pBTS.fkt_inh.Kom.email := cKom.komdata;
      WHEN cKom.komtyp = 'FAX' THEN
        pBTS.fkt_inh.Kom.fax := cKom.komdata;
      WHEN cKom.komtyp = 'INTERNET' THEN
        pBTS.fkt_inh.Kom.internet := cKom.komdata;
      ELSE
        NULL;
      END CASE;    
      
    END LOOP;
          
    -- Inhaber - Registrierung
    SELECT reg.* BULK COLLECT INTO pBTS.fkt_inh.reg  
    FROM aus_r_fkt_reg r
    JOIN aus_d_registrierung reg ON R.D_REG_ID = reg.id
    WHERE r.d_fkt_id = pBTS.fkt_inh.fkt.id;    

    IF pBTS.fkt_inh.reg.COUNT > 0 THEN
      FOR i IN pBTS.fkt_inh.reg.FIRST .. pBTS.fkt_inh.reg.LAST LOOP
        pBTS.fkt_inh.reg(i).gueltig_von := TRUNC(pBTS.fkt_inh.reg(i).gueltig_von);
        pBTS.fkt_inh.reg(i).gueltig_bis := TRUNC(pBTS.fkt_inh.reg(i).gueltig_bis);
      END LOOP; 
    END IF;
    -- wenn keine Gltigkeit in Registrierung vorhanden, dann vom Betrieb bernehmen
    /* wre falsche bei abweichendem Betreiber
    IF pBTS.fkt_inh.reg.COUNT > 0 THEN
      FOR i IN pBTS.fkt_inh.reg.FIRST .. pBTS.fkt_inh.reg.LAST LOOP
                  
        IF pBTS.fkt_inh.reg(i).gueltig_von IS NULL THEN
          pBTS.fkt_inh.reg(i).gueltig_von := pBTS.bts.gueltig_von;
        END IF;    
        IF pBTS.fkt_inh.reg(i).gueltig_bis IS NULL THEN
          pBTS.fkt_inh.reg(i).gueltig_bis := pBTS.bts.gueltig_bis;
        END IF;    

      END LOOP; 
    END IF; */
        
    -- PERS_ID als Registrierung IDV-INH speichern
    IF pBTS.fkt_inh.pers.pers_id <> '0' AND vVerfahren = QUELLE_IDV_NRW /*vGKZ2 = ZBR_AUS_DATA.NRW*/ THEN  
      vReg_idv_inh.art := ZBR_AUS_DATA.vIDV_INH;
      vReg_idv_inh.nummer := pBTS.fkt_inh.pers.pers_id;
      vReg_idv_inh.gueltig_von := pBTS.fkt_inh.fkt.gueltig_von;
      vReg_idv_inh.gueltig_bis := pBTS.fkt_inh.fkt.gueltig_bis;
      pBTS.fkt_inh.reg.EXTEND;
      pBTS.fkt_inh.reg( pBTS.fkt_inh.reg.LAST ) := vReg_idv_inh; 
    END IF;
    -- Inhaber - Adresse
    IF vUsecaseAEND = 0 THEN
      BEGIN
        SELECT r.d_adr_id, r.typ INTO vAdrId, vTyp
        FROM aus_R_fkt_ADR r 
        WHERE r.d_fkt_id = pBTS.fkt_inh.fkt.id;

        pBTS.Fkt_Inh.Adr := GetAdresse(vAdrID, vTyp);
        EXCEPTION WHEN no_data_found THEN NULL; --vAdrID := '-9999'; 
      END;
    ELSE
      vOrder := 0;
      FOR c1 IN (
        SELECT adr.id adr_id, r.typ
        FROM aus_R_fkt_ADR r 
        JOIN aus_d_adresse adr ON adr.id = r.d_adr_id
        WHERE r.d_fkt_id = pBTS.fkt_inh.fkt.id
        AND r.typ IN( 'ORG', 'PERS', ZBR_AUS_DATA.PostAdr, ZBR_AUS_DATA.BTRA)  
        ORDER BY adr.gueltig_von DESC NULLS FIRST 
      ) LOOP
        
        IF vOrder = 0 THEN
          pBTS.Fkt_Inh.Adr := GetAdresse(c1.adr_id, c1.typ);      
          vOrder := 1;
        ELSE
          pBTS.Fkt_Inh.Adr2 := GetAdresse(c1.adr_id, c1.typ);            
        END IF;
        
      END LOOP;  
    END IF;  
  END IF; -- pBTS_ID IS NOT NULL
  
END; --Fill_Bts 


/** Aufbereitung der Kommunikationsmittel 
  pTyp : 
  - BTS: fr Betriebsstaette ber BTS_ID
  - BTR: fr Betreiber ber aus_d_person.id
**/

PROCEDURE Komm(pID IN ZBR_AUS_DATA.tID, pTyp IN VARCHAR2,
 pKom OUT NOCOPY ZBR_AUS_DATA.tKom) AS

CURSOR cKomBts (pID IN ZBR_AUS_DATA.tID) IS
  SELECT d.komdata, d.komtyp
  FROM aus_d_kommunikation d
  JOIN aus_r_bts_kom r1 ON r1.d_kom_id = d.id 
  AND r1.d_bts_id = pID;
  
CURSOR cKomBtr (pID IN ZBR_AUS_DATA.tID) IS
  SELECT d.komdata, d.komtyp
  FROM aus_d_kommunikation d
  JOIN aus_r_fkt_kom r1 ON r1.d_kom_id = d.id 
  JOIN aus_d_funktion fkt ON fkt.id = r1.d_fkt_id
  AND fkt.d_pers_id = pID;

--CURSOR cKom (pID IN ZBR_AUS_DATA.tID) IS
--  SELECT d.komdata, d.komtyp
--  FROM aus_d_kommunikation d
--  WHERE d.id = pID;
  
TYPE tbKom IS TABLE OF cKomBts%ROWTYPE;
vKom tbKom;

BEGIN 

  CASE pTyp
  WHEN 'BTS' THEN
    OPEN cKomBts(pId);
    FETCH cKomBts BULK COLLECT INTO vKom LIMIT 4;
    CLOSE cKomBts;
  
  WHEN 'BTR' THEN
    OPEN cKomBtr(pId);
    FETCH cKomBtr BULK COLLECT INTO vKom LIMIT 4;
    CLOSE cKomBtr;

  END CASE;

  pKom.Telefon := NULL;
  pKom.Fax := NULL;
  pKom.Mobil := NULL;
  pKom.EMail := NULL;
  pKom.Internet := NULL;
  IF vKom.COUNT > 0 THEN

    FOR i IN vKom.FIRST .. vKom.LAST LOOP
      CASE vKom(i).komtyp
      WHEN 'TELEFON'  THEN pKom.telefon := vKom(i).komdata;  
      WHEN 'FAX'      THEN pKom.fax := vKom(i).komdata;  
      WHEN 'MOBIL'    THEN pKom.mobil := vKom(i).komdata;  
      WHEN 'EMAIL'    THEN pKom.email := vKom(i).komdata;  
      WHEN 'INTERNET' THEN pKom.internet := vKom(i).komdata;  
      END CASE;
    END LOOP;
  
  END IF;
  
END Komm;

PROCEDURE Komm(pID IN ZBR_AUS_DATA.tID, pTyp IN VARCHAR2,
  pTel OUT NOCOPY VARCHAR2, pFax OUT NOCOPY VARCHAR2, pMobil OUT NOCOPY VARCHAR2, pEMail OUT NOCOPY VARCHAR2) AS
vKom ZBR_AUS_DATA.tKom;
BEGIN

    Komm(pID, pTyp, vKom);    
    pTel := vKom.telefon;
    pFax := vKom.fax;
    pMobil := vKom.mobil;
    pEMail := vKom.Email;

END;

-- Lesen alle Protokolle zum Senden
FUNCTION ReadPrt0 RETURN ZBR_AUS_DATA.tbPrt PIPELINED AS
BEGIN
  FOR c1 IN (
    SELECT prt.*
    FROM aus_d_protokoll prt
    -- 0 - nicht verarbeitet, vor dem Vergleich, 
    -- 2 - gesendet, zum Vergleich, 
    -- 3 - nur zum Vergleich, wird nicht und wurde nicht gesendet, 
    -- 4 - nur zum Vergleich mit dem Eingangskorb, 
    -- 5 - neuer Betrieb ohne Dublettenabgleich senden, 
    -- 6 - ohne Plausiprfung (wird mit 0 gespeichert)
    WHERE prt.status IN( 0, 5, 6) 
    AND prt.deleted = 0
    ORDER BY prt.prio, prt.ins_date
  ) LOOP    
    PIPE ROW (c1);
  END LOOP;
  RETURN;
END ReadPrt0;

FUNCTION ReadPrt(pBTS_ID IN ZBR_AUS_DATA.tID) RETURN ZBR_AUS_DATA.tbPrt PIPELINED AS
v1 aus_d_protokoll%ROWTYPE;
BEGIN

  SELECT prt.* INTO v1
  FROM aus_d_protokoll prt
  WHERE prt.d_bts_id = pBTS_ID;

  PIPE ROW (v1);

  RETURN;
END ReadPrt;

FUNCTION ReadUsc(pBTS_ID IN ZBR_AUS_DATA.tID) RETURN ZBR_AUS_DATA.tbUsc PIPELINED AS
BEGIN
  FOR c1 IN (
   SELECT  usc.id         
   , usc.d_bts_id   
   , usc.d0101_id   
   , usc.usecase    
   , usc.mandant    
   , usc.user_sid   
   , usc.lastmodified 
   , usc.gueltig_von  
   , usc.gueltig_bis  
   , usc.aend_art   
   , usc.aend_grund 
   , usc.aend_bem   
   , usc.alter_wert 
   , usc.neuer_wert 
   , usc.d_bts_id2  
   , usc.ref_id     
   , usc.ref_id_alt 
  FROM aus_d_usecase usc
  WHERE usc.d_bts_id = pBTS_ID
  --AND usc.usecase <> 'ERSTBEFUELLUNG'
  ORDER BY 
  CASE 
  -- Abmeldungen und Storno als letztes bertragen
  WHEN usc.usecase LIKE 'ABMELD%' THEN 1
  WHEN usc.usecase LIKE 'STORNO%' THEN 1
  ELSE 0 END
  
  ) LOOP
    PIPE ROW (c1);  
  END LOOP;
  RETURN;
END ReadUsc;


FUNCTION ReadPrtPrio  RETURN ZBR_AUS_DATA.tbPrt PIPELINED AS
 CURSOR c1 IS
 SELECT DX.* FROM (
   SELECT /*+ FIRST_ROWS(1) */ 
    prt.*
   FROM aus_d_protokoll prt
   WHERE prt.deleted = 0
   AND prt.status IN (0, 5, 6)
   ORDER BY prt.prio, prt.ins_date
 ) dx
 WHERE ROWNUM = 1;
 vC1 c1%ROWTYPE;
BEGIN
  OPEN c1;
  FETCH c1 INTO vC1;
  IF c1%FOUND THEN
    PIPE ROW(vC1);
  END IF;
  CLOSE c1;
  RETURN;
END;

FUNCTION ReadBTS(pBTS_ID IN ZBR_AUS_DATA.tID) RETURN ZBR_AUS_DATA.tbBTS1 PIPELINED AS
v1 ZBR_AUS_DATA.tBTS1;
BEGIN
  FOR c1 IN (
    SELECT bts.*
    FROM aus_d_betriebsstaette bts
    WHERE bts.id = pBTS_ID
  ) LOOP
    v1.id := c1.id;
    v1.zusatzbez := c1.zusatzbez;
    v1.gueltig_von := c1.gueltig_von;
    v1.gueltig_bis := c1.gueltig_bis;
    v1.ref_id := c1.ref_id;
    
    Komm(pBTS_ID, 'BTS', v1.telefon, v1.fax, v1.mobil,v1.email);
    
    PIPE ROW (v1);
  END LOOP;
  RETURN;
END ReadBTS;

FUNCTION ReadBTA(pID IN ZBR_AUS_DATA.tID, pTyp IN VARCHAR2) RETURN ZBR_AUS_DATA.tbBTA PIPELINED AS
v1 aus_d_betriebsart%ROWTYPE;

  PROCEDURE Aktualisierung( p1 IN OUT aus_d_betriebsart%ROWTYPE) AS
  BEGIN
    IF p1.gueltig_bis = DATE '9999-01-01' THEN
      p1.gueltig_bis := NULL;
    END IF;
    p1.scope := 'NOT_VALID';  
  END;
BEGIN
  IF pTyp = 'ID' THEN
    SELECT bta.* INTO v1
    FROM aus_d_betriebsart bta 
    WHERE bta.ID = pID;
    Aktualisierung(v1);
    PIPE ROW(v1);
  ELSE
    FOR c1 IN (
      SELECT bta.*
      FROM aus_d_betriebsart bta
      WHERE bta.d_bts_id = pID
      AND bta.scope = BA_GROUP
    ) LOOP    
      v1 := c1;
      Aktualisierung(v1);
      PIPE ROW(v1);
    END LOOP;
  END IF;
  RETURN;
END ReadBTA; 

FUNCTION ReadTIR(pID IN ZBR_AUS_DATA.tID, pTyp IN VARCHAR2) RETURN ZBR_AUS_DATA.tbTIR PIPELINED AS
v1 zbr_aus_data.tTIR;
BEGIN
  IF pTyp = 'ID' THEN
    SELECT tir.ID, tir.D_BTS_ID, tir.D_BTA_ID, tir.BEZEICHNUNG, tir.CODE        
      , tir.ANZAHL, tir.GUELTIG_VON, tir.GUELTIG_BIS, tir.REF_ID, bta.CODE bta_code   
    INTO v1.ID, v1.D_BTS_ID, v1.D_BTA_ID, v1.BEZEICHNUNG, v1.CODE        
      , v1.ANZAHL, v1.GUELTIG_VON, v1.GUELTIG_BIS, v1.REF_ID, v1.BTA_CODE    
    FROM aus_d_tierangaben tir 
    JOIN aus_d_betriebsart bta ON bta.id = tir.d_bta_id
    WHERE tir.ID = pID;
    PIPE ROW(v1);
  ELSE
    FOR c1 IN (
      SELECT tir.ID, tir.D_BTS_ID, tir.D_BTA_ID, tir.BEZEICHNUNG, tir.CODE        
        , tir.ANZAHL, tir.GUELTIG_VON, tir.GUELTIG_BIS, tir.REF_ID, bta.CODE bta_code   
      FROM aus_d_tierangaben tir
      JOIN aus_d_betriebsart bta ON bta.id = tir.d_bta_id
      WHERE tir.d_bts_id = pID
    ) LOOP
      PIPE ROW(c1);
    END LOOP;
  END IF;
  RETURN;
END ReadTIR;

FUNCTION ReadReg(pID IN ZBR_AUS_DATA.tID, pTyp IN VARCHAR2) RETURN ZBR_AUS_DATA.tbReg PIPELINED AS
v1 aus_d_registrierung%ROWTYPE;
BEGIN
  CASE
  WHEN pTyp = 'ID' THEN
    SELECT reg.* INTO v1
    FROM aus_d_registrierung reg 
    WHERE reg.ID = pID;
    PIPE ROW(v1);

  WHEN pTyp = 'BTR' THEN -- Betreiber ber BTS_ID
    FOR c1 IN (
      SELECT reg.*
      FROM aus_d_registrierung reg
      JOIN aus_r_fkt_reg r1 ON r1.d_reg_id = reg.id 
      JOIN aus_d_funktion fkt ON fkt.id = r1.d_fkt_id
      AND fkt.d_bts_id = pID
    ) LOOP
      PIPE ROW(c1);
    END LOOP;

  ELSE -- alle zur Betriebsstaette
    FOR c1 IN (
      SELECT reg.*
      FROM aus_d_registrierung reg
      JOIN aus_r_bts_reg r1 ON r1.d_reg_id = reg.id 
      AND r1.d_bts_id = pID 
    ) LOOP
      PIPE ROW(c1);
    END LOOP;

  END CASE;
  RETURN;
END ReadReg;
/**   
  Typ: 
  BTS_STO Standortadresse der Betriebssttte ber BTS_ID
  BTS_PST Postadresse der Betriebssttte ber BTS_ID
  BTS_ADR Adresse der Betriebssttte direkt ber AUS_D_ADRESSE.ID
  BTR_STO Standortadresse des Betreibers ber BTS_ID
  BTR_PST Postadresse des Betreibers ber BTS_ID
  BTR_ADR Adresse des Betreibers direkt ber AUS_D_ADRESSE.ID    
**/    
FUNCTION ReadAdr(pID IN ZBR_AUS_DATA.tID, pTyp IN VARCHAR2) RETURN ZBR_AUS_DATA.tbAdr1 PIPELINED AS
  vAdr zbr_aus_data.tAdr1;
  vID ZBR_AUS_DATA.tID;
  
  CURSOR cBtsAdr (pD_BTS_ID IN VARCHAR2, pTyp IN VARCHAR2) IS 
    SELECT r1.d_adr_id 
    FROM aus_r_bts_adr r1
    WHERE r1.d_bts_id = pD_BTS_ID
    AND r1.typ IN pTyp
    UNION ALL
    SELECT r1.d_adr_id 
    FROM ein_r_bts_adr r1
    WHERE r1.d_bts_id = pD_BTS_ID
    AND r1.typ IN pTyp;
  
  CURSOR cBtrAdr (pD_BTS_ID IN VARCHAR2, pTyp1 IN VARCHAR2, pTyp2 IN VARCHAR2, pTyp3 IN VARCHAR2) IS
      SELECT r1.d_adr_id
      FROM aus_d_funktion fkt 
      JOIN aus_r_fkt_adr r1 ON r1.d_fkt_id = fkt.id
      WHERE fkt.d_bts_id = pD_BTS_ID
      AND r1.typ IN( pTyp1, pTyp2, pTyp3)
      UNION ALL
      SELECT r1.d_adr_id
      FROM ein_d_funktion fkt 
      JOIN ein_r_fkt_adr r1 ON r1.d_fkt_id = fkt.id
      WHERE fkt.d_bts_id = pD_BTS_ID
      AND r1.typ IN( pTyp1, pTyp2, pTyp3);
         
  FUNCTION Adr( pID IN VARCHAR2) RETURN PLS_INTEGER AS
  CURSOR cAdr (pAdr_ID IN VARCHAR2) IS
    SELECT 
    adr.id, adr.freibez, adr.wechsel, adr.gueltig_von, adr.gueltig_bis,
    kat.flurnummer, kat.flurstueck, kat.gemarkung, kat.x_wert, kat.y_wert, kat.rechtswert, kat.hochwert,  
    verw.gkz, verw.gemeinde,
    padr.hausnr, padr.hausnrzusatz, padr.ort, padr.ortsteil, padr.postfach, padr.staat, padr.strasse, padr.plz,
    padr.postfach_jn
    FROM aus_d_adresse adr
    LEFT JOIN aus_d_verwaltung verw ON verw.id = adr.d_verw_id
    LEFT JOIN aus_d_kataster kat ON kat.id = adr.d_kat_id
    LEFT JOIN aus_d_postadresse padr ON padr.id = adr.d_padr_id
    WHERE adr.id = pAdr_ID
    UNION ALL
    SELECT 
    adr.id, adr.freibez, adr.wechsel, adr.gueltig_von, adr.gueltig_bis,
    kat.flurnummer, kat.flurstueck, kat.gemarkung, kat.x_wert, kat.y_wert, kat.rechtswert, kat.hochwert,  
    verw.gkz, verw.gemeinde,
    padr.hausnr, padr.hausnrzusatz, padr.ort, padr.ortsteil, padr.postfach, padr.staat, padr.strasse, padr.plz,
    padr.postfach_jn
    FROM ein_d_adresse adr
    LEFT JOIN ein_d_verwaltung verw ON verw.id = adr.d_verw_id
    LEFT JOIN ein_d_kataster kat ON kat.id = adr.d_kat_id
    LEFT JOIN ein_d_postadresse padr ON padr.id = adr.d_padr_id
    WHERE adr.id = pAdr_ID;
    
    vCurAdr cAdr%ROWTYPE;
    vRes PLS_INTEGER := 0;
  BEGIN
    vAdr := NULL;
    OPEN cAdr ( pID );
    FETCH cAdr INTO vCurAdr;
    IF cAdr%FOUND THEN
      vRes := 1;
      
      vAdr.id := vCurAdr.ID; 
      --vAdr.FreiText := vCurAdr.FreiBez;
      vAdr.WECHSEL := vCurAdr.WECHSEL; 
      --vAdr.gueltig_von := vCurAdr.gueltig_von; 
      --vAdr.gueltig_bis := vCurAdr.gueltig_bis; 
      --TYP AUS_D_ADRESSE.TYP; 
      --ADRESSZUSATZ AUS_D_ADRESSE.ADRESSZUSATZ; 
      --typ AUS_D_ADRESSE.TYPE; 
      --bundesland AUS_D_ADRESSE.BUNDESLAND; 
      --bezirk AUS_D_ADRESSE.BEZIRK; 
      --kreis AUS_D_ADRESSE.KREIS; 
      vAdr.GEMEINDE := vCurAdr.GEMEINDE; 
      --fkz AUS_D_ADRESSE.GKZ; 
      --REGIONALSCHLUESSEL AUS_D_VERWALTUNG.REGIONALSCHLUESSEL; 
      vAdr.postfach_jn := vCurAdr.postfach_jn;
      vAdr.STRASSE := vCurAdr.STRASSE; 
      vAdr.Hausnummer := vCurAdr.Hausnr; 
      vAdr.Hausnummernzusatz := vCurAdr.Hausnrzusatz; 
      vAdr.Postfach := vCurAdr.Postfach; 
      vAdr.Staat := vCurAdr.Staat; 
      vAdr.PLZ := vCurAdr.PLZ; 
      vAdr.Ort := vCurAdr.Ort; 
      vAdr.Ortsteil := vCurAdr.Ortsteil; 
      --Teilort AUS_D_ADRESSE.Teilort; 
      vAdr.Flurnummer := vCurAdr.Flurnummer; 
      vAdr.Flurstueck := vCurAdr.Flurstueck; 
      vAdr.Gemarkung := vCurAdr.Gemarkung; 
      vAdr.X_Wert := vCurAdr.X_Wert; 
      vAdr.Y_Wert := vCurAdr.Y_Wert; 
      vAdr.Rechtswert := vCurAdr.Rechtswert; 
      vAdr.Hochwert := vCurAdr.Hochwert; 
      --Koordinatenherkunft AUS_D_ADRESSE.Koordinatenherkunft; 
      --s09_sid AUS_D_ADRESSE.S09_SID; 
      --ins_date AUS_D_ADRESSE.INS_DATE; 
      --glo_a24_sid AUS_D_ADRESSE.GLO_A24_SID;
      vAdr.gkz := vCurAdr.gkz;       
      
    END IF;  
    CLOSE cAdr;
    RETURN vRes;
  END;
BEGIN

  CASE 
  WHEN pTyp IN ('BTS_STO',       -- Standortadresse der Betriebssttte ber BTS_ID
                'BTS_PST') THEN  -- Postadresse der Betriebssttte ber BTS_ID 
    
    IF pTyp = 'BTS_STO' THEN
      OPEN cBtsAdr(pID, ZBR_AUS_DATA.vBTRO);
    ELSE
      OPEN cBtsAdr(pID, ZBR_AUS_DATA.vBTRA);
    END IF;
    
    FETCH cBtsAdr INTO vID;
    IF cBtsAdr%FOUND THEN      
      IF Adr(vID) = 1 THEN
        PIPE ROW (vAdr);
      END IF;  
    END IF;
    CLOSE cBtsAdr;
  
  WHEN pTyp IN ('BTS_ADR',      -- Adresse der Betriebssttte direkt ber AUS_D_ADRESSE.ID  
                'BTR_ADR') THEN -- Adresse des Betreibers direkt ber AUS_D_ADRESSE.ID   
    IF Adr(pID) = 1 THEN
      PIPE ROW (vAdr);
    END IF;  

  WHEN pTyp IN ('BTR_STO',        -- Standortadresse des Betreibers ber BTS_ID
                'BTR_PST') THEN   -- Postadresse des Betreibers ber BTS_ID
    
    IF pTyp = 'BTR_STO' THEN
      OPEN cBtrAdr(pID, ZBR_AUS_DATA.vBTRO, NULL, NULL);
    ELSE
      OPEN cBtrAdr(pID, ZBR_AUS_DATA.vBTRA, 'ORG', 'PERS');
    END IF;
    
    FETCH cBtrAdr INTO vID;
    IF cBtrAdr%FOUND THEN      
      IF Adr(vID) = 1 THEN
        PIPE ROW (vAdr);
      END IF;  
    END IF;
    CLOSE cBtrAdr;

  ELSE
    RAISE_APPLICATION_ERROR
    ( -20001,
      'FEHLER: Der Aufruf ZBR_AUS.ReadAdr mit dem Parameter Typ = "' || pTyp || '" ist nicht zulssig.'
    );

  END CASE;
  
  RETURN;   

END;

-- Liefert den Nachnamen zusammengesetzt aus Vorsatz Nachnamen und Nachsatz
FUNCTION ReadBtr(pID IN ZBR_AUS_DATA.tID, pTyp IN VARCHAR2) RETURN ZBR_AUS_DATA.tbPrs1 PIPELINED AS
v1 ZBR_AUS_DATA.tPrs1;

CURSOR cBTS (pID IN ZBR_AUS_DATA.tID) IS
  SELECT prs.ID, prs.KURZBEZ1, prs.KURZBEZ2, prs.TYP, prs.ANREDE, prs.TITEL, 
  prs.VORNAME, prs.NACHNAME, prs.vorsatz_nachname, prs.nachsatz_nachname, /*prs.GEBURTSDATUM, prs.GEBURTSORT,*/ 
  prs.BEZEICHNUNG, prs.BEZEICHNUNG2, prs.RECHTSFORM, /*prs.PERS_ID,*/ prs.REF_ID
  FROM aus_d_person prs 
  JOIN aus_d_funktion fkt ON fkt.d_pers_id = prs.id
  AND fkt.typ = zbr_aus_data.Betreiber
  AND fkt.d_bts_id = pID
  UNION ALL
  SELECT prs.ID, prs.KURZBEZ1, prs.KURZBEZ2, prs.TYP, prs.ANREDE, prs.TITEL, 
  prs.VORNAME, prs.NACHNAME, prs.vorsatz_nachname, prs.nachsatz_nachname, /*prs.GEBURTSDATUM, prs.GEBURTSORT,*/ 
  prs.BEZEICHNUNG, prs.BEZEICHNUNG2, prs.RECHTSFORM, /*prs.PERS_ID,*/ prs.REF_ID
  FROM ein_d_person prs 
  JOIN ein_d_funktion fkt ON fkt.d_pers_id = prs.id
  AND fkt.typ = zbr_aus_data.Betreiber
  AND fkt.d_bts_id = pID;
  
CURSOR cPrs (pID IN ZBR_AUS_DATA.tID) IS
  SELECT prs.ID, prs.KURZBEZ1, prs.KURZBEZ2, prs.TYP, prs.ANREDE, prs.TITEL, 
  prs.VORNAME, prs.NACHNAME, prs.vorsatz_nachname, prs.nachsatz_nachname, /*prs.GEBURTSDATUM, prs.GEBURTSORT,*/ 
  prs.BEZEICHNUNG, prs.BEZEICHNUNG2, prs.RECHTSFORM, /*prs.PERS_ID,*/ prs.REF_ID
  FROM aus_d_person prs 
  WHERE prs.id = pID
  UNION ALL
  SELECT prs.ID, prs.KURZBEZ1, prs.KURZBEZ2, prs.TYP, prs.ANREDE, prs.TITEL, 
  prs.VORNAME, prs.NACHNAME, prs.vorsatz_nachname, prs.nachsatz_nachname, /*prs.GEBURTSDATUM, prs.GEBURTSORT,*/ 
  prs.BEZEICHNUNG, prs.BEZEICHNUNG2, prs.RECHTSFORM, /*prs.PERS_ID,*/ prs.REF_ID
  FROM ein_d_person prs 
  WHERE prs.id = pID;
 
TYPE tbPrs IS TABLE OF cPrs%ROWTYPE;
vPrs tbPrs := tbPrs();
vPrs1 ZBR_AUS_DATA.tPrs1;
BEGIN

  IF pTyp = 'BTS' THEN
    OPEN cBts(pID);
    FETCH cBTS BULK COLLECT INTO vPrs LIMIT 1;
    CLOSE cBTS;

  ELSE
    OPEN cPrs(pID);
    FETCH cPrs BULK COLLECT INTO vPrs LIMIT 1;
    CLOSE cPrs;

  END IF;
  
  IF vPrs.COUNT > 0 THEN

   vPrs1.ID           := vPrs(1).ID;
   vPrs1.KURZBEZ1     := vPrs(1).KURZBEZ1; 
   vPrs1.KURZBEZ2     := vPrs(1).KURZBEZ2; 
   vPrs1.TYP          := vPrs(1).TYP; 
   vPrs1.ANREDE       := vPrs(1).ANREDE; 
   vPrs1.TITEL        := vPrs(1).TITEL; 
   vPrs1.VORNAME      := vPrs(1).VORNAME; 
   vPrs1.NACHNAME     := PersNachname(pNNAME => vPrs(1).NACHNAME, 
                                      pVORSATZ => vPrs(1).VORSATZ_NACHNAME, 
                                      pNACHSATZ => vPrs(1).NACHSATZ_NACHNAME) ;  
   --vPrs1.VORSATZ_NACHNAME  := vPrs(1).VORSATZ_NACHNAME; 
   --vPrs1.NACHSATZ_NACHNAME := vPrs(1).NACHSATZ_NACHNAME; 
   --vPrs1.GEBURTSDATUM := vPrs(1).GEBURTSDATUM; 
   --vPrs1.GEBURTSORT   := vPrs(1).GEBURTSORT; 
   vPrs1.BEZEICHNUNG  :=  vPrs(1).BEZEICHNUNG;    
   vPrs1.BEZEICHNUNG2 := vPrs(1).BEZEICHNUNG2; 
   vPrs1.RECHTSFORM   := vPrs(1).RECHTSFORM; 
   --vPrs1.PERS_ID      := vPrs(1).PERS_ID; 
   vPrs1.REF_ID       := vPrs(1).REF_ID;
   
   Komm(vPrs(1).ID, 'BTR', vPrs1.TELEFON, vPrs1.FAX, vPrs1.MOBIL, vPrs1.EMAIL);   
  
   PIPE ROW (vPrs1);
  END IF;
  RETURN;
END ReadBtr;

-- Liefert 
FUNCTION ReadBtr2(pID IN ZBR_AUS_DATA.tID, pTyp IN VARCHAR2) RETURN ZBR_AUS_DATA.tbPrs1 PIPELINED AS
v1 ZBR_AUS_DATA.tPrs1;

CURSOR cBTS (pID IN ZBR_AUS_DATA.tID) IS
  SELECT prs.ID, prs.KURZBEZ1, prs.KURZBEZ2, prs.TYP, prs.ANREDE, prs.TITEL, 
  prs.VORNAME, prs.NACHNAME, prs.vorsatz_nachname, prs.nachsatz_nachname, /*prs.GEBURTSDATUM, prs.GEBURTSORT,*/ 
  prs.BEZEICHNUNG, prs.BEZEICHNUNG2, prs.RECHTSFORM, /*prs.PERS_ID,*/ prs.REF_ID
  FROM aus_d_person prs 
  JOIN aus_d_funktion fkt ON fkt.d_pers_id = prs.id
  AND fkt.typ = zbr_aus_data.Betreiber
  AND fkt.d_bts_id = pID
  UNION ALL
  SELECT prs.ID, prs.KURZBEZ1, prs.KURZBEZ2, prs.TYP, prs.ANREDE, prs.TITEL, 
  prs.VORNAME, prs.NACHNAME, prs.vorsatz_nachname, prs.nachsatz_nachname, /*prs.GEBURTSDATUM, prs.GEBURTSORT,*/ 
  prs.BEZEICHNUNG, prs.BEZEICHNUNG2, prs.RECHTSFORM, /*prs.PERS_ID,*/ prs.REF_ID
  FROM ein_d_person prs 
  JOIN ein_d_funktion fkt ON fkt.d_pers_id = prs.id
  AND fkt.typ = zbr_aus_data.Betreiber
  AND fkt.d_bts_id = pID;
  
CURSOR cPrs (pID IN ZBR_AUS_DATA.tID) IS
  SELECT prs.ID, prs.KURZBEZ1, prs.KURZBEZ2, prs.TYP, prs.ANREDE, prs.TITEL, 
  prs.VORNAME, prs.NACHNAME, prs.vorsatz_nachname, prs.nachsatz_nachname, /*prs.GEBURTSDATUM, prs.GEBURTSORT,*/ 
  prs.BEZEICHNUNG, prs.BEZEICHNUNG2, prs.RECHTSFORM, /*prs.PERS_ID,*/ prs.REF_ID
  FROM aus_d_person prs 
  WHERE prs.id = pID
  UNION ALL
  SELECT prs.ID, prs.KURZBEZ1, prs.KURZBEZ2, prs.TYP, prs.ANREDE, prs.TITEL, 
  prs.VORNAME, prs.NACHNAME, prs.vorsatz_nachname, prs.nachsatz_nachname, /*prs.GEBURTSDATUM, prs.GEBURTSORT,*/ 
  prs.BEZEICHNUNG, prs.BEZEICHNUNG2, prs.RECHTSFORM, /*prs.PERS_ID,*/ prs.REF_ID
  FROM ein_d_person prs 
  WHERE prs.id = pID;
 
TYPE tbPrs IS TABLE OF cPrs%ROWTYPE;
vPrs tbPrs := tbPrs();
vPrs1 ZBR_AUS_DATA.tPrs1;
BEGIN

  IF pTyp = 'BTS' THEN
    OPEN cBts(pID);
    FETCH cBTS BULK COLLECT INTO vPrs LIMIT 1;
    CLOSE cBTS;

  ELSE
    OPEN cPrs(pID);
    FETCH cPrs BULK COLLECT INTO vPrs LIMIT 1;
    CLOSE cPrs;

  END IF;
  
  IF vPrs.COUNT > 0 THEN

   vPrs1.ID           := vPrs(1).ID;
   vPrs1.KURZBEZ1     := vPrs(1).KURZBEZ1; 
   vPrs1.KURZBEZ2     := vPrs(1).KURZBEZ2; 
   vPrs1.TYP          := vPrs(1).TYP; 
   vPrs1.ANREDE       := vPrs(1).ANREDE; 
   vPrs1.TITEL        := vPrs(1).TITEL; 
   vPrs1.VORNAME      := vPrs(1).VORNAME; 
   vPrs1.NACHNAME     := vPrs(1).NACHNAME; 
   vPrs1.VORSATZ_NACHNAME  := vPrs(1).VORSATZ_NACHNAME; 
   vPrs1.NACHSATZ_NACHNAME := vPrs(1).NACHSATZ_NACHNAME; 
   --vPrs1.GEBURTSDATUM := vPrs(1).GEBURTSDATUM; 
   --vPrs1.GEBURTSORT   := vPrs(1).GEBURTSORT; 
   vPrs1.BEZEICHNUNG  := vPrs(1).BEZEICHNUNG; 
   vPrs1.BEZEICHNUNG2 := vPrs(1).BEZEICHNUNG2; 
   vPrs1.RECHTSFORM   := vPrs(1).RECHTSFORM; 
   --vPrs1.PERS_ID      := vPrs(1).PERS_ID; 
   vPrs1.REF_ID       := vPrs(1).REF_ID;
   
   Komm(vPrs(1).ID, 'BTR', vPrs1.TELEFON, vPrs1.FAX, vPrs1.MOBIL, vPrs1.EMAIL);   
  
   PIPE ROW (vPrs1);
  END IF;
  RETURN;
END ReadBtr2;


PROCEDURE PrtConfirm(pBTS_ID IN ZBR_AUS_DATA.tID) AS
BEGIN
  PrtConfirm(pBTS_ID, 2);
END;

PROCEDURE PrtConfirm(pBTS_ID IN ZBR_AUS_DATA.tID, pStatus IN NUMBER) AS
BEGIN
  UPDATE aus_d_protokoll
  SET status = pStatus
  WHERE d_bts_id = pBTS_ID;
END;

PROCEDURE UscConfirm(pUSC_ID IN ZBR_AUS_DATA.tID) AS
vBTS_ID ZBR_AUS_DATA.tID;
BEGIN
  UPDATE aus_d_usecase
  SET status = 1
  WHERE id = pUsc_ID
  RETURNING d_bts_id INTO vBTS_ID;
  
  UPDATE aus_d_protokoll
  SET status = 2
  WHERE d_bts_id = vBTS_ID
  AND NOT EXISTS( SELECT 1 FROM aus_d_usecase uc WHERE uc.d_bts_id = vBTS_ID AND uc.status = 0 );  
END;

PROCEDURE UpdPrtPrio(pD0101_ID IN ZBR_AUS_DATA.tID, pPrio IN NUMBER) AS
BEGIN
  UPDATE aus_d_protokoll
  SET prio = pPrio
  WHERE d0101_id = pD0101_ID
  AND status IN (0, 5, 6); 
 
--, pBTS_ID IN ZBR_AUS_DATA.tID,
--  IF pBTS_ID <> '-1' THEN
--    UPDATE aus_d_protokoll
--    SET status = 0
--    WHERE d_bts_id = pBTS_ID
--    AND status = 10 
--  END IF;
END;

FUNCTION Version RETURN VARCHAR2 AS
BEGIN
  RETURN '$Revision: 841 $';
END;

BEGIN

  INIT;
  
END ZBR_AUS; 
/

